#include <iostream>
#include <array>

struct Activity {
	int start;
	int end;
};

int n;
std::array<Activity, 200'100> activities;

void input_data() noexcept {
	std::cin >> n;
	for (int i = 0; i < n; ++i) {
		std::cin >> activities[i].start >> activities[i].end;
	}
}

bool overlap(Activity a1, Activity a2) noexcept {
	return a1.start <= a2.end && a2.start <= a1.end;
}

int mask_size(int mask) noexcept {
	int size = 0;
	for (int i = 0; i < n; ++i)
		if (mask & (1 << i))
			++size;
	return size;
}

// 0 for incompatable
int compatable_size(int mask) noexcept {
	int size = 0;
	for (int i = 0; i < n; ++i)
		if (mask & (1 << i)) {
			++size;
			for (int j = 0; j < n; ++j)
				if (mask & (1 << j))
					if (overlap(activities[i], activities[j]))
						return 0;
		}
	return size;
}

int compute_m() noexcept {
	int m = 0;
	for (int mask = 0; mask < (1 << n); ++mask)
		for (int i = 0; i < n; ++i)
			for (int j = 0; j < n; ++j)
				m = std::max(compatable_size(mask), m);
	return m;
}

int solve(int m) noexcept {
	for (int mask = 0; mask < (1 << n); ++mask)
		if (mask_size(mask) == n / 2 && compatable_size(mask) == m / 2)
			return mask;
	std::cout << "Unreachable!";
}

void print_mask(int mask) noexcept {
	bool outputed = false;
	for (int i = 0; i < n; ++i)
		if (mask & (1 << i)) {
			if (outputed)
				std::cout << ' ';
			else
				outputed = true;

			std::cout << i + 1;
		}
	std::cout << '\n';
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int t;
	std::cin >> t;
	for (int ti = 0; ti < t; ++ti) {
		input_data();
		print_mask(solve(compute_m()));
	}
}
