#include <iostream>
#include <array>

int64_t n, q;
std::array<int64_t, 200> weights;

void input_data() noexcept {
	std::cin >> n >> q;
	for (int64_t i = 0; i < n; ++i)
		std::cin >> weights[i];
}

bool solve(int64_t k, int64_t a, int64_t b) noexcept {
	for (int selected = 0; selected < (1 << n); ++selected)
		for (int mask = 0; mask < (1 << n); ++mask) {
			int64_t sum1 = 0, sum2 = 0;
			for (int i = 0; i < n; ++i)
				if (weights[i] <= k && (selected & (1 << i))) {
					if (mask & (1 << i))
						sum1 += weights[i];
					else
						sum2 += weights[i];
				}

			if (sum1 == a && sum2 == b || sum1 == b && sum2 == a)
				return true;
		}
	return false;
}

void process_queries() noexcept {
	int64_t z;
	std::cin >> z;
	int64_t v = 0;
	for (int64_t qi = 0; qi < q; ++qi) {
		int64_t j, c, d;
		std::cin >> j >> c >> d;

		int64_t k = j - v * z, a = c - v * z, b = d - v * z;

		if (solve(k, a, b)) {
			++v;
			std::cout << "Yes\n";
		}
		else
			std::cout << "No\n";
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	input_data();
	process_queries();
}
