#include <iostream>
#include <array>
#include <bitset>
#include <map>
#include <tuple>

int64_t n, q;
std::array<int64_t, 200> weights;

void input_data() noexcept {
	std::cin >> n >> q;
	for (int64_t i = 0; i < n; ++i) {
		std::cin >> weights[i];
	}
}

std::array<std::array<std::bitset<200>, 5100>, 5100> is_accessable_table;
std::array<std::array<std::bitset<200>, 5100>, 5100> is_accessable_computed;

bool is_accessable(int64_t a, int64_t b, int64_t i = n - 1) noexcept {
	if (a == 0 && b == 0) return true;
	if (i == -1 || a < 0 || b < 0) return false;

	if (is_accessable_computed[a][b][i])
		return is_accessable_table[a][b][i];
	
	is_accessable_computed[a][b][i] = true;

	return is_accessable_table[a][b][i] = is_accessable(a - weights[i], b, i - 1) 
		                               || is_accessable(a, b - weights[i], i - 1) 
		                               || is_accessable(a, b, i - 1);
}

std::array<std::bitset<5100>, 5100> is_ideal_table;
std::array<std::bitset<5100>, 5100> is_ideal_computed;

int64_t is_ideal(int64_t a, int64_t b) noexcept {
	if (a < 0 || b < 0) return false;
	if (a == 0 && b == 0) return true;

	if (is_ideal_computed[a][b])
		return is_ideal_table[a][b];

	is_ideal_computed[a][b] = true;
	return is_ideal_table[a][b] = is_accessable(a, b) && (a == 0 || is_ideal(a - 1, b)) && (b == 0 || is_ideal(a, b - 1));
}

bool solve(int64_t k, int64_t a, int64_t b) noexcept {
	return is_ideal(a, b);
}

void process_queries() noexcept {
	int64_t z;
	std::cin >> z;
	int64_t v = 0;
	for (int64_t qi = 0; qi < q; ++qi) {
		int64_t j, c, d;
		std::cin >> j >> c >> d;

		int64_t k = j - v * z, a = c - v * z, b = d - v * z;

		if (solve(k, a, b)) {
			++v;
			std::cout << "Yes\n";
		}
		else
			std::cout << "No\n";
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	input_data();

	process_queries();
}
