#include <iostream>
#include <array>
#include <map>
#include <tuple>

int64_t n, q;
std::array<int64_t, 200> weights;

void input_data() noexcept {
	std::cin >> n >> q;
	for (int64_t i = 0; i < n; ++i) {
		std::cin >> weights[i];
	}
}

std::array<std::array<std::array<int64_t, 400>, 400>, 200> min_k_for_accessable_table;

int64_t min_k_for_accessable(int64_t a, int64_t b, int64_t i = n - 1) noexcept {
	if (a == 0 && b == 0) return 0;
	if (i == -1 || a < 0 || b < 0) return 2e18;

	int64_t& result = min_k_for_accessable_table[a][b][i];
	if (result != -1) return result;

	int64_t min_k_included = std::max(std::min(min_k_for_accessable(a - weights[i], b, i - 1),
		min_k_for_accessable(a, b - weights[i], i - 1)), weights[i]);
	
	return result = std::min(min_k_included, min_k_for_accessable(a, b, i - 1));
}

std::array<std::array<int64_t, 400>, 400> min_k_for_ideal_table;

int64_t min_k_for_ideal(int64_t a, int64_t b) noexcept {
	int64_t& result = min_k_for_ideal_table[a][b];
	if (result != -1) return result;

	result = min_k_for_accessable(a, b);
	if (a > 0) result = std::max(min_k_for_ideal(a - 1, b), result);
	if (b > 0) result = std::max(min_k_for_ideal(a, b - 1), result);

	return result;
}

void prepare_tables() noexcept {
	for (int a = 0; a < 400; ++ a)
		for (int b = 0; b < 400; ++b) {
			for (int i = 0; i < 200; ++i)
				min_k_for_accessable_table[a][b][i] = -1;
			min_k_for_ideal_table[a][b] = -1;
		}
}

bool solve(int64_t k, int64_t a, int64_t b) noexcept {
	return min_k_for_ideal(a, b) <= k;
}

void process_queries() noexcept {
	int64_t z;
	std::cin >> z;
	int64_t v = 0;
	for (int64_t qi = 0; qi < q; ++qi) {
		int64_t j, c, d;
		std::cin >> j >> c >> d;

		int64_t k = j - v * z, a = c - v * z, b = d - v * z;

		if (solve(k, a, b)) {
			++v;
			std::cout << "Yes\n";
		}
		else
			std::cout << "No\n";
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	input_data();
	prepare_tables();

	process_queries();
}
