#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<vector<int>> g;

vector<int> tin, tout;
vector<int> dp;

int timer;

void dfs(int v, int turn) {
    tin[v] = timer++;
    if (!g[v].empty()) {
        if (turn == 0) {
            dp[g[v][0]] = dp[v];
            dfs(g[v][0], 0);
            dp[g[v][1]] = dp[v] + 1;
            dfs(g[v][1], 1);
        } else if (turn == 1) {
            dp[g[v][0]] = dp[v] + 1;
            dfs(g[v][0], 0);
            dp[g[v][1]] = dp[v];
            dfs(g[v][1], 1);
        } else {
            dp[g[v][0]] = dp[v];
            dfs(g[v][0], 0);
            dp[g[v][1]] = dp[v];
            dfs(g[v][1], 1);
        }
    }
    tout[v] = timer++;
}

struct segtree {
    int n;
    vector<int> tree;

    segtree(int _n) {
        n = _n;
        tree.resize(2 * n);
    }

    void set(int i, int v) {
        i += n;
        tree[i] = v;
        i /= 2;
        while (i) {
            tree[i] = tree[2 * i] + tree[2 * i + 1];
            i /= 2;
        }
    }

    int get(int l, int r) {
        l += n;
        r += n;
        int ans = 0;
        while (l <= r) {
            if (l % 2 == 1) {
                ans += tree[l];
                l += 1;
            }
            if (r % 2 == 0) {
                ans += tree[r];
                r -= 1;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            l -= 1;
            r -= 1;
            g[i].push_back(l);
            g[i].push_back(r);
        }
    }

    dfs(0, 2);

    segtree sgt(2 * n);
    for (int i = 0; i < n; ++i) {
        if (g[i].empty() && dp[i] <= k) {
            sgt.set(tin[i], 1);
        }
    }

    while (q--) {
        int u;
        cin >> u;
        u -= 1;
        cout << sgt.get(tin[u], tout[u]) << '\n';
    }

}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#endif

    solve();

    return 0;
}
