#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct SegTree {
    vector<int> tree;
    int n;

    SegTree() {}
    SegTree(int n) : n(n) {
        tree.resize(4 * n, -INF);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l + 1 == r) {
            tree[v] = max(tree[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) {
            update(2 * v + 1, l, m, i, x);
        } else {
            update(2 * v + 2, m, r, i, x);
        }
        tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void update(int i, int x) {
        update(0, 0, n, i, x);
    }

    int get(int v, int l, int r, int li, int ri) {
        if (li >= r || l >= ri) {
            return -INF;
        }
        if (li <= l && r <= ri) {
            return tree[v];
        }
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, li, ri), get(2 * v + 2, m, r, li, ri));
    }

    int get(int li, int ri) {
        return get(0, 0, n, li, ri);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> v(n);
        cin >> v;
        for (auto &i : v) {
            --i;
        }
        vector<vector<int>> dp(n, vector<int>(n, -INF));
        dp[0][n - 1] = 0;
        vector<SegTree> str(n, SegTree(n)), sto(n, SegTree(n));
        str[0].update(n - 1, 0);
        sto[n - 1].update(0, 0);
        for (int i = 0; i < n; ++i) {
            for (int b = 0; b < n; ++b) {
                dp[v[i]][b] = max(dp[v[i]][b], sto[b].get(0, v[i] + 1) + 1);
            }
            for (int a = 0; a < n; ++a) {
                dp[a][v[i]] = max(dp[a][v[i]], str[a].get(v[i], n) + 1);
            }
            for (int j = 0; j < n; ++j) {
                str[v[i]].update(j, dp[v[i]][j]);
                sto[j].update(v[i], dp[v[i]][j]);
                str[j].update(v[i], dp[j][v[i]]);
                sto[v[i]].update(j, dp[j][v[i]]);
            }
//            vector<vector<int>> dpp(n, vector<int>(n, -INF));
//            for (int a = 0; a < n; ++a) {
//                for (int b = 0; b < n; ++b) {
//                    if (a <= v[i]) {
//                        dpp[v[i]][b] = max(dpp[v[i]][b], dp[a][b] + 1);
//                    } else {
//                        dpp[a][b] = max(dpp[a][b], dp[a][b]);
//                    }
//                    if (v[i] <= b) {
//                        dpp[a][v[i]] = max(dpp[a][v[i]], dp[a][b] + 1);
//                    } else {
//                        dpp[a][b] = max(dpp[a][b], dp[a][b]);
//                    }
//                }
//            }
//            dp = dpp;
        }
        int ans = 0;
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                ans = max(ans, dp[a][b]);
            }
        }
        cout << ans << "\n";
    }
}
