#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

struct SegTree {
    struct Node {
        int val = -INF, push = -1;
    };

    vector<Node> tree;
    int n;

    SegTree() {}

    SegTree(int n) : n(n) {
        tree.resize(4 * n);
    }

    void push(int v, int l, int r) {
        if (tree[v].push == -1) {
            return;
        }
        if (l + 1 < r) {
            tree[2 * v + 1].push = tree[v].push;
            tree[2 * v + 2].push = tree[v].push;
        }
        tree[v].val = tree[v].push;
        tree[v].push = -1;
    }

    void update_single(int v, int l, int r, int i, int x, bool f = 0) {
        push(v, l, r);
        if (i < l || i >= r) {
            return;
        }
        if (l + 1 == r) {
            if (f) {
                tree[v].val = x;
            } else {
                tree[v].val = max(tree[v].val, x);
            }
            return;
        }
        int m = (l + r) / 2;
        update_single(2 * v + 1, l, m, i, x, f);
        update_single(2 * v + 2, m, r, i, x, f);
        tree[v].val = max(tree[2 * v + 1].val, tree[2 * v + 2].val);
    }

    void update_single(int i, int x, bool f = 0) {
        update_single(0, 0, n, i, x, f);
    }

    void update(int v, int l, int r, int li, int ri, int x) {
        push(v, l, r);
        if (li >= r || l >= ri) {
            return;
        }
        if (li <= l && r <= ri) {
            tree[v].push = x;
            push(v, l, r);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, li, ri, x);
        update(2 * v + 2, m, r, li, ri, x);
        tree[v].val = max(tree[2 * v + 1].val, tree[2 * v + 2].val);
    }

    void update(int li, int ri, int x) {
        update(0, 0, n, li, ri, x);
    }

    int get(int v, int l, int r, int li, int ri) {
        push(v, l, r);
        if (li >= r || l >= ri) {
            return -INF;
        }
        if (li <= l && r <= ri) {
            return tree[v].val;
        }
        int m = (l + r) / 2;
        return max(get(2 * v + 1, l, m, li, ri), get(2 * v + 2, m, r, li, ri));
    }

    int get(int li, int ri) {
        return get(0, 0, n, li, ri);
    }
};

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> v(n);
        cin >> v;
        for (auto &i : v) {
            --i;
        }
        vector<vector<int>> dp(n, vector<int>(n, -INF));
        dp[0][n - 1] = 0;
        vector<SegTree> str(n, SegTree(n)), sto(n, SegTree(n));
        str[0].update_single(n - 1, 0);
        sto[n - 1].update_single(0, 0);
        for (int i = 0; i < n; ++i) {
//            for (int a = 0; a < n; ++a) {
//                for (int b = 0; b < n; ++b) {
//                    str[a].update_single(b, dp[a][b], 1);
//                    sto[b].update_single(a, dp[a][b], 1);
//                }
//            }
//            vector<int> aa(n, -INF), bb(n, -INF);
//            for (int b = 0; b < n; ++b) {
//                bb[b] = max(bb[b], sto[b].get(0, v[i] + 1) + 1);
//            }
//            for (int a = 0; a < n; ++a) {
//                aa[a] = max(aa[a], str[a].get(v[i], n) + 1);
//            }
//            for (int a = 0; a < n; ++a) {
//                for (int b = 0; b < n; ++b) {
//                    if (b >= v[i] || a <= v[i]) {
//                        str[a].update_single(b, -INF, 1);
//                        sto[b].update_single(a, -INF, 1);
//                    }
//                }
//            }
//            for (int a = 0; a < v[i]; ++a) {
//                str[a].update(0, n, -INF);
//            }
//            for (int j = 0; j < n; ++j) {
//                sto[j].update(0, v[i], -INF);
//            }
//            for (int b = v[i] + 1; b < n; ++b) {
//                sto[b].update(0, n, -INF);
//            }
//            for (int j = 0; j < n; ++j) {
//                str[j].update(v[i] + 1, n, -INF);
//            }
//            for (int j = 0; j < n; ++j) {
//                str[v[i]].update_single(j, bb[j]);
//                sto[j].update_single(v[i], bb[j]);
//                str[j].update_single(v[i], aa[j]);
//                sto[v[i]].update_single(j, aa[j]);
//            }
            vector<vector<int>> dpp(n, vector<int>(n, -INF));
//            auto dpp = dp;
            for (int a = 0; a < n; ++a) {
                for (int b = 0; b < n; ++b) {
                    if (a <= v[i]) {
                        dpp[v[i]][b] = max(dpp[v[i]][b], dp[a][b] + 1);
                    } else {
                        dpp[a][b] = max(dpp[a][b], dp[a][b]);
                    }
                    if (v[i] <= b) {
                        dpp[a][v[i]] = max(dpp[a][v[i]], dp[a][b] + 1);
                    } else {
                        dpp[a][b] = max(dpp[a][b], dp[a][b]);
                    }
                }
            }
//            for (int a = 0; a < n; ++a) {
//                for (int b = 0; b < n; ++b) {
//                    int govno1 = str[a].get(b, b + 1);
//                    if (govno1 < 0) {
//                        govno1 = -INF;
//                    }
//                    if (dpp[a][b] < 0) {
//                        dpp[a][b] = -INF;
//                    }
//                    if (govno1 != dpp[a][b]) {
//                        cout << "nigger\n";
//                    }
//                }
//            }
            dp = dpp;
        }
        int ans = 0;
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                ans = max(ans, dp[a][b]);
            }
//            ans = max(ans, str[a].get(0, n));
        }
        cout << ans << "\n";
    }
}
