#include<bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(),(x).end()
#define sz(x) (x).size()
using ll = long long;
using pll = pair<ll, ll>;
const int MAXN = 2e5 + 5;
const ll inf = 1e18;

ll square(ll x, ll y) {
    return (x + 1) * (y + 1);
}

struct segTree {
    vector<ll> mx, mn;
    int n;

    void build(int v, int l, int r, const vector<ll> &a) {
        if (r - l == 1) {
            mn[v] = mx[v] = a[l];
            return;
        }
        int mid = (l + r) >> 1;
        build(v * 2 + 1, l, mid, a);
        build(v * 2 + 2, mid, r, a);
        mx[v] = max(mx[v * 2 + 1], mx[v * 2 + 2]);
        mn[v] = min(mn[v * 2 + 1], mn[v * 2 + 2]);
    }

    segTree() {}

    segTree(const vector<ll> &a) {
        n = sz(a);
        mx.resize(n * 4);
        mn.resize(n * 4);
        build(0, 0, n, a);
    }

    ll askmn(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr)return inf;
        if (ql <= l && r <= qr)return mn[v];
        int mid = (l + r) >> 1;
        return min(askmn(v * 2 + 1, l, mid, ql, qr), askmn(v * 2 + 2, mid, r, ql, qr));
    }

    ll askmn(int l, int r) {
        return askmn(0, 0, n, l, r);
    }

    ll askmx(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr)return -inf;
        if (ql <= l && r <= qr)return mx[v];
        int mid = (l + r) >> 1;
        return max(askmx(v * 2 + 1, l, mid, ql, qr), askmx(v * 2 + 2, mid, r, ql, qr));
    }

    ll askmx(int l, int r) {
        return askmx(0, 0, n, l, r);
    }
};

pll pts[MAXN];
ll h, w, n;

pll relax() {
    sort(pts, pts + n, [](pll A, pll B) {
        return make_pair(A.second, A.first) < make_pair(B.second, B.first);
    });
    vector<ll> ys;
    for (int i = 0; i < n; i++) {
        ys.push_back(pts[i].first);
    }
    segTree tr(ys);
    pll ans = {inf, inf};
    for (int i = 1; i < n; i++) {
        ll mn = tr.askmn(i, n);
        ll mx = tr.askmx(0, i);
        if (mx >= mn)continue;
        ll x2 = pts[i - 1].second;
        ll x1 = pts[i].second;
        ll move = min(mx, h + 1 - mn);
        if (x2 != x1) {
            move += min(x2, w + 1 - x1);
            x2 += w;
        } else {
            x1 = pts[0].second;
            x2 = pts[n - 1].second;
        }
        ans = min(ans, {square(x2 - x1, h + mx - mn), move});
    }
    return ans;
}

ll mv(pll A) {
    auto [x, y] = A;
    ll ans = 0;
    if (x < 1)ans += 1 - x;
    if (y < 1)ans += 1 - y;
    if (x > h)ans += x - h;
    if (y > w)ans += y - w;
    return ans;
}

ll sq(pll A, pll B) {
    return (llabs(A.first - B.first) + 1) * (llabs(A.second - B.second) + 1);
}


void solve() {
    pll A, B;
    cin >> h >> w >> n;
    cin >> A.first >> A.second;
    cin >> B.first >> B.second;
    ll dx[] = {h, -h, 0};
    ll dy[] = {w, -w, 0};
    pll ans = {inf, inf};

    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            pll C = {B.first + dx[i], B.second + dy[j]};
            ans = min(ans, {sq(A, C), mv(C)});
        }
    }

    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            pll C = {A.first + dx[i], A.second + dy[j]};
            ans = min(ans, {sq(B, C), mv(C)});
        }
    }


    cout << ans.first << ' ' << ans.second << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
    return 0;
}
