#include <bits/stdc++.h>

using namespace std;

struct SegTree {
    int n;
    vector <pair <int, int>> t;

    SegTree(int n) : n(n) {
        t.resize(4 * n);
    }

    void update(int v, int l, int r, int i, int x) {
        if (l > i || i > r) return;
        if (l == r) {
            t[v] = make_pair(x, l);
            return;
        }
        int m = (l + r) / 2;
        update(2 * v, l, m, i, x);
        update(2 * v + 1, m + 1, r, i, x);
        t[v] = max(t[2 * v], t[2 * v + 1]);
    }

    inline void update(int i, int x) {
        update(1, 0, n - 1, i, x);
    }

    pair <int, int> get_max(int v, int l, int r, int A, int B) {
        if (l > B || A > r) return make_pair(-3, 0);
        if (A <= l && r <= B) return t[v];
        int m = (l + r) / 2;
        return max(get_max(2 * v, l, m, A, B), get_max(2 * v + 1, m + 1, r, A, B));
    }

    inline pair <int, int> get_max(int l, int r) {
        return get_max(1, 0, n - 1, l, r);
    }
};

inline void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; --a[i];
    }
    vector <int> dp1(n), c(n + 1, n);
    c[0] = -1;
    for (int i = 0; i < n; ++i) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (c[m] < a[i]) l = m;
            else r = m;
        }
        c[l + 1] = a[i];
        dp1[i] = l + 1;
    }
    vector <int> dp2(n);
    for (int i = 0; i <= n; ++i) c[i] = 0;
    c[0] = n;
    for (int i = n - 1; i >= 0; --i) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (c[m] > a[i]) l = m;
            else r = m;
        }
        c[l + 1] = a[i];
        dp2[i] = l + 1;
    }
    int nv = *max_element(dp1.begin(), dp1.end());
    if (nv >= n - 1) {
        cout << n << "\n";
        return;
    }
    vector <int> p(n + 1);
    vector <int> pos(n);
    for (int i = 0; i < n; ++i) pos[a[i]] = i;
    SegTree t(n);
    for (int i = n - 1; i >= 0; --i) {
        pair <int, int> val = t.get_max(i + 1, n - 1);
        t.update(i, dp1[i]);
        if (dp1[i] + val.first == nv) {
            ++p[i + 1];
            --p[val.second];
        }
    }
    for (int i = 1; i < n; ++i) p[i] += p[i - 1];
    int minn = n;
    for (int i = n - 1; i >= 0; --i) {
        if (!p[i]) continue;
        if (minn < a[i]) {
            cout << nv + 1 << "\n";
            return;
        }
        minn = a[i];
    }
    cout << nv << "\n";
}


signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    if (1) {
        int t = 1;
        cin >> t;
        while (t--) {
            solve();
        }
    }
    return 0;
}

/*
 2
 2
 2 1
 2
 5 2
 2 5

 */