#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

vector<vector<int>> from;
vector<int> mt;
vector<int> used;
bool khun(int u, int ind) {
	if (used[u] == ind) return false;
	used[u] = ind;
	for (int v : from[u]) {
		if (mt[v] == -1) {
			mt[v] = u;
			return true;
		}
	}
	for (int v : from[u]) {
		if (khun(mt[v], ind)) {
			mt[v] = u;
			return true;
		}
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	vector<vector<int>> mas;
	for (int i = 1; i <= 7; ++i) {
		for (int j = i + 1; j <= 7; ++j) {
			for (int k = j + 1; k <= 7; ++k) {
				mas.push_back({ i, j, k });
			}
		}
	}
	int cnt = mas.size();
	vector<vector<int>> g(cnt);
	from.resize(cnt);
	for (int i = 0; i < cnt; ++i) {
		for (int j = 0; j < cnt; ++j) {
			set<int> used = { mas[i][0], mas[i][1], mas[i][2] };
			if (used.find(mas[j][0]) == used.end() && used.find(mas[j][1]) == used.end() && used.find(mas[j][2]) == used.end()) {
				g[i].push_back(j);
				from[i].push_back(j);
			}
		}
	}
	mt.resize(cnt, -1);
	used.resize(cnt, -1);
	for (int i = 0; i < cnt; ++i) {
		khun(i, i);
	}
	vector<int> mt2(cnt);
	for (int i = 0; i < cnt; ++i) {
		mt2[mt[i]] = i;
	}
	int type, m;
	cin >> type >> m;
	if (type == 1) {
		for (int _ = 0; _ < m; ++_) {
			int n, k;
			cin >> n >> k;
			vector<int> a(k);
			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				a[i]--;
			}
			if (k == 1) {
				cout << (a[0] + 1) % n + 1 << endl;
			}
			else if (k == 2) {
				if (a[0] + 1 != a[1] && !(a[0] == 0 && a[1] == n - 1)) {
					int x1 = (a[0] + 1) % n + 1, x2 = (a[1] + 1) % n + 1;
					cout << min(x1, x2) << " " << max(x1, x2) << endl;
				}
				else {
					int x1 = (a[0] + 2) % n + 1, x2 = (a[1] + 2) % n + 1;
					cout << min(x1, x2) << " " << max(x1, x2) << endl;
				}
			}
			else if (k == n / 2 && n % 2 == 0) {
				vector<bool> used(n, false);
				for (int i = 0; i < k; ++i)
					used[a[i]] = true;
				for (int i = 0; i < n; ++i) {
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << endl;
			}
			else {
				for (int i = 0; i < cnt; ++i) {
					if (mas[i][0] - 1 == a[0] && mas[i][1] - 1 == a[1] && mas[i][2] - 1 == a[2]) {
						cout << mas[mt[i]][0] << " " << mas[mt[i]][1] << " " << mas[mt[i]][2] << endl;
						break;
					}
				}
			}
		}
	}
	else {
		for (int _ = 0; _ < m; ++_) {
			int n, k;
			cin >> n >> k;
			vector<int> a(k);
			for (int i = 0; i < k; ++i) {
				cin >> a[i];
				a[i]--;
			}
			if (k == 1) {
				cout << (a[0] + n - 1) % n + 1 << endl;
			}
			else if (k == 2 && n % 2 == 0) {
				if (a[0] + 1 != a[1] && !(a[0] == 0 && a[1] == n - 1)) {
					int x1 = (a[0] + n - 1) % n + 1, x2 = (a[1] + n - 1) % n + 1;
					cout << min(x1, x2) << " " << max(x1, x2) << endl;
				}
				else {
					int x1 = (a[0] + n - 2) % n + 1, x2 = (a[1] + n - 2) % n + 1;
					cout << min(x1, x2) << " " << max(x1, x2) << endl;
				}
			}
			else if (k == n / 2 &&n % 2 == 0) {
				vector<bool> used(n, false);
				for (int i = 0; i < k; ++i)
					used[a[i]] = true;
				for (int i = 0; i < n; ++i) {
					if (!used[i]) cout << i + 1 << " ";
				}
				cout << endl;
			}
			else {
				for (int i = 0; i < cnt; ++i) {
					if (mas[i][0] - 1 == a[0] && mas[i][1] - 1 == a[1] && mas[i][2] - 1 == a[2]) {
						cout << mas[mt2[i]][0] << " " << mas[mt2[i]][1] << " " << mas[mt2[i]][2] << endl;
						break;
					}
				}
			}
		}
	}

	return 0;
}