#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;
ll MOD;

ll get_mex(vector<ll>& a) {
	ll mex = 0;
	while (mex < a.size() && a[mex] == mex) {
		mex++;
	}
	return mex;
}

void ultra(vector<ll>& a) {
	ll mex = get_mex(a);
	for (int i = 0; i < a.size(); ++i) {
		a[i] ^= mex - 1;
	}
	sort(a.begin(), a.end());
}

bool check(const vector<ll>& a, ll p) {
	vector<ll> t = a;
	for (int i = 0; i < 100; ++i) {
		ultra(t);
	}
	ll mex = get_mex(t);
	if (mex != p)
		return false;
	for (int i = 0; i < 100; ++i) {
		ultra(t);
		if (get_mex(t) != p)
			return false;
	}
	return true;
}

ll answer1 = 0;
void gen(int left, ll k, ll p, vector<ll>& a) {
	if (left == 0) {
		answer1 += check(a, p);
		return;
	}
	for (int i = a.back() + 1; i < (1 << k); ++i) {
		a.push_back(i);
		gen(left - 1, k, p, a);
		a.pop_back();
	}
}

ll solve1(ll k, ll n, ll p) {
	vector<ll> a = { 0 };
	answer1 = 0;
	gen(n - 1, k, p, a);
	return answer1 % MOD;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	
	cin >> MOD;
	int t;
	cin >> t;
	while (t--) {
		ll n, k, p;
		cin >> n >> k >> p;
		cout << solve1(n, k, p) << "\n";
	}
}
