#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

int n, k, q;

vector<int> queries;
vector<pair<int, int>> g;
vector<pair<ll, ll>> dp;

void dfs1(int u) {
	dp[u].first = min(dp[u].first, dp[u].second + 1);
	if (g[u].first == -1)
		return;
	int l = g[u].first, r = g[u].second;
	dp[l].first = dp[u].first;
	dp[r].second = dp[u].second;
	dfs1(l);
	dfs1(r);
}

void solve1() {
	dp.assign(n, { INF, INF });
	dp[0] = { 0, 0 };
	dfs1(0);
	for (auto u : queries) {
		if (min(dp[u].first, dp[u].second) <= k) {
			cout << "1\n";
		}
		else {
			cout << "0\n";
		}
	}
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		cin >> n >> k >> q;
		g.resize(n);
		for (int u = 0; u < n; ++u) {
			int t;
			cin >> t;
			if (t == 2) {
				int l, r;
				cin >> l >> r;
				l--, r--;
				g[u] = { l, r };
			}
			else {
				g[u] = { -1, -1 };
			}
		}
		queries.resize(q);
		for (int i = 0; i < q; ++i) {
			cin >> queries[i];
			queries[i]--;
		}
		solve1();
	}
}
