#include <iostream>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
using namespace std;

using ll = long long;

const ll INF = 1e9;

struct Query {
	ll k, a, b;
};

int n, q;
vector<ll> w;
int z;
vector<Query> queries;

void solve4() {
	ll amax = 0, bmax = 0;
	for (auto [k, a, b] : queries) {
		amax = max(a, amax);
		bmax = max(b, bmax);
	}
	set<pair<ll, ll >> dp;
	dp.insert({ 0, 0 });
	dp.insert({ w[0], 0 });
	dp.insert({ 0, w[0] });
	for (int i = 1; i < n; ++i) {
		set<pair<ll, ll>> pdp = dp;
		for (auto [a, b] : pdp) {
			if (a + w[i] <= amax)
				dp.insert({ a + w[i], b });
			if (b + w[i] <= bmax)
				dp.insert({ a, b + w[i] });
		}
	}
	vector<ll> ansdp(amax + 1, -1);
	for (ll a = 0; a <= amax; ++a) {
		while (dp.count({ a, ansdp[a] + 1 })) {
			if (a > 0 && ansdp[a] >= ansdp[a - 1])
				break;
			ansdp[a]++;
		}
	}
	for (auto [k, a, b] : queries) {
		if (ansdp[a] >= b) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

void solve1() {
	for (auto [k, a, b] : queries) {
		ll amax = a, bmax = b;
		set<pair<ll, ll >> dp;
		dp.insert({ 0, 0 });
		if (w[0] <= k) {
			dp.insert({ w[0], 0 });
			dp.insert({ 0, w[0] });
		}
		for (int i = 1; i < n; ++i) {
			if (w[i] > k)
				continue;
			set<pair<ll, ll>> pdp = dp;
			for (auto [a, b] : pdp) {
				if (a + w[i] <= amax)
					dp.insert({ a + w[i], b });
				if (b + w[i] <= bmax)
					dp.insert({ a, b + w[i] });
			}
		}
		vector<ll> ansdp;
		while (true) {
			ll a = ansdp.size();
			ansdp.push_back(-1);
			while (dp.count({ a, ansdp[a] + 1 })) {
				if (a > 0 && ansdp[a] >= ansdp[a - 1])
					break;
				ansdp[a]++;
			}
			if (ansdp[a] == -1)
				break;
		}
		if (a < ansdp.size() && ansdp[a] >= b) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}


}

void solve2() {
	ll amax = 0;
	for (auto [k, a, b] : queries) {
		amax = max(a, amax);
	}
	vector<bool> dp(amax + 1, false);
	dp[0] = true;
	for (auto d : w) {
		vector<bool> ndp = dp;
		for (int i = 0; i < dp.size(); ++i) {
			if (i - d >= 0) {
				ndp[i] = dp[i] || dp[i - d];
			}
		}
		dp = ndp;
	}
	int ans = -1;
	while (ans < (int)dp.size() - 1 && dp[ans + 1]) {
		ans++;
	}
	for (auto [k, a, b] : queries) {
		if (a <= ans) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

void solve3() {
	vector<ll> t = w;
	sort(t.begin(), t.end());
	ll p = 0;
	ll maxa = 0;
	for (int i = 1; i < n; ++i) {
		if (p < t[i] - 1) {
			break;
		}
		p += t[i];
		maxa = p;
	}
	for (auto [k, a, b] : queries) {
		if (a <= maxa) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

int main() {
	int t = 1;
	// cin >> t;
	while (t--) {
		cin >> n >> q;
		w.resize(n);
		for (int i = 0; i < n; ++i) {
			cin >> w[i];
		}
		cin >> z;
		queries.resize(q);
		for (int i = 0; i < q; ++i) {
			cin >> queries[i].k >> queries[i].a >> queries[i].b;
		}
		solve3();
	}
}
