#include <iostream>
#include <vector>

#define int int64_t

using namespace std;

using matrix = vector<vector<int>>;

void mini(int& x, int y) {
    x = min(x, y);
}

void maxi(int& x, int y) {
    x = max(x, y);
}

int getSquare(const matrix& a, int r, int c) {
    int n = a.size() / 3;
    int m = a[0].size() / 3;

    int mni = n + 1;
    int mxi = -1;
    int mnj = m + 1;
    int mxj = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[r + i][c + j]) {
                mini(mni, r + i);
                maxi(mxi, r + i);
                mini(mnj, c + j);
                maxi(mxj, c + j);
                /*
                mni = min(mni, r + i);
                mxi = max(mxi, r + i);
                mnj = min(mnj, c + j);
                mxj = max(mxj, c + j);
                */
            }
        }
    }

    int ans = (mxj - mnj + 1) * (mxi - mni + 1);
    // cout << r << ' ' << c << ' ' << ans << '\n';
    // cout << r << ' ' << c << ' ' << mni << ' ' << mxi << ' ' << mnj << ' ' << mxj << ' ' << ans << '\n';
    return ans;
}

int getMoves(int n, int m, int i, int j) {
    return abs(n - i) + abs(m - j);
}

signed main() {
    int n, m, K;
    cin >> n >> m >> K;

    if (K == 1) {
        cout << 1 << ' ' << 0 << '\n';
        return 0;
    }

    matrix a(3 * n, vector<int>(3 * m));
    for (int k = 0; k < K; ++k) {
        int r, c;
        cin >> r >> c;
        --r;
        --c;
        for (int i = 0; i < 3; ++i) {
            for (int j = 0; j < 3; ++j) {
                a[r + n * i][c + m * j] = 1;// k + 1; //1;
            }
        }
    }


    /*
    for (int i = 0; i < 3*n; ++i) {
        for (int j = 0; j < 3 * m; ++j) {
            cout << a[i][j] << ' ';
        }
        cout << '\n';
    }
    */

    int best = 2e18;
    int besti = -1;
    int bestj = -1;
    for (int r = 0; r < 2 * n + 1; ++r) {
        for (int c = 0; c < 2 * m + 1; ++c) {
            int sq = getSquare(a, r, c);
            // cout << r + 1 << ' ' << c + 1 << ' ' << sq << '\n';
            if (sq < best || (sq == best && getMoves(n, m, r, c) < getMoves(n, m, besti, bestj))) {
                best = sq;
                besti = r;
                bestj = c;
            }
        }
    }

    cout << best << ' ' << getMoves(n, m, besti, bestj) << '\n';
}
