#include <bits/stdc++.h> 

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define FastIO cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(0)

typedef long long ll;
typedef long double ld;

using namespace std;

struct Segment {
	int lt, rt;
	int ind;
	Segment() {}
	Segment(int lt, int rt, int ind): lt(lt), rt(rt), ind(ind) {}
};

bool operator< (const Segment &a, const Segment &b) {
	return make_pair(a.rt, a.lt) < make_pair(b.rt, b.lt);
}

int f(const vector<Segment> &a, int lt, int rt) {
	int res = 0;
	for (auto &it : a) {
		if (lt < it.lt && it.rt < rt) ++res;
	}
	return res;
}

void solve() {
	int n;
	cin >> n; 
	vector<int> cords;
	vector<Segment> segs(n);
	for (int i = 0; i < n; ++i) {
		int lt, rt;
		cin >> lt >> rt;
		cords.emplace_back(lt);
		cords.emplace_back(rt);
		segs[i] =  Segment(lt, rt, i);
	}
	sort(all(cords));
	cords.resize(unique(all(cords)) - cords.begin());
	int t = cords.size();
	unordered_map<int, int> to_ind;
	for (int i = 0; i < t; ++i) to_ind[cords[i]] = i;
	for (int i = 0; i < n; ++i) {
		segs[i].lt = to_ind[segs[i].lt];
		segs[i].rt = to_ind[segs[i].rt];
	}
	vector<int> ends(t);
	vector<int> starts(t);
	for (int i = 0; i < n; ++i) {
		++starts[segs[i].lt + 1];
	   	if (segs[i].rt + 1 < t) ++ends[segs[i].rt + 1];
	}
	for (int i = 1; i < t; ++i) {
		starts[i] += starts[i - 1];
		ends[i] += ends[i - 1];
	}
	sort(all(segs));
	vector<Segment> tgood;
	tgood.emplace_back(segs[0]);
	for (int i = 1; i < n; ++i) {
		if (segs[i].lt > tgood.back().rt) {
			tgood.emplace_back(segs[i]);
		}
	}

	int m = tgood.size();

	vector<vector<pair<int, int>>> dp(m / 2 + 1, vector<pair<int, int>>(m + 1, make_pair(INT_MAX, INT_MAX)));
	vector<vector<int>> pr(m / 2 + 1, vector<int>(m + 1, 0));
	for (int i = 0; i <= m; ++i) dp[0][i].first = dp[0][i].second = 0;
	for (int i = 1; i <= m / 2; ++i) {
		for (int j = 1; j <= m; ++j) {
			dp[i][j].first = min(dp[i][j - 1].first, dp[i][j - 1].second);
			for (int k = 1; k <= min(j, i); ++k) {
				int tmp = j - k - 1;
				if (dp[i - k][tmp + 1].first == INT_MAX) continue;
				// int cnt = (j == m ? n : ends[tgood[j].lt]) - (tmp == -1 ? 0 : starts[tgood[tmp].rt]);
				int cnt = f(segs, (tmp == -1 ? -1 : tgood[tmp].rt), (j == m ? t + 1 : tgood[j].lt));
				if (dp[i - k][tmp + 1].first + cnt < dp[i][j].second) {
					dp[i][j].second = dp[i - k][tmp + 1].first + cnt;
					pr[i][j] = k;
				}
			}
			if (dp[i][j].first < dp[i][j].second) pr[i][j] = 0;
		}
	}
	vector<pair<int, int>> rm;
	int i = m / 2;
	int j = m;
	while (i != 0) {
		if (pr[i][j] == 0) {
			--j;
		} else {
			int tmp = j - pr[i][j] - 1;
			rm.emplace_back((tmp == -1 ? -1 : tgood[tmp].rt), (j == m ? t + 1 : tgood[j].lt));
			int val = pr[i][j];
			j -= val;
			i -= val;
		}
	}
	sort(all(rm));
	j = 0;
	vector<int> ans;
	vector<char> del(n, 0);
	vector<char> rem(n, 0);
	for (auto &it : segs) {
		while (j < rm.size() && it.rt >= rm[j].second) ++j;
		if (j < rm.size() && rm[j].first < it.lt && it.rt < rm[j].second) {
			del[it.ind] = 1;
		}
	}
	for (auto &it : tgood) {
		if (!del[it.ind]) rem[it.ind] = 1;
	}
	int x = min(dp[m / 2][m].first, dp[m / 2][m].second);
	for (int i = 0; i < n && x < n / 2; ++i) {
		if (!del[i] && !rem[i]) {
			++x;
			del[i] = 1;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!del[i]) cout << i + 1 << ' ';
	}
	cout << '\n';
}


signed main() {
#ifdef DEBUG
	freopen("inp", "r", stdin);
#endif 
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}

