#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<ll> p(n);
	for (auto& t : p)
		cin >> t;

	vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(n + 2, vector<ll>(n + 2, -INF)));

	dp[0][p[0]][n + 1] = 1;
	dp[0][0][p[0]] = 1;

	for (ll i = 1; i < n; ++i) {
		for (ll record = 0; record < dp[0].size(); ++record) {
			for (ll antirecord = 0; antirecord < p[i]; ++antirecord)
				dp[i][record][antirecord] = max(dp[i][record][antirecord], dp[i - 1][record][antirecord]);
			for (ll antirecord = p[i] + 1; antirecord < dp[0].size(); ++antirecord)
				dp[i][record][p[i]] = max(dp[i][record][p[i]], dp[i - 1][record][antirecord] + 1);
		}
		for (ll antirecord = 0; antirecord < dp[0].size(); ++antirecord) {
			for (ll record = 0; record < p[i]; ++record)
				dp[i][p[i]][antirecord] = max(dp[i][p[i]][antirecord], dp[i - 1][record][antirecord] + 1);
			for (ll record = p[i] + 1; record < dp[0].size(); ++record)
				dp[i][record][antirecord] = max(dp[i][record][antirecord], dp[i - 1][record][antirecord]);
		}
	}

	ll res = 0;
	for (ll record = 1; record <= n; ++record) {
		for (ll antirecord = 1; antirecord <= n; ++antirecord)
			res = max(res, dp.back()[record][antirecord]);
	}

	cout << res << '\n';
}