#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ld EPS = 1e-9L;


void init(istream& cin, ostream& cout);
void solve(istream& cin, ostream& cout);


ll MOD = 1e9 + 7;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	cin >> MOD;


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


template<typename ty, typename st>
ty binPow(ty a, st base) {
	ty res = 1;
	while (base > 0) {
		if (base % 2 == 1)
			res = res * a;
		a = a * a;
		base /= 2;
	}
	return res;
}


struct mint {
	ll x = 0;

	mint() = default;
	mint(const ll val) :x((val + MOD) % MOD) {}


	mint operator+(const mint val) const {
		return mint(x + val.x);
	}
	mint operator-(const mint val) const {
		return mint(x - val.x);
	}
	mint operator*(const mint val) const {
		return mint(x * val.x);
	}
	mint operator/(const mint val) const {
		return (*this) * binPow(val, MOD - 2);
	}
};


vector<mint> fct;
constexpr ll N = (1ll << 18);

void init(istream& cin, ostream& cout) {
	cin >> MOD;
	fct.emplace_back(1);
	for (ll i = 1; i < N; ++i)
		fct.emplace_back(fct.back() * mint(i));
}


mint C(const ll n, const ll m) {
	if (n < m || n < 0 || m < 0)
		return 0;
	return fct[n] / (fct[m] * fct[n - m]);
}


ll mex(const vector<ll>& a) {
	vector<bool> used(a.back() + 3);
	for (auto& t : a)
		used[t] = true;
	for (ll i = 0; i < used.size(); ++i) {
		if (!used[i])
			return i;
	}
	return 0;
}


ll ok(vector<ll> a) {
	vector<ll> b;
	for (ll q = 0; q < 1000; ++q) {
		ll m = mex(a);
		if (m == 0)
			return -1;
		b = a;
		for (auto& t : b)
			t = (t ^ (m - 1));
		sort(b.begin(), b.end());

		if (a == b)
			return m;
	}
	return -1;
}


ll k, n, p;
mint res;

vector<ll> a;


void fn(const ll i, const ll min_c = 1) {
	if (i == n) {
		if (ok(a) == p)
			res = res + 1;
		return;
	}
	for (ll c = min_c; c < (1ll << k); ++c) {
		a[i] = c;
		fn(i + 1, c + 1);
	}
}


void solve(istream& cin, ostream& cout) {
	cin >> k >> n >> p;
	res = 0;

	a.clear();
	a.resize(n);
	fn(1, 1);

	cout << res.x << '\n';
}