#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<ll>> g;
vector<vector<ll>> zp;
vector<ll> res;
ll n, k, q;


ll dfs(const ll v, const ll steps, const ll np) {
	ll cnt;


	if (steps > k)
		cnt = 0;
	else if (g[v].empty())
		cnt = 1;
	else
		cnt = dfs(g[v][np], steps, np) + dfs(g[v][np ^ 1], steps + 1, np ^ 1);


	for (auto& t : zp[v])
		res[t] = cnt;
	return cnt;
}


void dfsRoot(const ll v = 0) {
	if (g[v].empty())
		return;
	ll cnt = dfs(g[v][0], 0, 0) + dfs(g[v][1], 0, 1);

	for (auto& t : zp[v])
		res[t] = cnt;
}


void solve(istream& cin, ostream& cout) {
	cin >> n >> k >> q;
	g.resize(n);
	zp.resize(n);
	res.resize(q);


	for (ll i = 0; i < n; ++i) {
		ll t;
		cin >> t;
		if (t == 2) {
			g[i].resize(2);
			cin >> g[i][0] >> g[i][1];
			--g[i][0];
			--g[i][1];
		}
	}


	for (ll i = 0; i < q; ++i) {
		ll x;
		cin >> x;
		--x;
		zp[x].push_back(i);
	}

	dfsRoot();

	for (auto& t : res)
		cout << t << '\n';
}