#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <bitset>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;

using ll = long long;
using ull = unsigned long long;
using ld = long double;


constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


mt19937 rnd(45329843);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	int _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (auto& t : w)
		cin >> t;
	sort(w.begin(), w.end());
	ll z;
	cin >> z;


	constexpr ll MAX_A = 1500;

	map<ll, bitset<MAX_A + 1>> dp, dp_last;
	vector<vector<bool>> ok;


	auto fn = [&](const ll k) {
		dp.clear();
		dp_last.clear();
		ok.clear();
		ok.resize(MAX_A + 1, vector<bool>(MAX_A + 1));


		dp_last[0][0] = true;
		dp[0][0] = true;
		for (auto& t : w) {
			if (t > k)
				break;
			for (auto& [x, v] : dp_last) {
				if (x + t <= MAX_A)
					dp[x + t] |= dp_last[x];
				dp[x] |= (dp_last[x] << t);
			}
			dp_last = dp;
		}

		ok[0][0] = true;
		for (ll a = 0; a < ok.size(); ++a) {
			for (ll b = 0; b < ok.size(); ++b) {
				if (a > 0 && !ok[a - 1][b])
					break;
				if (b > 0 && !ok[a][b - 1])
					break;
				if (!dp[a][b])
					break;
				ok[a][b] = true;
			}
		}
	};

	vector<tuple<ll, ll, ll, ll>> mes;
	vector<bool> res(q);
	for (ll i = 0; i < q; ++i) {
		ll k, a, b;
		cin >> k >> a >> b;
		mes.emplace_back(k, a, b, i);
	}
	sort(mes.begin(), mes.end());

	ll last_k = -1;
	for (auto& [k, a, b, id] : mes) {
		if (k != last_k) {
			fn(last_k = k);
		}

		res[id] = ok[a][b];
	}

	for (auto t : res) {
		if (t)
			cout << "YES\n";
		else
			cout << "NO\n";
	}
}