#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(23223);
const ll inf = 1e18;


void print(const vector<ll> &a){
    for(auto x: a){
        cout << x << " ";
    }
    cout << endl;
}


int super_mod(int x, ll n){
    x %= n;
    if(x <= 0){
        x = n;
    }
    return x;
}


int find_block(ll n, int k, const vector<ll> &a){
    int frst = -1;
    for(auto x: a){
        int t = super_mod(x - 1, n);
        auto it = lower_bound(all(a), t);
        if(it == a.end() || *it != t){
            frst = x;
            break;
        }
    }
    if(frst == -1){
        return -1;
    }
    for(int i = 0; i < k; i += 1){
        int t= super_mod(frst + i, n);
        auto it = lower_bound(all(a), t);
        if(it == a.end() || *it != t){
            return -1;
        }
    }
    return frst;
}


vector<ll> Alice(ll n, int k, const vector<ll> &a){
    vector<ll> b;
    b.reserve(k);
    {
        int frst = find_block(n, k, a);
        if(frst != -1){
            for(int i = 0; i < k; i += 1){
                int t = super_mod(frst  + k + i, n);
                b.push_back(t);
            }
        }
        sort(all(b));
        return b;
    }
    set<ll> usd;
    for(auto x: a){
        usd.insert(x);
    }
    ll t = a[0];
    for(int i = 0; i < k; i += 1){
        while(usd.find(t) != usd.end()){
            t += 1;
            if(t > n){
                t -= n;
            }
        }
        usd.insert(t);
        b.push_back(t);
        
    }
    sort(all(b));
    return b;
}


vector<ll> Boris(ll n, int k, vector<ll> &a){
    vector<ll> b;
    b.reserve(k);
    {
        int frst = find_block(n, k, a);
        if(frst != -1){
            for(int i = 0; i < k; i += 1){
                int t = super_mod(frst - k + i, n);
                b.push_back(t);
            }
        }
        sort(all(b));
        return b;
    }
}


void gen_test(ll mxn, ll &n, int &k, vector<ll> &a, bool fixed_1){
    n = rnd() % (mxn - 1) + 2;
    k = rnd() % (n / 2) + 1;
    if(fixed_1){
        k = 1;
    }
    a.resize(k);
    set<int> usd;
    for(int i = 0; i < k; i += 1){
        ll x = rnd() % n + 1;
        while(usd.find(x) != usd.end()){
            x = rnd() % n + 1;
        }
        usd.insert(x);
        a.push_back(x);
    }
    sort(all(a));
}


void print_test(int tp, ll n, ll k, vector<ll> &a){
    cout << tp << "\n";
    cout << 1 << "\n";
    cout << n << " " << k << "\n";
    print(a);
}


void stress(){
    int c = 0;
    while(1){
        cout << ++c << "\n";
        ll n;
        int k;
        vector<ll> a;
        gen_test(4, n, k, a, true);
        auto b = Alice(n, k, a);
        if((int)b.size() != k){
            print_test(1, n, k, a);
            break;
        }
        auto c = Boris(n, k, a);
    }
}


int32_t main(){
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    int m;
    cin >> m;
    while(m--){
        ll n;
        int k;
        cin >> n >> k;
        vector<ll> a(k);
        for(int i = 0; i < k; i += 1){
            cin >> a[i];
        }
        vector<ll> b;
        if(t == 1){
            b = Alice(n, k, a);
        } else{
            b = Boris(n, k, a);
        }
        print(b);
    }
    return 0;
}