#include <bits/stdc++.h>


using namespace std;


#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(23223);
const ll inf = 1e18;


ll mod;
ll k, n, p;
ll sz;


ll get_xor(ll mask, ll m){
    ll new_mask = 0;
    for(int i = 0; i < sz; i += 1){
        if((mask >> i) & 1){
            new_mask += (1ll << (i ^ m));
        }
    }
    return new_mask;
}


ll get_mask_m(ll mask){
    for(int i = 0; ; i += 1){
        if((mask >> i) & 1){
            continue;
        }
        return i;
    }
}


ll count_rec(ll mask, ll p){
    ll rs = 1;
    for(int i = 0; i < sz; i += 1){
        if(i == p - 1){
            continue;
        }
        if((mask >> i) & 1){
            ll prvs_mask = get_xor(mask, i);
            if(get_mask_m(prvs_mask) == i + 1){
                rs += count_rec(prvs_mask, p);
            }
        }
    }
    return rs;
}


ll solve_slow(){
    int t = 0;
    while((1ll << t) < p){
        t += 1;
    }
    if((1ll << t) != p){
        return 0;
    }
    if(n < p - 1){
        return 0;
    }
    ll rs = 0;
    for(ll mask = 1; mask < (1 << sz); mask += 2){
        if((mask >> (p + p - 1)) & 1){
            continue;
        }
        if((mask >> p) & 1){
            continue;
        }
        if((mask ^ (mask + 1)) + 1 != (1ll << (p + 1))){
            continue;
        }
        ll cnt = 0;
        for(int i = 0; i < sz; i += 1){
            if((mask >> i) & 1){
                cnt += 1;
            }
        }
        if(cnt != n){
            continue;
        }

        rs += count_rec(mask, p);
    }
    return rs % mod;
}


ll stupid_solve(){
    int t = 0;
    while((1ll << t) < p){
        t += 1;
    }
    if((1ll << t) != p){
        return 0;
    }
    if(n < p - 1){
        return 0;
    }
    ll rs = 0;
    vector<int> usd(1 << sz, 0);
    int c = 1;
    for(ll mask = 1; mask < (1 << sz); mask += 2){
        ll cnt = 0;
        for(int i = 0; i < sz; i += 1){
            if((mask >> i) & 1){
                cnt += 1;
            }
        }
        if(cnt != n){
            continue;
        }
        ll m = mask;
        ll d = 0;
        c += 1;
        while(usd[m] != c){
            usd[m] = c;
            d += 1;
            m = get_xor(m, get_mask_m(m) - 1);
        }
        if(get_mask_m(m) == p){
            rs += 1;
        }
    }
    return rs % mod;
}


void stress(){
    int c = 0;
    while(1){
        cout << ++c << "\n";
        mod = 998244353;
        k = 4;
        sz = (1 << k);
        n = rnd() % sz + 1;
        p = rnd() % sz + 1;
        ll my_rs = solve_slow();
        ll right_rs = stupid_solve();
        if(my_rs != right_rs){
            cout << 998244353 << "\n";
            cout << 1 << "\n";
            cout << k << " " << n << " " << p << "\n";
            break;
        }
    }
}


int32_t main(){
    // stress();
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    /*
    for(int k = 1; k <= 4; k += 1){
        sz = (1 << k);
        for(int p = 1; p <= sz; p += 1){
            bool good = false;
            for(ll mask = 1; mask < (1 << sz); mask += 2){
                if((mask ^ (mask + 1)) + 1 == (1ll << (p + 1))){
                    ll prvs_mask = get_xor(mask, p - 1);
                    if((prvs_mask ^ (prvs_mask + 1)) + 1 == (1ll << (p + 1))){
                        good = true;
                    }
                }
            }
            if(good){
                cout << p << "\n";
            }
        }
    }
    */
    cin >> mod;
    int t;
    cin >> t;
    while(t--){
        cin >> k >> n >> p;
        sz = (1ll << k);
        cout << solve_slow() << "\n";

    }
    return 0;
}

/*
998244353
6
3 2 1
3 2 2
3 2 3
3 2 4
3 5 1
4 6 1

998244353
1
3 5 1

*/