#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e18;
mt19937 rnd(23424);

int n;
vector<ll> l, r;
vector<int> rs;
int sz;
vector<ll> cmprs;
vector<vector<pair<int, int>>> g;
vector<int> is_fxd;
vector<int> dp;
int m;


bool try_to_solve(int l, int r){
    vector<int> fxd, nt_fxd;
    fxd.reserve(m / 2);
    nt_fxd.reserve(n / 2);
    for(int u = 0; u < sz; u += 1){
        for(auto [to, num]: g[u]){
            if(l <= to && u <= r){
                if(is_fxd[num]){
                    fxd.push_back(num);
                } else{
                    nt_fxd.push_back(num);
                }
            }
        }
    }
    if((int)fxd.size() + (int)nt_fxd.size() < n / 2){
        return false;
    }
    rs = fxd;
    for(int i = 0; i < (int)nt_fxd.size() && (int)rs.size() < n / 2; i += 1){
        rs.push_back(nt_fxd[i]);
    }
    return true;
}


void solve(){
    rs.clear();
    rs.reserve(n / 2);
    cmprs.clear();
    cmprs.reserve(n + n);
    for(int i = 0; i < n; i += 1){
        cmprs.push_back(l[i]);
        cmprs.push_back(r[i] + 1);
    }
    sort(all(cmprs));
    cmprs.resize(unique(all(cmprs)) - cmprs.begin());
    sz = cmprs.size();
    g.assign(sz, {});
    is_fxd.assign(n, false);
    for(int i = 0; i < n; i += 1){
        int u = lower_bound(all(cmprs), l[i]) - cmprs.begin();
        int v = lower_bound(all(cmprs), r[i] + 1) - cmprs.begin();
        g[v].push_back(make_pair(u, i));
    }
    dp.assign(sz, 0);
    for(int i = 1; i < sz; i += 1){
        dp[i] = dp[i - 1];
        for(auto [to, num]: g[i]){
            if(dp[to] + 1 > dp[i]){
                dp[i] = dp[to] + 1;
                is_fxd[num] = true;
            }
        }
    }
    m = dp.back();
    int l = -1;
    int r = -1;
    for(int i = 0; i < sz; i += 1){
        if(dp[i] == m / 2){
            if(l == -1){
                l = i;
            }
            r = i;
        }
    }
    if(try_to_solve(0, r)){
        return;
    }
    try_to_solve(l, sz - 1);
}


template<class T>
void print(const vector<T> &a, T d){
    for(auto x: a){
        cout << x + d << " ";
    }
    cout << "\n";
}


int32_t main(){
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n;
        l.resize(n);
        r.resize(n);
        for(int i = 0; i < n; i += 1){
            cin >> l[i] >> r[i];
        }
        solve();
        print(rs, 1);
    }
    return 0;
}