#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <numeric>

using namespace std;

#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9 + 1;

void solve();

signed main() {
	fastIO();
	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
}

vvi gr;
vi dp;
vi leaf;
vi used;
set<ii> best;
vi par, s, deleted;
int m0 = 0;

void dfs(int u) {
	used[u] = 1;
	s[u] = 1;
	if (gr[u].empty()) dp[u] = 1, m0++, leaf[u] = 1;
    for (auto v: gr[u]){
        dp[u] += dp[v];
        s[u] += s[v];
    }
    if (gr[u].size() == 1){
        if (par[u] == -1 || gr[par[u]].size() > 1){
            best.insert({s[u], u});
        }
    }
}



void upd(int u){
	deleted[u] = 1;
	best.erase({s[u], u});
    if (par[u] >= 0){
        int p = par[u];
        s[p] -= s[u];
        dp[p]--;
        if (dp[p] == 1){
            best.insert({s[p], p});
        }
    }

}

void dfs2(int u, bool flag) {
	flag |= deleted[u];
	deleted[u] = flag;
	for (auto v : gr[u]) {
		dfs2(v, flag);
	}
}

vi answer;

void dfs3(int u) {
	if (!deleted[u] && !leaf[u]) answer.push_back(u);
	for (auto v : gr[u]) {
		dfs3(v);
	}
}

vii bs;

bool comp(int i, int j){
    return bs[i].second < bs[j].second;
}

bool comp2(ii a, ii b){
    return a.second < b.second;
}

void solve() {
    int n;
    cin >> n;
    gr = vvi(n);
    dp = vi(n);
	par = vi(n, -1);
	s = vi(n, 0);
	deleted = vi(n, 0);
	used = vi(n, 0);
    best.clear();

	vi st, inds;
	bs = vii(n);

    for (int i = 0; i < n; i++){
		int l, r;
		cin >> bs[i].first >> bs[i].second;
    }

    sort(all(inds), comp);
    sort(all(bs), comp2);

    for (int i = 0; i < n; i++){
        while (!st.empty() && bs[st.back()].first <= bs[i].first) {
			gr[i].push_back(st.back());
			par[st.back()] = i;
			st.pop_back();
		}

		st.push_back(i);
    }

    m0 = 0;
	used = vi(n);

	for (int i = 0; i < n; i++) if (!used[i]) dfs(i);

    int curm = m0;
	int sum = 0;

    for (int it = 0; it < m0 / 2; it++){
        auto buf = *best.begin();
		int w = buf.first;
		int u = buf.second;
		upd(u);
		sum += w;
    }

	used = vi(n);
	deleted = vi(n);
	for (int i = 0; i < n; i++) {
		if (!used[i]) dfs2(i, 0);
	}
	used = vi(n);
	for (int i = 0; i < n; i++) {
		if (!used[i]) dfs3(i);
	}

	for (auto i : answer) {
		cout << inds[i] + 1 << ' ';
	}
	cout << nl;


}






