#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define all(a) (a).begin(), (a).end()


vector<pii> graph, info;
vector<int> a, tree;
vector<bool> isTerm;
int tim = 0, k;


void dfs(int v, int ori, int cnt) {
    info[v].first = tim++;
    a.push_back(cnt);
    auto [l, r] = graph[v];

    if (l != -1 && r != -1) {
        if (ori == -1) {
            dfs(l, 0, cnt);
            dfs(r, 1, cnt);
        } else if (ori == 0) {
            dfs(l, 0, cnt);
            dfs(r, 1, cnt + 1);
        } else {
            dfs(l, 0, cnt + 1);
            dfs(r, 1, cnt);
        }
    } else {
        isTerm[v] = 1;
    }

    info[v].second = tim++;
    a.push_back(cnt);
}


void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        if (a[tl] <= k && isTerm[tl]) {
            tree[v] = 1;
        } else {
            tree[v] = 0;
        }
        return;
    }

    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm, tr);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}


int get(int v, int tl, int tr, int l, int r) {
    if (r <= tl || tr <= l) {
        return 0;
    }
    if (l <= tl && tr <= r) {
        return tree[v];
    }

    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, l, r) + get(2 * v + 2, tm, tr, l, r);
}


void print(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        cout << tree[v] << ' ';
        return;
    }

    int tm = (tl + tr) / 2;
    print(2 * v + 1, tl, tm);
    print(2 * v + 2, tm, tr);
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> k >> q;
    graph.resize(n);
    info.resize(n);
    isTerm.resize(n, 0);
    tree.resize(8 * n);

    for (int i = 0; i < n; ++i) {
        int son;
        cin >> son;
        if (son == 2) {
            int l, r;
            cin >> l >> r;
            graph[i] = { l - 1, r - 1 };
        } else {
            graph[i] = { -1, -1 };
        }
    }

    dfs(0, -1, 0);
    build(0, 0, 2 * n);

    cout << '\n';
    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        //cout << info[u - 1].first << ' ' << info[u - 1].second + 1 << '\n';
        cout << get(0, 0, 2 * n, info[u - 1].first, info[u - 1].second + 1) / 2 << '\n';
    }

    /*for (auto elem : a) {
        cout << elem << ' ';
    }
    cout << '\n';
    print(0, 0, 2 * n);*/

    return 0;
}
