#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <stack>

#define ll long long
#define xyi long long

inline void slave() {
    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> seg(n);
    for (auto &[l, r] : seg) {
        std::cin >> l >> r;
    }
    std::vector<std::set<int>> g(n);
    std::vector<int> prev(n);
    std::stack<int> open;
    std::vector<int> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = i;
        prev[i] = i;
    }
    std::sort(v.begin(), v.end(), [&](int a, int b){
        return seg[a] < seg[b];
    });
    for (auto i : v) {
        while (!open.empty() && seg[open.top()].second < seg[i].first) {
            open.pop();
        }
        if (!open.empty()) {
            g[open.top()].insert(i);
            prev[i] = open.top();
        }
        open.push(i);
    }
    std::set<int> a, b;
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) {
            m++;
        }
        if (g[i].empty() && g[prev[i]].size() != 1) {
            a.insert(i);
        } else {
            b.insert(i);
        }
    }
    std::vector<int> res;
    while (res.size() < m / 2) {
        auto i = *a.begin();
        a.erase(a.begin());
        res.push_back(i);
        g[prev[i]].erase(i);
        if (g[prev[i]].size() == 1) {
            a.erase(*g[prev[i]].begin());
            b.insert(*g[prev[i]].begin());
        }
    }
    while (res.size() < n / 2) {
        res.push_back(*b.begin());
        b.erase(b.begin());
    }
    for (auto &e : res) {
        std::cout << e + 1 << ' ';
    }
    std::cout << '\n';
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t --> 0) {
        slave();
    }
}