#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("O3")
#else
#define _GLIBCXX_DEBUG
#endif
using namespace std;
typedef long long ll;

struct Point {
    ll x, y;
};
ll h, v, k;
vector<ll> pts_x, pts_y;

bool srt_x(Point p1, Point p2) {
    if (p1.x == p2.x) {
        return p1.y < p2.y;
    }
    return p1.x < p2.x;
}

bool srt_y(Point p1, Point p2) {
    if (p1.y == p2.y) {
        return p1.x < p2.x;
    }
    return p1.y < p2.y;
}

pair<ll, ll> inside() {
    return {(pts_x.back() - pts_x[0] + 1) * (pts_y.back() - pts_y[0] + 1), 0};
}

pair<ll, ll> horizontal_cut() {
    ll y_min = pts_y[0], y_max = pts_y.back();
    ll d, u;
    ll ans = 1e18 + 3;
    for (int i = 0; i < k - 1; i++) {
        if (pts_x[i] == pts_x[i + 1]) {
            continue;
        }
        ll calc = (y_max - y_min + 1) * (pts_x[i] + (h - pts_x[i + 1]) + 1);
        if (ans > calc) {
            ans = calc;
            d = pts_x[i];
            u = pts_x[i + 1];
        }
    }
    return {ans, min(d, (h - u + 1))};
}

pair<ll, ll> vertical_cut() {
    ll x_min = pts_x[0], x_max = pts_x.back();
    ll l, r;
    ll ans = 1e18 + 3;
    for (int i = 0; i < k - 1; i++) {
        if (pts_y[i] == pts_y[i + 1]) {
            continue;
        }
        ll calc = (x_max - x_min + 1) * (pts_y[i] + (v - pts_y[i + 1]) + 1);
        if (ans > calc) {
            ans = calc;
            l = pts_y[i + 1];
            r = pts_y[i];
        }
    }
    return {ans, min(r, (v - l + 1))};
}

pair<ll, ll> separated() {
    ll ans = 1e18 + 3;
    ll l, d, u, r;
    for (int i = 0; i < k - 1; i++) {
        for (int j = 0; j < k - 1; j++) {
            if (pts_x[i] == pts_x[i + 1] || pts_y[j] == pts_y[j + 1]) {
                continue;
            }
            ll height = (pts_x[i] + h - pts_x[i + 1]);
            ll width = (pts_y[j] + v - pts_y[j + 1]);
            ll calc = (height + 1) * (width + 1);
            if (ans > calc) {
                ans = calc;
                d = pts_x[i];
                u = pts_x[i + 1];
                l = pts_y[j + 1];
                r = pts_y[j];
            }
        }
    }
    return {ans, min(r, (v - l + 1)) + min(d, (h - u + 1))};
}

void h_1() {
    ll no_cut = pts_y.back() - pts_y[0] + 1;
    ll l, r;
    ll ans = 1e18 + 3;
    for (int i = 0; i < k - 1; i++) {
        if (pts_y[i] == pts_y[i + 1]) {
            continue;
        }
        ll calc = pts_y[i] + ((v - pts_y[i + 1]) + 1);
        if (ans > calc) {
            ans = calc;
            r = pts_y[i];
            l = pts_y[i + 1];
        }
    }
    if (ans >= no_cut) {
        cout << no_cut << " " << 0;
    } else {
        cout << ans << " " << min(r, (v - l + 1));
    }
}

mt19937 rnd(time(0));

void solve() {
    cin >> h >> v >> k;
    pts_x.resize(k);
    pts_y.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> pts_x[i] >> pts_y[i];
    }
    sort(pts_x.begin(), pts_x.end());
    sort(pts_y.begin(), pts_y.end());
    if (h == 1) {
        h_1();
        return;
    }
    vector<pair<ll, ll>> candidate = {inside()};
    if (h > 1) {
        //candidate.push_back(horizontal_cut());
    }
    if (v > 1) {
        //candidate.push_back(vertical_cut());
    }
    if (v > 1 && h > 1) {
        //candidate.push_back(separated());
    }
    sort(candidate.begin(), candidate.end());
    cout << candidate[0].first << " " << candidate[0].second;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}