#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
//#pragma GCC optimize("O3")
#endif

typedef long long ll;

struct Event {
    ll t;
    ll type;//0 - open, 1 - close;
    Event *opposite;
    ll max_set, ind;
    vector<Event *> prevs;
    bool prot;

    Event(ll t, ll type, ll ind) : t(t), type(type), ind(ind) {
        opposite = nullptr;
        max_set = 1;
        prot = false;
    }
};

bool cmp(Event *a, Event *b) {
    if (a->t == b->t) {
        return a->type < b->type;
    }
    return a->t < b->t;
}

void protect(Event *e) {
    e->prot = true;
    if (!e->prevs.empty()) {
        protect(e->prevs[0]);
    }
}

mt19937 rnd(time(0));

void solve() {
    ll n;
    cin >> n;
    vector<Event *> events;
    ll mx = -1000;
    vector<pair<ll, ll>> inp(n);
    for (auto &p: inp) {
        cin >> p.first >> p.second;
    }
    //shuffle(inp.begin(), inp.end(), rnd);
    for (ll i = 0; i < n; i++) {
        ll l = inp[i].first, r = inp[i].second;
        auto *open = new Event(l, 0, i);
        auto *close = new Event(r, 1, i);
        open->opposite = close;
        close->opposite = open;
        events.push_back(open);
        events.push_back(close);
        mx = max(mx, max(l, r));
    }
    sort(events.begin(), events.end(), cmp);
    map<ll, ll> cur_max;
    mx = -1000;
    for (ll i = 0; i < events.size(); i++) {
        Event *e = events[i];
        if (e->type == 0) {
            for (ll j = 0; j < i; j++) {
                Event *prev = events[j];
                if (prev->type == 0) {
                    continue;
                }
                if (e->max_set < prev->max_set + 1) {
                    e->max_set = prev->max_set + 1;
                    e->opposite->max_set = e->max_set;
                    e->prevs.clear();
                }
                if (e->max_set == prev->max_set + 1) {
                    e->prevs.push_back(prev->opposite);
                }
            }
        }
        mx = max(mx, e->max_set);
    }
    if (mx % 2 != 0) {
        cout << 1 / 0;
    }
    vector<vector<Event *>> steps(mx + 1);
    for (auto e: events) {
        if (e->type == 0) {
            steps[e->max_set].push_back(e);
        }
    }
    ll k = 0;
    vector<bool> used(n, true);
    while (steps.size() > mx / 2 + 1) {
        while (!steps.back().empty()) {
            used[steps.back().back()->ind] = false;
            steps.back().pop_back();
            k++;
        }
        steps.pop_back();
    }
    protect(steps.back()[0]);
    while (k < n / 2) {
        while (k < n / 2 && !steps.back().empty()) {
            if (!steps.back().back()->prot) {
                used[steps.back().back()->ind] = false;
                k++;
            }
            steps.back().pop_back();

        }
        steps.pop_back();
    }
    for (ll i = 0; i < n; i++) {
        if (used[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << '\n';
//    for (ll i = 0; i < n; i++) {
//        if (used[i]) {
//            cout << inp[i].first << " " << inp[i].second << '\n';
//        }
//    }
    while (!events.empty()) {
        free(events.back());
        events.pop_back();
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
