#include <bits/stdc++.h>

using namespace std;

#define int long long

const int maxn = 2e5 + 5;
const int logn = 500;
vector<int> g[maxn];
vector<vector<int>> dp(maxn, vector<int>(logn));
vector<int> need(maxn);
vector<int> directions(maxn);

void calc_need(int v, int direction) {
    if (g[v].empty()) {
        return;
    }

    int l = g[v][0];
    int r = g[v][1];
    if (v == 0) {
        need[l] = 0;
        need[r] = 0;
        calc_need(l, 0);
        calc_need(r, 1);
    } else {
        if (direction == 0) {
            need[l] = need[v];
            need[r] = need[v] + 1;
            calc_need(l, 0);
            calc_need(r, 1);
        } else {
            need[l] = need[v] + 1;
            need[r] = need[v];
            calc_need(l, 0);
            calc_need(r, 1);
        }
    }

    directions[l] = 0;
    directions[r] = 1;
}

// 0 - left, 1 - right
void dfs(int v) {
    if (g[v].empty()) {
        for (int i = 0; i < logn; i++) {
            dp[v][i] = 1;
        }
        return;
    }

    int l = g[v][0];
    int r = g[v][1];
    dfs(l);
    dfs(r);

    if(v == 0) {
        for (int i = 0; i < logn; i++) {
            dp[v][i] += dp[l][i];
        }

        for (int i = 0; i < logn; i++) {
            dp[v][i] += dp[r][i];
        }
        return;
    }

    for (int i = 0; i < logn; i++) {
        if(i - (directions[v] != directions[l]) < 0) continue;
        dp[v][i] += dp[l][i - (directions[v] != directions[l])];
    }

    for (int i = 0; i < logn; i++) {
        if(i - (directions[v] != directions[r]) < 0) continue;
        dp[v][i] += dp[r][i - (directions[v] != directions[r])];
    }
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            g[i].push_back(l);
            g[i].push_back(r);
        }
    }

    calc_need(0, 0);
    dfs(0);

    while (q--) {
        int u;
        cin >> u;
        u--;
        if (k - need[u] < 0) {
            cout << 0 << endl;
            continue;
        }
        cout << dp[u][min({logn - 1, k - need[u]})] << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t;
// cin >> t
    t = 1;

    while (t--)
        solve();
}