#include <iostream>
#include <random>
#include <chrono>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
ll INF = 2e18, L_INF = 2e9, mod = 1e9 + 7;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define forall(aa, aaa) for(auto& aa: aaa)

void print(vector<ll> &a) {
    forall(i, a) cout << i << ' ';
    cout << '\n';
}

vector < vector < ll >> g;
vector < ll > sz, a;
vector < ll > dp[2];
vector < bool > used, gt;

void dfs(ll v) {
    used[v] = true;
    dp[0][v] = 0;
    dp[1][v] = a[v];
    forall(i, g[v]) {
        if (used[i]) continue;

        dfs(i);

        dp[0][v] += max(dp[0][i], dp[1][i]);
        dp[1][v] += dp[0][i];
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    g.resize(n);
    a.resize(n);
    used.resize(n, false);
    sz.resize(n, 1);
    dp[0].resize(n, 0);
    dp[1].resize(n, 0);
    for (ll i = 0; i < n - 1; i++) {
        ll s, f;
        cin >> s >> f;
        s--; f--;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    forall(i, a) cin >> i >> i;

    dfs(0);

    ll k = 0;
    for (ll i = 0; i < n; i++) {
        k ^= (x * (i + 1) + y * a[i] % m * a[i] % m) % m;
    }

    vector < ll > v(q);
    forall(i, v) cin >> i;
    forall(i, v) {
        if (i == max(dp[0][0], dp[1][0])) cout << k << ' ';
        else cout << -1 << ' ';
    }
    cout << endl;

    ll c;
    cin >> c;
    while (c) {
        c--;
        if (v[c] == max(dp[0][0], dp[1][0])) {
            for (ll i = 0; i < n; i++) cout << a[i] << ' ';
            cout << endl;
        }
        else {
            cout << -1 << endl;
        }
        cin >> c;
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
