#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937 rnd(666);

struct Event {
    int l, r, id;
};

struct SegTree {
    int n;
    vector<int> tree;

    SegTree() = default;
    SegTree(int n) : n(n), tree(2 * n) {}

    void update(int i, int val) {
        i += n;
        if (tree[i] > val) {
            return;
        }
        tree[i] = val;
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    int get(int l, int r) {
        l += n;
        r += n;
        int ans = 0;
        while (l < r) {
            if (l & 1) {
                ans = max(ans, tree[l++]);
            }
            if (r & 1) {
                ans = max(ans, tree[--r]);
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};



void solve() {
    int n;
    cin >> n;
    vector<Event> a(n), A;
    vector<int> b;
    b.reserve(2 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].l >> a[i].r;
        a[i].id = i;
        b.emplace_back(a[i].l);
        b.emplace_back(a[i].r);
    }
    A = a;
    b.emplace_back(-1);
    sort(all(b));
    b.resize(unique(all(b)) - b.begin());
    for (auto &[l, r, id] : a) {
        l = (int)(lower_bound(all(b), l) - b.begin());
        r = (int)(lower_bound(all(b), r) - b.begin());
    }
    sort(all(a), [](Event lhs, Event rhs) {
        return (lhs.r < rhs.r);
    });

    int m = 0;

    {
        SegTree tr(sz(b));
        for (auto &[l, r, id] : a) {
            int cur = 1 + tr.get(0, l);
            tr.update(r, cur);
        }
        m = tr.get(0, sz(b));
    }

    vector<int> take(n, 0);
    int T = 1;
    vector<int> p(n);
    iota(all(p), 0);
    for (int iter = 0; iter < n * 250; ++iter) {
        shuffle(all(p), rnd);
        for (int i = 0; i < n / 2; ++i) {
            take[p[i]] = T;
        }
        SegTree tr(sz(b));
        for (auto &[l, r, id] : a) {
            if (take[id] != T) {
                continue;
            }
            int cur = 1 + tr.get(0, l);
            tr.update(r, cur);
        }
        if (tr.tree[1] * 2 == m) {
            for (int i = 0; i < n / 2; ++i) {
                cout << p[i] + 1 << ' ';
            }
            cout << en;
            return;
        }
        ++T;
    }
    assert(0);

//    cerr << m << endl;

//    vector<vector<int>> adds(sz(b));
//    vector<vector<int>> dels(sz(b));
//    for (int i = 0; i < n; ++i) {
//        adds[a[i].l].emplace_back(a[i].id);
//        dels[a[i].r].emplace_back(a[i].id);
//    }
//    tree.resize(n);
//    vector<int> in(n);
//    vector<int> out(n);
//    set<pii> cur;
//    for (int t = 1; t < sz(b); ++t) {
//        for (auto i : adds[t]) {
//            cur.emplace(A[i].r - A[i].l, i);
//        }
//        for (auto i : adds[t]) {
//            if (i == *cur.be)
//        }
//    }
}

int main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
