#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

struct seg {
    int l, r;
};

vector<seg> segs;

bool cmp(int i, int j) {
    if (segs[i].r == segs[j].r) {
        return segs[i].l > segs[j].l;
    }
    return segs[i].r < segs[j].r;
}

vector<bool> used;

int calc(vector<int> &order) {
    int m = 0, last = -1;
    for (auto i: order) {
        if (used[i]) continue;
        if (segs[i].l > last) {
            last = segs[i].r;
            m++;
        }
    }
    return m;
}

void solve() {
    segs.clear();
    int n; cin >> n;
    segs.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].l >> segs[i].r;
    }
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }
    sort(all(order), cmp);
    used.assign(n, false);
    int m = calc(order);
    for (int i = 0; i < (1 << n); ++i) {
        int ones = 0;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) % 2) {
                ones++;
                used[j] = false;
            } else {
                used[j] = true;
            }
        }
        if (ones * 2 != n) continue;
        int m1 = calc(order);
        if (m1 * 2 == m) {
            for (int j = 0; j < n; ++j) {
                if ((i >> j) % 2) {
                    cout << j + 1 << " ";
                }
            }
            cout << '\n';
            break;
        }
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}
