#include <iostream>
#include "vector"
#include "algorithm"

#define ll long long
#define all(x) (x).begin(), (x).end()

using namespace std;

vector<vector<int>> g;
vector<ll> a;
vector<pair<ll, ll>> dp;

void dfs(int v, int p = -1) {
    dp[v] = {a[v], 0};
    for (auto u: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v].first += dp[u].second;
        dp[v].second += max(dp[u].first, dp[u].second);
    }
}


void solve() {
    g.clear(); a.clear(); dp.clear();
    int n, q; cin >> n >> q;
    ll x, y, m; cin >> x >> y >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u; cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> a[i];
    }
    dp.resize(n);
    dfs(0);
    ll res = max(dp[0].first, dp[0].second);
    ll hsh = 0;
    for (int i = 0; i < n; ++i) {
        hsh = hsh ^ ((x * (i + 1) + y * a[i] * a[i]) % m);
    }
    vector<bool> psbl;
    while (q--) {
        ll tr; cin >> tr;
        if (tr == res) {
            cout << hsh << ' ';
            psbl.push_back(true);
        } else {
            cout << -1 << ' ';
            psbl.push_back(false);
        }
    }
    cout << endl;
    int ask; cin >> ask;
    while (ask) {
        ask--;
        if (psbl[ask]) {
            for (int i = 0; i < n; ++i) {
                cout << a[i] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> ask;
    }
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}
