#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
#include <iomanip>
#include <random>

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll) a.size()

const ll INF = 1e18;

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector <ll> x(k), y(k);
    for (ll i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--, y[i]--;
    }
    if (k == 1) {
        cout << "1 0";
        return;
    }
    sort(all(x)), sort(all(y));
    x.resize(unique(all(x)) - x.begin());
    y.resize(unique(all(y)) - y.begin());
    ll S = (x.back() - x[0] + 1) * (y.back() - y[0] + 1), C = 0;
    for (ll xd = -n + 1; xd < n; xd++) {
        for (ll yd = -m + 1; yd < m; yd++) {
            ll l = INF, r = -INF, u = -INF, d = INF;
            for (auto& i : x) {
                l = min(l, (i + xd + n) % n);
                r = max(r, (i + xd + n) % n);
            }
            for (auto& i : y) {
                d = min(d, (i + yd + m) % m);
                u = max(u, (i + yd + m) % m);
            }
            if ((r - l + 1) * (u - d + 1) < S) {
                S = (r - l + 1) * (u - d + 1);
                C = abs(xd) + abs(yd);
            } else if ((r - l + 1) * (u - d + 1) == S) {
                C = min(C, abs(xd) + abs(yd));
            }
        }
    }
    cout << S << ' ' << C;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    while (T--) {
        solve();
    }
    return 0;
}
