#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pp;
const ll maxn = 3e5 + 11;
ll dp[maxn];
ll tree[maxn * 4];
ll arr[maxn];
ll prv[maxn];

void build(int v, int l, int r) {
    tree[v] = 0;
    if (l == r) {
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m + 1, r);
}

ll bst(ll a, ll b) {
    if (dp[a] > dp[b])
        return a;
    return b;
}

int get(int v, int l, int r, int lq, int rq) {
    if (l > rq || lq > r) {
        return 0;
    }
    if (lq <= l && r <= rq) {
        return tree[v];
    }
    int m = (l + r) / 2;
    int L = get(v * 2 + 1, l, m, lq, rq);
    int R = get(v * 2 + 2, m + 1, r, lq, rq);
    return bst(L, R);
}


void upd(int v, int l, int r, int id, int val) {
    if (l > id || id > r) {
        return;
    }
    if (l == r && l == id) {
        tree[v] = id;
        return;
    }
    int m = (l + r) / 2;
    upd(v * 2 + 1, l, m, id, val);
    upd(v * 2 + 2, m + 1, r, id, val);
    tree[v] = bst(tree[v * 2 + 1], tree[v * 2 + 2]);
}

void solve() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; i++) {
        cin >> arr[i];

    }
    build(0, 0, n);
    for (int i = 0; i < n; i++) {
        ll id = get(0, 0, n, 0, arr[i]);
        dp[arr[i]] = dp[id] + 1;
        prv[arr[i]] = id;
        upd(0, 0, n, arr[i], dp[arr[i]]);

    }
    ll best_idx = 0;

    for (int i = 1; i <= n; i++) {
        if (dp[i] > dp[best_idx]) {
            best_idx = i;
        }
    }

    vector<ll> ans = {best_idx};
    ll pos = best_idx;
    while (true) {
        best_idx = prv[best_idx];
        if (best_idx == 0) { break; }
        ans.push_back(best_idx);
    }
    vector<bool> used(n + 1);
    for (int el: ans) {
        used[el] = true;
    }
    vector<int> b;
    for (int i = 0; i < n; i++) {
        if (!used[arr[i]]) {
            b.push_back(arr[i]);
        }
    }
    /*for (int el: b) {
        cout << el << ' ';
    }
    cout << '\n';
    for (int el: ans) {
        cout << el << ' ';
    }
    cout << '\n';*/
    vector<int> cb = b;
    sort(cb.begin(), cb.end());
    if (cb == b) {
        if (dp[pos] == n) {
            cout << n << '\n';
        } else {
            cout << dp[pos] + 1 << '\n';
        }
    } else {
        cout << ans.size() + 2 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}