#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

ostream& operator<<(ostream& out, const vector<int>& v) {
	for (int x : v) out << x << " ";
	return out;
}

struct t {

	t() {}
	t(int l, int r, int i) : l(l), r(r), i(i) {}

	int l, r, i;

};

int cnt(vector<pair<int, int>> v) {
	sort(all(v), [](pair<int, int> a, pair<int, int> b) {
		return a.second < b.second;
	});
	int ans = 0, r = -1e9;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first > r) {
			ans++;
			r = v[i].second;
		}
	}
	return ans;
}

vector<vector<int>> grev;
vector<int> deleted, child, ndeleted, nchild;

int dfs(int v) {
	int cnt = 1;
	ndeleted[v] = 1;
	for (int to : grev[v]) {
		if (ndeleted[to]) continue;
		nchild[to]--;
		if (!nchild[to]) cnt += dfs(to);
	}
	return cnt;
}

void solve() {
	int n;
	cin >> n;
	vector<t> V(n);
	for (int i = 0; i < n; i++) {
		cin >> V[i].l >> V[i].r;
		V[i].i = i;
	}
	sort(all(V), [](t a, t b) {
		if (a.r == b.r) {
			return a.l > b.l;
		}
		return a.r < b.r;
	});
//	for (int i = 0; i < n; i++) {
//		cout << V[i].l << " " << V[i].r << " " << V[i].i << "\n";
//	}

	grev.assign(n, vector<int>());
	child.assign(n, 0);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (i == j) continue;
			if (V[j].l == V[i].l && V[j].r == V[i].r && i > j) continue;
			if (V[j].l <= V[i].l && V[i].r <= V[j].r) {
				grev[i].push_back(j);
				child[j]++;
			}
		}
	}

//	for (int i = 0; i < n; i++) cout << i << ": " << grev[i] << "\n";
//	cout << child << "\n";

	int m = count(all(child), 0);

	deleted.assign(n, 0);
	for (int id = 0; id < m / 2; id++) {
		int mn = 1e9, mni = -1;
		for (int i = 0; i < n; i++) {
			if (deleted[i] || child[i]) continue;

			nchild = child;
			ndeleted = deleted;
			int c = dfs(i);
			if (c < mn) {
				mn = c;
				mni = i;
			}
		}

//		cout << "mni = " << mni << "\n";

		assert(mni != -1);

		int v = mni;
		nchild = child;
		ndeleted = deleted;
		dfs(v);
		child = nchild;
		deleted = ndeleted;
	}
//
//	cout << deleted << "\n";
//	cout << child << "\n";

	assert(count(all(deleted), 1) <= n / 2);
	int need = n / 2 - count(all(deleted), 1);
	for (int cc = 0; cc < need; cc++) {
		for (int i = 0; i < n; i++) {
			if (!deleted[i] && child[i] > 0) {
				deleted[i] = 1;
				break;
			}
		}
	}

	{
		int cnt = 0;
		for (int i = 0; i < n; i++) {
			cnt += (!deleted[i] && !child[i]);
		}
		assert(cnt >= m / 2);
	}

	assert(count(all(deleted), 1) == n / 2);
	{
		vector<pair<int, int>> t;
		for (int i = 0; i < n; i++) {
			if (!deleted[i]) t.emplace_back(V[i].l, V[i].r);
		}
		assert(m / 2 == cnt(t));
	}

	for (int i = 0; i < n; i++) {
		if (!deleted[i]) cout << V[i].i + 1 << " ";
	}
	cout << "\n";
}

//1
//6
//0 10
//0 5
//0 4
//0 3
//0 2
//6 10

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int T;
	cin >> T;
	while (T--) solve();

}
