#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

ostream& operator<<(ostream& out, const vector<int>& v) {
	for (int x : v) out << x << " ";
	return out;
}

struct t {

	t() {}
	t(int l, int r, int i) : l(l), r(r), i(i) {}

	int l, r, i;

};

int cnt(vector<pair<int, int>> v) {
	sort(all(v), [](pair<int, int> a, pair<int, int> b) {
		return a.second < b.second;
	});
	int ans = 0, r = -1e9;
	for (int i = 0; i < v.size(); i++) {
		if (v[i].first > r) {
			ans++;
			r = v[i].second;
		}
	}
	return ans;
}

// forest
void solve() {
	int n;
	cin >> n;
	vector<t> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].l >> v[i].r;
		v[i].i = i;
	}
	sort(all(v), [](t a, t b) {
		if (a.r == b.r) {
			return a.l > b.l;
		}
		return a.r < b.r;
	});

	vector<int> parent(n, -1);
	vector<int> child(n);
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[j].l <= v[i].l && v[i].r <= v[j].r) {
				parent[i] = j;
				child[j]++;
				break;
			}
		}
	}

	int m = 0;
	for (int i = 0; i < n; i++) m += !child[i];
	assert(m % 2 == 0);
	{
		vector<pair<int, int>> t(n);
		for (int i = 0; i < n; i++) t[i] = {v[i].l, v[i].r};
		assert(m == cnt(t));
	}

	vector<int> deleted(n);
	for (int id = 0; id < m / 2; id++) {
		int mn = 1e9, mni = -1;
		for (int i = 0; i < n; i++) {
			if (child[i]) continue;
			int cnt = 1, v = i;
			while (parent[v] != -1 && child[parent[v]] == 1) {
				v = parent[v];
				cnt++;
			}
			if (cnt < mn) {
				mn = cnt;
				mni = i;
			}
		}

		assert(mni != -1);

		int v = mni;
		while (child[v] == 0) {
			deleted[v] = 1;
			if (parent[v] == -1) break;
			child[parent[v]]--;
			v = parent[v];
		}
	}

//	assert(count(all(deleted), 1) <= n / 2);
	int need = n / 2 - count(all(deleted), 1);
	for (int cc = 0; cc < need; cc++) {
		for (int i = 0; i < n; i++) {
			if (!deleted[i] && child[i] > 0) {
				deleted[i] = 1;
				break;
			}
		}
	}

	{
		assert(count(all(child), 0) >= m / 2);
	}

	assert(count(all(deleted), 1) == n / 2);
	{
		vector<pair<int, int>> t;
		for (int i = 0; i < n; i++) {
			if (!deleted[i]) t.emplace_back(v[i].l, v[i].r);
		}
//		assert(m / 2 == cnt(t));
	}

	for (int i = 0; i < n; i++) {
		if (!deleted[i]) cout << v[i].i + 1 << " ";
	}
	cout << "\n";
}

//1
//6
//0 10
//0 5
//0 4
//0 3
//0 2
//6 10

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	int T;
	cin >> T;
	while (T--) solve();

}
