#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include <map>

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
ll t, n;

bool cmpSegments(pll &s1, pll &s2) {
    return s1.second < s2.second || (s1.second == s2.second && s1.first < s2.first);
}

int main() {
    cin >> t;
    for (ll tn = 0; tn < t; ++tn) {
        cin >> n;
        vector<pll> segments(n);
        map<pll, ll> numbers;
        for (ll i = 0; i < n; ++i) {
            ll l, r;
            cin >> l >> r;
            segments[i] = {l, r};
            numbers[{l, r}] = i;
        }
        sort(segments.begin(), segments.end(), cmpSegments);
        // ищем наибольшую последовательность
        ll m;
        {
            ll length = 1;
            ll lastCoord = segments[0].second;
            ll p = 1;
            while (p < n) {
                ll l = segments[p].first;
                ll r = segments[p].second;
                if (l > lastCoord) {
                    lastCoord = r;
                    ++length;
                }
                ++p;
            }
            m = length;
        }
        ll a = m / 2;
        vector<pll> potencial_segments;
        for (ll i = n / 2; i < n; ++i) {
            potencial_segments.push_back(segments[i]);
        }
        for (ll i = n / 2; i < n; ++i) {
            segments.pop_back();
        }
        while (true) {
            // ищем наибольшую последовательность
            ll length = 1;
            ll lastCoord = segments[0].second;
            ll p = 1;
            deque<pll> inc;
            while (p < n / 2) {
                ll l = segments[p].first;
                ll r = segments[p].second;
                if (l > lastCoord) {
                    lastCoord = r;
                    ++length;
                    inc.push_back({l, r});
                }
                ++p;
            }
            if (length < a) {
                ll leftLength = a - length;
                p = 0;
                while (p < n / 2) {
                    if (leftLength == 0) break;
                    ll l = potencial_segments[p].first;
                    ll r = potencial_segments[p].second;
                    if (l > lastCoord) {
                        lastCoord = r;
                        --leftLength;
                        segments.push_back({l, r});
                    }
                    ++p;
                }
            } else if (length > a) {
                ll to_remove = length - a;
                for (ll i = 0; i < to_remove; ++i) {
                    segments.erase(std::find(segments.begin(), segments.end(), inc.front()));
                    inc.pop_front();
                }
                p = 0;
                while (p < n / 2) {
                    if (to_remove == 0) break;
                    ll l = potencial_segments[p].first;
                    ll r = potencial_segments[p].second;
                    if (l < lastCoord) {
                        lastCoord = r;
                        --to_remove;
                        segments.push_back({l, r});
                    }
                    ++p;
                }
            } else {
                break;
            }
        }
        for (auto seg: segments) {
            cout << numbers[seg] + 1 << ' ';
        }
        cout << endl;
    }
}