#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

struct cmp {
    bool operator()(const pii& a, const pii& b) const {
        return pii{a.first, -a.second} < pii{b.first, -b.second};
    }
};

int calc(const multiset<pii, cmp>& segs) {
    set<pii> small;
    for (auto [l, r]: segs) {
        while (!small.empty() && r <= small.rbegin()->second) {
            small.erase(*small.rbegin());
        }
        small.emplace(l, r);
    }

    vector<pii> small_segs = {all(small)};
    small_segs.resize(sz(small_segs) / 2);

    int m = 0, r = 0;
    for (auto [cl, cr]: small_segs) {
        if (cl > r) {
            r = cr;
            m += 1;
        }
    }

    return m;
}

void solve() {
    mt19937 rng(42);
    int n;
    cin >> n;

    vector<pii> segs(n);
    multiset<pii, cmp> ssegs;
    rep(i, 0, n) {
        cin >> segs[i].first >> segs[i].second;
        ssegs.insert(segs[i]);
    }

    int m = calc(ssegs);
    vi p(n);
    iota(all(p), 0);
    shuffle(all(p), rng);

    multiset<pii, cmp> cur;
    rep(i, 0, n / 2) {
        cur.insert(segs[p[i]]);
    }

    int ans = abs(m / 2 - calc(cur));
    rep(iter, 0, 10 * n) {
        if (ans == 0) break;
        double t = 1.0 / iter;
        int f = rng() % (n / 2), s = rng() % (n / 2);

        cur.erase(cur.find(segs[p[f]]));
        cur.insert(segs[p[s + n / 2]]);

        int val = abs(m / 2 - calc(cur));
        if (val < ans || (1.0 * rng() / rng.max()) < exp((ans - val) / t)) {
            ans = val;
            swap(p[f], p[s + n / 2]);
        } else {
            cur.insert(segs[p[f]]);
            cur.erase(cur.find(segs[p[s + n / 2]]));
        }
    }
//    cerr << ans << '\n';
    rep(i, 0, n / 2) {
        cout << p[i] + 1 << ' ';
    }
    cout << '\n';
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}