#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
using ll = long long;

struct Node {
	Node* left = nullptr, * right = nullptr, *parent;
	ll l, r;
	int x;//first empty cell
	Node(ll l1, ll r1, Node* par) {
		l = l1;
		r = r1;
		x = l1;
		parent = par;
	}
	void check() {
		if (r - l != 1 and left == nullptr) {
			left = new Node(l, (l + r) / 2, this);
			right = new Node((l + r) / 2, r, this);
		}
	}
	void upd() {
		if (r - l == 1) return;
		x = min(left->x, right->x);
	}
	Node* to_leaf(int k) {
		if (r - l == 1) return this;
		check();
		if (k < left->r) return left->to_leaf(k);
		else return right->to_leaf(k);
	}
	int next(int k) {
		//cout << k << "__" << l << " " << r << " " << x << "\n";
		if (r - l == 1) return x;
		check();
		if (k >= right->l) return right->next(k);
		return min(left->next(k), right->x);
	}
};

Node* root;
void assign(int k) {
	Node* leaf = root->to_leaf(k);
	leaf->x = 1e9;
	while (leaf != nullptr) {
		leaf->upd();
		leaf = leaf->parent;
	}
}

void encode(vector<int>& from, set<int>& to, int n) {
	root = new Node(0, (1 << 30), nullptr);
	int k = from.size();
	for (int i = 0; i < k; ++i) assign(from[i]);
	for (int i = k - 1; i >= 0; --i) {
		int nxt = root->next(from[i]);
		if (nxt == n) nxt = root->next(0);
		//cout << nxt << "_\n";
		to.insert(nxt);
		assign(nxt);
	}
}
void decode(vector<int>& from, set<int>& to, int n) {
	root = new Node(0, (1 << 30), nullptr);
	int k = from.size();
	for (int i = 0; i < k; ++i) assign(n - 1 - from[i]);
	for (int i = 0; i < k; ++i) {
		int nxt = root->next(n - 1 - from[i]);
		if (nxt == n) nxt = root->next(0);
		//cout << nxt << "_\n";
		to.insert(n - 1 - nxt);
		assign(nxt);
	}
}

int main() {

	int a;
	cin >> a;
	int m, n, k;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		cin >> n >> k;
		vector<int> nums(k);
		for (int i = 0; i < k; ++i) {
			cin >> nums[i];
			--nums[i];
		}
		set<int> res;
		if (a == 1) encode(nums, res, n);
		else decode(nums, res, n);
		for (int el : res) cout << el + 1 << " ";
		cout << "\n";
	}
	cout << endl;

	return 0;
}