#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <random>
#include <ctime>
using namespace std;
using Seg = pair<int, int>;
using ll = long long;

void logvec(vector<int> a, string s) {
	for (int el : a) cout << el << s;
	cout << "\n";
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(nullptr));

	int n, Q;
	cin >> n >> Q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) cin >> w[i];
	sort(w.begin(), w.end());

	ll mex = 1;
	for (int i = 0; i < n; ++i) {
		if (w[i] > mex) break;
		mex += w[i];
	}

	vector<ll> prefsum(n + 1, 0);
	for (int i = 0; i < n; ++i) prefsum[i + 1] = prefsum[i] + w[i];

	ll z;
	cin >> z;
	ll k, a, b,
		j, c, d;
	ll sum = 0;
	for (int q = 1; q <= Q; ++q) {
		cin >> j >> c >> d;
		k = j - z * sum;
		a = c - z * sum;
		b = d - z * sum;

		int index = upper_bound(w.begin(), w.end(), k) - w.begin();

		if (a >= mex or a > prefsum[index]) {
			cout << "No\n";
		}
		else {
			cout << "Yes\n";
			sum += q;
		}
	}

	return 0;
}