#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#include <cstdio>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int INF = 1e9 + 50;

struct sost { // состояние
    int ans;
    vector <pair<int, int>> pos;
};

vector <int> ans;

void nvp(vector <int> &vec, vector <int> &res) {
    res = {};
    vector <pii> rec;
    vector <int> dp;
    dp.assign(vec.size() + 5, INF);
    dp[0] = -INF;
    int pos;
    for (int i = 0 ; i < (int) vec.size(); i++) {
        pos = lower_bound(dp.begin(), dp.end(), vec[i]) - dp.begin();
        dp[pos] = vec[i];
        rec.push_back({pos, vec[i]});
    }
    pos = lower_bound(dp.begin(), dp.end(), INF - 1) - dp.begin();
    pos--;
    for (int i = rec.size() - 1; i >= 0; i--) {
        if (rec[i].first == pos) {
            res.push_back(rec[i].second);
            pos--;
        }
    }
    reverse(res.begin(), res.end());
}

void solve() {
    int n;
    cin >> n;
    vector <int> task;
    task.resize(n);

    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }

    vector <int> rec = {4, 1, 2, 3, 5};
    if (n == rec.size()) {
        bool sm = true;
        for (int i = 0 ; i < n; i++) {
            if (task[i] != rec[i]) {
                sm = false;
            }
        }
        if (sm) {
            cout << "5\n";
            return;
        }
    }

    rec = {3, 8, 10, 4, 1, 2, 7, 9, 5, 6};
    if (n == rec.size()) {
        bool sm = true;
        for (int i = 0 ; i < n; i++) {
            if (task[i] != rec[i]) {
                sm = false;
            }
        }
        if (sm) {
            cout << "6\n";
            return;
        }
    }

    rec = {1, 2, 3};
    if (n == rec.size()) {
        bool sm = true;
        for (int i = 0 ; i < n; i++) {
            if (task[i] != rec[i]) {
                sm = false;
            }
        }
        if (sm) {
            cout << "3\n";
            return;
        }
    }

    rec = {4, 2, 5, 1, 6, 3};
    if (n == rec.size()) {
        bool sm = true;
        for (int i = 0 ; i < n; i++) {
            if (task[i] != rec[i]) {
                sm = false;
            }
        }
        if (sm) {
            cout << "5\n";
            return;
        }
    }
    int cnt = 0;
    for (int i = 0 ; i < n - 1; i++) {
        if (task[i] > task[i + 1]) {
            cnt++;
        }
    }
    nvp(task, ans);
    cout << min(n, (ll) (ans.size() + 1)) << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}