#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#include <cstdio>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int INF = 1e9 + 50;

vector <int> v1, v2;

int check() {
    vector <int> dp1, dp2;
    dp1.assign(20, INF);
    dp1[0] = -INF;
    int pos;
    for (int i = 0; i < v1.size(); i++) {
        pos = lower_bound(dp1.begin(), dp1.end(), v1[i]) - dp1.begin();
        dp1[pos] = v1[i];
    }
    dp2.assign(20, INF);
    dp2[0] = -INF;
    reverse(v2.begin(), v2.end());
    for (int i = 0; i < v2.size(); i++) {
        pos = lower_bound(dp2.begin(), dp2.end(), v2[i]) - dp2.begin();
        dp2[pos] = v2[i];
    }
    pos = lower_bound(dp1.begin(), dp1.end(), INF - 1) - dp1.begin() + lower_bound(dp2.begin(), dp2.end(), INF - 1) - dp2.begin();
    return pos - 2;
}

void solve() {
    int n;
    cin >> n;
    vector <int> task;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    int ans = 0;
    for (int key = 0; key < (1 << n); key++) {
        v1 = {};
        v2 = {};
        for (int i = 0 ; i < n; i++) {
            if ((key & (1 << i)) == 0) {
                v1.push_back(task[i]);
            } else {
                v2.push_back(task[i]);
            }
        }
        if (v1.size() >= 0 && v2.size() >= 0) {
            ans = max(ans, check());
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
} 