#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <string>
#include <random>
#include <chrono>
#include <cstdio>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int INF = 1e9 + 50;

vector <int> v1, v2;

int nvp_sz(vector <int> &vec) {
    vector <pii> dp; // {sz, last}
    dp.resize(vec.size());
    dp[0] = {1, vec[0]};
    for (int i = 1 ; i < (int) vec.size(); i++) {
        dp[i] = {1, vec[i]};
        for (int j = 0 ; j < i; j++) {
            if (vec[i] > dp[j].second) {
                if (dp[i].first < dp[j].first + 1) {
                    dp[i] = {dp[j].first + 1, vec[i]};
                } else if (dp[i].first == dp[j].first + 1) {
                    dp[i].second = min(dp[i].second, vec[i]);
                }
            } else {
                if (dp[i].first < dp[j].first) {
                    dp[i] = {dp[j].first, vec[i]};
                } else if (dp[i].first == dp[j].first) {
                    dp[i].second = min(dp[i].second, vec[i]);
                }
            }
        }
    }
    return dp[dp.size() - 1].first;
}

int check() {
    // vector <int> dp1, dp2;
    // dp1.assign(20, INF);
    // dp1[0] = -INF;
    // int pos;
    // for (int i = 0; i < (int) v1.size(); i++) {
    //     pos = upper_bound(dp1.begin(), dp1.end(), v1[i]) - dp1.begin();
    //     dp1[pos] = v1[i];
    // }
    // dp2.assign(20, INF);
    // dp2[0] = -INF;
    // reverse(v2.begin(), v2.end());
    // for (int i = 0; i < (int) v2.size(); i++) {
    //     pos = upper_bound(dp2.begin(), dp2.end(), v2[i]) - dp2.begin();
    //     dp2[pos] = v2[i];
    // }
    // pos = upper_bound(dp1.begin(), dp1.end(), INF - 1) - dp1.begin() + upper_bound(dp2.begin(), dp2.end(), INF - 1) - dp2.begin();
    // return pos - 2;
    reverse(v2.begin(), v2.end());
    return nvp_sz(v1) + nvp_sz(v2);
}

void solve() {
    int n;
    cin >> n;
    vector <int> task;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    int ans = 2;
    for (int key = 0; key < (1 << n); key++) {
        v1 = {};
        v2 = {};
        for (int i = 0 ; i < n; i++) {
            if ((key & (1 << i)) == 0) {
                v1.push_back(task[i]);
            } else {
                v2.push_back(task[i]);
            }
        }
        if (v1.size() > 0 && v2.size() > 0) {
            ans = max(ans, check());
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
} 