#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <unordered_map>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

vector <vector <int>> g;
vector <int> dp0;
vector <int> dp1;
// vector <int> res0;
// vector <int> res1;
vector <pii> task;
int x, y, m;
vector <bool> used;

void dfs(int v, int p) {
    for (int n: g[v]) {
        if (n != p) {
            dfs(n, v);
            dp0[v] += max(dp0[n], dp1[n]);
            dp1[v] += dp0[n];
        }
    }
    dp1[v] += task[v].second;
}

void upd(int v, int p, int t) {
    if (t == 1) {
        used[v] = true;
        for (int n: g[v]) {
            if (n != p) {
                upd(n, v, 0);
            }
        }
    } else {
        for (int n: g[v]) {
            if (n != p) {
                if (dp0[n] > dp1[n]) {
                    upd(n, v, 0);
                } else {
                    upd(n, v, 1);
                }
            }
        }
    }
}

vector <int> v1, v2;

// int find(int val) {
//     int l = -1, r = v1.size();
//     int m;
//     while (l + 1 < r) {
//         m = (l + r) >> 1;
//         if (v1[m] <= val) {
//             l = m;
//         } else {
//             r = m;
//         }
//     }
//     if (l == -1) {
//         return ((val * val) % m);
//     }
//    val -= v1[l];
//    return ((v2[l] + val * val) % m);
// }

void solve() {
    int n, q;
    cin >> n >> q;
    dp0.assign(n, 0);
    used.assign(n, false);
    dp1.assign(n, 0);
    // res0.assign(n, 0);
    // res1.assign(n, 0);
    cin >> x >> y >> m;
    g.assign(n, {});
    int t1, t2;
    for (int i = 1; i < n; i++) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g[t1].push_back(t2);
        g[t2].push_back(t1);
    }
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i].first >> task[i].second;
    }
    vector <int> ask;
    ask.resize(q);
    for (int i = 0 ; i < q; i++) {
        cin >> ask[i];
    }
    dfs(0, -1);
    int sert = 0;
    for (int i = 0 ; i < n; i++) {
        // int val = y * task[i].first;
        // val %= m;
        // val *= task[i].first;
        // val %= m;
        int val = x * (i + 1);
        val %= m;
        sert ^= val;
    }
    if (dp0[0] > dp1[0]) {
        upd(0, -1, 0);
    } else {
        upd(0, -1, 1);
    }
    int base = 0LL;
    for (int i = 0 ; i < n; i++) {
        base ^= ((x * (i + 1)) % m);
    }
    v1 = {};
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            if (v1.size() == 0) {
                v1.push_back(base ^ ((x * (i + 1)) % m));
                v1.back() ^= ((x * (i + 1) + y) % m);
            } else {
                v1.push_back(v1.back() ^ ((x * (i + 1)) % m));
                v1.back() ^= ((x * (i + 1) + y) % m);
            }
        }
    }
    for (int i = 0 ; i < q; i++) {
        if (ask[i] == 0) {
            cout << base << " ";
        } else
        if (ask[i] <= v1.size()) {
            cout << v1[ask[i] - 1] % m << " ";
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    int t;
    while (true) {
        cin >> t;
        if(t == 0) {
            return;
        }
        t--;
        if (ask[t] <= v1.size()) {
            int left = ask[t];
            for (int i = 0 ; i < n; i++) {
                if (used[i] && left > 0) {
                    left--;
                    cout << "1 ";
                } else {
                    cout << "0 ";
                }
            }
        } else {
            cout << "-1";
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}