#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define re return
#define ll long long
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

template<class T> istream& operator>>(istream& u, vector<T>& v) { for (auto& i : v) u >> i; re u; }
template<class T, class U> istream& operator>>(istream& u, pair<T, U>& v) { re u >> v.first >> v.second; }

struct info {
	ll l, r, i;
};

void solve1(ll n, ll m, vector<info>& v) {
	fori(n / 2) cout << i + 1 << " ";
	cout << endl;
}

vector<info> tv;
bool ok = false;
void rec(ll pos, ll m, ll mx, ll st, vector<info>& v) {
	if (st == 0) {
		ll q = 0;
		ll prev = -1e9;
		fori(tv.size()) {
			if (tv[i].l > prev) {
				prev = tv[i].r;
				q++;
			}
		}

		if (q * 2 == m) {
			fori(tv.size()) {
				cout << tv[i].i + 1 << " ";
			}
			cout << "\n";
			ok = true;
		}

		re;
	}

	tv.push_back(v[pos]);
	rec(pos + 1, m, mx, st - 1, v);
	tv.pop_back();

	if (st == mx - pos || ok) re;

	rec(pos + 1, m, mx, st, v);
}

void solve2(ll n, ll m, vector<info>& v) {
	ok = false;
	rec(0, m, n, n / 2, v);
}

struct dsu {
	vector<int> v;
	vector<int> cnt;

	void build(int n) {
		v.resize(n);
		fori(n)
			v[i] = i;
		cnt.resize(n, 1);
	}

	int get_par(int i) {
		if (i != v[i])v[i] = get_par(v[i]);
		re v[i];
	}

	int get_cnt(int i) {
		re cnt[get_par(i)];
	}

	void merge(int i1, int i2) {
		int p1 = get_par(i1),
			p2 = get_par(i2);

		if (rand() % 2)swap(p1, p2);

		v[p1] = p2;
		cnt[p2] += cnt[p1];
	}

	void minus(int i) {
		cnt[get_par(i)]--;
	}
};

void dfs2(int i, int j, vector<vector<ll>>& v, dsu& d) {
	if (v[i].size() == 0)d.merge(i, j);
	else dfs2(v[i][0], j, v, d);
}

bool dfs(int i, ll c, vector<vector<ll>>& v, vector<pair<ll, ll>>& ans, dsu& d) {
	if (v[i].size() == 0) {
		ans.push_back({ c, i });
		re true;
	}

	if (v[i].size() == 1)re dfs(v[i][0], c + 1, v, ans, d);

	ll cnt = 0;
	for (auto j : v[i]) {
		cnt += dfs(j, 1, v, ans, d);
	}

	int j = v[i][0];
	while (v[j].size() > 0) {
		j = v[j][0];
	}

	if (cnt == v[i].size()) {
		for (int a = 1; a < v[i].size(); a++) {
			dfs2(v[i][a], j, v, d);
		}
	}

	re false;
}

void dfs3(int i, vector<vector<ll>>& v, vector<vector<ll>>& rv, vector<ll>& del) {
	if (rv[i].size() > 1)re;
	del.push_back(i);
	dfs3(v[i][0], v, rv, del);
}

void dfs4(int i, ll& s, vector<vector<ll>>& v, vector<bool>& del) {
	if (s == 0)re;
	ll cnt = 0;

	for (auto j : v[i])
		cnt += del[j];

	if (cnt == 0)re;

	s--;
	del[i] = 1;
	for (auto j : v[i]) {
		if (!del[j])dfs4(j, s, v, del);
	}
}

void solve3(ll n, ll m, vector<info>& v) {
	vector<vector<ll>> way(n);
	vector<vector<ll>> rway(n);
	vector<info> t;

	fori(n) {
		while (t.size() > 0 && v[i].l <= t.back().l) {
			way[v[i].i].push_back(t.back().i);
			rway[t.back().i].push_back(v[i].i);
			t.pop_back();
		}

		t.push_back(v[i]);
	}

	vector<pair<ll, ll>> ans;
	dsu d;
	d.build(n);

	fori(t.size())
		dfs(t[i].i, 0, way, ans, d);

	sort(rall(ans));

	vector<ll> del;


	ll de = m / 2;
	while (de) {
		if (d.get_cnt(ans.back().second) > 1) {
			d.minus(ans.back().second);
			de--;
			dfs3(ans.back().second, rway, way, del);
		}
			ans.pop_back();
	}

	vector<bool> deleted(n);
	fori(del.size())
		deleted[del[i]] = 1;

	ll st = (n / 2) - del.size();
	
	fori(t.size())
		dfs4(t[i].i, st, way, deleted);

	fori(n)
		if (!deleted[i]) cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<info> v(n);
		fori(n) {
			cin >> v[i].l >> v[i].r;
			v[i].i = i;
		}

		sort(all(v), [](info& a, info& b) {
			if(a.r != b.r) re a.r < b.r;
			re a.l > b.l;
		});

		ll m = 0;
		ll prev = -1e9;
		fori(n) {
			if (v[i].l > prev) {
				prev = v[i].r;
				m++;
			}
		}

		if (m == n)solve1(n, m, v);
		else if (n <= 30)solve2(n, m, v);
		else solve3(n, m, v);
	}
}