#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;
mt19937 rd(time(0));

int get_best(vector<pair<int, int>>& vec, vector<bool>& used) {
	int n = vec.size();
	int cnt = 0, lst = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i])
			continue;
		if (vec[i].first > lst) {
			lst = vec[i].second;
			cnt++;
		}
	}
	return cnt;
}

struct seg {
	int l, r, ind;
	seg(int l1 = 0, int r1 = 01, int ind1 = -1) : l(l1), r(r1), ind(ind1) {}
};

bool cmp(seg a, seg b) {
	return a.r < b.r;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	for (int q = 0; q < t; q++) {
		int n;
		cin >> n;
		vector<seg> vec(n, seg());
		for (int i = 0; i < n; i++) {
			cin >> vec[i].l >> vec[i].r;
			vec[i].ind = i;
		}
		sort(vec.begin(), vec.end(), cmp);
		vector<pair<int, int>> ind(n);
		vector<pair<int, int>> mas(n);
		vector<bool> used(n, 1);
		for (int i = 0; i < n; i++) {
			ind[i] = { i, vec[i].ind };
			mas[i] = { vec[i].l, vec[i].r };
		}
		int m = get_best(mas, used);
		bool tf = 1;
		while (tf) {
			shuffle(ind.begin(), ind.end(), rd);
			for (int i = 0; i < n; i++)
				used[i] = 0;
			for (int i = 0; i < n / 2; i++)
				used[ind[i].first] = 1;
			if (get_best(mas, used) == m / 2)
				tf = 0;
		}

		for (int i = 0; i < n / 2; i++)
			cout << ind[i].second + 1 << ' ';
		cout << endl;
	}
}
