#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <random>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;
const int SZ = 3e5;
mt19937 rd(100232103);

int get_best(vector<pair<int, int>>& vec, vector<bool>& used) {
	int n = vec.size();
	int cnt = 0, lst = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i])
			continue;
		if (vec[i].first > lst) {
			lst = vec[i].second;
			cnt++;
		}
	}
	return cnt;
}

struct seg {
	int l, r, ind;
	seg(int l1 = 0, int r1 = 01, int ind1 = -1) : l(l1), r(r1), ind(ind1) {}
};

bool cmp(seg a, seg b) {
	return a.r < b.r;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, q;
	cin >> n >> q;
	vector<ll> w(n + 1, 0);
	for (int i = 1; i <= n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());

	ll max_ab = 300 + 1;
	/*vector<vector<ll>> dp(n, vector<ll>(max_ab, -1));
	dp[0][0] = 0;
	for (int i = 1; i <= n; i++) {
		for (int a = 0; a < max_ab; a++) {
			dp[i][a] = dp[i - 1][a];
			if (a >= w[i])
				dp[i][a] = max(dp[i][a], dp[i - 1][a - w[i]]);

			ll best = -1;
			for (ll b = 0; b <= max_ab; b++) {
				if (dp[i][b] < a && b >= w[i] && dp[i][b - w[i]] < a)
					break;
				best = b;
			}
			dp[i][a] = max(dp[i][a], best);
		}
	}*/

	vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(max_ab, vector<bool> (max_ab, 0)));
	//vector<int> ans(n + 1, -1);
	vector<vector<vector<bool>>> ans(n + 1, vector<vector<bool>>(max_ab, vector<bool>(max_ab, 0)));
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		for (ll a = 0; a < max_ab; a++) {
			for (ll b = 0; b < max_ab; b++) {
				dp[i][a][b] = dp[i - 1][a][b];
				if (a >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a - w[i]][b];
				if (b >= w[i])
					dp[i][a][b] = dp[i][a][b] | dp[i - 1][a][b - w[i]];
			}
		}
	}

	/*for (int i = 1; i <= n; i++) {
		ans[i] = ans[i - 1];
		while (ans[i] + 1 < max_ab && dp[i][ans[i] + 1])
			ans[i]++;
	}*/
	for (int i = 1; i <= n; i++) {
		ans[i][0][0] = 1;
		for (int j = 1; j < max_ab; j++) {
			ans[i][0][j] = ans[i][0][j - 1] & dp[i][j][0];
			ans[i][j][0] = ans[i][j - 1][0] & dp[i][j][0];
		}
		for (int a = 1; a < max_ab; a++) {
			for (int b = 1; b < max_ab; b++)
				ans[i][a][b] = dp[i][a][b] & ans[i][a - 1][b] & ans[i][a][b - 1];
		}
	}

	ll z, v = 0;
	cin >> z;
	for (int i = 0; i < q; i++) {
		ll j, k, a, b, c, d;
		cin >> j >> c >> d;
		k = j - v * z;
		a = c - v * z;
		b = d - v * z;

		int l = 0, r = n + 1;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (w[mid] <= k) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		if (ans[l][a][b]) {
			v++;
			cout << "Yes" << endl;
		}
		else {
			cout << "No" << endl;
		}
	}
}
