#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cmath>

using namespace std;

typedef pair<int, int> pii;

#define X first
#define Y second

const int INF = 1e9 + 179;

signed main()
{
	int h, w, k;
	cin >> h >> w >> k;
	vector<pii> pts(k);
	for (int i = 0; i < k; i++) {
		cin >> pts[i].X >> pts[i].Y;
		pts[i].X--;
		pts[i].Y--;
	}
	int min_dx = INF, opt_x = 0;
	for (int dx = -h; dx <= h; dx++) {
		int cur = 0;
		int min_x = h + 1, max_x = -1;
		for (pii& p : pts) {
			min_x = min(min_x, (p.X + dx + h) % h);
			max_x = max(max_x, (p.X + dx + h) % h);
		}
		int d = max_x - min_x;
		if (min_dx > d || (min_dx == d && abs(opt_x) > abs(dx))) {
			min_dx = d;
			opt_x = dx;
		}
	}

	int min_dy = INF, opt_y = 0;
	for (int dy = -w; dy <= w; dy++) {
		int cur = 0;
		int min_y = w + 1, max_y = -1;
		for (pii& p : pts) {
			min_y = min(min_y, (p.Y + dy + w) % w);
			max_y = max(max_y, (p.Y + dy + w) % w);
		}
		int d = max_y - min_y;
		if (min_dy > d || (min_dy == d && abs(opt_y) > abs(dy))) {
			min_dy = d;
			opt_y = dy;
		}
	}
	cout << 1ll * (min_dx + 1) * (min_dy + 1) << ' ' << abs(opt_x) + abs(opt_y) << '\n';
}