#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <string>
#include <cmath>
#include <set>
#include <cassert>

using namespace std;

typedef pair<int, int> pii;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()

const int INF = 1e9;

void meq(int& var, int val) {
	var = max(var, val);
}

void solve() {
	int n;
	cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i];
		p[i]--;
	}
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n, vector<int>(n, -INF)));
	dp[0][0][n - 1] = 0;
	for (int i = 1; i <= n; i++) {
		int val = p[i-1];
		for (int x = 0; x < n; x++) {
			for (int y = 0; y < n; y++) {
				meq(dp[i][max(x, val)][y], dp[i - 1][x][y] + (val >= x));
				meq(dp[i][x][min(y, val)], dp[i - 1][x][y] + (val <= y));
			}
		}
	}
	int ans = 0;
	for (int x = 0; x < n; x++) {
		for (int y = 0; y < n; y++) {
			meq(ans, dp[n][x][y]);
		}
	}
	cout << ans << '\n';
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}