#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <numeric>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;

#define All(x) (x).begin(), (x).end()
#define X first
#define Y second

vector<vector<ll>> gr, dp;
vector<ll> l, r;

void dfs(ll v, ll p = -1) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (ll u : gr[v]) {
		if (u == p) continue;
		dfs(u, v);
		dp[v][0] += max(dp[u][0], dp[u][1]);
		dp[v][1] += dp[u][0];
	}
}

//vector<ll> ans;
//
//void restore(ll v, ll st, ll p = -1) {
//	if (st == 0 || (st == 1 && dp[v][0] > dp[v][1])) {
//		for (ll u : gr[v]) {
//			if (u == p) continue;
//			restore(u, 1, v);
//		}
//	}
//	else {
//		ans.push_back(v);
//		for (ll u : gr[v]) {
//			if (u == p) continue;
//			restore(u, 0, v);
//		}
//	}
//}

ll mod;

ll mul(ll a, ll b) {
	return (1ll * a * b) % mod;
}

void solve() {
	ll n, q, v, u;
	cin >> n >> q;
	ll x, y;
	cin >> x >> y >> mod;
	
	gr.resize(n);
	l.resize(n);
	r.resize(n);
	dp.assign(n, vector<ll>(2));
	
	for (ll i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--, u--;
		gr[v].push_back(u);
		gr[u].push_back(v);
	}
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	dfs(0);
	ll opt = max(dp[0][0], dp[0][1]);
	//restore(0, 1, -1);
	vector<ll> plans;
	while (q--) {
		ll val;
		cin >> val;
		plans.push_back(val);
		if (val != opt)
			cout << -1 << endl;
		else {
			ll hash = 0;
			for (ll j = 0; j < n; j++) {
				hash ^= ((mul(x, j + 1) + mul(y, mul(r[j], r[j]))) % mod);
			}
			cout << hash << endl;
		}
	}
	cout << endl;
	while (1) {
		ll i;
		cin >> i;
		i--;
		if (i == -1) return;
		if (plans[i] == opt) {
			for (ll v = 0; v < n; v++)
				cout << r[v] << ' ';
			cout << endl;
		}
		else
			cout << -1 << endl;
	}
	cout << endl;
}

void init() {
	gr.clear();
	//ans.clear();
	dp.clear();
	l.clear();
	r.clear();
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);

	ll t;
	cin >> t;
	while (t--) {
		init();
		solve();
	}
}