#include <bits/stdc++.h>
#define int long long
using namespace std;

array<int, 2> dp_on_graph(const vector<int> &a, const vector<vector<int>> &g, int u = 0, int p = -1) {
    array<int, 2> cur = {0, a[u]};
    for (int v : g[u]) {
        if (v != p) {
            auto res = dp_on_graph(a, g, v, u);
            cur[0] += max(res[0], res[1]);
            cur[1] += res[0];
        }
    }
    return cur;
}

int cerf(const vector<int> &a, const int &x, const int &y, const int &m) {
    int n = (int)a.size();
    int res = 0;
    for (int i = 0; i < n; i++) {
        res ^= (x * (i + 1) + y * a[i] % m * a[i]) % m;
    }
    return res;
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n);
    vector<int> r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    map<int, vector<int>> saved;
    for (int mask = 0; mask < (1 << n); mask++) {
        vector<int> a(n);
        for (int i = 0; i < n; i++) {
            if (mask & (1 << i)) {
                a[i] = r[i];
            } else {
                a[i] = l[i];
            }
        }
        auto res = dp_on_graph(a, g);
        int val = max(res[0], res[1]);
        saved[val] = a;
    }
    vector<int> u(q);
    for (int i = 0; i < q; i++) {
        cin >> u[i];
        if (saved.count(u[i])) {
            cout << cerf(saved[u[i]], x, y, m);
        } else {
            cout << -1;
        }
        cout << " \n"[i == q - 1];
    }
    cout.flush();
    int i;
    while (true) {
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (saved.count(u[i])) {
            const auto &ans = saved[u[i]];
            for (int j = 0; j < n; j++) {
                cout << ans[j] << " \n"[i == n - 1];
            }
            cout.flush();
        } else {
            cout << -1 << endl;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}