#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

using std::cin;
using std::cout;
using std::vector;
using std::string;
using ll = long long;
using ld  = long double;
using pl = std::pair<ll, ll>;
using sl = std::pair<ll, vector<pl>>;
#define all(x) x.begin(),x.end()

vector<ll> vozr(vector<ll>& vc)
{
	if (vc.size() == 0)return {};
	ll n = vc.size();
	vector<ll> dp(n, 1), p(n, -1);
	for (ll i = 0; i < n; ++i)
	{
		for (ll j = 0; j < i; ++j)
		{
			if (vc[i] < vc[j])continue;
			if (dp[i] < dp[j] + 1)
			{
				dp[i] = dp[j] + 1;
				p[i] = j;
			}
		}
	}

	vector<ll> ans;
	ll ps = 0;
	for (ll i = 0; i < dp.size(); ++i)
	{
		if (dp[i] > dp[ps])ps = i;
	}

	while (ps != -1)
	{
		ans.push_back(ps);
		ps = p[ps];
	}
	std::reverse(all(ans));
	return ans;
}

vector<ll> ub(vector<ll>& vc)
{
	if (vc.size() == 0)return {};
	ll n = vc.size();
	vector<ll> dp(n, 1), p(n, -1);
	for (ll i = 0; i < n; ++i)
	{
		for (ll j = 0; j < i; ++j)
		{
			if (vc[i] > vc[j])continue;
			if (dp[i] < dp[j] + 1)
			{
				dp[i] = dp[j] + 1;
				p[i] = j;
			}
		}
	}

	vector<ll> ans;
	ll ps = 0;
	for (ll i = 0; i < dp.size(); ++i)
	{
		if (dp[i] > dp[ps])ps = i;
	}

	while (ps != -1)
	{
		ans.push_back(ps);
		ps = p[ps];
	}
	std::reverse(all(ans));
	return ans;
}

void solve()
{
	ll n; cin >> n;
	vector<ll> vc(n); for (ll& i : vc)cin >> i;
	
	vector<ll> a = vozr(vc);
	ll t = 0;
	vector<ll> nv;
	for (ll i = 0; i < n; ++i)
	{
		if (t < a.size() && a[t] == i)
		{
			++t;
			continue;
		}
		nv.push_back(vc[i]);
	}

	ll s1 = a.size() + ub(nv).size();

	a = ub(vc);
	t = 0;
	nv.clear();
	for (ll i = 0; i < n; ++i)
	{
		if (t < a.size() && a[t] == i)
		{
			++t;
			continue;
		}
		nv.push_back(vc[i]);
	}

	ll s2 = a.size() + vozr(nv).size();

	cout << '\t';
	cout << std::max(s1, s2);
	cout << '\n';
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--)
	{
		solve();
	}

}