#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <string>
#include <tuple>
#include <random>
#include <set>

using ll = int;
using ld = long double;
using std::cin;
using std::cout;
using std::vector;
using std::string;
#define all(x) x.begin(),x.end()

struct pl
{
	ll l, r, id;
};

vector<ll> sz(vector<pl>& vc)
{
	vector<ll> dp(vc.size(), 1);
	vector<ll> pmx(vc.size());
	vector<ll> pr(vc.size(), -1);
	for (ll i = 0; i < vc.size(); ++i)pmx[i] = i;

	for (ll i = 1; i < dp.size(); ++i)
	{
		ll l = 0;
		ll r = i;
		while (r - l > 1)
		{
			ll m = (l + r) >> 1;
			if (vc[m].r < vc[i].l)l = m;
			else r = m;
		}
		if (vc[l].r >= vc[i].l)
		{
			pmx[i] = pmx[i - 1];
			continue;
		}
		dp[i] = dp[pmx[l]] + 1;
		pr[i] = pmx[l];
		if (dp[i] < dp[pmx[i - 1]])
		{
			pmx[i] = pmx[i - 1];
		}
	}

	vector<ll> ans;
	ll t = pmx.back();
	while (t != -1)
	{
		ans.push_back(t);
		t = pr[t];
	}
	std::reverse(all(ans));
	return ans;
}

std::mt19937 mt;
void solve()
{
	ll n; cin >> n;
	vector<pl> vc;
	vc.assign(n, {});
	for (ll i = 0; i < n; ++i)
	{
		cin >> vc[i].l >> vc[i].r;
		vc[i].id = i;
	}

	std::sort(all(vc), [](pl a, pl b) {return std::tie(a.r, a.l) < std::tie(b.r, b.l); });
	vector<ll> r = sz(vc);

	ll m = r.size();

	for (ll t = mt() % (1 << m);; t = mt() % (1 << m))
	{
		std::set<ll> st;
		ll lmn = 1e18, rmx = -1e18;
		for (ll i = 0; i < m; ++i)
		{
			if (t & (1 << i))
			{
				st.insert(r[i]);
				rmx = std::max(rmx, vc[r[i]].r);
				lmn = std::min(lmn, vc[r[i]].l);
			}
		}

		vector<ll> bd(n);
		ll c = 0;
		for (ll i = 0; i < n; ++i)
		{
			if (st.count(i))continue;
			if (vc[i].l > rmx || vc[i].r < lmn)
			{
				++c;
				bd[i] = 1;
			}
		}

		if (c <= n / 2)
		{
			c = n / 2;
			for (ll i = 0; i < n; ++i)
			{
				if (bd[i] == 0 || st.count(i))continue;
				cout << vc[i].id + 1 << ' ';
				--c;
			}
			for (ll i = 0; i < n && c; ++i)
			{
				if (bd[i] || st.count(i))continue;
				cout << vc[i].id + 1 << ' ';
				--c;
			}
			return;
		}
	}
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll t; cin >> t;
	while (t--)
	{
		solve();
		cout << '\n';
	}
}