#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAl
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void solve1() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		--a[i];
	}
	if (k == 1) {
		a[0] = (a[0] + 1) % n;
	} else if (k == 2) {
		if (a[1] - a[0] == 1 || a[1] - a[0] == n - 1) {
			a[0] = (a[0] + 2) % n;
			a[1] = (a[1] + 2) % n;
		} else {
			a[0] = (a[0] + 1) % n;
			a[1] = (a[1] + 1) % n;
		}
	} else if (k * 2 == n) {
		vector<int> used(n, 0);
		for (const int &x : a) {
			used[x] = 1;
		}
		a.clear();
		for (int i = 0; i < n; ++i) {
			if (used[i] == 0) {
				a.push_back(i);
			}
		}
	} else {
		vector<int> xs = a;
		set<int> q;
		for (int i = 0; i < k; ++i) {
			int x;
			cin >> x;
			--x;
			xs.push_back(x);
			q.insert(x);
		}
		sort(xs.begin(), xs.end());
		a.clear();
		for (int x : xs) {
			while (q.find(x) != q.end()) {
				x = (x + 1) % n;
			}
			q.insert(x);
			a.push_back(x);
		}
	}
	sort(a.begin(), a.end());
	for (const int &x : a) {
		cout << x + 1 << " ";
	}
	cout << endl;
}

void solve2() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i];
		--a[i];
	}
	if (k == 1) {
		a[0] = (a[0] - 1 + n) % n;
	} else if (k == 2) {
		if (a[1] - a[0] == 1 || a[1] - a[0] == n - 1) {
			a[0] = (a[0] - 2 + n) % n;
			a[1] = (a[1] - 2 + n) % n;
		} else {
			a[0] = (a[0] - 1 + n) % n;
			a[1] = (a[1] - 1 + n) % n;
		}
	} else if (k * 2 == n) {
		vector<int> used(n, 0);
		for (const int &x : a) {
			used[x] = 1;
		}
		a.clear();
		for (int i = 0; i < n; ++i) {
			if (used[i] == 0) {
				a.push_back(i);
			}
		}
	} else {
		vector<int> xs = a;
		set<int> q;
		for (int i = 0; i < k; ++i) {
			int x;
			cin >> x;
			--x;
			xs.push_back(x);
			q.insert(x);
		}
		sort(xs.begin(), xs.end());
		a.clear();
		for (int x : xs) {
			while (q.find(x) != q.end()) {
				x = (x - 1) % n;
			}
			q.insert(x);
			a.push_back(x);
		}
	}
	sort(a.begin(), a.end());
	for (const int &x : a) {
		cout << x + 1 << " ";
	}
	cout << endl;
}

void solve() {
	int t, T;
	cin >> t >> T;
	while (T--) {
		if (t == 1) {
			solve1();
		} else {
			solve2();
		}
	}
}

int32_t main() {
	int T = 1;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
