#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <cassert>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

int mod;

vector<pair<int, int>> g;
vector<int> dp;

int calc(int mask) {
	if (dp[mask] == -2) {
		dp[mask] = g[mask].first;
	}
	if (dp[mask] == -1) {
		dp[mask] = -2;
		dp[mask] = calc(g[mask].second);
	}
	return dp[mask];
}

void solve() {
	int k, n, p;
	cin >> k >> n >> p;
	k = (1 << k);
	g.assign(1 << k, make_pair(-1, -1));
	for (int mask = 1; mask < (1 << k); ++mask) {
		if (bit_i(mask, 0) == 0) {
			continue;
		}
		int cnt = 0;
		for (int i = 0; i < k; ++i) {
			cnt += bit_i(mask, i);
		}
		if (cnt != n) {
			continue;
		}
		int mex = 0;
		for (int i = 0; i < k; ++i) {
			if (bit_i(mask, i) == 0) {
				mex = i;
				break;
			}
		}
		if (mex == 0) {
			cout << -1 << endl;
			exit(0);
		}
		g[mask] = make_pair(mex, 0);
		for (int i = 0; i < k; ++i) {
			if (bit_i(mask, i) == 1) {
				g[mask].second |= (1 << (i ^ (mex - 1)));
			}
		}
	}
	dp.assign((int) g.size(), -1);
	int ans = 0;
	for (int mask = 1; mask < (1 << k); ++mask) {
		if (calc(mask) == p) {
			++ans;
		}
	}
	cout << ans % mod << endl;
}

int32_t main() {
	cin >> mod;
	int T = 1;
	cin >> T;
#ifdef LOCAL
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
