#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>
#include <bitset>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	{
		int z;
		cin >> z;
		assert(z == 0);
	}
	const int N = 5000;
	bitset<N + 1> dp[N + 1];
	dp[0][0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = N; j >= 0; --j) {
			dp[j] |= (dp[j] << a[i]);
			if (j >= a[i]) {
				dp[j] |= dp[j - a[i]];
			}
		}
	}
	bitset<N + 1> dp2[N + 1];
	for (int i = 0; i <= N; ++i) {
		for (int j = 0; j <= N; ++j) {
			dp2[i][j] = dp[i][j];
			if (i && !dp2[i - 1][j]) {
				dp2[i][j] = 0;
			}
			if (j && !dp2[i][j - 1]) {
				dp2[i][j] = 0;
			}
		}
	}
	for (int i = 0; i < m; ++i) {
		int k, x, y;
		cin >> k >> x >> y;
		assert(x <= N);
		assert(y <= N);
		if (dp2[x][y]) {
			cout << "Yes" << endl;
		} else {
			cout << "No" << endl;
		}
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
