#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <iomanip>
#include <fstream>

using namespace std;

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

#ifdef LOCAL
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int bit_i(int n, int i) {
	return (n >> i) & 1;
}

vector<vector<int>> g;
vector<int> l, r;
vector<vector<int>> dp1;
vector<vector<int>> dp2;
vector<int> ans;

void dfs(int u, int p) {
	dp1[u][0] = l[u];
	dp1[u][1] = 0;
	dp2[u][0] = r[u];
	dp2[u][1] = 0;
	for (const int &v : g[u]) {
		if (v != p) {
			dfs(v, u);
			dp1[u][0] += dp1[v][1];
			dp1[u][1] += max(dp1[v][0], dp1[v][1]);
			dp2[u][0] += dp2[v][1];
			dp2[u][1] += max(dp2[v][0], dp2[v][1]);
		}
	}
}

void dfs2(int u, int p, int fl, int sum) {
	if (fl == 0) {
		for (int i = l[u]; i <= r[u]; ++i) {
			int L = 0, R = 0;
			for (const int &v : g[u]) {
				if (v != p) {
					L += dp1[v][1];
					R += dp2[v][1];
				}
			}
			if (L <= sum - i && sum - i <= R) {
				ans[u] = i;
				int lsum = sum - i;
				for (const int &v : g[u]) {
					if (v != p) {
						L -= dp1[v][1];
						R -= dp2[v][1];
						for (int j = dp1[v][1]; j <= dp2[v][1]; ++j) {
							if (L <= lsum - j && lsum - j <= R) {
								lsum -= j;
								dfs2(v, u, 1, j);
								break;
							}
						}
					}
				}
				return;
			}
		}
	}
	for (int i = l[u]; i <= r[u]; ++i) {
		int L = 0, R = 0;
		for (const int &v : g[u]) {
			if (v != p) {
				L += min(dp1[v][0], dp1[v][1]);
				R += max(dp2[v][0], dp2[v][1]);
			}
		}
		if (L <= sum && sum <= R) {
			ans[u] = i;
			int lsum = sum;
			for (const int &v : g[u]) {
				if (v != p) {
					L -= min(dp1[v][0], dp1[v][1]);
					R -= max(dp2[v][0], dp2[v][1]);
					for (int j = min(dp1[v][0], dp1[v][1]); j <= max(dp2[v][0], dp2[v][1]); ++j) {
						if (L <= lsum - j && lsum - j <= R) {
							lsum -= j;
							dfs2(v, u, 0, j);
						}
					}
				}
			}
			return;
		}
	}
	assert(0);
}

void solve() {
	g.clear();
	int n, m, x, y, mod;
	cin >> n >> m >> x >> y >> mod;
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u;
		--v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	l.resize(n);
	r.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	dp1.assign(n, vector<int>(2));
	dp2.assign(n, vector<int>(2));
	dfs(0, -1);
	vector<int> qs(m);
	ans.resize(n);
	for (int i = 0; i < m; ++i) {
		cin >> qs[i];
		if (max(dp1[0][0], dp1[0][1]) <= qs[i] && qs[i] <= max(dp2[0][0], dp2[0][1])) {
			dfs2(0, -1, 0, qs[i]);
			int sum = 0;
			for (int j = 0; j < n; ++j) {
				sum ^= (x * (j + 1) + y * ans[j] % mod * ans[j]) % mod;
			}
			cout << sum << " ";
		} else {
			cout << -1 << " ";
		}
	}
	cout << endl << flush;
	while (1) {
		int i;
		cin >> i;
		--i;
		if (i == -1) {
			break;
		}
		if (max(dp1[0][0], dp1[0][1]) <= qs[i] && qs[i] <= max(dp2[0][0], dp2[0][1])) {
			dfs2(0, -1, 0, qs[i]);
			for (int j = 0; j < n; ++j) {
				cout << ans[j] << " ";
			}
			cout << endl << flush;
		} else {
			cout << -1 << endl << flush;
		}
	}
}

int32_t main() {
	int T = 1;
	cin >> T;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
	return 0;
}
