#include <bits/stdc++.h>
using namespace std;
const int maxSets = 12870, maxSz = 16;
int mod, p;
int sets[maxSets][maxSz], mex[maxSets], nxt[maxSets], setsSz;
int curSet[maxSz], curSz;
int tmpSet[maxSz];

void rec(int n, int lim) {
    if (curSz == n) {
        for (int i = 0; i < n; ++i) {
            sets[setsSz][i] = curSet[i];
        }
        ++setsSz;
        return;
    }
    for (int j = curSet[curSz - 1] + 1; j < lim; ++j) {
        curSet[curSz] = j;
        ++curSz;
        rec(n, lim);
        --curSz;
    }
}

struct DSU {
    int n;
    vector<int> par, sz, start;
    // vector<char> isGood;
    DSU() {}
    DSU(int _n) {
        n = _n;
        par.resize(n);
        sz.resize(n);
        start.resize(n);
        // isGood.resize(n, false);
        for (int i = 0; i < n; ++i) {
            par[i] = i;
            sz[i] = 1;
            start[i] = -1;
        }
    }
    int getParent(int v) {
        if (par[v] != v) {
            par[v] = getParent(par[v]);
        }
        return par[v];
    }
    void uniteSets(int v, int u) {
        int oldV = v;
        v = getParent(v), u = getParent(u);
        if (v == u) {
            /*bool able = true;
            do {
                if (mex[u] != p) {
                    able = false;
                    break;
                }
                u = nxt[u];
            } while (u != v);
            isGood[v] = able;*/
            start[v] = oldV;
            return;
        }
        if (sz[v] < sz[u]) { swap(v, u); }
        sz[v] += sz[u];
        par[u] = v;
        assert(start[v] == -1 || start[u] == -1);
        if (start[u] != -1) {
            start[v] = start[u];
        }
        // isGood[v] = isGood[v] || isGood[u];
    }
    ~DSU() {}
};

void solve() {
    int k, n;
    cin >> k >> n >> p;
    setsSz = 0;
    curSet[0] = 0, curSz = 1;
    rec(n, 1 << k);
    /*for (int i = 0; i < setsSz; ++i) {
        cerr << "i: " << i << ", :";
        for (int j = 0; j < n; ++j) {
            cerr << sets[i][j] << ' ';
        }
        cerr << '\n';
    }*/
    for (int i = 0; i < setsSz; ++i) {
        mex[i] = 1;
        while (mex[i] < n && sets[i][mex[i]] == mex[i]) {
            ++mex[i];
        }
        // cerr << "i: " << i << ", mex: " << mex[i] << '\n';
        for (int j = 0; j < n; ++j) {
            tmpSet[j] = sets[i][j] ^ (mex[i] - 1);
        }
        sort(tmpSet, tmpSet + n);
        /*for (int j = 0; j < n; ++j) {
            cerr << tmpSet[j] << ' ';
        }
        cerr << '\n';*/
        int l = -1, r = setsSz - 1;
        // in r we have first set >= tmpSet
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            bool isLess = false;
            for (int j = 0; j < n; ++j) {
                if (sets[m][j] == tmpSet[j]) { continue; }
                if (sets[m][j] < tmpSet[j]) {
                    // cerr << "m: " << m << ", j: " << j << '\n';
                    isLess = true;
                }
                break;
            }
            if (isLess) {
                l = m;
            } else {
                r = m;
            }
        }
        /*for (int j = 0; j < n; ++j) {
            assert(tmpSet[j] == sets[r][j]);
        }*/
        nxt[i] = r;
        // cerr << "i: " << i << ", nxt: " << nxt[i] << ", mex: " << mex[i] << '\n';
    }
    DSU dsu(setsSz);
    for (int i = 0; i < setsSz; ++i) {
        dsu.uniteSets(i, nxt[i]);
    }
    int ans = 0;
    for (int i = 0; i < setsSz; ++i) {
        if (dsu.getParent(i) == i) {
            // cerr << "cycle: " << '\n';
            int v = dsu.start[i], u = v;
            bool isGood = true;
            do {
                // cerr << u << ' ';
                if (mex[u] != p) {
                    isGood = false;
                    break;
                }
                u = nxt[u];
            } while (u != v);
            if (isGood) {
                // cerr << "sz: " << dsu.sz[i] << '\n';
                ans += dsu.sz[i];
            }
            // cerr << '\n';
        }
    }
    cout << ans % mod << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> mod;
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
        cerr << "---\n";
    }
#else
    cin >> mod;
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
