#include <bits/stdc++.h>
using namespace std;

struct Seg {
    int l, r, idx;
    Seg() {}
    Seg(int _l, int _r, int _idx) {
        l = _l, r = _r, idx = _idx;
    }
    ~Seg() {}
};

bool cmpL(const Seg& A, const Seg& B) {
    return A.l < B.l;
}

bool cmpR(const Seg& A, const Seg& B) {
    return A.r < B.r;
}

void solve() {
    int n;
    cin >> n;
    vector<Seg> segs(n);
    vector<int> byL(n), byR(n);
    vector<char> vis(n);
    for (int i = 0; i < n; ++i) {
        cin >> segs[i].l >> segs[i].r;
        segs[i].idx = i;
        byL[i] = segs[i].l;
        byR[i] = segs[i].r;
    }
    sort(byL.begin(), byL.end());
    sort(byR.begin(), byR.end());
    vector<int> dp(n + 1), par(n + 1);
    vector<pair<int, int>> mx(n + 1);
    // dpRight
    dp.assign(n + 1, 0);
    par.assign(n + 1, -1);
    mx.assign(n + 1, {-1, -1});
    sort(segs.begin(), segs.end(), cmpR);
    mx[0] = {0, 0};
    // dp, idx in dp
    for (int i = 0; i < n; ++i) {
        int l = -1, r = i;
        // l is rightmost with .r < segs[i].l
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (segs[m].r < segs[i].l) {
                l = m;
            } else {
                r = m;
            }
        }
        dp[i + 1] = mx[l + 1].first + 1;
        par[i + 1] = mx[l + 1].second;
        mx[i + 1] = max(mx[i], make_pair(dp[i + 1], i + 1));
    }
    cerr << "!\n";
    int sz = mx[n].first;
    vis.assign(n, false);
    for (int i = 0; i < n; ++i) {
        int ptr = upper_bound(byL.begin(), byL.end(), segs[i].l) - byL.begin();
        ptr = n - ptr;
        if (2 * dp[i + 1] == sz && 2 * ptr <= n) {
            vector<int> ans;
            for (int j = i + 1; j > 0; j = par[j]) {
                vis[segs[j - 1].idx] = true;
                ans.emplace_back(segs[j - 1].idx);
            }
            for (int j = 0; j < n && (int)ans.size() * 2 < n; ++j) {
                if (!vis[segs[j].idx] && segs[j].l <= segs[i].l) {
                    ans.emplace_back(segs[j].idx);
                }
            }
            for (const int& idx : ans) {
                cout << idx + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
    // dpLeft
    dp.assign(n + 1, 0);
    par.assign(n + 1, n);
    mx.assign(n + 1, {-1, n});
    sort(segs.begin(), segs.end(), cmpL);
    mx[n] = {0, n};
    // dp, idx in dp
    for (int i = n - 1; i >= 0; --i) {
        int l = i, r = n;
        // r is leftmost with .l > segs[i].r
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (segs[m].l > segs[i].r) {
                r = m;
            } else {
                l = m;
            }
        }
        dp[i] = mx[r].first + 1;
        par[i] = mx[r].second;
        mx[i] = max(mx[i + 1], make_pair(dp[i], i));
    }
    sz = mx[0].first;
    for (int i = n - 1; i >= 0; --i) {
        int ptr = lower_bound(byR.begin(), byR.end(), segs[i].r) - byR.begin();
        if (2 * dp[i] == sz && 2 * ptr <= n) {
            // found
            vector<int> ans;
            for (int j = i; j < n; j = par[j]) {
                vis[segs[j].idx] = true;
                ans.emplace_back(segs[j].idx);
            }
            for (int j = 0; j < n; ++j) {
                if (!vis[segs[j].idx] && segs[j].r >= segs[i].r) {
                    ans.emplace_back(segs[j].idx);
                }
            }
            for (const int& idx : ans) {
                cout << idx + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
    assert(false);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
