#include <bits/stdc++.h>
using namespace std;

struct Query {
    long long k, a, b;
    int idx;
    Query() {}
    Query(long long _k, long long _a, long long _b, int _idx) {
        k = _k, a = _a, b = _b, idx = _idx;
    }
    bool operator<(const Query& other) const {
        return k < other.k;
    }
    ~Query() {}
};
const int maxw = 301;
bool dp[maxw][maxw];
int fen[maxw + 1][maxw + 1];

void add(int x, int y) {
    for (int i = x; i <= maxw; i += (i & -i)) {
        for (int j = y; j <= maxw; j += (j & -j)) {
            ++fen[i][j];
        }
    }
}

int getPref(int x, int y) {
    int res = 0;
    for (int i = x; i > 0; i -= (i & -i)) {
        for (int j = y; j > 0; j -= (j & -j)) {
            res += fen[i][j];
        }
    }
    return res;
}

void solve() {
    int n, qNum;
    cin >> n >> qNum;
    vector<long long> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    int useless;
    cin >> useless;
    vector<Query> q(qNum);
    for (int i = 0; i < qNum; ++i) {
        cin >> q[i].k >> q[i].a >> q[i].b;
        q[i].idx = i;
    }
    sort(q.begin(), q.end());
    vector<char> ans(qNum, false);
    if (n <= 10 && qNum <= 10) {
        vector<vector<long long>> able;
        vector<long long> tmp(3);
        for (int mask1 = 0; mask1 < (1 << n); ++mask1) {
            long long x = 0, kx = 0;
            for (int i = 0; i < n; ++i) {
                if ((mask1 & (1 << i)) != 0) {
                    x += w[i];
                    kx = max(kx, w[i]);
                }
            }
            for (int mask2 = 0; mask2 < (1 << n); ++mask2) {
                if (mask1 & mask2) { continue; }
                long long y = 0, ky = 0;
                for (int i = 0; i < n; ++i) {
                    if ((mask2 & (1 << i)) != 0) {
                        y += w[i];
                        ky = max(ky, w[i]);
                    }
                }
                tmp[0] = x, tmp[1] = y, tmp[2] = max(kx, ky);
                able.emplace_back(tmp);
            }
        }
        sort(able.begin(), able.end());
        vector<vector<long long>> rest;
        for (int i = 0; i < (int)able.size(); ++i) {
            if (rest.empty() || rest.back()[0] != able[i][0] || rest.back()[1] != able[i][1]) {
                rest.emplace_back(able[i]);
            }
        }
        for (const auto& [k, a, b, idx] : q) {
            long long need = (a + 1) * (b + 1);
            // cerr << "k: " << k << ", a: " << a << ", b: " << b << ", need: " << need << '\n';
            for (int i = 0; i < (int)rest.size(); ++i) {
                if (rest[i][0] <= a && rest[i][1] <= b && rest[i][2] <= k) {
                    --need;
                }
            }
            if (need == 0) {
                ans[idx] = true;
            }
        }
    } else {
        int last = 0;
        for (int x = 0; x < maxw; ++x) {
            for (int y = 0; y < maxw; ++y) {
                dp[x][y] = 0;
            }
        }
        dp[0][0] = 1;
        add(1, 1);
        vector<pair<int, int>> tmp;
        for (const auto& [k, a, b, idx] : q) {
            // int cnt = 0;
            while (last < n && w[last] <= k) {
                // upd
                // cerr << "last: " << last << '\n';
                for (int x = 0; x < maxw; ++x) {
                    for (int y = 0; y < maxw; ++y) {
                        if (!dp[x][y]) { continue; }
                        if (x + w[last] < maxw && !dp[x + w[last]][y]) {
                            tmp.emplace_back(x + w[last], y);
                        }
                        if (y + w[last] < maxw && !dp[x][y + w[last]]) {
                            tmp.emplace_back(x, y + w[last]);
                        }
                    }
                }
                while (!tmp.empty()) {
                    /*if (tmp.back().first <= 15 && tmp.back().second <= 3) {
                        ++cnt;
                    }*/
                    // cerr << "x: " << tmp.back().first << ", y: " << tmp.back().second << '\n';
                    dp[tmp.back().first][tmp.back().second] = true;
                    add(tmp.back().first + 1, tmp.back().second + 1);
                    tmp.pop_back();
                }
                ++last;
            }
            int have = getPref(a + 1, b + 1);
            // cerr << "k: " << k << ", a: " << a << ", b: " << b << ", have: " << have << '\n';
            // cerr << "cnt: " << cnt << '\n';
            if (have == (a + 1) * (b + 1)) {
                ans[idx] = true;
            }
        }
    }
    for (int i = 0; i < qNum; ++i) {
        if (ans[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
