#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

const int N = 1 << 12;
struct segtree{
#define left 2 * i + 1, l, (r + l) / 2
#define right 2 * i + 2, (r + l) / 2, r
    int seg[2 * N - 1], add[2 * N - 1];

    void push(int i, int l, int r){
        if (add[i]){
            seg[i] = -inf;
            if (r - l > 1) add[2 * i + 1] = add[2 * i + 2] = 1;
            add[i] = 0;
        }
    }

    int getseg(int L, int R, int i, int l, int r){
        push(i, l, r);
        if (L <= l && r <= R) return seg[i];
        if (L >= r || l >= R) return -inf;
        return max(getseg(L, R, left), getseg(L, R, right));
    }

    void clear(int L, int R, int i, int l, int r){
        if (L <= l && r <= R){
            add[i] = 1;
            push(i, l, r);
            return;
        }
        push(i, l, r);
        if (L >= r || l >= R) return;
        clear(L, R, left), clear(L, R, right);
        seg[i] = max(seg[2 * i + 1], seg[2 * i + 2]);
    }

    void upd(int I, int x, int i, int l, int r){
        push(i, l, r);
        if (I < l || I >= r) return;
        if (r - l == 1) {
            seg[i] = x;
            return;
        }
        upd(I, x, left), upd(I, x, right);
        seg[i] = max(seg[2 * i + 1], seg[2 * i + 2]);
    }
};

void upd(int &i, int j){
    if (j > i) i = j;
}

segtree hor[N], ver[N];
int p[N];

void clearsquare(int lx, int rx, int ly, int ry){
    for (int i = lx; i <= rx; i++) hor[i].clear(ly, ry + 1, 0, 0, N);
    for (int i = ly; i <= ry; i++) ver[i].clear(lx, rx + 1, 0, 0, N);
}

int gethor(int x, int ly, int ry){
    return hor[x].getseg(ly, ry + 1, 0, 0, N);
}

int getver(int lx, int rx, int y){
    return ver[y].getseg(lx, rx + 1, 0, 0, N);
}

int upd(int x, int y, int k){
    hor[x].upd(y, k, 0, 0, N);
    ver[y].upd(x, k, 0, 0, N);
}

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> p[i], p[i]--;
    for (int i = 0; i < n; i++) hor[i].clear(0, N, 0, 0, N), ver[i].clear(0, N, 0, 0, N);
    int mxi = p[0], mni = p[0], cmx = 1, cmn = 1;
    for (int i = 1; i < n; i++){
        int x = p[i];
        for (int mn = 0; mn < n; mn++){
            upd(mn, x, getver(0, x - 1, mn));
        }
        for (int mx = 0; mx < n; mx++){
            upd(x, mx, gethor(mx, x + 1, n - 1));
        }
        clearsquare(x + 1, n - 1, 0, x - 1);
        upd(mni, x, cmn + 1);
        upd(x, mxi, cmx + 1);
        if (x > mxi) mxi = x, cmx++;
        if (x < mni) mni = x, cmn++;
    }
    int ans = -1;
    for (int i = 0; i < n; i++) upd(ans, gethor(i, 0, n - 1));
    cout << ans << endl;
}

int32_t main(){
#ifdef LOCAL
    auto start = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - start) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}