#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

ll n, k, q;
vector<vector<ll>> G;
vector <ll> L, R, Ans;
vector<bool> used;

void solve() {
	ll to;
	cin >> to; to--;
	cout << Ans[to] << "\n";
}

const ll LEFT = 1, RIGHT = 2, EMPTY = 0;

void dfs(ll v, ll last_type, ll can) {
	used[v] = true;
	if (L[v] == -1) {
		Ans[v] += 1;
	}
	if (L[v] != -1) {
		if (last_type != RIGHT) {
			dfs(L[v], LEFT, can);
		}
		else if (can > 0) {
			dfs(L[v], LEFT, can - 1);
		}
		Ans[v] += Ans[L[v]];
	}
	if (R[v] != -1) {
		if (last_type != LEFT) {
			dfs(R[v], RIGHT, can);
		}
		else if (can > 0) {
			dfs(R[v], RIGHT, can - 1);
		}
		Ans[v] += Ans[R[v]];
	}
}

int main() {
	cin >> n >> k >> q;
	G.assign(n, {});
	L.assign(n, -1);
	R.assign(n, -1);
	Ans.assign(n, 0);
	used.assign(n, false);
	ll u, v, ttt;
	for (ll i = 0; i < n; i++) {
		cin >> ttt;
		if (ttt == 2) {
			cin >> L[i] >> R[i];
			L[i]--; R[i]--;
		}
	}
	dfs(0, EMPTY, k);
	while (q--) {
		solve();
	}
}