#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

struct Seg {
	ll l, r, ind;
};

bool operator<(Seg a, Seg b) {
	if (a.r != b.r)
		return a.r < b.r;
	return a.l < b.l;
}

void solve() {
	ll n, m;
	cin >> n;
	vector<Seg> segs(n);
	for (ll i = 0; i < n; i++) {
		cin >> segs[i].l >> segs[i].r;
		segs[i].ind = i;
	}
	sort(segs.begin(), segs.end());
	vector<ll> dp(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		ll l = -1, r = n, mid, ind;
		while (l + 1 < r) {
			mid = (l + r) / 2;
			if (segs[mid].r < segs[i].l) { // отрезок хороший, можно брать
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ind = l;
		dp[i + 1] = max(dp[i], dp[ind + 1] + 1);
	}
	m = dp[n];
	if (m == n) {
		for (ll i = 0; i < n / 2; i++) {
			cout << i + 1 << "\n";
		}
	}
	else {
		assert(0);
	}
}

int main() {
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}