#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <random>
#include <ctime>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

struct Q {
	ll k, a, b, ind;
};

bool cmp(Q a, Q b) {
	return a.k < b.k;
}

const ll MAXN = 301;

void solve() {
	ll n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (ll& elem : w) {
		cin >> elem;
	}
	sort(w.begin(), w.end());
	ll z, j, c, d, k, a, b;
	cin >> z;
	ll v = 0; // cnt k идеальных пар
	vector<Q> Rs;
	for (ll i = 0; i < q; i++) {
		cin >> j >> c >> d;
		k = j - v * z;
		a = c - v * z;
		b = d - v * z;
		Rs.push_back({ k, a, b, i });
	}
	sort(Rs.begin(), Rs.end(), cmp);
	ll ind = 0;
	vector<vector<bool>> Can(MAXN, vector<bool>(MAXN, false));
	vector<vector<bool>> Good(MAXN, vector<bool>(MAXN, false));
	vector<bool> ans(q, false);
	Can[0][0] = true;
	Good[0][0] = true;
	bool New, last = false;
	for (ll i = 0; i < q; i++) {
		New = false;
		while (ind < n && w[ind] <= Rs[i].k) { // пока есть яблоки, которые можно использовать
			New = true;
			for (ll i2 = MAXN - 1; i2 >= 0; i2--) {
				for (ll j2 = MAXN - 1; j2 >= 0; j2--) {
					if (Can[i2][j2] && j2 + w[ind] < MAXN) {
						Can[i2][j2 + w[ind]] = true;
					}
					if (Can[i2][j2] && i2 + w[ind] < MAXN) {
						Can[i2 + w[ind]][j2] = true;
					}
				}
			}
			ind++;
		}
		bool good = true;
		if (New) {
			for (ll i2 = 0; i2 <= Rs[i].a; i2++) {
				for (ll j2 = 0; j2 <= Rs[i].b; j2++) {
					if ((i2 == 0 || Good[i2 - 1][j2]) && (j2 == 0 || Good[i2][j2 - 1]) && Can[i2][j2]) {
						Good[i2][j2] = true;
					}
				}
			}
		}
		else {
			good = last;
		}
		ans[Rs[i].ind] = Good[Rs[i].a][Rs[i].b];
		last = good;
	}
	for (ll i = 0; i < q; i++) {
		if (ans[i]) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}