#include <bits/stdc++.h>

using namespace std;

#define int long long

/* consts */
const int inf = 1LL << 60;
const int mod = 100000007;

random_device rd;

/* output */
template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1,T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T& x : a) s << x << " ";
    s << endl;
    return s;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& s, map<T1,T2>& m) {
    for (auto [k, v] : m) {
        s << k << " -> " << m << endl;
    }
    return s;
}

/* do */
struct node {
    int x = 0;
    int delta = 0;
};

void update(vector<node>& tree, int i, int l, int r) {
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    tree[i].x = tree[i1].x + tree[i2].x;
}

void build_tree(vector<node>& tree, vector<int>& a, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x = a[l];
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    build_tree(tree, a, i1, l, m);
    build_tree(tree, a, i2, m, r);
    update(tree, i, l, r);
}

void build_tree(vector<node>& tree, vector<int>& a) {
    build_tree(tree, a, 0, 0, a.size());
}

int get(vector<node>& tree, int i_c, int i, int l, int r) {
    if (r - l == 1) return tree[i].x + tree[i].delta;
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        return tree[i].delta + get(tree, i_c, i1, l, m);
    else
        return tree[i].delta + get(tree, i_c, i2, m, r);
}

int get(vector<node>& tree, int i_c, int n) {
    return get(tree, i_c, 0, 0, n);
}

int get_i(vector<node>& tree, int l_c, int r_c, int i, int l, int r, int delta) {
    delta += tree[i].delta;
    if (l_c >= r || r_c <= l) return 0;
    if (l >= l_c && r <= r_c) {
        return delta * (r - l) + tree[i].x;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    return get_i(tree, l_c, r_c, i1, l, m, delta) + get_i(tree, l_c, r_c, i2, m, r, delta);
}

int get_i(vector<node>& tree, int l_c, int r_c, int n) {
    return get_i(tree, l_c, r_c, 0, 0, n, 0);
}

void inc(vector<node>& tree, int i_c, int x, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        inc(tree, i_c, x, i1, l, m);
    else
        inc(tree, i_c, x, i2, m, r);
    update(tree, i, l, r);
}

void inc(vector<node>& tree, int i_c, int x, int n) {
    inc(tree, i_c, x, 0, 0, n);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int i, int l, int r) {
    cout << "inc_i " << l_c << " " << r_c << " " << i << " " << l << " " << r << endl;
    if (l_c >= r || r_c <= l) return;
    if (l >= l_c && r <= r_c) {
        tree[i].delta += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    inc_i(tree, l_c, r_c, x, i1, l, m);
    inc_i(tree, l_c, r_c, x, i2, m, r);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int n) {
    inc_i(tree, l_c, r_c, x, 0, 0, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; i++) cin >> a[i];

        int ans = 0;
        for (int i = 1; i < (1 << n) - 1; i++) {
            int min_a = inf, max_a = -inf, cur = 0;
            for (int j = 0; j < n; j++) {
                if (i & (1 << j)) {
                    if (a[j] < min_a) {
                        cur++;
                        min_a = a[j];
                    }
                } else {
                    if (a[j] > max_a) {
                        cur++;
                        max_a = a[j];
                    }
                }
            }
            ans = max(ans, cur);
        }
        cout << ans << endl;
    }
}
