#include <bits/stdc++.h>

using namespace std;

#define int long long

/* consts */
const int inf = 1LL << 60;
const int mod = 100000007;

random_device rd;

/* output */
template<typename T1, typename T2>
ostream& operator<<(ostream& s, pair<T1,T2>& p) {
    s << "(" << p.first << ", " << p.second << ")";
    return s;
}

template<typename T>
ostream& operator<<(ostream& s, vector<T>& a) {
    for (T x : a) s << x << " ";
    s << endl;
    return s;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& s, map<T1,T2>& m) {
    for (auto [k, v] : m) {
        s << k << " -> " << v << endl;
    }
    return s;
}

/* do */
struct node {
    int x = 0;
    int delta = 0;
};

void update(vector<node>& tree, int i, int l, int r) {
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    tree[i].x = tree[i1].x +
                tree[i2].x +
                tree[i1].delta * (m - l) +
                tree[i2].delta * (r - m);
}

void build_tree(vector<node>& tree, vector<int>& a, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x = a[l];
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    build_tree(tree, a, i1, l, m);
    build_tree(tree, a, i2, m, r);
    update(tree, i, l, r);
}

void build_tree(vector<node>& tree, vector<int>& a) {
    build_tree(tree, a, 0, 0, a.size());
}

int get(vector<node>& tree, int i_c, int i, int l, int r) {
    if (r - l == 1) return tree[i].x + tree[i].delta;
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        return tree[i].delta + get(tree, i_c, i1, l, m);
    else
        return tree[i].delta + get(tree, i_c, i2, m, r);
}

int get(vector<node>& tree, int i_c, int n) {
    return get(tree, i_c, 0, 0, n);
}

int get_i(vector<node>& tree, int l_c, int r_c, int i, int l, int r, int delta) {
    delta += tree[i].delta;
    if (l_c >= r || r_c <= l) return 0;
    if (l >= l_c && r <= r_c) {
        //cout << "get_i " << i << " " << l << " " << r << "\t" << delta << " " << tree[i].x << endl;
        return delta * (r - l) + tree[i].x;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    return get_i(tree, l_c, r_c, i1, l, m, delta) + get_i(tree, l_c, r_c, i2, m, r, delta);
}

int get_i(vector<node>& tree, int l_c, int r_c, int n) {
    return get_i(tree, l_c, r_c, 0, 0, n, 0);
}

void inc(vector<node>& tree, int i_c, int x, int i, int l, int r) {
    if (r - l == 1) {
        tree[i].x += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    if (i_c < m)
        inc(tree, i_c, x, i1, l, m);
    else
        inc(tree, i_c, x, i2, m, r);
    update(tree, i, l, r);
}

void inc(vector<node>& tree, int i_c, int x, int n) {
    inc(tree, i_c, x, 0, 0, n);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int i, int l, int r) {
    if (l_c >= r || r_c <= l) return;
    if (l >= l_c && r <= r_c) {
        //cout << "inc_i " << l_c << " " << r_c << " " << i << " " << l << " " << r << endl;
        tree[i].delta += x;
        return;
    }
    int m = (l + r) >> 1, i1 = (i << 1) + 1, i2 = i1 + 1;
    inc_i(tree, l_c, r_c, x, i1, l, m);
    inc_i(tree, l_c, r_c, x, i2, m, r);
    update(tree, i, l, r);
}

void inc_i(vector<node>& tree, int l_c, int r_c, int x, int n) {
    inc_i(tree, l_c, r_c, x, 0, 0, n);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n,q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(a.begin(), a.end());
    //cout << a;
    vector<int> max_w(n + 1, 1);
    int cur_w = 1;
    for (int i = 0; i < n; i++) {
        int x = a[i];
        //cout << max_i << " " << a[i] << " " << max_w << endl;
        if (x <= cur_w) cur_w += x;
        max_w[i + 1] = cur_w;
    }
    //cout << max_w;
    int w;
    cin >> w;
    int v = 0;
    while (q--) {
        int k, l, r;
        cin >> k >> l >> r;
        k -= w * v;
        l -= w * v;
        r -= w * v;
        int max_i = n;
        while (max_i > 0 && a[max_i - 1] > k) max_i--;
        //cout << l << " " << max_i << " " << max_w[max_i] << endl;
        if (l < max_w[max_i]) {
            v++;
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}
