// A.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstring>

using namespace std;
using ll=long long;

const int MAXN = 100000;
const size_t NC = -1;

struct event
{
	size_t l, r, num;

	bool operator<(const event& oth) const
	{
		if (r < oth.r)
			return true;
		if (r == oth.r && l > oth.l)
			return true;
		return false;
	}
};

#define allv(x) x.begin(),x.end()

ll findm(vector <event> ev)
{
	sort(allv(ev));
	ll ans = 0;
	size_t last = 0;
	for (auto& i : ev)
	{
		if (i.l <= last)
			continue;
		ans++;
		last = i.r;
	}
	return ans;
}

void print_answer(std::vector<int>& stay, ll& m, std::vector<event>& rec);

void solve()
{
	ll n;
	cin >> n;
	if (n % 2 == 1)
		n--;
	vector <event> lst, rec;
	for (size_t i = 0; i < n; i++)
	{
		event ev;
		cin >> ev.l >> ev.r;
		ev.num = i;
		lst.push_back(ev);
	}
	rec = lst;
	sort(allv(lst));
	vector <int> tmp;
	size_t last = 0;
	for (auto& i : lst)
	{
		if (i.l <= last)
			continue;
		tmp.push_back(i.num);
		last = i.r;
	}
#ifdef _DEBUG
	cerr << "m = " << tmp.size() << '\n';
#endif
	ll m = tmp.size() >> 1;
	ll val1 = count_if(allv(rec), [&rec, &m, &tmp](event ev) {return ev.l > rec[tmp[m - 1]].r; }),
		val2 = count_if(allv(rec), [&rec, &m, &tmp](event ev) {return ev.r < rec[tmp[m]].l; });
	if (val2 <= (n >> 1))
	{
		// delete val1
		vector <int> stay;
		stay.insert(stay.end(), tmp.begin() + m, tmp.end());
		vector <bool>used(n);
		for (auto& i : stay)
		{
			used[i] = 1;
		}
		for (int i = n - 1; i >= 0; i--)
		{
			if (stay.size() == (n >> 1))
				break;
			size_t it = lst[i].num;
			if (lst[i].r < rec[tmp[m]].l)
				continue;
			if (!used[it])
			{
				used[it] = true;
				stay.push_back(it);
			}
		}
		if (stay.size() < (n >> 1))
			exit(-1);
		sort(allv(stay));
		print_answer(stay, m, rec);
		return;
	}
	// delete val2;
	vector <int> stay;
	stay.insert(stay.end(), tmp.begin(), tmp.begin() + m);
	vector <bool>used(n);
	for (auto& i : stay)
	{
		used[i] = 1;
	}
	for (size_t i = 0; i < n; i++)
	{
		if (stay.size() == (n >> 1))
			break;
		size_t it = lst[i].num;
		if (lst[i].l > rec[tmp[m - 1]].r)
			continue;
		if (!used[it])
		{
			used[it] = true;
			stay.push_back(it);
		}
	}
	if (stay.size() < (n >> 1))
		exit(-1);
	sort(allv(stay));
	print_answer(stay, m, rec);
	return;
}

void print_answer(std::vector<int>& stay, ll& m, std::vector<event>& rec)
{
	vector <event> core;
	for (auto& i : stay)
	{
		core.push_back(rec[i]);
	}
	if (m != findm(core))
		exit(-1);
	for (auto& i : stay)
	{
		cout << i + 1 << ' ';
	}
	cout << '\n';
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	ll t;
	cin >> t;
	while (t--)
	{
		solve();
	}
	return 0;
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
