#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
const int inf = (1 << 31) - 1;

struct segtree {
    vector<pair<int, int>> tree;
    int size = 1;

    segtree(int n) {
        while (size < n) size <<= 1;
        tree = vector<pair<int, int>> (size * 2 - 1, {0, inf});
    }

    void put(int i, int k, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = {k, k};
            return;
        }
        int m = (rx + lx) / 2;
        if (i < m) {
            put(i, k, x * 2 + 1, lx, m);
        } else {
            put(i, k, x  *2 + 2, m, rx);
        }
        tree[x].first = max(tree[x * 2 + 1].first, tree[x * 2 + 2].first);
        tree[x].second = min(tree[x * 2 + 1].second, tree[x * 2 + 2].second);
    }

    void put(int i, int k) {
        put(i, k, 0, 0, size);
    }

    int mim(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return inf;
        }
        if (l <= lx && rx <= r) {
            return tree[x].second;
        }
        int m = (rx + lx) / 2;
        int x1 = mim(l, r, x * 2 + 1, lx, m);
        int x2 = mim(l, r, x * 2 + 2, m, rx);
        return min(x1, x2);
    }

    int mim(int l, int r) {
        return mim(l, r, 0, 0, size);
    }

    int mam(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x].first;
        }
        int m = (rx + lx) / 2;
        int x1 = mam(l, r, x * 2 + 1, lx, m);
        int x2 = mam(l, r, x * 2 + 2, m, rx);
        return max(x1, x2);
    }

    int mam(int l, int r) {
        return mam(l, r, 0, 0, size);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = 0;
    for (int i = 1; i < (1 << n) - 1; i++) {
        int ma = 0, mi = inf;
        int c = 0, cc = 0;
        for (int j = 0; j < n; j++) {
            if ((i >> j) & 1) {
                if (a[j] > ma) {
                    c++;
                    ma = a[j];
                }
            } else {
                if (a[j] < mi) {
                    cc++;
                    mi = a[j];
                }
            }
        }
        ans = max(ans, c + cc);
    }
    cout << ans << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
