#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;
const int inf = (1 << 31) - 1;

struct segtree {
    vector<int> tree;
    int size = 1;

    segtree(int n) {
        while (size < n) size <<= 1;
        tree = vector<int> (size * 2 - 1, 0);
    }

    void put(int i, int k, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = k;
            return;
        }
        int m = (rx + lx) / 2;
        if (i < m) {
            put(i, k, x * 2 + 1, lx, m);
        } else {
            put(i, k, x * 2 + 2, m, rx);
        }
        tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
    }

    void put(int i, int k) {
        put(i, k, 0, 0, size);
    }

    int mam(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int m = (rx + lx) / 2;
        int x1 = mam(l, r, x * 2 + 1, lx, m);
        int x2 = mam(l, r, x * 2 + 2, m, rx);
        return max(x1, x2);
    }

    int mam(int l, int r) {
        return mam(l, r, 0, 0, size);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ma = 0;
    segtree tree(n);
    vector<vector<pair<int, int>>> cnt(n + 1);
    for (int i = 0; i < n; i++) {
        int x = tree.mam(0, a[i]);
        tree.put(a[i] - 1, x + 1);
        cnt[x + 1].push_back({i, a[i]});
        ma = max(ma, x + 1);
    }
    vector<int> used(n + 1);
    pair<int, int> last = {n, inf};
    while (ma) {
        int l = 0, r = cnt[ma].size();
        sort(cnt[ma].begin(), cnt[ma].end());
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (cnt[ma][m] < last) {
                l = m;
            } else {
                r = m;
            }
        }
        last = cnt[ma][l];
        used[cnt[ma][l].second] = 1;
        ma--;
    }
    vector<int> b;
    for (int i = 0; i < n; i++) {
        if (!used[a[i]]) {
            b.push_back(a[i]);
        }
    }
    swap(b, a);
    segtree treee(n);
    ma = 0;
    for (int i = 0; i < a.size(); i++) {
        int x = treee.mam(a[i], n);
        ma = max(ma, x + 1);
        treee.put(a[i] - 1, x + 1);
    }
    int s = 0;
    for (int i : used) s += i;
    cout << ma + s << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
