#include <iostream>
#include <bits/stdc++.h>
#include <random>
#define int long long

using namespace std;

mt19937_64 rnd(17112004);

const int inf = 1ll << 63;

struct segtree {
    vector<int> tree;
    int size = 1;

    segtree(int n) {
        while (size < n) size <<= 1;
        tree = vector<int> (size * 2 - 1, 0);
    }

    void put(int i, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x]++;
            return;
        }
        int m = (rx + lx) / 2;
        if (i < m) {
            put(i, x * 2 + 1, lx, m);
        } else {
            put(i, x * 2 + 2, m, rx);
        }
        tree[x] = tree[x * 2 + 1] + tree[x * 2 + 2];
    }

    void put(int i) {
        put(i, 0, 0, size);
    }

    int sum(int l, int r, int x, int lx, int rx) {
        if (rx <= l || r <= lx) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int m = (rx + lx) / 2;
        int x1 = sum(l, r, x * 2 + 1, lx, m);
        int x2 = sum(l, r, x * 2 + 2, m, rx);
        return x1 + x2;
    }

    int sum(int l, int r) {
        return sum(l, r, 0, 0, size);
    }

    void print() {
        int l = 1;
        int ind = 2;
        for (int i = 0; i < tree.size(); i++) {
            if (i == l) {
                cout << endl;
                l += ind;
                ind <<= 1;
            }
            cout << tree[i] << " ";
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n * 2);
    vector<pair<int, int>> b(n);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a[i * 2] = {x, 0, i};
        a[i * 2 + 1] = {y, 1, i};
    }
    sort(a.begin(), a.end());
    vector<int> cnt(n, 0);
    vector<int> dp(n * 2, 0);
    vector<int> ll(n, 0);
    int ind = 0;
    int last = 0;
    int ans = 0;
    for (int i = 0; i < n * 2; i++) {
        if (a[i][0] > last) {
            last = a[i][0];
            a[i][0] = ind;
            if (a[i][1] ^ 1) {
                ll[a[i][2]] = ind;
            } else {
                b[a[i][2]] = {ll[a[i][2]], ind};
            }
            ind++;
        } else {
            last = a[i][0];
            a[i][0] = ind - 1;
            if (a[i][1] ^ 1) {
                ll[a[i][2]] = ind - 1;
            } else {
                b[a[i][2]] = {ll[a[i][2]], ind - 1};
            }
        }
        if (a[i][1] ^ 1) {
            cnt[a[i][2]] = ans;
        } else {
            ans = max(ans, cnt[a[i][2]] + 1);
        }
        dp[i] = ans;
    }
    segtree tree1(ind * 2), tree2(ind * 2);
    vector<vector<int>> gg;
    for (int i = 0; i < n * 2; i++) {
        if (a[i][1] ^ 1) {
            tree1.put(a[i][0]);
            tree1.put(a[i][0] + ind);
        } else {
            tree2.put(a[i][0]);
            tree2.put(a[i][0] + ind);
        }
        if (i && dp[i] > dp[i - 1]) {
            gg.push_back({b[a[i][2]].first, b[a[i][2]].second, i});
            gg.push_back({b[a[i][2]].first + ind, b[a[i][2]].second + ind, i});
        }
    }
    sort(gg.begin(), gg.end());
    int l, r;
    for (int i = ans / 2 - 1; i < ans * 2; i++) {
        int x = tree2.sum(0, gg[i - ans / 2 + 1][0]) + tree1.sum(gg[i][1] + 1, ind * 2);
        int y = n * 2 - x;
        if (y >= n / 2) {
            l = gg[i - ans / 2 + 1][0];
            r = gg[i][1];
            vector<vector<int>> ass;
            for (int j = 0; j < n; j++) {
                if ((l <= b[j].first && b[j].first <= r) || (l <= b[j].second && b[j].second <= r)) {
                    ass.push_back({b[j].first, 0, j, ass.size() / 2});
                    ass.push_back({b[j].second, 1, j, ass.size() / 2});
                    continue;
                }
                b[j].first += ind;
                b[j].second += ind;
                if ((l <= b[j].first && b[j].first <= r) || (l <= b[j].second && b[j].second <= r)) {
                    ass.push_back({b[j].first - ind, 0, j, ass.size() / 2});
                    ass.push_back({b[j].second - ind, 1, j, ass.size() / 2});
                    continue;
                }
            }
            sort(ass.begin(), ass.end());
            vector<bool> imp(ass.size() / 2, 0);
            int ss = 0;
            vector<int> cht(ass.size() / 2);
            int sus = ans / 2;
            for (int j = 0 ; j < ass.size(); j++) {
                if (ass[j][1] ^ 1) {
                    cht[ass[j][3]] = ss;
                } else {
                    if (ss < cht[ass[j][3]] + 1) {
                        cout << ass[j][2] + 1 << " ";
                        ss = cht[ass[j][3]] + 1;
                        imp[ass[j][3]] = 1;
                    }
                }
            }
            for (int j = 0; j < ass.size() && sus < n / 2; j++) {
                if (ass[j][1] || imp[ass[j][3]]) {
                    continue;
                }
                cout << ass[j][2] + 1 << " ";
                sus++;
            }
            cout << "\n";
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
