#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;
typedef long double dl;

pair <ll, ll> nvp(ll l, ll r, ll mi, vector <ll>& a)
{
	ll n = a.size(), ans = 0;
	vector <ll> dp(n, 1e18), p1(n, -1);
	for (ll i = r; i >= l; i--)
	{
		if (a[i] > mi) continue;
		ll in = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
		if (dp[in] == 1e18) ans++;
		dp[in] = a[i];
		//cout << a[i] << "\n";
		if (in == ans - 1) p1[a[i] - 1] = ans - 1;
	}
	ll mii = 0;
	for (ll i = 0; i < n; i++)
	{
		if (p1[i] == 0) mii = i + 1;
	}
	return { ans, mii };
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	random_device rd;
	mt19937 gen(rd());
	
	ll t;
	cin >> t;
	while (t--)
	{
		ll n;
		cin >> n;
		vector <ll> a(n);
		for (ll i = 0; i < n; i++) cin >> a[i];
		vector <vector <ll>> dp(n + 1, vector <ll>(n + 2, -1e18));
		dp[1][n + 1] = 1;
		ll ans = 0;
		for (ll i = 2; i <= n; i++)
		{
			auto [cn, mi] = nvp(0, i - 2, 1e18, a);
			dp[i][mi] = cn + 1;
			for (ll j = 1; j < i; j++)
			{
				if (a[j - 1] > a[i - 1]) continue;
				for (ll u = 1; u <= n + 1; u++)
				{
					auto [cn, mi] = nvp(j, i - 2, u, a);
					dp[i][mi] = max(dp[i][mi], dp[j][u] + cn + 1);
					ans = max(ans, dp[i][mi]);
				}
			}
		}
		for (ll i = 1; i <= n; i++)
		{
			for (ll u = 1; u <= n + 1; u++)
			{
				ans = max(ans, dp[i][u] + nvp(i, n - 1, u, a).first);
			}
		}
		cout << ans << "\n";
	}

	return 0;
}
/*

C

1
8
5 8 2 6 3 1 4 7

4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3

*/