#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;
#define ll long long

struct segTree {
    struct node {
        ll val = 0;
        ll prev = -1;
        ll cur=-1;

        node operator+(node oth) {
            node res;
            if (val >= oth.val)
                return *this;
            else
                return oth;
        }
    };

    vector<node> t;
    vector<int> a;
    ll n;

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = {0, -1, a[l]};
            return;
        }
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }

    void build(vector<int> b) {
        a = b;
        n = a.size();
        t.resize(n * 4);
        build(0, 0, n);
    }

    node get(int v, int l, int r, int ql, int qr) {
        if (qr <= l || ql >= r)return node{};
        if (qr >= r && ql <= l)return t[v];
        int m = (r + l) / 2;
        return get(v * 2 + 1, l, m, ql, qr) + get(v * 2 + 2, m, r, ql, qr);
    }

    void set(int v, int l, int r, int pos, node val) {
        if (pos < l || pos >= r)return;
        if (l == pos && r == pos + 1) {
            t[v] = val;
            return;
        }
        int m = (l + r) / 2;
        set(v * 2 + 1, l, m, pos, val);
        set(v * 2 + 2, m, r, pos, val);
        t[v] = t[v * 2 + 1] + t[v * 2 + 2];
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &o: a) {
        cin >> o;
        o--;
    }
    segTree st;
    st.build(a);
    for (int i = 0; i < n; i++) {
        auto best = st.get(0, 0, n, 0, a[i]);
        best.val++;
        best.prev = best.cur;
        best.cur = a[i];
        st.set(0, 0, n, a[i], {best});
    }
    auto res = st.get(0, 0, n, 0, n);
    int ptr = res.cur;
    vector<bool> used(n + 1);
    while (ptr != -1) {
        auto cur = st.get(0, 0, n, ptr, ptr + 1);
        used[cur.cur] = true;
        ptr = cur.prev;
    }
    int ma = -1;
    for (int i = 0; i < n; i++) {
        if (used[a[i]])continue;
        if (ma > a[i]) {
            cout << st.get(0, 0, n, 0, n).val + 2;
        }
        ma = max(ma, a[i]);
    }
    cout << min((ll) n, st.get(0, 0, n, 0, n).val + 1);
}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << '\n';
    }
}