#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void generate_sequences(int n, int i, int length, vector <int> current, vector <vector <int>> &result, int last) {
	if (i == length) {
		result.push_back(current);
		return;
	}

	for (int j = last + 1; j <= n; j++) {
		current.push_back(j);
		generate_sequences(n, i + 1, length, current, result, j);
		current.pop_back();
	}	
}

bool intersects(vector <int> &a, vector <int> &b) {
	unordered_set <int> seen;
	for (int x: a)
		seen.insert(x);

	for (int x: b) {
		if (seen.find(x) != seen.end()) {
			return true;
		}
	}

	return false;
}

void generate_encodings(vector <vector <int>>& sequences, vector <int> &encodings) {
	int total = sequences.size();

	vector <int> options (total);
	iota(options.begin(), options.end(), 0);

	for (int i = 0; i < total; i++) {
		vector <int> removed;
		while (!options.empty() && intersects(sequences[i], sequences[options.back()])) {
			removed.push_back(options.back());
			options.pop_back();
		}

		assert(!options.empty());

		encodings.push_back(options.back());	
		options.pop_back();

		for (int x: removed) {
			options.push_back(x);
		}
	}


}

void solve_run_1() {
	int n, k;
	cin >> n >> k;

	vector <int> a(k);
	for (int &x: a) cin >> x;

	vector <int> b;
	if (a[0] == 1) {
		b.push_back(n);
	} else {
		b.push_back(a[0] - 1);
	}

	int offset = (a[0] + n / 2 - 1 - 1) % n + 1;
	for (int i = 1; i < k; i++) {
		b.push_back((offset + a[i] - a[i - 1] - 1) % n + 1);
		offset = b.back();
	}

	sort(b.begin(), b.end());

	for (int x: b)
		cout << x << ' ';
	cout << '\n';
}

void solve_run_2() {
	int n, k;
	cin >> n >> k;

	vector <int> a(n);
	for (int &x: a) cin >> x;

	vector <int> result;
	for (int i = 1; i < k; i++) {
		if (a[i] - a[i - 1] >= n / 2) {
			if (a[i - 1] == n) {
				result.push_back(1);
			} else {
				result.push_back(a[i - 1] + 1);
			}

			result.push_back(result.back() + a[i] - a[i - 1] - n / 2);

			for (int j = 1; j < k - 1; j++) {
				int x = (i + j) % k, y = (i + j - 1 + k) % k;
				if (a[x] < a[y]) {
					result.push_back(result.back() + a[x] + a[y] - n);					
				} else {
					result.push_back(result.back() + a[x] - a[y]);
				}
			}
		}
	}

	if (result.empty()) {
		assert(a[0] + a[k - 1] - n >= n / 2);

		if (a[k - 1] == n) {
			result.push_back(1);
		} else {
			result.push_back(a[k - 1] + 1);
		}

		result.push_back(result.back() + a[0] + a[k - 1] - n - n / 2);

		int i = 0;
		for (int j = 1; j < k - 1; j++) {
			int x = (i + j) % k, y = (i + j - 1 + k) % k;
			result.push_back(result.back() + a[x] - a[y]);
		}
	}

	sort(result.begin(), result.end());

	for (int x: result)
		cout << x << ' ';
	cout << '\n';
}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	int run;
	cin >> run;

	int m;
	cin >> m;

	while (m--) {
		if (run == 1) {
			solve_run_1();
		} else {
			solve_run_2();
		}
	}
}