#include "bits/stdc++.h"

using namespace std;


#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;
vector<pair<int, int>> g[N];
int tin[N], tout[N], timer = 0;

struct Fenwick {
    vector<int> t;
    int n;
    void init (int z) {
        n = z + 10;
        t.assign(n + 10, 0);
    }
    void add (int k, int x) {
        for (; k <= n; k += k & -k) {
            t[k] += x;
        }
    }
    int sum (int k) {
        int res = 0;
        for (; k > 0; k -= k & -k) {
            res += t[k];
        }
        return res;
    }
    int sum (int l, int r) {
        return sum(r) - sum(l - 1);
    }
} f;

int k;

void dfs (int u, int cur = 0, int direction = -1) {
    tin[u] = timer++;
    for (auto x : g[u]) {
        int cnt = cur;
        if (x.second != direction) {
            cnt++;
        }
        dfs(x.first, cnt, x.second);
    }
    if (sz(g[u]) == 0 && cur <= k) {
        f.add(tin[u] + 1, 1);
    }
    tout[u] = timer;
}

void solve() {
    int n, q;
    cin >> n >> k >> q;
    k++;
    for (int i = 0; i < n; i++) {
        int d;
        cin >> d;
        for (int j = 0; j < d; j++) {
            int u;
            cin >> u;
            u--;
            g[i].push_back({u, j});
        }
    }
    f.init(4 * N);
    dfs(0);
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        u--;
        cout << f.sum(tin[u] + 1, tout[u]) << '\n';
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}