#include "bits/stdc++.h"

using namespace std;


#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Segment {
    int l, r, index;
    Segment () : l(0), r(0) {}
    Segment (int lx, int rx) : l(lx), r(rx) {}
    bool operator < (const Segment &other) {
        if (r == other.r) {
            return l > other.l;
        }
        return r < other.r;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<Segment> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].l >> s[i].r;
        s[i].index = i;
    }
    sort(all(s));

    vector<deque<int>> seg;
    vector<int> cnt;
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            cnt.push_back(1);
            seg.emplace_back();
            seg.back().emplace_back(i);
        } else {
            if (s[i].r >= s[i - 1].r && s[i].l <= s[i - 1].l) {
                cnt.back()++;
                seg.back().emplace_back(i);
            } else {
                cnt.push_back(1);
                seg.emplace_back();
                seg.back().emplace_back(i);
            }
        }
    }
    sort(all(cnt));
    sort(all(seg), [&] (deque<int> &a, deque<int> &b) {
        return sz(a) < sz(b);
    });
    vector<int> ans;
    int mid = sz(cnt) / 2;
    vector<int> zxc;
    int cur = 0;
    for (int i = mid; i < sz(cnt); i++) {
        cnt[i]--;
        cur++;
        zxc.push_back(s[seg[i].back()].index);
        seg[i].pop_back();
    }
    for (int i = mid; i < sz(cnt); i++) {
        while (cur < n / 2 && !seg[i].empty()) {
            zxc.push_back(s[seg[i].back()].index);
            seg[i].pop_back();
            cur++;
        }
    }
    for (int i = 0; i < sz(zxc); i++) {
        cout << zxc[i] + 1 << " ";
    }
    cout << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}