#include "bits/stdc++.h"

using namespace std;


#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Segment {
    int l, r, index;
    Segment () : l(0), r(0) {}
    Segment (int lx, int rx) : l(lx), r(rx) {}
    bool operator < (const Segment &other) {
        if (r == other.r) {
            return l < other.l;
        }
        return r < other.r;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<Segment> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].l >> s[i].r;
        s[i].index = i;
    }
    sort(all(s));
    int mx;
    auto solve_mask = [&] (int mask) {
        vector<int> p;
        for (int i = 0; i < n; i++) {
            if ((mask >> i) & 1)p.push_back(i);
        }
        vector<int> dp(sz(p), 1);
        for (int i = 0; i < sz(p); i++) {
            for (int j = i - 1; j >= 0; j--) {
                if (s[p[j]].r < s[p[i]].l) dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        return *max_element(all(dp)) == mx / 2;
    };
    vector<int> dp(n, 1);
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (s[j].r < s[i].l) dp[i] = max(dp[i], dp[j] + 1);
        }
    }
    mx = *max_element(all(dp));
    for (int mask = 0; mask < (1 << n); mask++) {
        if (__builtin_popcount(mask) == n / 2) {
            if (solve_mask(mask)) {
                for (int i = 0; i < n; i++) {
                    if ((mask >> i) & 1) {
                        cout << s[i].index + 1 << " ";
                    }
                }
                cout << endl;
                return;
            }
        }
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}