#include "bits/stdc++.h"

using namespace std;


#define int long long
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(x) cout << #x << " = " << (x) << endl;

mt19937_64 rng(chrono::high_resolution_clock::now().time_since_epoch().count());

struct Segment {
    int l, r, index;
    Segment () : l(0), r(0) {}
    Segment (int lx, int rx) : l(lx), r(rx) {}
    bool operator < (const Segment &other) {
        if (l == other.l) {
            return r < other.r;
        }
        return l < other.l;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<Segment> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].l >> s[i].r;
        s[i].index = i;
    }
    sort(all(s));
    int mx;
    auto solve_mask = [&] (int l, int r) {
        vector<int> p;
        for (int j = l; j < r; j++) {
            p.push_back(j);
        }
        int last = -1;
        vector<int> who(sz(p), -1);
        for (int i = 0; i < sz(p); i++) {
            while (last + 1 != i && s[p[last + 1]].r < s[p[i]].l) {
                last++;
            }
            who[i] = last;
        }
        vector<int> dp(sz(p), 1);
        vector<int> pref(sz(p) + 1, 0);
        for (int i = 0; i < sz(p); i++) {
            dp[i] = max(dp[i], pref[who[i] + 1] + 1);
            pref[i + 1] = max(pref[i + 1], dp[i]);
        }
        return *max_element(all(dp)) == mx / 2;
    };
    vector<int> dp(n, 1);
    for (int i = 0; i < n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            if (s[j].r < s[i].l) dp[i] = max(dp[i], dp[j] + 1);
        }
    }
    int mid = n / 2;
    mx = *max_element(all(dp));
    for (int i = 0; i < mid; i++) {
        if (solve_mask(i, i + mid)) {
            for (int j = i; j < i + mid; j++) {
                cout << s[j].index + 1 << " ";
            }
            cout << '\n';
            return;
        }
    }
    cout << endl;
    assert(false);
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}