#pragma GCC optimize("Ofast", "unroll-loops", "no-stack-protector")
#pragma GCC target("avx,sse")
#pragma GCC optimize("Os")

#include <bits/stdc++.h>

#define endl "\n"
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define ll long long
using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
        }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
        }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
        }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
        }
    return in;
}

struct Fenwick {
    vector<int> tree;
    int n;
    
    void add(int a) {
        for (; a < n; a |= a + 1) {
            tree[a]++;
            }
        }
    
    int get(int a) {
        int res = 0;
        for (; a >= 0; a &= a + 1, a--) {
            res += tree[a];
            }
        return res;
        }
    
    int get(int l, int r) {
        if (l > r) {
            return 0;
            }
        return get(r) - get(l - 1);
        }
    
    void init(int n) {
        this->n = n;
        tree.assign(n, 0);
        }
};

struct SegmentTree {
    vector<int> tree;
    int n;
    
    void upd(int v, int val) {
        v += n;
        rmax(tree[v], val);
        
        for (; v > 1; v >>= 1) {
            tree[v >> 1] = max(tree[v], tree[v ^ 1]);
            }
        }
    
    int get(int l, int r) {
        int ans = 0;
        
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                rmax(ans, tree[l++]);
                }
            
            if (r & 1) {
                rmax(ans, tree[--r]);
                }
            }
        return ans;
        }
    
    void init(int n) {
        this->n = n;
        tree.assign(2 * n, 0);
        }
};


void solve() {
    int n;
    cin >> n;
    
    vector<int> a(n);
    cin >> a;

    vector<pii> swapped;
    vector<int> my;
    int cnt = 0;
    for (int i = 0; i + 1 < n; i++) {
        if (a[i] > a[i + 1]) {
            cnt--;
            my.push_back(a[i + 1]);
        }
    }
    SegmentTree tree;
    tree.init(n + 1);

    for (int &it : my) {
        int ans = tree.get(it, n + 1);
        tree.upd(it, ans + 1);
    }

    cout << tree.get(0, n + 1) + cnt << endl;
//    cout << n << endl;
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    
#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    
    int t = 1;
    cin >> t;
    
    while (t--) {
        solve();
    }
}