#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
using namespace std;

#define MT

struct cut {
    int l, r, ind;
};

int n, m;
vector<cut> cuts;

struct sost {
    int i, j, k;
};

void solve_smarter() {
    vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(n + 1, vector<bool>(n + 1, false))); // O(n^3)
    vector<vector<vector<sost>>> par(n + 1, vector<vector<sost>>(n + 1, vector<sost>(n + 1, {-1, -1, -1}))); // O(n^3)
    vector<vector<vector<bool>>> berem(n + 1, vector<vector<bool>>(n + 1, vector<bool>(n + 1, false)));

    dp[0][0][0] = true;

    for (int i = 0; i < n; ++i) {
        // 1) не беру i в мн-во

        for (int j = 0; j <= n; ++j) {
            for (int k = 0; k <= n; ++k) {
                if (dp[i][j][k]) {
                    dp[i + 1][j][k] = true;
                    berem[i + 1][j][k] = false;
                    par[i + 1][j][k] = {i, j, k};
                }
            }
        }

        dp[i + 1][1][1] = true;
        par[i + 1][1][1] = {-1, -1, -1};
        berem[i + 1][1][1] = true;

        bool was = false;
        for (int r = i - 1; r >= 0; ++r) {
            // не брал [r + 1..i - 1]

            for (int j = 0; j <= n; ++j) {
                for (int k = 0; k <= n; ++k) {
                    if (cuts[r].r >= cuts[i].l) { // пересекаются
                        if (was)
                            break;
                        if (j != n) {
                            if (dp[r + 1][j][k]) {
                                dp[i + 1][j + 1][k] = true;
                                par[i + 1][j + 1][k] = {r + 1, j, k};
                                berem[i + 1][j + 1][k] = true;
                            }
                        }
                    } else { // берем хорошим
                        if (k != n && j != n) {
                            if (dp[r + 1][j][k]) {
                                dp[i + 1][j + 1][k + 1] = true;
                                par[i + 1][j + 1][k + 1] = {r + 1, j, k};
                                berem[i + 1][j + 1][k + 1] = true;
                            }
                        }
                    }
                }
            }

            was = true;
        }
    }

    int i = n, j = n / 2, k = m / 2;
    assert(dp[i][j][k]);

    vector<int> ans;
    while (i > 0) {
        if (!berem[i][j][k]) { // не берем
        } else { // берем
            ans.push_back(cuts[i - 1].ind);
        }
        auto [nw_i, nw_j, nw_k] = par[i][j][k];
        i = nw_i;
        j = nw_j;
        k = nw_k;
    }

    sort(all(ans));
    for (auto &el : ans) {
        cout << el + 1 << ' ';
    }
    cout << '\n';
}

void solve() {
    cin >> n;
    cuts.resize(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        cuts[i] = {l, r, i};
    }

    sort(all(cuts), [&](const cut &c1, const cut &c2) {
        if (c1.r == c2.r) {
            return c1.l > c2.l;
        }
        return c1.r < c2.r;
    });

    int last = -1e9;
    m = 0;
    for (auto &el: cuts) {
        if (el.l > last) {
            ++m;
            last = el.r;
        }
    }

    if (n <= 500) {
        solve_smarter();
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}