#include <bits/stdc++.h>

using namespace std;

bool cmp(tuple<int, int, int> a, tuple<int, int, int> b) {
    auto [l1, r1, i1] = a;
    auto [l2, r2, i2] = b;
    if (r1 != r2) {
        return r1 < r2;
    }
    return l1 > l2;
}

int calcbest(vector<tuple<int, int, int>> & qs, int mx) {
    sort(qs.begin(), qs.end(), cmp);
    vector<int> left(mx + 1, -1);
    int last = 0;
    int idxn = 0;
    for (auto [l, r, idx] : qs) {
        if (r != last) {
            left[r] = idxn;
        }
        last = r;
        idxn++;
    }
    vector<int> dp(mx + 1);
    for (int i = 1; i <= mx; i++) {
        dp[i] = dp[i - 1];
        if (left[i] != -1) {
            auto [l, r, idx] = qs[left[i]];
            dp[i] = max(dp[i], dp[l - 1] + 1);
        }
    }
    return dp.back();
}

void solve() {
    int n;
    cin >> n;
    vector<int> coords;
    vector<tuple<int, int, int>> qs;
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        qs.push_back({l, r, i + 1});
        coords.push_back(l);
        coords.push_back(r);
    }
    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());
    for (auto & [l, r, idx] : qs) {
        l = lower_bound(coords.begin(), coords.end(), l) - coords.begin() + 1;
        r = lower_bound(coords.begin(), coords.end(), r) - coords.begin() + 1;
    }
    int m = calcbest(qs, coords.size());
    sort(qs.begin(), qs.end());
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int> (n + 1, 1e9)));
    vector<vector<vector<int>>> pr(n + 1, vector<vector<int>> (n + 1, vector<int> (n + 1, -1)));
    dp[0][0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n / 2; j++) {
            for (int k = 1; k <= m / 2; k++) {
                auto [l, r, idx] = qs[i - 1];
                if (dp[i - 1][j][k - 1] < l) {
                    pr[i][j][k] = 1;
                    if (dp[i][j][k] > r) {
                        pr[i][j][k] = 2;
                    }
                    dp[i][j][k] = min(dp[i][j][k], r);
                }
                if (j >= 1) {
                    if (dp[i][j][k] > dp[i - 1][j - 1][k]) {
                        pr[i][j][k] = 3;
                    }
                    dp[i][j][k] = min(dp[i][j][k], dp[i - 1][j - 1][k]);
                }
            }
        }
    }
    vector<int> ans;
    int j = n / 2, k = m / 2;
    for (int i = n; i >= 1; i--) {
        if (pr[i][j][k] == 2) {
            k--;
        }
        if (pr[i][j][k] == 3) {
            j--;
        } else {
            ans.push_back(i);
        }
    }
    for (auto e : ans) {
        cout << e << ' ';
    }
    cout << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
