#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <random>
#include <deque>
#include <queue>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 7;
const ll LL_INF = 2e18 + 7;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

template<typename T> ostream& operator << (ostream& out, const vector<T>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	return out;
}

struct Segment_tree {
	int type;
	int n;
	vector<int> tree;
	Segment_tree(int _type, int _n) {
		type = _type;
		n = _n + 1;
		tree.resize(4 * n);
	}
	void _update(int u, int l, int r, int i, int val) {
		if (l > i || r <= i) {
			return;
		}
		if (l + 1 == r) {
			tree[u] = max(tree[u], val);
			return;
		}
		int m = (l + r) / 2;
		int v1 = 2 * u + 1;
		int v2 = 2 * u + 2;
		_update(v1, l, m, i, val);
		_update(v2, m, r, i, val);
		tree[u] = max(tree[v1], tree[v2]);
	}
	void update(int i, int val) {
		_update(0, 0, n, i, val);
	}
	int _get(int u, int l, int r, int lq, int rq) {
		if (l >= rq || r <= lq) {
			return 0;
		}
		if (l >= lq && r <= rq) {
			return tree[u];
		}
		int m = (l + r) / 2;
		return max(_get(2 * u + 1, l, m, lq, rq), _get(2 * u + 2, m, r, lq, rq));
	}
	int get(int l, int r) {
		return _get(0, 0, n, l, r + 1);
	}
};

mt19937 rnd(time(0));

int main() {
	int t_num;
	cin >> t_num;
	while (t_num--) {
		int n;
		cin >> n;
		//ll sum = 0;
		if (n <= 16) {
			vector<int> a(n);
			cin >> a;
			int ans = 0;
			for (int mask = 1; mask < (1 << n); mask++) {
				vector<int> b1, b2;
				for (int i = 0; i < n; i++) {
					if (mask & (1 << i)) {
						b1.push_back(a[i]);
					}
					else {
						b2.push_back(a[i]);
					}
				}
				//sum += n;
				int cnt = 0;
				for (int i = 0, maxim = -INT_INF; i < b1.size(); i++) {
					if (b1[i] > maxim) {
						maxim = b1[i];
						cnt++;
					}
				}
				for (int i = 0, minim = INT_INF; i < b2.size(); i++) {
					if (b2[i] < minim) {
						minim = b2[i];
						cnt++;
					}
				}
				ans = max(ans, cnt);
			}
			cout << ans << '\n';
			//cout << sum;
		}
		else {

		}
	}
}
