#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <algorithm>
#include <numeric>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include <cassert>
#include <random>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 7;
const int LL_INF = 2e18 + 7;

struct Segment {
	int l, r;
	int num;
	Segment() : l(0), r(0), num(0) {}
	Segment(int _l, int _r, int _num) : l(_l), r(_r), num(_num) {}
	bool operator < (const Segment& other) {
		return r < other.r;
	}
};

int main() {
	int t_num;
	cin >> t_num;
	while (t_num--) {
		int n;
		cin >> n;
		vector<Segment> a(n);
		for (int i = 0; i < n; i++) {
			int l, r;
			cin >> l >> r;
			l--;
			r--;
			a[i] = Segment(l, r, i);
		}
		sort(a.begin(), a.end());
		vector<int> dp(n, 1);
		int m = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; a[j].r < a[i].l; j++) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
			m = max(m, dp[i]);
		}
		if (m == n) {
			for (int i = 0; i < n / 2; i++) {
				cout << i + 1 << ' ';
			}
			cout << '\n';
			continue;
		}
		int cur_m = m;
		for (int it = 0; it < n; it++, n--) {
			int min_seq = 0, max_seq = 0;
			dp.assign(n, 1);
			vector<int> p(n, -1);
			vector<int> is_p_for(n, 0);
			cur_m = 1;
			for (int i = 0; i < n; i++) {
				for (int j = 0; a[j].r < a[i].l; j++) {
					if (dp[j] + 1 > dp[i]) {
						dp[i] = dp[j] + 1;
						p[i] = j;
						is_p_for[j]++;
					}
				}
				cur_m = max(cur_m, dp[i]);
			}
			vector<bool> is_in_max_seq(n, false);
			for (int i = n - 1; i >= 0; i--) {
				if (dp[i] == cur_m) {
					is_in_max_seq[i] = true;
				}
				if (is_in_max_seq[i] && p[i] != -1) {
					is_in_max_seq[p[i]] = true;
				}
			}
			if (cur_m > m / 2) {
				/*
				for (int j = 0; j < n; j++) {
					if (is_in_max_seq[j] > is_in_max_seq[i] || is_p_for[j] > is_p_for[i]) {
						i = j;
					}
				}
				*/
				vector<int> intrw(n);
				for (int i = 0; i < n; i++) {
					for (int j = 0; j < n; j++) {
						if (!(a[i].l > a[j].r || a[i].r < a[j].l)) {
							intrw[i]++;
						}
					}
				}
				int i = 0;
				for (int j = 0; j < n; j++) {
					if (intrw[j] < intrw[i]) {
						i = j;
					}
				}
				a.erase(a.begin() + i);
			}
			else {
				bool erased = false;
				for (int i = 0; i < n; i++) {
					if (!is_in_max_seq[i]) {
						a.erase(a.begin() + i);
						erased = true;
						break;
					}
				}
				if (!erased) {
					a.erase(a.begin());
				}
			}
		}
		dp.assign(n, 1);
		cur_m = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; a[j].r < a[i].l; j++) {
				dp[i] = max(dp[i], dp[j] + 1);
			}
			cur_m = max(cur_m, dp[i]);
		}
		assert(cur_m >= m / 2);
		for (auto& i : a) {
			cout << i.num + 1 << ' ';
		}
		cout << '\n';
	}
}
