#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

void solve1(int n, int k, vector<int> &v);
void solve2(int n, int k, vector<int> &v);

void print(vector<int> &v){
    sort(v.begin(), v.end());
    for (auto el : v){
        cout << el + 1 << ' ';
    }
    cout << endl;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int z;
    int t;
    cin >> z >> t;
    for (int i = 0; i < t; ++i) {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (int j = 0; j < k; ++j) {
            cin >> v[j];
            v[j]--;
        }
        sort(v.begin(), v.end());
        if (z == 1){
            solve1(n, k, v);
        } else{
            solve2(n, k, v);
        }
    }
}

void solve1(int n, int k, vector<int> &v){
    unordered_map<int, int> used;
    for (int i = 0; i < k; ++i) {
        used[v[i]] = 2;
    }
    vector<int> w;
    int bal = 0;
    for (int i = 0; i < k; ++i) {
        bal++;
        int j = (v[i] + 1) % n;
        while (!used[j] && bal > 0){
            used[j] = 1;
            bal--;
            w.push_back(j);
            j = (j + 1) % n;
        }
    }
    print(w);
}

void solve2(int n, int k, vector<int> &v){
    unordered_map<int, int> used;
    for (int i = 0; i < k; ++i) {
        used[v[i]] = 2;
    }
    vector<int> w;
    int bal = 0;
    for (int i = k - 1; i >= 0; --i){
        bal++;
        int j = (v[i] - 1 + n) % n;
        while (!used[j] && bal > 0){
            used[j] = 1;
            bal--;
            w.push_back(j);
            j = (j - 1 + n) % n;
        }
    }
    print(w);
}
/*
2
2
2 1
2
5 2
2 5
*/