#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;

#define all(c) c.begin(), c.end()

using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;

vector<pair<int, int>> ev;
vector<vector<int>> dp;
vector<vector<int>> pred;

void solve()
{
    int n; cin >> n;
    ev.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> ev[i].second >> ev[i].first;
    }
    vector<int> ord(n); iota(all(ord), 0);
    sort(all(ord), [&](int i, int j){return ev[i] < ev[j]; });
    int m = 0;
    int r = -1;
    for (int i = 0; i < n; ++i)
    {
        if (ev[ord[i]].second > r)
        {
            ++m;
            r = ev[ord[i]].first;
        }
    }
    int maxm = m / 2 + 1;
    dp.assign(n, vi(maxm, n + 1));
    pred.assign(n, vi(maxm, -1));
    for (int I = 0; I < n; ++I)
    {
        dp[ord[I]][0] = I + 1;
    }
    for (int I = 0; I < n; ++I)
    {
        int i = ord[I];
        dp[i][1] = I;
        pred[i][1] = -1;
        int W = 0;
        auto comp = [&](int a, int b) {return ev[a].second < ev[b].second; };
        priority_queue<int, vi, decltype(comp)> q(comp);
        for (int J = I - 1; J >= 0; --J) {
            int j = ord[J];
            if (ev[j].first >= ev[i].second) continue;
            while (!q.empty() && ev[q.top()].second > ev[j].first)
            {
                ++W;
                q.pop();
            }
            q.push(j);
            for (int M = 2; M < maxm; ++M) {
                if (dp[i][M] > dp[j][M - 1] + W) {
                    dp[i][M] = dp[j][M - 1] + W;
                    pred[i][M] = j;
                }
            }
        }
    }
    int W = 0;
    auto comp = [&](int a, int b) {return ev[a].second < ev[b].second; };
    priority_queue<int, vi, decltype(comp)> q(comp);
    vector<bool> del(n, false);
    vector<bool> choose(n, false);
    for (int I = n - 1; I >= 0; --I)
    {
        int i = ord[I];
        while (!q.empty() && ev[q.top()].second > ev[i].first)
        {
            ++W;
            del[q.top()] = true;
            q.pop();
        }
        q.push(i);
        if (dp[i][maxm-1] + W <= n / 2)
        {
            int M = maxm - 1;
            int J = I;
            while (i > -1)
            {
                choose[i] = true;
                int j = pred[i][M];
                --M;
                int r = (j > -1? ev[j].first : -1);
                for (; J >= 0 && ord[J] != j; --J)
                {
                    if (ev[ord[J]].first >= ev[i].second) continue;
                    if (ev[ord[J]].second <= r) continue;
                    del[ord[J]] = true;
                }
                i = j;
                --J;
            }
            break;
        }
    }
    int diff = n / 2 - m / 2;
    for (int i = 0; i < n; ++i)
    {
        if (!del[i])
        {
            if (choose[i])
            {
                cout << i + 1 << " ";
            }
            else if (diff > 0)
            {
                --diff;
                cout << i + 1 << " ";
            }
        }
    }
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int tt; cin >> tt;
    while (tt--)
    {
        solve();
        cout << endl;
    }
    return 0;
}
