#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

bool comp(vector <int> a, vector <int> b) {
    return a[0] < b[0];
}

int findmax(const vector <vector <int>>& seg) {
    set<pair<int, int>> st;
    int ans = 0, n = seg.size();
    for (int i = 0; i < n; i++) {
        st.insert(make_pair(seg[i][1], seg[i][2]));
    }
    int ptr = 0;
    while (!st.empty()) {
        pair<int, int> y = *(st.begin());
        //cout << y.first << "*\n";
        ans++;
        while (ptr < n && seg[ptr][0] <= y.first) {
            st.erase(make_pair(seg[ptr][1], seg[ptr][2]));
            ptr++;
        }
    }
    return ans;
}


bool findmax2(const vector <vector <int>>& seg, int m, int rasn) {
    set<pair<int, int>> st;
    int ans = 0, n = seg.size();
    for (int i = 0; i < n; i++) {
        st.insert(make_pair(seg[i][1], seg[i][2]));
    }
    int ptr = 0;
    while (!st.empty()) {
        pair<int, int> y = *(st.begin());
        //cout << y.first << "*\n";
        ans++;
        if (ans != m / 2) {
            while (ptr < n && seg[ptr][0] <= y.first) {
                st.erase(make_pair(seg[ptr][1], seg[ptr][2]));
                ptr++;
            }
    }   else {
            while (ptr < n && seg[ptr][0] <= y.first + rasn - 1) {
                st.erase(make_pair(seg[ptr][1], seg[ptr][2]));
                ptr++;
            }
    }
    }
    return ans >= m;
}

vector <int> findmax3(const vector <vector <int>>& seg, int m, int rasn) {
    set<pair<int, int>> st;
    vector <int> num;
    int ans = 0, n = seg.size();
    for (int i = 0; i < n; i++) {
        st.insert(make_pair(seg[i][1], seg[i][2]));
    }
    int ptr = 0;
    while (!st.empty()) {
        pair<int, int> y = *(st.begin());
        //cout << y.first << "*\n";
        ans++;
        num.push_back(y.second);
        if (ans != m / 2) {
            while (ptr < n && seg[ptr][0] <= y.first) {
                st.erase(make_pair(seg[ptr][1], seg[ptr][2]));
                ptr++;
            }
    }   else {
            while (ptr < n && seg[ptr][0] <= y.first + rasn - 1) {
                st.erase(make_pair(seg[ptr][1], seg[ptr][2]));
                ptr++;
            }
    }
    }
    return num;
}
int main() {
    int q_tests;
    cin >> q_tests;
    for (int kind = 0; kind < q_tests; kind++) {
        int n;
        cin >> n;
        vector <vector <int>> seg(n, vector <int> (3));
        vector <vector <int>> segord(n, vector <int> (2));
        for (int i = 0; i < n; i++) {
            cin >> seg[i][0] >> seg[i][1];
            seg[i][2] = i;
            segord[i][0] = seg[i][0];
            segord[i][1] = seg[i][1];
        }
        sort(seg.begin(), seg.end(), comp);
        int m = findmax(seg);
        //cout << m;
        int l = 1, r = 1000000001;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (findmax2(seg, m, mid)) {
                l = mid;
        }   else {
                r = mid;
        }
        }
        //cout << l;
        vector <int> vkl = findmax3(seg, m, l);
        int i1 = vkl[m / 2 - 1], i2 = vkl[m / 2];
        int lg = segord[i1][1], rg = segord[i2][0];
        vector <int> left;
        vector <int> right;
        vector <int> middler;
         vector <int> middlel;
        for (int i = 0; i < n; i++) {
            if (segord[i][1] <= lg) {
                left.push_back(i);
            }   else if (segord[i][0] >= rg) {
                right.push_back(i);
            }   else {
                if (seg[i][1] >= rg) {
                middler.push_back(i);
                }   else {
                    middlel.push_back(i);
                }
            }
        }
        if (middler.size() + right.size() >= n / 2) {
            vector <bool> used(n);
            int q = 0;
            for (int i = m / 2; i < m; i++) {
                cout << vkl[i] + 1 << " ";
                used[vkl[i]] = true;
                q++;
            }
            for (int i = 0; i < right.size(); i++) {
                if (q == n / 2) {
                    break;
                }
                if (!used[right[i]]) {
                    cout << right[i] + 1 << " ";
                    q++;
                    used[right[i]] = true;
                }
            }
            for (int i = 0; i < middler.size(); i++) {
                if (q == n / 2) {
                    break;
                }
                if (!used[middler[i]]) {
                    cout << middler[i] + 1 << " ";
                    q++;
                    used[middler[i]] = true;
                }
            }
        }   else {
               vector <bool> used(n);
            int q = 0;
            for (int i = 0; i < m / 2; i++) {
                cout << vkl[i] + 1 << " ";
                used[vkl[i]] = true;
                q++;
            }
            for (int i = 0; i < left.size(); i++) {
                if (q == n / 2) {
                    break;
                }
                if (!used[left[i]]) {
                    cout << left[i] + 1 << " ";
                    q++;
                    used[left[i]] = true;
                }
            }
            for (int i = 0; i < middlel.size(); i++) {
                if (q == n / 2) {
                    break;
                }
                if (!used[middlel[i]]) {
                    cout << middlel[i] + 1 << " ";
                    q++;
                    used[middlel[i]] = true;
                }
            }
        }
        cout << "\n";
    }
}
