#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (auto& i : w) cin >> i;
    sort(w.begin(), w.end());
    ll z;
    cin >> z;
    while(q--)
    {
        ll k, a, b;
        cin >> k >> a >> b;
        ll c = (1 << 20);
        if (a > c || b > c || (a + 1)*(b + 1) > c)
        {
            cout << "No\n";
            continue;
        }
        int m = 0;
        while(m < n && w[m] <= k) m++;
        set<pair<ll, ll>> s;
        for (int i = 0; i < (1 << m); i++) for (int j = 0; j < (1 << m); j++)
        {
            if (i & j) continue;
            ll sumA = 0;
            ll sumB = 0;
            for (int o = 0; o < m; o++)
            {
                if (i & (1 << o)) sumA += w[o];
                if (j & (1 << o)) sumB += w[o];
            }
            s.insert({sumA, sumB});
        }
        bool ans = true;
        for (int i = 0; i <= a; i++) for (int j = 0; j <= b; j++)
        {
            if (s.find({i, j}) == s.end()) ans = false;
        }
        if (ans) cout << "Yes\n";
        else cout << "No\n";
    }
    return 0;
}
