#include <bits/stdc++.h>

#include <immintrin.h>

#pragma GCC target("avx,avx2")

#define ll int64_t
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define x first
#define y second

#define double ld
#define endl '\n'

using namespace std;

const int inf = 1e9;
const ll INF = 1e18;

const int maxn = 2e3;

struct ST {
    vector<int> tree;
    int rsz;

    void resize(int sz) {
        tree.assign(4 * sz, -inf);
        rsz = sz;
    }

    int get(int i, int l, int r, int ql, int qr) {
        if (qr <= l or r <= ql)
            return -inf;
        if (ql <= l and r <= qr)
            return tree[i];
        int mid = (l + r) / 2;
        return max(get(2 * i + 1, l, mid, ql, qr),
                   get(2 * i + 2, mid, r, ql, qr));
    }

    void set(int i, int l, int r, int q, int val) {
        if (q < l or r <= q)
            return;
        if (l + 1 == r) {
            tree[i] = val;
            return;
        }

        int mid = (l + r) / 2;
        set(2 * i + 1, l, mid, q, val);
        set(2 * i + 2, mid, r, q, val);
        tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
    }

    int get(int l, int r) {
        return get(0, 0, rsz, l, r);
    }

    void set(int x, int val) {
        set(0, 0, rsz, x, val);
    }
};


int dp[maxn + 1][maxn + 1];

ST st[maxn + 1];

set<int> a[maxn + 1];
set<int> b[maxn + 1];


bool cmax(int &a, int b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}


int avxINF[8];

void solve() {
    int n;
    cin >> n;
    vector<int> p(n + 1);
    for (int i = 1; i <= n; ++i)
        cin >> p[i];

    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = -inf;
        }

        st[i].resize(n + 2);
    }

    dp[p[1]][0] = 1;
    dp[0][p[1]] = 1;

    st[0].set(0, 0, n + 1, p[1], 1);
    st[p[1]].set(0, 0, n + 1, 0, 1);

    set<pair<int, int>> s;

    for (int i = 0; i <= n; ++i) {
        a[i].clear();
        b[i].clear();
    }

    auto add = [&](int u, int v) {
        s.insert({u, v});
        a[u].insert(v);
        b[v].insert(u);
    };

    auto remove = [&](int u, int v) {
        s.erase({u, v});
        a[u].erase(v);
        b[v].erase(u);
    };


    for (int i = 0; i < 8; ++i)
        avxINF[i] = -inf;

    for (int i = 2; i <= n; ++i) {
        for (int p2 = 1; p2 <= n; ++p2) {
            if (p2 == p[i])
                continue;

            if (cmax(dp[p[i]][p2], dp[0][p2] + 1)) {
                add(p[i], p2);
                st[p[i]].set(p2, dp[0][p2] + 1);
            }

            if (p[i] > p2) {
                if (cmax(dp[0][p[i]], dp[0][p2] + 1)) {
                    st[0].set(p[i], dp[0][p2] + 1);
                }

                dp[0][p2] = -inf;
                st[0].set(p2, -inf);
            }
        }

        for (int p1 = 1; p1 <= n; ++p1) {
            if (p1 == p[i])
                continue;

            if (cmax(dp[p1][p[i]], dp[p1][0] + 1)) {
                add(p1, p[i]);
                st[p1].set(p[i], dp[p1][0] + 1);
            }

            if (p[i] < p1) {
                if (cmax(dp[p[i]][0], dp[p1][0] + 1)) {
                    st[p[i]].set(0, dp[p1][0] + 1);
                }

                dp[p1][0] = -inf;
                st[p1].set(0, -inf);
            }
        }

        for (int y = 1; y <= n; ++y) {
            if (y == p[i])
                continue;

            int val = dp[p[i]][y] - 1;

            __m256i d = _mm256_lddqu_si256((__m256i*)avxINF);


            int x = p[i] + 1;

            for (; x <= n; ++x) {
                val = max(val, dp[x][y]);
            }

            int aval = -inf;
            aval = max(aval, (int) _mm256_extract_epi32(d, 0));
            aval = max(aval, (int) _mm256_extract_epi32(d, 1));
            aval = max(aval, (int) _mm256_extract_epi32(d, 2));
            aval = max(aval, (int) _mm256_extract_epi32(d, 3));
            aval = max(aval, (int) _mm256_extract_epi32(d, 4));
            aval = max(aval, (int) _mm256_extract_epi32(d, 5));
            aval = max(aval, (int) _mm256_extract_epi32(d, 6));
            aval = max(aval, (int) _mm256_extract_epi32(d, 7));

            dp[p[i]][y] = max(val, aval) + 1;
            st[p[i]].set(y, val + 1);

            add(p[i], y);
        }

        for (int x = 1; x <= n; ++x) {
            if (x == p[i])
                continue;

            int val = dp[x][p[i]] - 1;

            __m256i d = _mm256_lddqu_si256((__m256i*)avxINF);

            int y = 1;
            for (; y + 8 <= p[i]; y += 8) {
                d = _mm256_max_epi32(d, _mm256_lddqu_si256((__m256i*)dp[x] + y));
            }

            for (; y < p[i]; ++y) {
                val = max(val, dp[x][y]);
            }
            
            int aval = -inf;
            aval = max(aval, (int) _mm256_extract_epi32(d, 0));
            aval = max(aval, (int) _mm256_extract_epi32(d, 1));
            aval = max(aval, (int) _mm256_extract_epi32(d, 2));
            aval = max(aval, (int) _mm256_extract_epi32(d, 3));
            aval = max(aval, (int) _mm256_extract_epi32(d, 4));
            aval = max(aval, (int) _mm256_extract_epi32(d, 5));
            aval = max(aval, (int) _mm256_extract_epi32(d, 6));
            aval = max(aval, (int) _mm256_extract_epi32(d, 7));
            val = max(val, aval);

            dp[x][p[i]] = val + 1;
            add(x, p[i]);
        }

        for (int x = p[i] + 1; x <= n; ++x) {
            while (a[x].size() > 0 and *a[x].begin() < p[i]) {
                dp[x][*a[x].begin()] = -inf;
                remove(x, *a[x].begin());
            }
        }
    }

    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();

    return 0;
}