#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 1e5;

vector <int> g[MAXN];
vector <int> deg(MAXN, 0);
vector <bool> used(MAXN, false);

struct otr {
    int l;
    int r;
    int id;
};

bool cmp(otr a, otr b) {
    if (a.r == b.r) {
        return a.l > b.l;
    }
    return a.r < b.r;
}

bool per(int l1, int r1, int l2, int r2) {
    return max(l1, l2) <= min(r1, r2);
}

void solve() {
    int n;
    cin >> n;
    vector <otr> p(n);
    for (int i = 0; i < n; i++) {
        g[i].clear();
        used[i] = false;
        deg[i] = 0;
        cin >> p[i].l >> p[i].r;
        p[i].id = i;
    }
    int m = 0;
    sort(p.begin(), p.end(), cmp);
    vector <int> st;
    vector <int> q;
    for (int i = 0; i < n; i++) {
        while (!st.empty() && per(p[i].l, p[i].r, p[st.back()].l, p[st.back()].r)) {
            g[p[st.back()].id].push_back(p[i].id);
            deg[p[i].id]++;
            st.pop_back();
        }
        if (deg[p[i].id] == 0) {
            q.push_back(p[i].id);
            m++;
        }
        st.push_back(i);
    }
    m = m / 2;
    int cnt = 0;
    while (m) {
        int now = q[0];
        int nn = n + 1;
        for (auto v : q) {
            if (used[v]) {
                continue;
            }
            int u = v;
            int x = 0;
            while (deg[u] <= 1 && !g[u].empty()) {
                u = g[u][0];
                x++;
            }
            if (x <= nn) {
                nn = x;
                now = v;
            }
        }
        cnt += nn;
        int u = now;
        while (deg[u] <= 0 && !g[u].empty()) {
            used[u] = true;
            u = g[u][0];
            deg[u]--;
        }
        m--;
    }
    for (int i = 0; i < n && cnt < n / 2; i++) {
        if (!used[i]) {
            used[i] = true;
            cnt++;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}