#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 200001;

int lex_incr(vector<int> v) {
    vector<int> ans = {-MAXN};
    for (auto x : v) {
        auto i = upper_bound(ans.begin(), ans.end(), x);
        if (i == ans.end())
            ans.push_back(x);
        else
            i[0] = x;
    }
    return ans.size() - 1;
}

int brute_force(vector<int>& p, int i, int a, int b) {
    if (i >= p.size())
        return 0;
    if (a >= b) {
        vector<int> inc;
        vector<int> dec;
        for (int j = i; j < p.size(); ++j) {
            if (p[j] >= a)
                inc.push_back(p[j]);
            if (p[j] <= b)
                dec.push_back(-p[j]);
        }
        return lex_incr(inc) + lex_incr(dec);
    }
    int ans = 0;
    if (a <= p[i])
        ans = max(ans, 1 + brute_force(p, i + 1, p[i], b));
    else
        ans = max(ans, brute_force(p, i + 1, a, b));
    if (p[i] <= b)
        ans = max(ans, 1 + brute_force(p, i + 1, a, p[i]));
    else
        ans = max(ans, brute_force(p, i + 1, a, b));
    return ans;
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    cout << brute_force(p, 0, 0, n - 1) << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
