#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int MAXN = 200809;

int lex_incr(vector<int> v) {
    vector<int> ans = {-MAXN};
    for (auto x : v) {
        auto i = upper_bound(ans.begin(), ans.end(), x);
        if (i == ans.end())
            ans.push_back(x);
        else
            i[0] = x;
    }
    return ans.size() - 1;
}

int p[MAXN];
int mnsf[MAXN];
int mxsf[MAXN];
vector<int> incsf[MAXN];
vector<int> decsf[MAXN];

int get_greed(int n, int i, int a, int b) {
    int inc = incsf[i].end() - lower_bound(incsf[i].begin(), incsf[i].end(), a) - 1;
    int dec = upper_bound(decsf[i].begin(), decsf[i].end(), b) - decsf[i].begin() - 1;
    return inc + dec;
}

int brute_force(int n, int i, int a, int b) {
    if (i >= n) {
        if (a == 0 || b == n + 1)
            return -MAXN;
        return 0;
    }
    int ans = 0;
    if ((a > 0 || mxsf[i] >= b) && (b <= n || mnsf[i] <= a))
        ans = get_greed(n, i, b, a);
    if (a <= p[i] && p[i] <= b) {
        ans = max(ans, 1 + brute_force(n, i + 1, p[i], b));
        ans = max(ans, 1 + brute_force(n, i + 1, a, p[i]));
    } else {
        ans = max(ans, brute_force(n, i + 1, a, b));
        if (p[i] >= b)
            ans = max(ans, get_greed(n, i, p[i], b));
        if (p[i] <= a)
            ans = max(ans, get_greed(n, i, a, p[i]));
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    mnsf[n - 1] = mxsf[n - 1] = p[n - 1];
    for (int i = n - 2; i >= 0; --i) {
        mnsf[i] = min(mnsf[i], mnsf[i + 1]);
        mxsf[i] = max(mxsf[i], mxsf[i + 1]);
    }
    incsf[n] = {MAXN};
    for (int i = n - 1; i >= 0; --i) {
        incsf[i] = incsf[i + 1];
        auto it = lower_bound(incsf[i].begin(), incsf[i].end(), p[i]);
        if (it == incsf[i].begin())
            incsf[i].insert(incsf[i].begin(), p[i]);
        else
            it[-1] = p[i];
    }
    decsf[n] = {-MAXN};
    for (int i = n - 1; i >= 0; --i) {
        decsf[i] = decsf[i + 1];
        auto it = upper_bound(decsf[i].begin(), decsf[i].end(), p[i]);
        if (it == decsf[i].end())
            decsf[i].push_back(p[i]);
        else
            it[0] = p[i];
    }
    cout << brute_force(n, 0, 0, n + 1) << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
