#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const int MAXN = 2e5 + 123;
vector<int> edg[MAXN];
pair<ll, ll> sg[MAXN];

pair<ll, ll> effect_dfs(int v, int rt, vector<ll>& a) {
    ll ans = 0;
    ll dif = a[v];
    for (auto u : edg[v]) {
        if (u == rt)
            continue;
        pair<ll, ll> p = effect_dfs(u, v, a);
        ans += p.first + p.second;
        dif -= p.second;
    }
    return {ans, max(dif, 0ll)};
}

ll get_effect(vector<ll> a) {
    pair<ll, ll> ans = effect_dfs(0, -1, a);
    return ans.first + ans.second;
}

ll get_hash(vector<ll> a, ll x, ll y, ll MOD) {
    ll ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        ans ^= (x * (i + 1) + y * a[i] % MOD * a[i]) % MOD;
    }
    return ans;
}

vector<ll> get_vals(int n, ll v) {
    vector<ll> ans(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = sg[i].first + min(v, sg[i].second - sg[i].first);
        v -= min(v, sg[i].second - sg[i].first);
    }
    return ans;
}

void solve(int n, int q) {
    ll x, y, MOD;
    cin >> x >> y >> MOD;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        edg[u].push_back(v);
        edg[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> sg[i].first >> sg[i].second;
    }
    vector<ll> qrs(q);
    for (int i = 0; i < q; ++i)
        cin >> qrs[i];
    ll smdf = 0;
    for (int i = 0; i < n; ++i) {
        smdf += sg[i].second - sg[i].first;
    }
    vector<ll> ans(q, -1);
    for (int qi = 0; qi < q; ++qi) {
        ll eff = qrs[qi];
        ll lb = -1, ub = smdf + 1;
        while (ub - lb > 1) {
            ll mb = (lb + ub) / 2;
            vector<ll> vals = get_vals(n, mb);
            ll ceff = get_effect(vals);
            cout << mb << ": " << ceff << endl;
            if (eff == ceff) {
                ans[qi] = mb;
                break;
            } else if (ceff < eff) {
                lb = mb;
            } else {
                ub = mb;
            }
        }
    }
    vector<ll> hashes(q);
    for (int qi = 0; qi < q; ++qi) {
        if (ans[qi] == -1)
            hashes[qi] = -1;
        else {
            hashes[qi] = get_hash(get_vals(n, ans[qi]), x, y, MOD);
        }
    }
    for (int i = 0; i < q; ++i)
        cout << hashes[i] << ' ';
    cout << endl;
    int qi;
    while (cin >> qi) {
        --qi;
        if (qi == -1)
            return;
        if (ans[qi] == -1) {
            cout << "-1" << endl;
            continue;
        }
        vector<ll> ans = get_vals(n, ans[qi]);
        for (auto x : ans)
            cout << x << ' ';
        cout << endl;
    }
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        solve(n, q);
        for (int i = 0; i < n; ++i)
            edg[i].clear();
    }
}
