#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;


int stupidSolve(vector<int> p) {
    int n = (int)p.size();
    int ans = 0;
    for (int mask = 1; mask < (1 << n) - 1; ++mask) {
        vector<int> q, r;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                q.push_back(p[i]);
            } else {
                r.push_back(p[i]);
            }
        }
        int mxQ = 0, mnR = INT64_MAX, tmpAns = 0;
        for (auto i : q) {
            if (i > mxQ) {
                mxQ = i;
                tmpAns++;
            }
        }
        for (auto i : r) {
            if (i < mnR) {
                mnR = i;
                tmpAns++;
            }
        }
        ans = max(ans, tmpAns);
    }
    return ans;
}

struct Elem {
    int ans, mxQ, mnR;
};

int smartSolve(vector<int> p) {
    int n = (int)p.size();
    p.insert(p.begin(), 0);
    vector<vector<Elem>> dp(n + 2, vector<Elem>(n + 1, {0, 0, n + 1}));
    for (int i = n + 1; i >= 1; --i) {
        for (int j = 0; j < n; ++j) {
            auto [ans, mx, mn] = dp[i][j];
            for (int next = j + 1; next <= n; ++next) {
                if (next != j + 1) {
                    if (p[next - 1] < mn) {
                        ans++;
                        mn = p[next - 1];
                    }
                }
                if (mn < i) break;
                int tmpAns = ans;
                if (p[next] > mx) {
                    tmpAns++;
                }
                if (dp[i][next].ans < tmpAns ||
                (dp[i][next].ans == tmpAns && (dp[i][next].mxQ > max(mx, p[next]) || dp[i][next].mnR < mn))) {
                    dp[i][next] = {tmpAns, max(mx, p[next]), mn};
                }
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= n + 1; ++i) {
        for (int j = 1; j <= n; ++j) {
            int tmpAns = dp[i][j].ans;
            int mn = dp[i][j].mnR;
            for (int k = j + 1; k <= n; ++k) {
                if (p[k] < mn) {
                    tmpAns++;
                    mn = p[k];
                }
            }
            ans = max(ans, tmpAns);
        }
    }
    return ans;
}

int strangeSolve(vector<int> p) {
    int n = (int)p.size();
    vector<int> minAforD(n + 1, INT32_MAX);
    minAforD[0] = 0;
    vector<int> dp(n);
    dp[0] = 0;
    minAforD[1] = p[0];
    for (int i = 1; i < n; ++i) {
        auto it = lower_bound(all(minAforD), p[i]);
        --it;
        dp[i] = (it - minAforD.begin()) + 1;
        minAforD[dp[i]] = min(minAforD[dp[i]], p[i]);
    }
    return *max_element(all(dp)) + 1;
}

mt19937 rnd(57);

vector<int> gen() {
    int n = rnd() % 6 + 2;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i + 1;
    }
    shuffle(all(p), rnd);
    return p;
}

void stress() {
    while (true) {
        auto p = gen();
        auto ansRight = stupidSolve(p);
        auto ansFalse = smartSolve(p);
        if (ansFalse != ansRight) {
            for (auto i : p) {
                cout << i << ' ';
            }
            cout << '\n' << ansFalse << '\n' << ansRight << '\n';
            exit(0);
        }
        cerr << "OK\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
//    stress();
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        int n; cin >> n;
        vector<int> p(n);
        for (int j = 0; j < n; ++j) cin >> p[j];
        cout << strangeSolve(p) << '\n';
    }
    return 0;
}