#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <iomanip>
#include <random>

using namespace std;

int code(int x, int n) {
    if (x == n) {
        return 1;
    }
    if (x == n + 1) {
        return 2;
    }
    return x + 1;
}

int decode(int x, int n) {
    if (x == 1) {
        return n;
    }
    if (x == 0) {
        return n - 1;
    }
    return x - 1;
}

map<int, int> create_bi(int n, int k) {
    set<int> done;
    map<int, int> ans;
    for (int mask = 0; mask < ((1ll)<<n); ++mask) {
        if (__builtin_popcount(mask) != k) continue;
        for (int mask_to = 0; mask_to < ((1ll)<<n); ++mask_to) {
            if (__builtin_popcount(mask_to) != k) continue;
            if ((mask&mask_to) != 0) continue;
            if (done.find(mask_to) != done.end()) continue;
            ans[mask] = mask_to;
        }
    }
    return ans;
}

void print(int mask, int n) {
    for (int i = 0; i < n; ++i) {
        if (mask&(1<<i)) {
            cout << i + 1 << " ";
        }
    }
}

void solve1(int n, int k, vector<int> v) {
    auto mp = create_bi(n, k);
    int now_m = 0;
    for (auto i : v) {
        now_m += (1ll<<(i - 1));
    }
    int ans = mp[now_m];
    print(ans, n);
}

void solve2(int n, int k, vector<int> v) {
    auto mp = create_bi(n, k);
    int now_m = 0;
    for (auto i : v) {
        now_m += (1ll<<(i - 1));
    }
    int ans;
    for (auto i : mp) {
        if (i.second == now_m) {
            ans = i.first;
            break;
        }
    }
    print(ans, n);
}

void solve() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> v(k);
        for (int i = 0; i < k; ++i) {
            cin >> v[i];
        }
        if (t == 1) {
            solve1(n, k, v);
        } else {
            solve2(n, k, v);
        }
        cout << "\n";
    }
}

signed main() {
#ifdef BENTSA
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    solve();
}
