#include <iostream>
#include <algorithm>

using namespace std;

struct event
{
	bool isStart;
	int pos, id;

	event() {}
	event(bool isStart, int pos, int id) : isStart(isStart), pos(pos), id(id) {}
};

void solve(int n)
{
	int l, r, count = 0, prev = -1, started = 0;
	auto events = new event[2 * n];
	auto index = new pair<int, int>[n];
	for (int i = 0; i < n; i++)
	{
		cin >> l >> r;
		events[2 * i] = event(true, l, i);
		events[2 * i + 1] = event(false, r, i);
	}
	sort(events, events + 2 * n, [](event x, event y)
		{
			return x.pos < y.pos || x.pos == y.pos && x.isStart && !y.isStart;
		});
	for (int i = 0; i < 2 * n; i++)
	{
		if (events[i].isStart) index[events[i].id] = pair<int, int>(count + 1, prev);
		else if (index[events[i].id].first > count)
		{
			count = index[events[i].id].first;
			prev = events[i].id;
		}
	}
	for (int i = 0; i < 2 * n; i++)
	{
		if (events[i].isStart)
		{
			started++;
			continue;
		}
		if (index[events[i].id].first * 2 < count) continue;
		bool begin = started * 2 >= n;
		started = 0;
		if (begin) prev = events[i].id;
		while (begin ? prev != -1 : index[prev].first * 2 > count)
		{
			cout << prev + 1 << " ";
			started++;
			index[prev].first = -1;
			prev = index[prev].second;
		}
		for (int j = begin ? 0 : n - 1; started * 2 < n; begin ? j++ : j--)
		{
			if (!events[j].isStart || index[events[j].id].first == -1) continue;
			cout << events[j].id + 1 << " ";
			started++;
		}
		cout << endl;
		break;
	}
	delete[] events;

}

int main()
{
	int t, n;
	cin >> t;
	for (int i = 0; i < t; i++)
	{
		cin >> n;
		solve(n);
	}
	return 0;
}
