#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct Segment {
    int l, r, i;
};

void solve() {
    int n;
    cin >> n;

    vector<Segment> s(n);
    vector<int> yy;

    for (int i = 0; i < n; ++i) {
        cin >> s[i].l >> s[i].r;
        s[i].i = i;

        yy.push_back(s[i].l);
        yy.push_back(s[i].r);
    }

    sort(yy.begin(), yy.end());
    yy.resize(unique(yy.begin(), yy.end()) - yy.begin());

    for (auto &[l, r, i] : s) {
        l = lower_bound(yy.begin(), yy.end(), l) - yy.begin();
        r = lower_bound(yy.begin(), yy.end(), r) - yy.begin();
    }

    vector<int> ordl(n), ordr(n);

    iota(ordl.begin(), ordl.end(), 0);
    sort(ordl.begin(), ordl.end(), [&](int i, int j) {
        return s[i].l < s[j].l;
    });

    iota(ordr.begin(), ordr.end(), 0);
    sort(ordr.begin(), ordr.end(), [&](int i, int j) {
        return s[i].r < s[j].r;
    });

    vector<bool> can(n, true), opt(n, false);

    auto best = [&]() -> int {
        vector<array<int, 2>> events;

        for (int i = 0; i < n; ++i) {
            if (can[i]) {
                events.push_back({s[i].r, i});
            }
        }

        sort(events.begin(), events.end());

        int r = -1, ans = 0;

        fill(opt.begin(), opt.end(), false);

        for (auto [x, y] : events) {
            if (s[y].l > r) {
                r = x;
                ans += 1;
                opt[y] = true;
            }
        }

        return ans;
    };

//    cout << "here" << endl;

    const int m = best();

//    cout << "m: " << m << endl;

    assert(m % 2 == 0);

    for (int tt = 0; tt < 2; ++tt) {
        for (int t = 0; t < 2; ++t) {
            int lo = 0, hi = n;

            while (lo + 1 < hi) {
                int mid = (lo + hi) >> 1;

                fill(can.begin(), can.end(), false);

                for (int i = 0; i < mid; ++i) {
                    can[ordl[i]] = true;
                }

                int ans = best();

                if (ans <= m / 2) {
                    lo = mid;
                } else {
                    hi = mid;
                }
            }

            hi -= 1;

            if (hi >= n / 2) {
                fill(can.begin(), can.end(), false);

                for (int i = 0; i < hi; ++i) {
                    can[ordl[i]] = true;
                }

                int ans = best();

                int del = n / 2 - m / 2;

                for (int i = 0; i < n; ++i) {
                    if (can[i] && !opt[i] && del > 0) {
                        del -= 1;
                        opt[i] = true;
                    }
                }

                assert(del == 0);

                for (int i = 0; i < n; ++i) {
                    if (opt[i]) {
                        cout << s[i].i + 1 << " ";
                    }
                }

                cout << '\n';

                return;
            }

            swap(ordl, ordr);
        }

        reverse(ordl.begin(), ordl.end());
        reverse(ordr.begin(), ordr.end());
    }

    assert(false);
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
