#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5;

int w[N], wL[N], wR[N], MOD;
ll kX = 0, kY = 0;
ll dp[N][2];

vector<int> adj[N], ord;

void dfs(int v, int par) {
    dp[v][0] = 0, dp[v][1] = w[v];

    for (int to : adj[v]) {
        if (to != par) {
            dfs(to, v);

            dp[v][1] += dp[to][0];
            dp[v][0] += max(dp[to][0], dp[to][1]);
        }
    }
}

void getOrd(int v, int par) {
    for (int to : adj[v]) {
        if (to != par) {
            getOrd(to, v);
        }
    }

    ord.push_back(v);
}

ll getBest() {
    dfs(0, -1);
    return max(dp[0][0], dp[0][1]);
}

int fM(int i) {
    return (kX * (i + 1) + kY * w[i] % MOD * w[i]) % MOD;
}

int ff(int i, int ww) {
    return (kX * (i + 1) + kY * ww % MOD * ww) % MOD;
}

//x * j + y * a[j]**2 % mod

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> kX >> kY >> MOD;

    for (int i = 0; i < n; ++i) {
        adj[i].clear();
    }

    ord.clear();


    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a -= 1, b -= 1;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }

//    getOrd(0, -1);

    for (int i = 0; i < n; ++i) {
        cin >> wL[i] >> wR[i];
        w[i] = wL[i];
    }

    vector<ll> qv(q);

    for (int i = 0; i < q; ++i) {
        cin >> qv[i];
    }

    vector<int> certificate(q);

    const ll least = getBest();

    int cc = 0;

    for (int i = 0; i < n; ++i) {
        w[i] = wR[i];

        cc ^= fM(i);
    }

    const ll most = getBest();

    vector<ll> val(n);
    vector<int> prefF(n + 1), sufF(n + 1);

    ord.assign(n, 0);

    iota(ord.begin(), ord.end(), 0);

    for (int i = 0; i < n; ++i) {
        sufF[i] = fM(ord[i]);
    }

    for (int i = n - 1; i >= 0; --i) {
        sufF[i] ^= sufF[i + 1];
    }

    assert(is_sorted(val.rbegin(), val.rend()));

//    assert(val.back() == least);

    for (int i = 0; i < q; ++i) {
        if (qv[i] < least || qv[i] > most) {
            certificate[i] = -1;
            continue;
        }

        certificate[i] = sufF[0];
    }

    for (int i = 0; i < q; ++i) {
        cout << certificate[i] << " ";
    }

//    cout << '\n';

    cout << endl;

    int i;

    while (true) {
        cin >> i;

        if (i == 0) {
            break;
        }

        i -= 1;

        if (certificate[i] == -1) {
            cout << -1;
            cout << endl;
            continue;
        }

        if (qv[i] < least || qv[i] > most) {
            assert(false);
        }

        for (int i = 0; i < n; ++i) {
            cout << wL[i] << " ";
        }

        cout << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }


    return 0;
}
