#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
using namespace std;
#define int long long

const int maxn = 2e5 + 1;
int dp[maxn][2];
int h[maxn];
void dfs(int v, vector<vector<int>> &g, int p, vector<int> &l) {
    dp[v][1] = l[v];
    dp[v][0] = 0;
    for (int u : g[v]) {
        if (u != p) {
            h[u] = h[v] + 1;
            dfs(u, g, v, l);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
}
void rec(int v, int c, vector<int> &res, vector<vector<int>> &g, int p) {
    if (c) res.push_back(v);
    for (int u : g[v]) {
        if (u != p) {
            if (c) {
                rec(u, 0, res, g, v);
            } else {
                if (dp[u][0] < dp[u][1]) {
                    rec(u, 1, res, g, v);
                } else {
                    rec(u, 0, res, g, v);
                }
            }
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0, g, 0, r);
    vector<int> v(q);
    for (int& i : v) {
        cin >> i;
    }
    vector<int> res;
    vector<pair<int, int>> a;
    for (int i = 0; i < n; ++i) {
        a.push_back({ h[i], i });
    }
    sort(a.rbegin(), a.rend());
    vector<int> ban(n, false);
    vector<int> cer(n + 1, 0);
    vector<int> rsrs;
    if (dp[0][0] >= dp[0][1]) {
        rec(0, 0, rsrs, g, 0);
    } else {
        rec(0, 1, rsrs, g, 0);
    }
    for (int i = 1; i <= n; ++i) {
        cer[0] ^= (i * x) % m;
    }
    for (int v : rsrs) {
        res.push_back(v);
        cer[res.size()] = cer[res.size() - 1] ^ ((x * (v + 1) + y) % m);
        cer[res.size()] ^= (x * (v + 1)) % m;
    }
    for (int i : v) {
        if (i <= res.size()) {
            cout << cer[i] << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl;
    while (1) {
        int x;
        cin >> x;
        if (x == 0) break;
        --x;
        if (v[x] > res.size()) {
            cout << -1 << endl;
        } else {
            for (int j = 0; j < v[x]; ++j) {
                l[res[j]] = 1;
            }
            for (int i : l) {
                cout << i << ' ';
            }
            cout << endl;
            for (int j = 0; j < v[x]; ++j) {
                l[res[j]] = 0;
            }
        }
    }
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}