#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
using namespace std;
#define int long long

const int maxn = 2e5 + 1;
int dp[maxn][2];

void dfs(int v, vector<vector<int>> &g, int p, vector<int> &l) {
    dp[v][1] = l[v];
    dp[v][0] = 0;
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, g, v, l);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
}
void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    dfs(0, g, 0, l);
    vector<int> v(q);
    for (int& i : v) {
        cin >> i;
    }
    int cer = 0;
    for (int i = 0; i < n; ++i) {
        cer ^= ((x * (i + 1) + ((y * l[i]) % m) * l[i]) % m);
    }
    for (int i : v) {
        if (i == max(dp[0][0], dp[0][1])) {
            cout << cer << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl;
    while (1) {
        int x;
        cin >> x;
        if (x == 0) break;
        --x;
        if (v[x] != max(dp[0][0], dp[0][1])) {
            cout << -1 << endl;
        } else {
            for (int i : l) {
                cout << i << ' ';
            }
            cout << endl;
        }
    }
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}