#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) x.begin(), x.end()
//#define int ll

const int INF = 1e9 + 42;

struct Node {
    vector<int> p, q;
    int pmax = -INF, qmin = INF;
    int cnt = 0;

    Node() = default;
    Node(const vector<int>& p_, const vector<int>& q_) : p(p_), q(q_) {
        for (auto i : p)
            if (pmax < i) {
                pmax = i;
                ++cnt;
            }
        for (auto i : q)
            if (qmin > i) {
                qmin = i;
                ++cnt;
            }
    }

    void update(int t, int x) {
        if (t == 0) {
            p.push_back(x);
            if (pmax < x) {
                pmax = x;
                ++cnt;
            }
        } else {
            q.push_back(x);
            if (qmin > x) {
                qmin = x;
                ++cnt;
            }
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    vector<vector<int>> dp(n, vector<int>(n, 2));
    for (int i = 0; i < n; ++i)
        dp[i][i] = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            if (i > j) {
                for (int x = 0; x < i; ++x)
                    if (a[x] < a[i])
                        dp[i][j] = max(dp[i][j], dp[x][j] + 1);
            }
            else {
                for (int x = 0; x < j; ++x)
                    if (a[x] > a[j])
                        dp[i][j] = max(dp[i][j], dp[i][x] + 1);
            }
            for (int x = 0; x < min(i, j); ++x)
                for (int y = 0; y < min(i, j); ++y)
                    if (a[x] < a[i] && a[y] > a[j])
                        dp[i][j] = max(dp[i][j], dp[x][y] + 2);
        }
    /*
    for (auto i : dp) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }*/

    int ans = 0;
    for (auto& i : dp)
        for (auto j : i)
            ans = max(ans, j);
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}