#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iostream>
#define f first
#define s second
#define int long long
#define debug(x) cerr << (#x)<<": "<<x<<endl
#define pb push_back
#define INF 1e9+7
using namespace std;
int min(int a, int b) {
	if (a <= b) return a;
	return b;
}
int max(int a, int b) {
	if (a >= b) return a;
	return b;
}
struct node {
	int i, j, p;
};
int n, m;
const int MAXN = 300;
vector<pair<int, int> > all;
vector<vector<int> > st;
int dp[MAXN][MAXN][MAXN];
node pred[MAXN][MAXN][MAXN];
void make_start() {
	st[1][0] = 0;
	st[1][1] = all[1].second;
	for (int i = 2; i <= n; i++) {
		int l = all[i].first, r = all[i].second;
		for (int j = 0; j < i; j++) {
			int cur_r = st[i - 1][j];
			if (cur_r == INF || cur_r > l) continue;
			st[i][j] = min(st[i - 1][j], st[i][j]);
			st[i][j + 1] = min(st[i][j + 1], r);
		}
	}
}
void make_dp() {
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		int l = all[i].first;
		for (int j = 0; j <= i; j++) {
			for (int p = 0; p <= i; p++) {
				int cur_r = all[p].second;
				if (dp[i - 1][j][p] == 1) {
					dp[i][j][p] = 1;
					pred[i][j][p] = { i - 1,j,p };
				}
				if (j > 0 && dp[i - 1][j - 1][p] == -1) continue;
				if (l > cur_r) {
					dp[i][j][i] = 1;
					pred[i][j][i] = { i - 1,j - 1,p };
				}
			}
		}
	}
}
void solve() {
	all.clear();
	cin >> n;
	st = vector<vector<int> >(n + 1, vector<int>(n + 1, INF));
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		all.pb({ l,r });
	}
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int p = 0; p <= n; p++) {
				dp[i][j][p] = -1;
				pred[i][j][p] = { -1,-1,-1 };
			}
		}
	}
	sort(all.begin(), all.end());
	reverse(all.begin(), all.end());
	all.pb({ 0,0 });
	reverse(all.begin(), all.end());
	make_start();
	for (int i = 0; i <= n; i++) {
		if (st[n][i] != INF) {
			m = i;
		}
	}
	for (int i = 0; i <= n; i++) {
		if (dp[n][m / 2][i]) {
			cout << "YES" << endl;
		}
	}
}
signed main()
{
	ios_base::sync_with_stdio();
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}
}
