#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iostream>
#define f first
#define s second
#define int long long
#define debug(x) cerr << (#x)<<": "<<x<<endl
#define pb push_back
#define INF 1e9+7
using namespace std;
int min(int a, int b) {
	if (a <= b) return a;
	return b;
}
int max(int a, int b) {
	if (a >= b) return a;
	return b;
}
struct node {
	int i, j, p;
};
int n, m;
const int MAXN = 300;
vector<pair<int, int> > all;
vector<vector<int> > st;
vector<pair<int, pair<int, int> > > for_sort;
vector<int> what_pos;
int dp[MAXN][MAXN][MAXN];
node pred[MAXN][MAXN][MAXN];
void make_start() {
	st[1][0] = 0;
	st[1][1] = for_sort[1].second.first;
	for (int i = 2; i <= n; i++) {
		int l = for_sort[i].first, r = for_sort[i].second.first;
		for (int j = 0; j < i; j++) {
			int cur_r = st[i - 1][j];
			if (cur_r == INF || cur_r > l) continue;
			st[i][j] = min(st[i - 1][j], st[i][j]);
			st[i][j + 1] = min(st[i][j + 1], r);
		}
	}
}
void make_dp() {
	dp[0][0][0] = 0;
	pred[0][0][0] = { 0,0,0 };
	for (int i = 1; i <= n; i++) {
		int l = for_sort[i].first;
		for (int j = 0; j <= min(n / 2, i); j++) {
			for (int p = 0; p < i; p++) {
				int cur_r = for_sort[p].second.first;
				/*
				debug(i);
				debug(j);
				debug(l);
				debug(p);
				debug(cur_r);
				*/
				if (dp[i - 1][j][p] != -1 && dp[i][j][p] < dp[i-1][j][p]) {
					dp[i][j][p] = dp[i - 1][j][p];
					pred[i][j][p] = { i - 1,j,p };
				}
				if (dp[i][j][p] == m / 2 && j == n/2) continue;
				if (l > cur_r && dp[i - 1][j][p] + 1 > dp[i][j + 1][i] && dp[i - 1][j][p]!=-1 ) {
					dp[i][j + 1][i] = dp[i - 1][j][p] + 1;
					pred[i][j + 1][i] = { i - 1,j,p };
				}
			}
		}
	}
}
void solve() {
	all.clear();
	cin >> n;
	st = vector<vector<int> >(n + 1, vector<int>(n + 1, INF));
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> l >> r;
		all.pb({ l,r });
		for_sort.pb({ l,{r,i} });
	}
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int p = 0; p <= n; p++) {
				dp[i][j][p] = -1;
				pred[i][j][p] = { -1,-1,-1 };
			}
		}
	}
	reverse(all.begin(), all.end());
	all.pb({ 0,0 });
	reverse(all.begin(), all.end());
	sort(for_sort.begin(), for_sort.end());
	reverse(for_sort.begin(), for_sort.end());
	for_sort.pb({ 0,{0,0 } });
	reverse(for_sort.begin(), for_sort.end());
	make_start();
	for (int i = 0; i <= n; i++) {
		if (st[n][i] != INF) {
			m = i;
		}
	}
	make_dp();
	node l = { -1,-1,-1 };
	vector<int> ans;
	for (int i = 0; i <= n; i++) {
		if (dp[n][m / 2][i]!=-1) {
			l = { n,m / 2,i };
			break;
		}
	}
	while (l.i != 0) {
		node nex = pred[l.i][l.j][l.p];
		if (nex.j != l.j) {
			ans.pb(for_sort[l.j].second.second);
		}
		l = nex;
	}
	vector<int> used(n);
	for (auto c : ans) used[c] = 1;
	for (auto c : for_sort) {
		if (ans.size() == n / 2) break;
		if (used[c.second.second]) continue;
		ans.pb(c.second.second);
	}
	for (auto c : ans) cout << c + 2 << " ";
	cout << endl;
}
signed main()
{
	ios_base::sync_with_stdio();
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	cin>>t;
	while (t--) {
		solve();
	}
}