#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<pair<int, int>> tree;

pair<int, int> mx(int v, int l, int r, int ql, int qr) {
    if (ql == qr) {
        return {0, -1};
    }
    if (l >= qr || r <= ql) {
        return {0, -1};
    }
    if (l >= ql && r <= qr) {
        return tree[v];
    }
    return max(mx(v * 2 + 1, l, (l + r) / 2, ql, qr), mx(v * 2 + 2, (l + r) / 2, r, ql, qr));
}

void upd(int v, int l, int r, int i, pair<int, int> x) {
    if (l + 1 == r) {
        tree[v] = max(x, tree[v]);
        return;
    }
    if ((l + r) / 2 <= i) {
        upd(v * 2 + 2, (l + r) / 2, r, i, x);
    } else {
        upd(v * 2 + 1, l, (l + r) / 2, i, x);
    }
    tree[v] = max(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get1(vector<int> a, int M) {
    int lst = -1;
    int res = 0;
    for (auto i: a) {
        if (i > lst) {
            ++res;
            lst = i;
        }
    }
    return res;
}

int get2(vector<int> a, int M) {
    int lst = 1e9 + 1;
    int res = 0;
    for (auto i: a) {
        if (i < lst) {
            ++res;
            lst = i;
        }
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    set<int> b;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int ans = 0;
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<int> f;
        vector<int> s;
        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                f.push_back(a[i]);
            } else {
                s.push_back(a[i]);
            }
        }
        ans = max(ans, get1(f, 0) + get2(s, 0));
    }
    cout << ans << "\n";
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
