#include <bits/stdc++.h>

#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define For(i, n) for (int i = 0; i < n; i++)
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpi vector<pii>
#define ld long double
#define ll long long
#define pb push_back
#define eb emplace_back

using namespace std;

const int INF = 1e9 + 7;
const int INFLL = 1e18 + 3;

mt19937 rnd(time(0));

struct Fenwick {
    int n;
    vi s;
    Fenwick(int nn) {
        n = nn;
        s.resize(nn, 0);
    }
    int get_pref(int r) {
        int res = 0;
        for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
            res = max(res, s[i]);
        }
        return res;
    }
    void upd(int pos, int val) {
        for (int i = pos; i < n; i = (i | (i + 1))) {
            s[i] = max(s[i], val);
        }
    }
};

int nvp(vi & a) {
    Fenwick fen(sz(a) + 1);
    for (int i = 0; i < sz(a); i++) {
        int v = fen.get_pref(a[i] - 1);
        v++;
        fen.upd(a[i], v);
    }
    return fen.get_pref(sz(a));
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    string da = "YES\n"; string net = "NO\n"; string OK = "OK\n";

    int T;
    cin >> T;
    while (T--) {
        int n;
        cin >> n;
        vi a(n);
        For(i, n) cin >> a[i];

        vi ind(n + 1);
        For(i, n) {
            ind[a[i]] = i;
        }
        int mxq = 0;
        int q = nvp(a);
        vi pref_max(n + 1, 0);
        vi suf_max(n + 1, 0);
        For(i, n) {
            if (a[i] > mxq) {
                mxq = a[i];
            }
            pref_max[i + 1] = mxq;
        }
        mxq = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (a[i] > mxq) {
                mxq = a[i];
            }
            suf_max[i] = mxq;
        }
        int ans;
        if (q == n) {
            ans = n;
            cout << ans << endl;
            continue;
        }
        else {
            ans = q + 1;
        }

        for (int mx = n; mx >= 1; mx--) {
            if (ind[mx] == n - 1) continue;
            if (ind[mx] == n - 2 && mx == n) continue;\
//            cout << mx << ' ' << ind[mx] << ' ' << pref_max[ind[mx]] << ' ' << suf_max[ind[mx] + 1] << endl;
            if (pref_max[ind[mx]] < suf_max[ind[mx] + 1]) {
                ans++;
                break;
            }
        }
        cout << ans << endl;
    }
    return 1337 / 2286942;
}
