#include <bits/stdc++.h>

#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define pb push_back
#define eb emplace_back
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define vpi vector<pii>
#define ll long long
#define ld long double
#define For(i, n) for (int i = 0; i < n; i++)

using namespace std;

const int INF = 1e9 + 7;
const int INFLL = 1e18 + 3;

mt19937 rnd(time(0));

int n;
vvi gr;
vi cnt; // cnt turns on the way to vertex v
vi tin, tout;
vpi times; // segment of leaves
vi leaves;

int timer = 0;
void dfs(int v, int type) {
    if (!gr[v].empty()) {
        For(i, 2) {
            if (i == type || v == 0) {
                cnt[gr[v][i]] = cnt[v];
            } else {
                cnt[gr[v][i]] = cnt[v] + 1;
            }
            dfs(gr[v][i], i);
        }
    }
}

pii dfs2(int v) {
    if (gr[v].empty()) {
        times[v] = {timer, timer + 1};
        timer++;
        leaves.pb(cnt[v]);
        return times[v];
    } else {
        int l = dfs2(gr[v][0]).first;
        int r = dfs2(gr[v][1]).second;
        times[v] = {l, r};
        return times[v];
    }
}

struct SegmentTree {
    int n;
    vvi tree;
    void build(vi & arr) {
        n = sz(arr);
        tree.resize(4 * n);
        build(0, 0, n, arr);
    }
    void build(int v, int tl, int tr, vi & arr) {
        if (tl + 1 == tr) {
            tree[v].pb(arr[tl]);
        } else {
            int tm = (tl + tr) / 2;
            build(2 * v + 1, tl, tm, arr);
            build(2 * v + 2, tm, tr, arr);
            merge(all(tree[2 * v + 1]), all(tree[2 * v + 2]), back_inserter(tree[v]));
        }
    }

    int get(int l, int r, int k) {
        return get(0, 0, n, l, r, k);
    }
    int get(int v, int tl, int tr, int l, int r, int k) {
        if (tl >= r || tr <= l) {
            return 0;
        }
        if (tl >= l && tr <= r) {
            return upper_bound(all(tree[v]), k) - tree[v].begin();
        }
        int tm = (tl + tr) / 2;
        return get(2 * v + 1, tl, tm, l, r, k) + get(2 * v + 2, tm, tr, l, r, k);
    }
};


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    string da = "YES\n", net = "NO\n", OK = "OK\n";

    int k, T;
    cin >> n >> k >> T;
    gr.resize(n);
    cnt.resize(n, 0);
    tin.resize(n);
    tout.resize(n);
    times.resize(n);
    For(i, n) {
        int t; cin >> t;
        if (t == 2) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            gr[i].pb(a);
            gr[i].pb(b);
        }
    }
    dfs(0, -1);
    dfs2(0);
    SegmentTree tree;
    tree.build(leaves);
//    For(i, n) {
//        cout << i + 1 << ' ' << cnt[i] << endl;
//    }
//    For(i, sz(leaves)) {
//        cout << leaves[i] << ' ';
//    }
//    cout << endl;

    while (T--) {
        int u;
        cin >> u; u--;
        auto [l, r] = times[u];
        int ans = tree.get(l, r, k);
        cout << ans << endl;
    }
    return 1337 / 2286942;
}
