#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()

vector<int> tree;

int gtmx(int i, int l, int r, int lq, int rq) {
	if (rq <= l || r <= lq) {
		return 0;
	}
	if (lq <= l && r <= rq) {
		return tree[i];
	}
	int mid = (l + r) / 2;
	return max(gtmx(2 * i + 1, l, mid, lq, rq), gtmx(2 * i + 2, mid, r, lq, rq));
}

void st(int i, int l, int r, int q, int val) {
	if (l + 1 == r) {
		tree[i] = val;
		return;
	}
	int mid = (l + r) / 2;
	if (q < mid) {
		st(2 * i + 1, l, mid, q, val);
	} else {
		st(2 * i + 2, mid, r, q, val);
	}
	tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

void solve() {
	int n; cin >> n;
	vector<int> p(n);
	for (int i = 0; i < n; ++i) {
		cin >> p[i];
	}
	if (n > 200) {
		tree.resize((n + 1) * 4, 0);
		vector<int> didnt_add;
		didnt_add.push_back(0);
		int mx1 = 0;
		for (int i = 0; i < n; ++i) {
			int nw = gtmx(0, 0, n + 1, 0, p[i]) + 1;
			if (p[i] > mx1) {
				mx1 = p[i];
			} else {
				for (int j : didnt_add) {
					if (j != mx1) {
						st(0, 0, n + 1, j, gtmx(0, 0, n + 1, j, j + 1) + 1);
					}
				}
				didnt_add.clear();
				didnt_add.push_back(mx1);
			}
			didnt_add.push_back(p[i]);
			st(0, 0, n + 1, p[i], nw);
		}
		int ans = tree[0] + 1;
		ans = min(ans, n);
		cout << ans << '\n';
		return;
	}
	vector<vector<int>> dp(n + 2, vector<int>(n + 2, -1));
	vector<vector<int>> ndp = dp;
	dp[0][n + 1] = 0;
	for (int nxt = 0; nxt < n; ++nxt) {
		for (int i = 0; i <= n + 1; ++i) {
			for (int j = 0; j <= n + 1; ++j) {
				ndp[i][j] = -1;
			}
		}
		for (int mx = 0; mx <= n; ++mx) {
			for (int mn = 1; mn <= n + 1; ++mn) {
				if (dp[mx][mn] == -1) {
					continue;
				}
				int val = dp[mx][mn];
				if (p[nxt] < mx || p[nxt] > mn) {
					ndp[mx][mn] = max(ndp[mx][mn], val);
				}
				if (p[nxt] > mx) {
					ndp[p[nxt]][mn] = max(ndp[p[nxt]][mn], val + 1);
				}
				if (p[nxt] < mn) {
					ndp[mx][p[nxt]] = max(ndp[mx][p[nxt]], val + 1);
				}
			}
		}
		dp = ndp;
	}
	int ans = 0;
	for (int i = 0; i <= n + 1; ++i) {
		for (int j = 0; j <= n + 1; ++j) {
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
