#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
#include <map>
#include <deque>
#include <cmath>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
const int SZ = (1 << 16);
int to[SZ];
int MEX[SZ];
int used[SZ];
int in_cycle[SZ];
int MEX_PR[SZ];

void solve() {
	int k, n, p;
	cin >> k >> n >> p;
	int ans = 0;
	k = (1 << k);
	for (int mask = 1; mask < (1 << k); mask += 2) {
		int cn = 0;
		for (int j = 0; j < k; ++j) {
			if ((mask & (1 << j))) {
				++cn;
			}
		}
		if (cn == n && MEX_PR[mask] == p) {
			++ans;
		}
	}
	cout << ans << '\n';
}

void dfs(int u) {
	used[u] = 1;
	int v = to[u];
	if (used[v] == 1) {
		in_cycle[v] = 1;
	}
	if (used[v] == 0) {
		dfs(v);
	}
	used[u] = 2;
}

int dfs2(int u, int must_be) {
	used[u] = 3;
	if (MEX[u] != must_be) {
		return 0;
	}
	int v = to[u];
	if (used[v] == 3) {
		return 1;
	}
	return dfs2(v, must_be);
}

void dfs3(int u, int mex_pr) {
	MEX_PR[u] = mex_pr;
	used[u] = 4;
	int v = to[u];
	if (used[v] == 4) {
		return;
	}
	dfs3(v, mex_pr);
}

void dfs4(int u) {
	used[u] = 4;
	int v = to[u];
	if (used[v] != 4) {
		dfs4(v);
	}
	MEX_PR[u] = MEX_PR[v];
}

void precalc() {
	for (int mask = 1; mask < SZ; mask += 2) {
		vector<int> p;
		for (int j = 0; j < 16; ++j) {
			if ((mask & (1 << j))) {
				p.push_back(j);
			}
		}
		int mex = -1;
		for (int j = 1; j < (int)p.size(); ++j) {
			if (p[j - 1] + 1 != p[j]) {
				mex = p[j - 1] + 1;
				break;
			}
		}
		if (mex == -1) {
			mex = p.back() + 1;
		}
		MEX[mask] = mex;
		int new_mask = 0;
		for (int j = 0; j < (int)p.size(); ++j) {
			new_mask += (1 << ((mex - 1) ^ p[j]));
		}
		to[mask] = new_mask;
	}
	for (int i = 1; i < SZ; i += 2) {
		if (used[i] == 0) {
			dfs(i);
		}
	}
	for (int i = 1; i < SZ; i += 2) {
		if (in_cycle[i]) {
			int nw = dfs2(i, MEX[i]);
			if (nw == 0) {
				dfs3(i, -1);
			} else {
				dfs3(i, MEX[i]);
			}
		}
	}
	for (int i = 1; i < SZ; i += 2) {
		if (used[i] == 2) {
			dfs4(i);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	precalc();
	ll m; cin >> m;
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
