#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
ll inf = 1e18;

vector<vector<int>> edge;
vector<ll> L, R, a;

pair<ll, ll> dfs(int u, int p) {
	ll nt = 0, t = 0;
	for (int v : edge[u]) {
		if (v == p) {
			continue;
		}
		pair<ll, ll> ns = dfs(v, u);
		nt += max(ns.first, ns.second);
		t += ns.first;
	}
	t += a[u];
	return { nt, t };
}

ll cert(ll x, ll y, ll m) {
	ll ans = 0;
	for (int i = 0; i < (int)a.size(); ++i) {
		ans = (ans ^ (((ll)i * x + (((y * a[i]) % m) * a[i] % m)) % m));
	}
	return ans;
}

void solve() {
	edge.clear();
	L.clear();
	R.clear();
	a.clear();
	int n, q; cin >> n >> q;
	ll x, y, m; cin >> x >> y >> m;
	edge.resize(n);
	L.resize(n);
	R.resize(n);
	a.resize(n);
	for (int i = 0; i + 1 < n; ++i) {
		int u, v; cin >> u >> v; --u; --v;
		edge[u].push_back(v);
		edge[v].push_back(u);
	}
	for (int i = 0; i < n; ++i) {
		cin >> L[i] >> R[i];
		a[i] = L[i];
	}
	vector<ll> v(q);
	for (int i = 0; i < q; ++i) {
		cin >> v[i];
	}
	auto ns = dfs(0, 0);
	ll V = max(ns.first, ns.second);
	for (int i = 0; i < q; ++i) {
		if (v[i] != V) {
			cout << "-1 ";
		} else {
			cout << cert(x, y, m) << ' ';
		}
	}
	cout << '\n'; cout.flush();
	int i; cin >> i;
	while (i > 0) {
		--i;
		if (v[i] != V) {
			cout << "-1\n";
			cout.flush();
		} else {
			for (int i = 0; i < n; ++i) {
				cout << a[i] << ' ';
			}
			cout << '\n';
			cout.flush();
		}
		cin >> i;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
