#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <deque>
#include <iomanip>

using namespace std;

typedef long long ll;

#define all(x) x.begin(), x.end()
ll inf = 1e18;

vector<vector<int>> edge;
vector<ll> L, R, a;
vector<vector<ll>> aw;
vector<ll> V;
vector<ll> ccr;
map<ll, int> byc;
ll x, y, m;

pair<ll, ll> dfs(int u, int p) {
	ll nt = 0, t = 0;
	for (int v : edge[u]) {
		if (v == p) {
			continue;
		}
		pair<ll, ll> ns = dfs(v, u);
		nt += max(ns.first, ns.second);
		t += ns.first;
	}
	t += a[u];
	return { nt, t };
}

ll cert() {
	ll ans = 0;
	for (int i = 0; i < (int)a.size(); ++i) {
		ans = (ans ^ (((ll)(i + 1) * x + (((y * a[i]) % m) * a[i] % m)) % m));
	}
	return ans;
}

void obr() {
	auto ans = dfs(0, 0);
	aw.push_back(a);
	V.push_back(max(ans.first, ans.second));
	ccr.push_back(cert());
	byc[V.back()] = V.size();
}

void per(int i, int n) {
	if (i == n) {
		obr();
		return;
	}
	for (ll cost = L[i]; cost <= R[i]; cost += 1LL) {
		a[i] = cost;
		per(i + 1, n);
	}
}

void solve() {
	aw.clear();
	V.clear();
	ccr.clear();
	byc.clear();
	edge.clear();
	L.clear();
	R.clear();
	a.clear();
	int n, q; cin >> n >> q;
	cin >> x >> y >> m;
	edge.resize(n);
	L.resize(n);
	R.resize(n);
	a.resize(n);
	for (int i = 0; i + 1 < n; ++i) {
		int u, v; cin >> u >> v; --u; --v;
		edge[u].push_back(v);
		edge[v].push_back(u);
	}
	for (int i = 0; i < n; ++i) {
		cin >> L[i] >> R[i];
	}
	per(0, n);
	vector<ll> v(q);
	for (int i = 0; i < q; ++i) {
		cin >> v[i];
	}
	for (int i = 0; i < q; ++i) {
		if (byc[v[i]] == 0) {
			cout << "-1 ";
		} else {
			cout << ccr[byc[v[i]] - 1] << ' ';
		}
	}
	cout << '\n'; cout.flush();
	int i; cin >> i;
	while (i > 0) {
		--i;
		if (byc[v[i]] == 0) {
			cout << "-1\n"; cout.flush();
		} else {
			vector<ll> ws = aw[byc[v[i]] - 1];
			for (ll j : ws) {
				cout << j << ' ';
			}
			cout << '\n'; cout.flush();
		}
		cin >> i;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int t = 1; cin >> t;
	while (t--) {
		solve();
	}
}
