#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

void push(vector<ll> &d, ll v, ll vl, ll vr) {
    if (d[v] < 0) return;
    if (vl + 1 != vr) {
        d[LC(v)] = d[v];
        d[RC(v)] = d[v];
    }
    d[v] = -1;
}

void update(vector<ll> &d, ll l, ll r, ll x, ll v, ll vl, ll vr) {
    if (r <= vl || vr <= l) return;
    if (l <= vl && vr <= r) d[v] = x;
    else {
        push(d, v, vl, vr);
        ll vm = (vl + vr) / 2;
        update(d, l, r, x, LC(v), vl, vm);
        update(d, l, r, x, RC(v), vm, vr);
    }
}

ll query(vector<ll> &d, ll i, ll v, ll vl, ll vr) {
    if (i < vl || vr <= i) return -1;
    if (vl + 1 == vr) return d[v];
    else {
        push(d, v, vl, vr);
        ll vm = (vl + vr) / 2;
        ll x = query(d, i, LC(v), vl, vm);
        ll y = query(d, i, RC(v), vm, vr);
        return max(x, y);
    }
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
ios_base::sync_with_stdio(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n;
        cin >> n;
        vector<pair<ll, ll>> a(n);
        for (auto &[l, r]: a) cin >> l >> r;
        {
            vector<ll> f;
            f.reserve(2 * n);
            for (auto &[l, r]: a) {
                f.push_back(l);
                f.push_back(r);
            }
            sort(f.begin(), f.end());
            f.resize(unique(f.begin(), f.end()) - f.begin());
            for (auto &[l, r]: a) {
                l = lower_bound(f.begin(), f.end(), l) - f.begin();
                r = lower_bound(f.begin(), f.end(), r) - f.begin();
            }
        }
        vector<ll> o(n);
        for (ll i = 0; i < n; i++) o[i] = i;
        sort(o.begin(), o.end(), [&a](ll i, ll j) -> bool {
            ll si = a[i].second - a[i].first;
            ll sj = a[j].second - a[j].first;
            return si > sj;
        });
        vector<set<ll>> g(n);
        vector<ll> p(n, -1);
        {
            vector<ll> d(8 * n, -1);
            for (ll u: o) {
                ll v0 = query(d, a[u].first, 0, 0, 2 * n);
                if (v0 != -1) {
                    g[v0].insert(u);
                    p[u] = v0;
                }
                update(d, a[u].first, a[u].second + 1, u, 0, 0, 2 * n);
            }
        }
        vector<ll> w(n);
        set<ll> s;
        for (ll v = 0; v < n; v++) if (g[v].empty()) s.insert(v);
        ll m = ll(s.size());
        ll del1 = ll(s.size()) / 2ll, del0 = n / 2;
        while (del1) {
            ll v0 = -1, c0 = 1e18;
            for (ll v: s) {
                ll c = 0;
                for (ll u = v; u != -1 && ll(g[u].size()) < 2; u = p[u]) c++;
                if (c < c0) c0 = c, v0 = v;
            }
            s.erase(v0);
            del1--;
            for (ll u = v0; u != -1 && ll(g[u].size()) < 1; u = p[u]) {
                w[u] = 1;
                del0--;
                if (p[u] != -1) g[p[u]].erase(u);
            }
        }
        s.clear();
        for (ll v = 0; v < n; v++) if (!w[v] && !g[v].empty() && p[v] == -1) s.insert(v);
        while (del0) {
            ll v = *s.begin();
            s.erase(s.begin());
            w[v] = 1;
            for (ll u: g[v]) if (!g[u].empty()) s.insert(u);
            del0--;
        }
        ll sus = 0, kek = 0;
        for (ll v = 0; v < n; v++) if (!w[v]) cout << v + 1 << ' ', sus++, kek += ll(g[v].empty());
        cout << '\n';
    }
}
/*
1
12
1 14
2 4
3 4
6 10
6 8
9 10
12 14
16 24
16 19
16 19
21 24
22 23
*/