#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

pair<ll, ll> calc(const vector<vector<ll>> &g, const vector<ll> &a, ll v = 0, ll w = -1) {
    pair<ll, ll> res{a[v], 0};
    for (ll u: g[v]) {
        if (u == w) continue;
        auto cur = calc(g, a, u, v);
        res.first += cur.second;
        res.second += max(cur.first, cur.second);
    }
    return res;
}

void comb(const vector<vector<ll>> &g, const vector<pair<ll, ll>> &f, unordered_map<ll, vector<ll>> &d, vector<ll> &a,
          ll i = 0) {
    ll n = ll(a.size());
    if (i == n) {
        pair<ll, ll> res = calc(g, a);
        ll cur = max(res.first, res.second);
        d[cur] = a;
        return;
    }
    for (ll e = f[i].first; e <= f[i].second; e++) {
        a[i] = e;
        comb(g, f, d, a, i + 1);
    }
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
ios_base::sync_with_stdio(0);
#endif
    ll t;
    cin >> t;
    while (t--) {
        ll n, q;
        cin >> n >> q;
        vector<vector<ll>> g(n);
        ll x, y, m;
        cin >> x >> y >> m;
        for (ll j = 0; j < n - 1; j++) {
            ll v, u;
            cin >> v >> u;
            v--, u--;
            g[v].push_back(u);
            g[u].push_back(v);
        }
        vector<pair<ll, ll>> f(n);
        for (auto &[l, r]: f) cin >> l >> r;
        vector<ll> h(q);
        for (ll &e: h) cin >> e;
        unordered_map<ll, vector<ll>> d;
        {
            vector<ll> a(n);
            //comb(g, f, d, a);
        }
        for (ll j = 0; j < q; j++) {
            if (d.find(h[j]) == d.end()) {
                cout << "-1 ";
                continue;
            }
            const auto &a = d[h[j]];
            ll sum = 0;
            for (ll i = 0; i < n; i++) {
                ll cur = (x * (i + 1) % m + y * a[i] % m * a[i] % m) % m;
                sum ^= cur;
            }
            cout << sum << ' ';
        }
        cout << endl;
        while (true) {
            ll j;
            cin >> j;
            if (!j) break;
            j--;
            if (d.find(h[j]) == d.end()) {
                cout << "-1" << endl;
                continue;
            }
            const auto &a = d[h[j]];
            for (ll e: a) cout << e << ' ';
            cout << endl;
        }
    }
}