#include "bits/stdc++.h"


using namespace std;
using ll = long long;


#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
constexpr int MAXN = 2e5 + 10;


struct Segment {
	int first, second, ind;

	Segment() = default;
	Segment(int first, int second, int ind) : first(first), second(second), ind(ind) {}
};


void solve() {
	int n;
	cin >> n;
	vector<Segment> v(n);
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		v[i] = Segment(l, r, i);
	}
	sort(v.begin(), v.end(), [](Segment& x, Segment& y) {return x.second < y.second || x.second == y.second && x.first > y.first; });
	int last = -1e9;
	int m = 0;
	for (int i = 0; i < n; ++i) {
		auto [l, r, ind] = v[i];
		if (l > last) {
			++m;
			last = r;
		}
	}
	for (int l = 0; l < n; ++l) {
		for (int r = l + n / 2; r <= n; ++r) {
			int last = 0;
			unordered_set<int> used;
			used.reserve(m);
			for (int i = l; i < r; ++i) {
				auto [l, r, ind] = v[i];
				if (l > last) {
					last = r;
					used.insert(i);
				}
			}
			if (used.size() == m / 2) {
				for (auto it : used) cout << v[it].ind + 1 << '\n';
				int ost = n / 2 - m / 2;
				for (int i = l; i < r; ++i) {
					if (ost && used.find(i) == used.end()) {
						--ost;
						cout << v[i].ind + 1 << ' ';
					}
				}
				return;
			}
		}
	}
}


signed main() {
	FAST_IO;
	int t;
	for (cin >> t; t; --t) {
		solve();
		cout << '\n';
	}
}