#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <bitset>
using namespace std;
#define int long long
#define ll long long
#define ld long double
#define pi pair<int, int>
#define vi vector<int>
const int INF = 1e10;
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}
vector<int> en;
vector<int> go_to;
vector<int> mech;
vector<int> used;
vector<bool> is_on_cyc;
vector<int> cyc;
int M = 0;
void DFS(int msk) {
	used[msk] = 1;
	int gt = go_to[msk];
	if (used[gt] == 1) {
		is_on_cyc[gt] = true;
		used[gt] = 2;
		if (gt == msk) used[gt] = 2;
		return;
	}
	if (used[gt] == 0) DFS(gt);
	used[msk] = 2;
}
void DFS2(int num) {
	used[num] = 2;
	cyc.push_back(num);
	int gt = go_to[num];
	if (used[gt] == 2) return;
	else DFS2(gt);
}
void DFS3(int num) {
	used[num] = 2;
	int gt = go_to[num];
	if (used[gt] != 2) DFS3(gt);
	en[num] = en[gt];
}
void solve() {
	cyc.clear();
	int K = 0, N = 0, P = 0; cin >> K >> N >> P;
	int sz = (1 << K);
	go_to.assign((1 << sz), -1);
	mech.assign((1 << sz), -1);
	for (int i = 0; i < (1 << sz); ++i) {
		vector<int> a;
		for (int j = 0; j < sz; ++j) {
			if (isKthBitSet(i, j)) {
				a.push_back(j);
			}
		}
		if (!isKthBitSet(i, 0)) continue;
		if (a.size() != N) continue;
		sort(a.begin(), a.end());
		int mch = -1;
		for (int j = 0; j < a.size(); ++j) {
			if (a[j] != j) {
				mch = j; break;
			}
		}
		if (mch == -1) mch = a.size();
		int tozr = 0;
		for (auto x : a) {
			tozr += (1ll << (x ^ (mch - 1)));
		}
		go_to[i] = tozr;
		mech[i] = mch;
	}
	used.assign((1 << sz), false);
	is_on_cyc.assign((1 << sz), false);
	for (int i = 0; i < (1 << sz); ++i) {
		if (mech[i] == -1) continue;
		if (!used[i]) DFS(i);
	}
	used.assign((1 << sz), 0);
	en.assign((1 << sz), -1);
	for (int i = 0; i < (1 << sz); ++i) {
		if (mech[i] == -1) continue;
		cyc.clear();
		if (is_on_cyc[i] && !used[i]) DFS2(i);
		else continue;
		int nmch = mech[cyc[0]];
		bool brk = false;
		for (auto x : cyc) {
			if (mech[x] != nmch) {
				brk = true;
				break;
			}
		}
		if (brk) {
			for (auto x : cyc) en[x] = -1;
		}
		else {
			for (auto x : cyc) en[x] = nmch;
		}
	}
	for (int i = 0; i < (1 << sz); ++i) {
		if (mech[i] == -1) continue;
		if (!used[i]) DFS3(i);
	}
	vector<int> ans; ans.assign(1ll << K + 1, 0);
	for (int i = 0; i < (1 << sz); ++i) {
		if (mech[i] == -1 || en[i] == -1) continue;
		ans[en[i]]++;
	}
	ans[P] %= M;
	cout << ans[P] << "\n";
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1;
	cin >> M;
	cin >> T;
	while (T--) {
		solve();
	}
}