#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <random>
#include <map>
#include <set>
#include <cassert>
using namespace std;
#define int long long
#define pi pair<int, int>
#define vi vector<int> 
const int INF = 1e18 + 10;
int gt(vi& a) {
	int cur = 0;
	for (int j = 0; j < a.size(); ++j) {
		if (a[j] - 1 > cur) return cur;
		cur += a[j];
	}
	return cur;
}
bool isKthBitSet(int num, int k) {
	return num & (1ll << k);
}
const int AMAX = 301;
void solve() {
	int N = 0, Q = 0; cin >> N >> Q;
	vector<int> w; w.assign(N, 0);
	for (auto& x : w) cin >> x;
	sort(w.begin(), w.end());
	vector<int> rch; rch.push_back(0);
	for (int i = 0; i < N; ++i) {
		if (rch.back() < w[i] - 1) rch.push_back(rch.back());
		else rch.push_back(rch.back() + w[i]);
	}
	int z = 0; cin >> z;
	vector<vector<vector<int>>> dp;
	dp.assign(N + 1, vector<vi>(AMAX, vi(AMAX, -1)));
	dp[0][0][0] = 1;
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j < AMAX; ++j) {
			for (int k = 0; k < AMAX; ++k) {
				if (dp[i][j][k] == -1) continue;
				if (j + w[i] < AMAX) dp[i + 1][j + w[i]][k] = 1;
				if (k + w[i] < AMAX) dp[i + 1][j][k + w[i]] = 1;
				dp[i + 1][j][k] = 1;
			}
		}
	}
	vector<vector<int>> mn;
	mn.assign(AMAX, vector<int>(AMAX, INF));
	for (int i = 0; i < AMAX; ++i) {
		for (int j = 0; j < AMAX; ++j) {
			for (int ind = 0; ind <= N; ++ind) {
				if (dp[ind][i][j] == 1) {
					if (ind == 0) mn[i][j] = ind;
					else mn[i][j] = w[ind - 1];
					break;
				}
			}
		}
	}
	vector<vector<int>> pref;
	pref.assign(AMAX, vector<int>(AMAX, 0));
	pref[0][0] = mn[0][0];
	for (int i = 0; i < AMAX; ++i) {
		for (int j = 0; j < AMAX; ++j) {
			pref[i][j] = mn[i][j];
			if (i > 0) pref[i][j] = max(pref[i][j], mn[i - 1][j]);
			if (j > 0) pref[i][j] = max(pref[i][j], mn[i][j - 1]);
		}
	}
	while (Q--) {
		int jj = 0, c = 0, d = 0; cin >> jj >> c >> d;
		if (d == 0) {
			int ps = upper_bound(w.begin(), w.end(), jj) - w.begin();
			if (rch[ps] >= c) cout << "Yes\n";
			else cout << "No\n"; 
			continue;
		}
		if (pref[c][d] > jj) cout << "No\n";
		else cout << "Yes\n";
	}
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1; //cin >> T;
	for (int i = 0; i < T; ++i) {
		solve();
	}
	return 0;
}
