#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <deque>

using namespace std;
typedef long long ll;

inline vector <int> code(int n, vector <int> a)
{
	int k = a.size();
	vector <int> ans;

	set <int> all;
	for (auto i : a) all.insert(i);

	int i = 1;

	for (auto j : a)
	{
		i = max(i, j + 1);
		while (true)
		{
			if (i > n) i = 1;
			if (all.count(i))
			{
				++i;
				continue;
			}
			ans.push_back(i);
			all.insert(i);
			++i;
			break;
		}
	}

	sort(ans.begin(), ans.end());
	return ans;
}

bool b[5010];

inline vector <int> decode(int n, vector <int> a)
{
	int k = a.size();
	vector <int> emp;
	vector <int> ans;

	for (int i = 1; i <= n; ++i) b[i] = false;
	for (auto i : a) b[i] = true;

	int more = 0;
	for (int i = 1; i <= n; ++i)
	{
		if (b[i] && emp.size())
		{
			ans.push_back(emp.back());
			emp.pop_back();
		}
		else if (b[i])
		{
			++more;
		}
		else
		{
			emp.push_back(i);
		}
	}

	while (more--)
	{
		ans.push_back(emp.back());
		emp.pop_back();
	}

	sort(ans.begin(), ans.end());
	return ans;
}

bool check(int n)
{
	set <vector <int>> all;
	for (int i = 1; i < (1 << n); ++i)
	{
		vector <int> to;
		for (int j = 0; j < n; ++j)
		{
			if ((i >> j) & 1) to.push_back(j + 1);
		}
		if (to.size() * 2 > n) continue;
		auto got = code(n, to);
		auto got2 = decode(n, got);
		if (got2 != to)
		{
			cout << "!";
		}
	}
	return true;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	
	//for (int i = 2; i < 10; ++i) check(i);

	int t;
	cin >> t;
	int m;
	cin >> m;
	while (m--)
	{
		vector <int> got;
		int n, k;
		cin >> n >> k;
		vector <int> a(k);
		for (int i = 0; i < k; ++i) cin >> a[i];
		if (t == 1) got = code(n, a);
		else got = decode(n, a);
		for (auto i : got) cout << i << ' ';
		cout << endl;
	}

	return 0;
}