#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>

using namespace std;
typedef long long ll;
#define endl '\n'
#define int long long

int n, q;
int w[300010];
int Z;

const int A = 5010;

int dp[A][A];
const int inf = 1e18;

bool solve(int k, int a, int b)
{
	int l = 0, r = n + 1;
	while (l + 1 < r)
	{
		int mid = (l + r) >> 1;
		if (w[mid] <= k) l = mid;
		else r = mid;
	}
	int ans = inf;
	for (int j = 0; j <= a; ++j) ans = min(ans, dp[l][j]);
	return ans >= b;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> q;

	for (int i = 1; i <= n; ++i)
	{
		cin >> w[i];
	}

	sort(w + 1, w + 1 + n);

	for (int i = 0; i <= n; ++i) for (int j = 0; j < A; ++j) dp[i][j] = -inf;

	dp[0][0] = 0;

	for (int i = 1; i <= n; ++i)
	{
		for (int j = A - 1; j >= 0; --j)
		{
			dp[i][j] = dp[i - 1][j];
			if (dp[i][j] >= w[i] - 1) dp[i][j] += w[i];
			if (j >= w[i]) dp[i][j] = max(dp[i][j], dp[i - 1][j - w[i]]);
		}
	}

	cin >> Z;
	int v = 0;
	while (q--)
	{
		int j, c, d;
		cin >> j >> c >> d;
		int k = j - v * Z, a = c - v * Z, b = d - v * Z;

		auto got = solve(k, a, b);
		v += got;
		cout << (got ? "Yes" : "No") << endl;
	}

	return 0;
}