#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

struct Query {
    int k, a, b, id;
};

void solve() {
    int n, q;
    cin >> n >> q;

    vector <int> w(n);
    for (int& i : w)
        cin >> i;

    sort(all(w));

    int z;
    cin >> z;

    vector <Query> query;
    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;
        query.push_back({k, a, b, i});
    }

    sort(all(query), [&](Query i, Query j) {
        return i.k < j.k;
    });

    const int MAX = 305;

    vector <vector <bool>> ok(MAX, vector <bool> (MAX, false));
    ok[0][0] = 1;

    for (int i = 0; i < n; i++) {
        for (int j = MAX - 1; j >= 0; j--) {
            for (int k = MAX - 1; k >= 0; k--) {
                if (ok[j][k]) {
                    if (j + w[i] < MAX) {
                        ok[j + w[i]][k] = true;
                    }
                    if (k + w[i] < MAX) {
                        ok[j][k + w[i]] = true;
                    }
                }
            }
        }
    }

    vector <vector <bool>> ans(MAX, vector <bool> (MAX, false));
    ans[0][0] = true;
    for (int i = 1; i < MAX; i++) {
        ans[i][0] = ans[i - 1][0] && ok[i][0];
        ans[0][i] = ans[0][i - 1] && ok[0][i];
    }
    for (int i = 1; i < MAX; i++) {
        for (int j = 1; j < MAX; j++) {
            ans[i][j] = (ans[i - 1][j] && ans[i][j - 1] && ok[i][j]);
        }
    }

    vector <int> res(q);
    for (int i = 0; i < q; i++) {
        res[query[i].id] = ans[query[i].a][query[i].b];
    }

    for (auto& i : res) {
        cout << (i ? "Yes" : "No") << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
