#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mxn = (int)2010;
const int inf = (int)1e6 + 7;

#define all(x) begin(x), end(x)

struct segtree {
	vector<int> t;
	int lf, rg;
	segtree() {};
	void init(int n) {
		t.assign(n * 4, -inf);
		lf = 0, rg = n - 1;
	}
	void upd(int v, int tl, int tr, int pos, int x) {
		if (tl == tr) {
			t[v] = max(t[v], x);
		} else {
			int tm = (tl + tr) / 2;
			if (pos <= tm) upd(v * 2, tl, tm, pos, x);
			else upd(v * 2 + 1, tm + 1, tr, pos, x);
			t[v] = max(t[v * 2], t[v * 2 + 1]);
		}
	}
	int get(int v, int tl, int tr, int ql, int qr) {
		ql = max(ql, lf);
		qr = min(qr, rg);
		if (ql > qr) return -inf;
		if (tl == ql && qr == tr) return t[v];
		int tm = (tl + tr) / 2;
		return max(get(v * 2, tl, tm, ql, min(tm, qr)),
			get(v * 2 + 1, tm + 1, tr, max(tm + 1, ql), qr));
	}

};

segtree hor[mxn];
segtree ver[mxn];

void solve() {
	int n;
	cin >> n;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i <= n + 1; i++) {
		hor[i].init(n + 2);
		ver[i].init(n + 2);
	}
	hor[0].upd(1, 0, n + 1, n + 1, 0);
	ver[n + 1].upd(1, 0, n + 1, 0, 0);
	for (int i = 0; i < n; i++) {
		int cur = a[i + 1];
		vector<pair<int, pair<int, int>>> val;
		for (int mx = n + 1; mx >= 0; mx--) {
			int opt = hor[mx].get(1, 0, n + 1, cur + 1, n + 1) + 1;
			val.push_back({ opt, {mx, cur} });
			if (mx < cur) {
				hor[mx].rg = min(hor[mx].rg, cur);
			}
		}
		for (int mn = 0; mn <= n + 1; mn++) {
			int opt = ver[mn].get(1, 0, n + 1, 0, cur - 1) + 1;
			val.push_back({ opt, {cur, mn} });
			if (mn > cur) {
				ver[mn].lf = max(ver[mn].lf, cur);
			}
		}
		for (auto [opt, coord] : val) {
			hor[coord.first].upd(1, 0, n + 1, coord.second, opt);
			ver[coord.second].upd(1, 0, n + 1, coord.first, opt);
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans = max(ans, hor[i].get(1, 0, n + 1, 1, n));
		ans = max(ans, ver[i].get(1, 0, n + 1, 1, n));
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}