#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int mxn = (int)210;
const int mod = (int)1e9 + 7;

#define all(x) begin(x), end(x)

int dp[mxn][mxn][mxn];

void solve() {
	int n;
	cin >> n;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
	for (int i = 0; i <= n + 1; i++) {
		for (int mx = 0; mx <= n + 1; mx++) {
			for (int mn = 0; mn <= n + 1; mn++) {
				dp[i][mx][mn] = -1;
			}
		}
	}
	dp[0][0][n + 1] = 0;
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int cur = a[i + 1];
		for (int mx = 0; mx <= n + 1; mx++) {
			for (int mn = 0; mn <= n + 1; mn++) {
				if (dp[i][mx][mn] == -1) continue;
				int nmx = (cur > mx ? cur : mx);
				int nmn = (cur < mn ? cur : mn);
				dp[i + 1][nmx][mn] = max(dp[i + 1][nmx][mn], dp[i][mx][mn] + (nmx > mx));
				dp[i + 1][mx][nmn] = max(dp[i + 1][mx][nmn], dp[i][mx][mn] + (nmn < mn));
			}
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			ans = max(ans, dp[n][i][j]);
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}