#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)510;

struct seg {
	int l = 0, r = 0;
	int idx = -1;
};

bool operator<(const seg& a, const seg& b) {
	if (a.r != b.r) return a.r < b.r;
	return a.l < b.l;
}

int get(vector<seg> a) {
	int n = (int)a.size() - 1;
	sort(a.begin() + 1, a.end());
	vector<int> dp(n + 1);
	int j = 0;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		while (j < i && a[j].r < curL) j++;
		dp[i] = max(dp[i - 1], dp[j - 1] + 1);
	}
	return dp[n];
}

bool intersect(seg a, seg b) {
	return max(a.l, b.l) <= min(a.r, b.r);

}
bool cmp(vector<seg>& a, vector<seg>& b) {
	return a.size() < b.size();
}
int dp[maxn][maxn][maxn];
int iter[maxn];
mt19937 rnd;
void solve() {
	int n = 4;
	cin >> n;
	vector<seg> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i].l >> a[i].r;
		a[i].idx = i;
	}
	/*for (int i = 1; i <= n; i++) {
		a[i].l = rnd() % 5 + 1;
		a[i].r = a[i].l + 1 + rnd() % 5;
		a[i].idx = i;
	}*/
	int m = get(a);
	if (m % 2 != 0) return;
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int k = 0; k <= n; k++) {
				dp[i][j][k] = 0;
				iter[i] = 0;
			}
		}
	}
	sort(a.begin() + 1, a.end());
	
	vector<vector<seg>> groups;
	int it = 0;
	for (int i = 1; i <= n; i++) {
		int curL = a[i].l, curR = a[i].r;
		while (it < i && a[it].r < curL) it++;
		iter[i] = it;
	}
	for (int i = n; i >= 1; i = iter[i] - 1) {
		vector<seg> g;
		for (int j = iter[i]; j <= i; j++) {
			g.push_back(a[j]);
		}
		groups.push_back(g);
	}
	int kick = 0;
	sort(groups.rbegin(), groups.rend(), cmp);
	assert(groups.size() == m);
	for (int i = 0; i < m / 2; i++) {
		kick += groups.back().size();
		groups.pop_back();
	}
	assert(kick <= n / 2);
	for (int i = 0; i < groups.size(); i++) {
		while (kick < n / 2 && groups[i].size() > 1) {
			groups[i].pop_back();
			kick += 1;
		}
	}
	assert(kick == n / 2);
	for (auto& x : groups) {
		for (auto i : x) {
			cout << i.idx << " ";
		}
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}