#include <bits/stdc++.h>
#define int long long

using namespace std;

void encrypt(int n, int k) {
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (a + 1 == b || (b == n - 1 && a == 0)) {
        int fir = (a - 2 + n) % n;
        int sec = (b - 2 + n) % n;
        if (fir > sec)
            swap(fir, sec);
        cout << fir + 1 << ' ' << sec + 1 << endl;
        return;
    }
    int fir = (a - 1 + n) % n;
    int sec = (b - 1 + n) % n;
    if (fir > sec)
        swap(fir, sec);
    cout << fir + 1 << ' ' << sec + 1 << endl;
    return;
}

void decrypt(int n, int k) {
    int fir, sec;
    cin >> fir >> sec;
    fir -= 1, sec -= 1;
    if (fir == 0 && sec == n - 1) {
        cout << "2 3" << endl;
        return;
    }
    if (fir + 1 == sec) {
        int a = (fir + 2) % n;
        int b = (sec + 2) % n;
        if (a > b)
            swap(a, b);
        cout << a + 1 << ' ' << b + 1 << endl;
        return;
    }
    int a = (fir + 1) % n;
    int b = (sec + 1) % n;
    if (a > b)
        swap(a, b);
    cout << a + 1 << ' ' << b + 1 << endl;
    return;
}

vector<int> process(int n, int k, const vector<int>& in) {
    vector<int> res;
    res.reserve(k);
    int ptr = 0;
    for (int i = 1; i <= n; ++i) {
        if (ptr < k && in[ptr] == i) {
            ptr += 1;
            continue;
        }
        res.push_back(i);
        if (res.size() == k)
            break;
    }
    return res;
}

void work(int n, int k) {
    vector<int> in(k);
    for (auto& el : in)
        cin >> el;
    auto res = process(n, k, in);
    for (auto el : res)
        cout << el << ' ';
    cout << endl;
}

void small_encrypt(int n, int k) {
    int tmp;
    cin >> tmp;
    tmp -= 1;
    int res = (tmp - 1 + n) % n;
    cout << res + 1 << endl;
}

void small_decrypt(int n, int k) {
    int tmp;
    cin >> tmp;
    tmp -= 1;
    int res = (tmp + 1) % n;
    cout << res + 1 << endl;
}

map<int, int> mapping = { {112, 7}, {104, 19}, {98, 13}, {88, 35}, {82, 41}, {76, 49}, {74, 37}, {69, 50}, {67, 52}, {56, 70}, {52, 74}, {50, 69}, {49, 14}, {44, 67}, {42, 21}, {100, 25}, {41, 22}, {97, 26}, {38, 88}, {37, 82}, {35, 28}, {28, 97}, {26, 100}, {21, 42}, {19, 76}, {84, 11}, {25, 98}, {13, 112}, {7, 104}, {70, 56}, {11, 84}, {73, 38}, {14, 81}, {81, 44}, {22, 73} };
map<int, int> revmapping;

void large_encrypt(int n, int k) {
    vector<int> in(k);
    int mp = 0;
    for (auto& el : in) {
        cin >> el;
        el--;
        mp += (1 << el);
    }
    mp = mapping[mp];
    for (int i = 0; i < n; ++i)
        if (mp & (1 << i))
            cout << i + 1 << ' ';
    cout << endl;
}

void large_decrypt(int n, int k) {
    vector<int> in(k);
    int mp = 0;
    for (auto& el : in) {
        cin >> el;
        el--;
        mp += (1 << el);
    }
    mp = revmapping[mp];
    for (int i = 0; i < n; ++i)
        if (mp & (1 << i))
            cout << i + 1 << ' ';
    cout << endl;
}

signed main() {
    for (auto [a, b] : mapping)
        revmapping[b] = a;
    int tp;
    cin >> tp;
    int tc;
    cin >> tc;
    if (tp == 1) {
        while (tc--) {
            int n, k;
            cin >> n >> k;
            if (k == 1)
                small_encrypt(n, k);
            else if (k == 2)
                encrypt(n, k);
            else {
                if (n == 6)
                    work(n, k);
                else
                    large_encrypt(n, k);
            }
        }
    }
    else {
        while (tc--) {
            int n, k;
            cin >> n >> k;
            if (k == 1)
                small_decrypt(n, k);
            else if (k == 2)
                decrypt(n, k);
            else {
                if (n == 6)
                    work(n, k);
                else
                    large_decrypt(n, k);
            }
        }
    }
}