#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int sz = 100100;

struct otr {
	ll l = 0, r = 0;
	int num = 0;
	bool operator <(otr a) {
		if (l != a.l) return l < a.l;
		return r > a.r;
	}
};

int dp[sz], mx[sz], cnt[sz];

bool cross(otr a, otr b) {
	return !(a.r < b.l || b.r < a.l);
}

bool check(int n, vector <otr>& b) {
	int crt = 0;
	for (int i = 0; i < b.size(); ++i) {
		if (cnt[i] > 0) ++crt;
		else crt = 0;
		if (crt == n) {
			for (int j = i - n + 1; j <= i; ++j) {
				cout << b[j].num << ' ';
			}
			return true;
		}
	}
	return false;
}

void solve() {
	int n;
	cin >> n;
	vector <otr> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].l >> a[i].r;
		a[i].num = i + 1;
		cnt[i] = 0;
	}
	vector <otr> v(1), b;
	v[0].l = v[0].r = 0;
	sort(a.begin(), a.end());
	for (auto& p : a) {
		while (!v.empty() && v.back().l <= p.l && p.r <= v.back().r) {
			b.push_back(v.back());
			v.pop_back();
		}
		v.push_back(p);
	}
	a.resize(0);
	dp[0] = 0;
	int m = 0;
	int it = 0;
	for (int i = 1; i < v.size(); ++i) {
		dp[i] = 1;
		for (int j = 0; j < i; ++j) {
			if (!cross(v[i], v[j])) {
				dp[i] = max(dp[i], dp[j] + 1);
				m = max(m, dp[i]);
			}
		}
	}
	otr last;
	last.l = last.r = 2e9;
	for (int i = v.size() - 1; i > 0; --i) {
		if (dp[i] == m && v[i].r < last.l) {
			a.push_back(v[i]);
			--m;
			last = v[i];
		}
		else {
			b.push_back(v[i]);
		}
	}
	set <int> s;
	for (auto p : a) {
		s.insert(p.num);
	}
	for (auto p : b) {
		s.insert(p.num);
	}
	if (s.size() != n) {
		while (1) {}
	}
	if (a.size() == n) {
		for (int i = 1; i <= n / 2; ++i) {
			cout << i << ' ';
		}
		cout << '\n';
		return;
	}
	m = a.size() / 2;
	n = b.size() / 2;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < b.size(); ++j) {
			if (cross(a[i], b[j])) ++cnt[j];
		}
	}
	if (check(n, b)) {
		for (int i = 0; i < m; ++i) {
			cout << a[i].num << ' ';
		}
		cout << '\n';
		return;
	}
	for (int i = 1; i + m <= a.size(); ++i) {
		for (int j = 0; j < b.size(); ++j) {
			if (cross(a[i - 1], b[j])) --cnt[j];
			if (cross(a[i + m - 1], b[j])) ++cnt[j];
		}
		if (check(n, b)) {
			for (int j = i; j < i + m; ++j) {
				cout << a[j].num << ' ';
			}
			cout << '\n';
			return;
		}
	}
}

int main() {
	//freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}