#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;


template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
/*
 *
 */

const int SZ = 1 << 30;

struct Node {
    int sm;
    Node* left = nullptr;
    Node* right = nullptr;
    Node(int _tl, int _tr): sm(_tr - _tl) {}
    void update(int tl, int tr, int ind) {
        --sm;
        if (tr - tl == 1)
            return;
        int mid = (tl + tr) / 2;
        if (ind < mid) {
            if (left == nullptr)
                left = new Node(tl, mid);
            left->update(tl, mid, ind);
        }
        else {
            if (right == nullptr)
                right = new Node(mid, tr);
            right->update(mid, tr, ind);
        }
    }

    int get_kth(int tl, int tr, int k) {
        int mid = (tl + tr) / 2;
        if (tr - tl == 1)
            return tl;
        if (left == nullptr)
            left = new Node(tl, mid);
        if (left->sm >= k)
            return left->get_kth(tl, mid, k);
        if (right == nullptr)
            right = new Node(mid, tr);
        return right->get_kth(mid, tr, k - left->sm);
    }

    int get_kth_right(int tl, int tr, int k) {
        int mid = (tl + tr) / 2;
        if (tr - tl == 1)
            return tl;
        if (right == nullptr)
            right = new Node(mid, tr);
        if (right->sm >= k)
            return right->get_kth(mid, tr, k);
        if (left == nullptr)
            left = new Node(tl, mid);
        return left->get_kth(tl, mid, k - right->sm);
    }

    int get(int tl, int tr, int ql, int qr) {
        if (tr <= ql || qr <= tl)
            return 0;
        if (ql <= tl && tr <= qr)
            return sm;
        int mid = (tl + tr) / 2;
        if (left == nullptr)
            left = new Node(tl, mid);
        if (right == nullptr)
            right = new Node(mid, tr);
        return left->get(tl, mid, ql, qr) + right->get(mid, tr, ql, qr);
    }
};

void first(int n, vector<int>& a) {
    Node* tree = new Node(0, SZ);
    for (int e: a)
        tree->update(0, SZ, e - 1);
    vector<int> b;
    b.reserve(a.size());
    for (int e: a) {
        int pt;
        if (tree->get(0, SZ, e - 1, n) == 0) {
            pt = tree->get_kth(0, SZ, 1);
        }
        else {
            int need = tree->get(0, SZ, 0, e) + 1;
            pt = tree->get_kth(0, SZ, need);
        }
        tree->update(0, SZ, pt);
        b.push_back(pt + 1);
    }
    sort(all(b));
    cout << b << endl;
}

void second(int n, vector<int>& a) {
    Node* tree = new Node(0, SZ);
    for (int e: a)
        tree->update(0, SZ, e - 1);
    vector<int> b;
    b.reserve(a.size());
    for (int e: a) {
        int need = tree->get(0, SZ, 0, e);
        if (need == 0) {
            need = tree->get(0, SZ, 0, n);
        }
        int pt = tree->get_kth(0, SZ, need);
        tree->update(0, SZ, pt);
        b.push_back(pt + 1);
    }
    sort(all(b));
    cout << b << endl;
}

int main() {
     ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    int t, test;
    cin >> t >> test;
    while (test--) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        cin >> a;
        sort(all(a));
        if (t == 1) {
            first(n, a);
        }
        else {
            second(n, a);
        }
    }
}
