#pragma GCC optimize("popcnt")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;
typedef unsigned int uint;


template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
/*
 *
 */

ll MOD;

uint get_bit(uint mask, int i) {
    return (mask & (1 << i)) >> i;
}

void set_bit(uint& mask, int i) {
    mask |= (1 << i);
}

void print_mask(uint mask, int k) {
    for (int i = 0; i < k; ++i) {
        cout << get_bit(mask, i);
    }
}

//const int N = 201;
//pair<int, int> dp[N][N][N];

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    int best = 0;
    for (uint mask = 0; mask < (1 << n); ++mask) {
        vector<int> q, r;
        for (int i = 0; i < n; ++i) {
            if (get_bit(mask, i))
                q.push_back(a[i]);
            else
                r.push_back(a[i]);
        }
        int res = 0;
        int prev = 0;
        int i = 0;
        while (i < q.size() && q[i] > prev) {
            prev = q[i];
            ++i;
        }
        res += i;
        i = 0;
        prev = n + 1;
        while (i < r.size() && r[i] < prev) {
            prev = r[i];
            ++i;
        }
        res += i;
        maxi(best, res);
    }
    cout << best;
}

int main() {
     ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    //cin >> MOD;
    int test;
    cin >> test;
    while (test--) {
        solve();
        cout << '\n';
    }
}
