#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

int g_ind = 0;

struct Seg {
    int l = -1, r = -1, id = -1;
    bool del = false;

    friend istream &operator>>(istream &in, Seg &s) {
        in >> s.l >> s.r;
        s.id = g_ind++;
        return in;
    }

    friend ostream &operator<<(ostream &out, const Seg &s) {
        out << s.l << ' ' << s.r;
        return out;
    }

    bool operator < (const Seg& other) const {
        if (l != other.l)
            return l < other.l;
        return r < other.r;
    }
};

struct Event {
    int x, t, id;
    Event(int _x, int _t, int _id): x(_x), t(_t), id(_id) {}
    bool operator < (const Event& other) const {
        if (x != other.x)
            return x < other.x;
        if (t != other.x)
            return t > other.t;
        return id < other.id;
    }
};

vector<int> used;

const int INF = 1e9;

int calc_m(vector<Seg>& segs, int to_del) {
    int n = segs.size();
    vector<Event> evs;
    for (int i = 0; i < n; ++i)
        used[i] = false;
    evs.reserve(n * 2);
    for (const Seg& s :segs) {
        if (s.del)
            continue;
        evs.emplace_back(s.l, 1, s.id);
        evs.emplace_back(s.r, -1, s.id);
    }
    sort(all(evs));
    set<int> opened;
    int res = 0;
    for (const Event& e :evs) {
        if (e.t == 1) {
            used[e.id] = -1;
            opened.insert(e.id);
        }
        else {
            if (opened.find(e.id) == opened.end())
                continue;
            used[e.id] = opened.size();
            opened.clear();
            ++res;
        }
    }
    if (to_del == 1) {
        int mn = INF, imn = -1;
        for (int i = 0; i < n; ++i) {
            if (used[i] > 0 && mini(mn, used[i]))
                imn = i;

        }
        segs[imn].del = true;
    }
    else if (to_del == -1) {
        for (int i = 0; i < n; ++i) {
            if (used[i] < 0) {
                segs[i].del = true;
                break;
            }

        }
    }
    return res;
}


void solve() {
    int n;
    cin >> n;
//    g_ind = 0;
//    used.clear();
//    used.resize(n);
    vector<Seg> segs(n);
    cin >> segs;
    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    int test;
    cin >> test;
    while (test--) {
        solve();
        cout << '\n';
    }
}
