#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int))
        end_char = ' ';
    for (const T& e :vec)
        out << e << end_char;
    return out;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

int g_ind = 0;

struct Query {
    ll k, a, b, id;
    friend istream& operator >> (istream& in, Query& q) {
        in >> q.k >> q.a >> q.b;
//        if (q.a > q.b)
//            swap(q.a, q.b);
        q.id = g_ind++;
        return in;
    }
    bool operator < (const Query& other) const{
        if (k != other.k)
            return k < other.k;
        return id < other.id;
    }
};

const int N = 303;

bool dost[N][N];
bool perf[N][N];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    vector<ll> a(n);
    cin >> a;
    sort(all(a));
    int z;
    cin >> z;
    vector<Query> qs(m);
    cin >> qs;
//    sort(all(qs));
    dost[0][0] = true;
    perf[0][0] = true;
    int pt = 0;
    vector<bool> res(m);
    for (int i = 0; i < n; ++i) {
//        while (pt < m && qs[pt].k < a[i]) {
//            res[qs[pt].id] = perf[qs[pt].a][qs[pt].b];
//            ++pt;
//        }
        for (int x = N - 1; x >= 0; --x) {
            for (int y = N; y >= 0; --y) {
                if (!dost[x][y])
                    continue;
                if (x + a[i] < N)
                    dost[x + a[i]][y] = true;
                if (y + a[i] < N)
                    dost[x][y + a[i]] = true;
            }
        }
        for (int y = 1; y < N; ++y) {
            if (dost[0][y] && perf[0][y - 1])
                perf[0][y] = true;
            else
                break;
        }
        for (int x = 1; x < N; ++x) {
            if (dost[x][0] && perf[x - 1][0])
                perf[x][0] = true;
            for (int y = 1; y < N; ++y) {
                if (!perf[x][y] && dost[x][y] && perf[x - 1][y] && perf[x][y - 1])
                    perf[x][y] = true;
            }
        }
    }
//    for (int x = 0; x < 30; ++x) {
//        for (int y = 0; y < 30; ++y) {
//            cout << dost[x][y] << ' ';
//        }
//        cout << endl;
//    }
//    cout << endl;
//    for (int x = 0; x < 30; ++x) {
//        for (int y = 0; y < 30; ++y) {
//            cout << perf[x][y] << ' ';
//        }
//        cout << endl;
//    }
//    while (pt < m) {
//        res[qs[pt].id] = perf[qs[pt].a][qs[pt].b];
//        ++pt;
//    }
    for (Query q :qs) {
        bool ok = true;
        for (int x = 0; x <= q.a && ok; ++x) {
            for (int y = 0; y <= q.b && ok; ++y) {
                if (!dost[x][y])
                    ok = false;
            }
        }
        if (ok)
            cout << "Yes\n";
        else
            cout << "No\n";
    }
//    for (bool r : res) {
//        if (r)
//            cout << "Yes\n";
//        else
//            cout << "No\n";
//    }
}
