#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define F first
#define S second
mt19937 rnd(100);

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    ll n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (ll &i: w)
        cin >> i;
    sort(w.begin(), w.end());

    vector<set<pair<ll, ll>>> arr(n + 1); // Для каждого а храним набор подходящих отрезков б
    arr[0].insert({0, 0});
    for (int i = 0; i < n; ++i) {
        for (auto &p: arr[i]) {
            arr[i + 1].insert(p);
            arr[i + 1].insert({p.F + w[i], p.S});
            arr[i + 1].insert({p.F, p.S + w[i]});
        }
    }

    ll k, a, b, z;
    cin >> z;
    for (int i = 0; i < q; ++i) {
        cin >> k >> a >> b;

        ll l = 0, r = n + 1, m;
        while (r - l > 1) {
            m = (r + l) / 2;
            if (w[m] > k)
                r = m;
            else
                l = m;
        }

        bool ok = 1;
        for (int j = a; j >= 1 && ok; --j)
            for (int i1 = b; i1 >= 1 && ok; --i1)
                ok = arr[l + 1].count({j, i1});
        if (ok)
            cout << "Yes" << endl;
        else
            cout << "No" << endl;
    }

    return 0;
}
/*
Допустим мы взяли w > b. тогда наш префикс b больше не будет увиличиваться.
 Это значит что b всегда префикс. Тоже касается и a.
Это значит что при добавлении k идиальная пара {a, b} становится
 {a + k, b} при a + 1 >= k, {a, b + k} при b + 1 >= k.

8 5
17 1 3 2 100 5 6 1
0
6 15 3
9 4 4
5 15 3
17 34 1
16 33 2

1 1 2 3 5 6

1 3 5 6 | 1 2
*/