#include <bits/stdc++.h>

using namespace std;
typedef long long ll;


struct segtree {
    struct node {
        ll maxim = -1e9;
        ll op = -1;
    };
    vector<node> tree;
    int sz = 1;

    segtree(int n) {
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1);
    }

    void push(int v, int l, int r) {
        if (tree[v].op == -1) return;
        if (r - l == 1) return;
        tree[2 * v + 1].maxim = tree[v].op;
        tree[2 * v + 2].maxim = tree[v].op;
        tree[2 * v + 1].op = tree[2 * v + 2].op = tree[v].op;
        tree[v].op = -1;
    }

    ll get(int v, int l, int r, int ql, int qr) {
        push(v, l, r);
        if (ql <= l && r <= qr) {
            return tree[v].maxim;
        }
        if (qr <= l || r <= ql) {
            return -1e9;
        }
        int mid = (r + l) / 2;
        ll m1 = get(2 * v + 1, l, mid, ql, qr);
        ll m2 = get(2 * v + 2, mid, r, ql, qr);
        return max(m1, m2);
    }

    ll get(int ql, int qr) {
        return get(0, 0, sz, ql, qr);
    }


    void set(int v, int l, int r, int ql, int qr, int x) {
        push(v, l, r);
        if (ql <= l && r <= qr) {
            tree[v].maxim = x;
            tree[v].op = x;
            return;
        }
        if (qr <= l || r <= ql) {
            return;
        }
        int mid = (r + l) / 2;
        set(2 * v + 1, l, mid, ql, qr, x);
        set(2 * v + 2, mid, r, ql, qr, x);
        tree[v].maxim = max(tree[2 * v + 1].maxim, tree[2 * v + 2].maxim);
    }

    void set(int ql, int qr, int x) {
        set(0, 0, sz, ql, qr, x);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<ll> p(n);
    for (auto &el: p) {
        cin >> el;
    }
    vector<segtree> had(n + 2, n + 2);
    vector<segtree> had_vert(n + 2, n + 2);
    for (auto &el : had){
        el.set(0, n + 2, -1e9);
    }
    for (auto &el : had_vert){
        el.set(0, n + 2, -1e9);
    }
    vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, -1e9));
    dp[0][n + 1] = 0;
    had[0].set(n + 1, n + 2, 0);
    had_vert[n + 1].set(0, 1, 0);
    for (int i = 0; i < n; i++) {
        vector<ll> maximus(n + 2, -1e9);
        for (int max_i = n + 1; max_i >= 0; max_i--) {
            maximus[max_i] = had[max_i].get(p[i] + 1, n + 2);
        }
        vector<ll> maximus2(n + 2);
        for (int min_j = 0; min_j <= n + 1; min_j++) {
            ll maxim = had_vert[min_j].get(0, p[i]);
//            for (int max_i = 0; max_i < p[i]; max_i++) {
//                maxim = max(maxim, dp[max_i][min_j]);
//            }
            maximus2[min_j] = maxim;
        }
        for (int max_i = 0; max_i < p[i]; max_i++) {
            for (int min_j = p[i] + 1; min_j <= n + 1; min_j++) {
                dp[max_i][min_j] = -1e9;
            }
            had[max_i].set(p[i] + 1, n + 2, -1e9);
        }
        for (int min_j = p[i] + 1; min_j <= n + 1; min_j++) {
            had_vert[min_j].set(0, p[i], -1e9);
        }
        for (int min_j = 0; min_j <= n + 1; min_j++) {
            if (maximus2[min_j] != -1e9) {
                dp[p[i]][min_j] = max(dp[p[i]][min_j], maximus2[min_j] + 1);
                had[p[i]].set(min_j, min_j + 1,  dp[p[i]][min_j]);
                had_vert[min_j].set(p[i], p[i] + 1, dp[p[i]][min_j]);
            }
            if (maximus[min_j] != -1e9) {
                dp[min_j][p[i]] = max(dp[min_j][p[i]], maximus[min_j] + 1);
                had[min_j].set(p[i], p[i] + 1,  dp[min_j][p[i]]);
                had_vert[p[i]].set(min_j, min_j + 1, dp[min_j][p[i]]);
            }
        }
    }
    ll maxim = 0;
    for (auto el: dp) {
        for (auto el2: el) {
            maxim = max(maxim, el2);
        }
    }
    cout << maxim << "\n";

}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();

    }
    return 0;
}