#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

vector<pair<int, pair<int, int>>>arr;

bool comp(pair<int, pair<int, int>>a, pair<int, pair<int, int>>b) {
	return a.second.second < b.second.second || (a.second.second == b.second.second && a.second.first < b.second.first);
}

int get_best(int x) {
	int l = -1, r = x;
	while (l + 1 != r) {
		int m = (l + r) / 2;
		if (arr[m].second.second <= arr[x].second.first)
			l = m;
		else
			r = m;
	}
	return l;
}

int get_score(int n) {
	vector<int>dp(n, 1);
	for (int i = 0; i < n; i++) {
		for (int j = i - 1; j >= 0; j--) {
			if (arr[j].second.second < arr[i].second.first)
				dp[i] = max(dp[i], dp[j] + 1);
		}
	}
	return *max_element(dp.begin(), dp.end());
}

void solve() {
	arr.clear();
	int n;
	cin >> n;
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].second.first >> arr[i].second.second;
		arr[i].first = i;
	}
	sort(arr.begin(), arr.end(), comp);
	int score = get_score(n);
	vector<vector<vector<bool>>>dp(n + 1, vector<vector<bool>>(n / 2 + 1, vector<bool>(score / 2 + 1)));
	vector<vector<vector<int>>>pr(n + 1, vector<vector<int>>(n / 2 + 1, vector<int>(score / 2 + 1, -1)));
	for (int i = 0; i <= n; i++)
		dp[i][0][0] = true;
	int win_i = -1;
	bool stop = false;
	for (int i = 1; i <= n &&!stop; i++) {
		for (int x = 0; x <= score / 2 && !stop; x++) {
			for (int have = 1; have <= n / 2 && !stop; have++) {
				for (int last = i - 1; last >= 0 && !dp[i][have][x]; last--) {
					int dop = (last == 0 || arr[last - 1].second.second < arr[i - 1].second.first);
					if (x - dop >= 0 && dp[last][have - 1][x - dop]) {
						dp[i][have][x] = true;
						pr[i][have][x] = last;
					}
				}
				if (x == score / 2 && have == n / 2 && dp[i][have][x]) {
					win_i = i;
					stop = true;
					break;
				}
			}
		}
	}
	vector<int>ans;
	int have = n / 2, x = score / 2;
	while (have > 0) {
		int go = pr[win_i][have][x];


		ans.push_back(win_i);
		if (go == 0 || go == -1)
			break;
		if (arr[go - 1].second.second < arr[win_i - 1].second.first)
			x--;
		have--;
		win_i = go;
	}
	for (auto i : ans)
		cout << i << ' ';
	cout << '\n';
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}