#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <random>
#include <bitset>
#include <chrono>
#include <algorithm>
#include <queue>
#include <deque>
#include <iomanip>
#include <string>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct seg {
	v<ll> tree;
	ll size = 1;

	seg(ll n) {
		while (size < n) {
			size *= 2;
		}
		tree.resize(size * 2 - 1, 0);
	}

	ll get(ll l_find, ll r_find, ll l, ll r, ll i) {
		if (l >= r_find || r <= l_find) return 0;
		if (l >= l_find && r <= r_find) return tree[i];
		ll mid = l + (r - l) / 2;
		return std::max(get(l_find, r_find, l, mid, i * 2 + 1), get(l_find, r_find, mid, r, i * 2 + 2));
	}

	void set(ll pos, ll val, ll l, ll r, ll i) {
		if (l > pos || r <= pos) return;
		if (r - l == 1) {
			tree[i] = val;
			return;
		}
		ll mid = l + (r - l) / 2;
		set(pos, val, l, mid, i * 2 + 1);
		set(pos, val, mid, r, i * 2 + 2);
		tree[i] = std::max(tree[i * 2 + 1], tree[i * 2 + 2]);
	}
};

void solve() {
	ll n;
	std::cin >> n;
	v<ll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i];
	}
	bool check = true;
	for (int i = 1; i < n; ++i) {
		if (list[i] <= list[i - 1]) {
			check = false;
		}
	}
	ll max = 0;
	seg tree(n);
	v<ll> dp(n, 0);
	for (int i = 0; i < n; ++i) {
		dp[i] = tree.get(0, list[i], 0, tree.size, 0) + 1;
		tree.set(list[i], dp[i], 0, tree.size, 0);
		max = std::max(dp[i], max);
	}
	if (check) {
		std::cout << std::min(n, max + 1) << '\n';
	}
	else {
		std::cout << std::min(n, max + 2) << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}