#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <string>
#include <iomanip>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <utility>

#define all(a) (a).begin(), (a).end()
#define v std::vector

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll Lg = 20;

std::mt19937 rnd(42);

struct node {
	ll k, a, b;
	ll num;
};

void solve() {
	ll n, q;
	std::cin >> n >> q;
	v<ll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i];
	}
	std::sort(all(list));
	ll z;
	std::cin >> z;
	v<v<v<ll>>> dp(n + 1, v<v<ll>>(301, v<ll>(301, 0)));
	dp[0][0][0] = 1;
	ll last = 0;
	v<node> qu(q);
	for (int i = 0; i < q; ++i) {
		std::cin >> qu[i].k >> qu[i].a >> qu[i].b;
		qu[i].num = i;
	}
	std::sort(all(qu), [](node a, node b) {
		return a.k > b.k;
		});
	v<ll> ans(q);
	for (int i = 1; i <= n; ++i) {
		v<v<ll>> real(301, v<ll>(301, 0));
		real[0][0] = 1;
		for (int x = 0; x <= 300; ++x) {
			for (int y = 0; y <= 300; ++y) {
				dp[i][x][y] = dp[i - 1][x][y];
				if (list[i - 1] <= x) {
					dp[i][x][y] |= dp[i - 1][x - list[i - 1]][y];
				}
				if (list[i - 1] <= y) {
					dp[i][x][y] |= dp[i - 1][x][y - list[i - 1]];
				}
			}
		}
		for (int a = 0; a <= 300; ++a) {
			for (int b = 0; b <= 300; ++b) {
				if (a == 0 && b == 0) continue;
				if (a == 0) {
					real[a][b] = (real[a][b - 1] & dp[i][a][b]);
				}
				else if (b == 0) {
					real[a][b] = (real[a - 1][b] & dp[i][a][b]);
				}
				else {
					real[a][b] = (real[a - 1][b] & real[a][b - 1] & dp[i][a][b]);
				}
			}
		}
		while (!qu.empty() && (i == n || qu.back().k < list[i])) {
			ans[qu.back().num] = real[qu.back().a][qu.back().b];
			qu.pop_back();
		}
	}
	for (int i = 0; i < q; ++i) {
		std::cout << (ans[i] ? "Yes" : "No") << '\n';
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(10);
	ll t = 1;
	//std::cin >> t;
	while (t--) {
		solve();
	}
}