#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include "random"

using namespace std;
typedef long long ll;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

}

struct node {
    int l = 0, r = 2e9;
    int mx = 0, ndx = 0;
    node *l_c = nullptr, *r_c = nullptr;

    node() = default;

    node(int l, int r) : l(l), r(r) {}

    void upd() {
        if (r_c == nullptr)
            r_c = new node(l, (r + l) / 2);
        if (l_c == nullptr)
            l_c = new node((r + l) / 2, r);
    }

    void set(int x, int val) {
        if (x < l || x >= r)
            return;
        if (x == l && l + 1 == r) {
            mx = val;
            return;
        }
        upd();
        r_c->set(x, val);
        l_c->set(x, val);
        if (r_c->mx > l_c->mx) {
            mx = r_c->mx;
            ndx = r_c->ndx;
        } else {
            mx = l_c->mx;
            ndx = l_c->ndx;
        }
    }

    pair<int, int> get(int L, int R) {
        if (l >= R || L >= r)
            return {0, 0};
        if (L <= l && r <= R)
            return {mx, ndx};
        upd();
        return max(r_c->get(L, R), l_c->get(L, R));
    }

};

int find(int n, vector<pair<int, int>> v) {
    node *t = new node(0, 2e9);
    map<int, int> mn;
    for (auto &[a, b]: v) {
        mn[b] = max(mn[b], a);
    }
    sort(all(v));
    vector<int> dp(n, 0);
    int i = 0;
    int m = 0, ndx = 0;
    map<int, int> val, j;
    for (auto [l, r]: v) {
        auto p = t->get(0, l);
        if (p.first + 1 > m) {
            m = p.first + 1;
            ndx = i;
        }
        if (val[r + 1] < p.first + 1) {
            val[r + 1] = p.first + 1;
            j[r + 1] = i;
        }
        dp[i++] = p.second;
        t->set(r + 1, p.first + 1);
    }
    return m;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto &[a, b]: v)
        cin >> a >> b;
    int m = find(n, v);
    mt19937 rnd(1);
    while (1) {
        vector<pair<int, int>> v1;
        set<int> ndx;
        while (ndx.size() != n / 2) {
            ndx.insert(rnd() % n);
        }
        for (int i: ndx) {
            v1.push_back(v[i]);
        }
        if (find(n / 2, v1) == m / 2) {
            for (int i: ndx) {
                cout << i + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }

}