#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include "random"
#include "unordered_map"

using namespace std;
typedef long long ll;

#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

}

vector<pair<ll, ll>> mx;

void upd(ll x, ll val, ll l, ll r, ll ndx) {
    if (x >= r || x < l)
        return;
    if (x == l && l + 1 == r) {
        mx[ndx] = max(mx[ndx], {val, l});
        return;
    }
    upd(x, val, l, (r + l) / 2, ndx * 2 + 1);
    upd(x, val, (r + l) / 2, r, ndx * 2 + 2);
    mx[ndx] = max(mx[ndx * 2 + 1], mx[ndx * 2 + 2]);
}

pair<ll, ll> get(ll l, ll r, ll L, ll R, ll ndx) {
    if (l >= R || L >= r)
        return {0, -1};
    if (l <= L && R <= r) {
        return mx[ndx];
    }
    return max(get(l, r, L, (R + L) / 2, ndx * 2 + 1),
               get(l, r, (R + L) / 2, R, ndx * 2 + 2));
}

ll find(ll n, vector<pair<ll, ll>> &v) {
    mx.clear();
    mx.resize(2e6, {0, -1});
    sort(all(v));
    ll i = 0;
    ll m = 0;
    for (auto [l, r]: v) {
        auto p = get(0, l, 0, 5e5 + 1, 0);
        if (p.first + 1 > m) {
            m = p.first + 1;
        }
        upd(r, p.first + 1, 0, 5e5 + 1, 0);
    }
    return m;
}

map<pair<ll, ll>, vector<ll>> c;

bool f(vector<pair<ll, ll>> &v, ll ind) {
    ll n = v.size();
    mx.clear();
    mx.resize(2e6, {0, -1});
    sort(all(v));
    vector<ll> dp(n, 0);
    ll i = 0;
    ll m = 0, ndx = 0;
    map<ll, ll> val, j;
    for (auto [l, r]: v) {
        auto p = get(0, l, 0, 5e5 + 1, 0);
        if (p.first + 1 > m) {
            m = p.first + 1;
            ndx = i;
        }
        if (val[r] < p.first + 1) {
            val[r] = p.first + 1;
            j[r] = i;
        }
        dp[i++] = p.second;
        upd(r, p.first + 1, 0, 5e5 + 1, 0);
    }
    vector<pair<ll, ll>> v1{v[ndx]};
    set<pair<ll, ll>> s{v[ndx]};
    while (dp[ndx] != -1) {
        v1.push_back(v[j[dp[ndx]]]);
        s.insert(v[j[dp[ndx]]]);
        ndx = j[dp[ndx]];
    }
    sort(all(v1));
    vector<pair<ll, ll>> v2, v3;
    for (ll i = ind; i < ind + v1.size() / 2; i++) {
        v2.push_back(v1[i % v1.size()]);
    }
    ll R = v2.back().second;
    ll L = v2[0].first;
    for (auto [l, r]: v) {
        if (s.find({l, r}) != s.end())
            continue;
        if (!(l > R || L > r)) {
            v2.push_back({l, r});
        }
    }
    if (v2.size() >= n / 2) {
        while (v2.size() > n / 2)
            v2.pop_back();
        if (find(n / 2, v2) == m / 2) {
            for (auto [l, r]: v2) {
                cout << c[{l, r}].back() << ' ';
                c[{l, r}].pop_back();
            }
            cout << '\n';
            return 1;
        }
    }
    return 0;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> v(n);
    set<ll> s;
    for (auto &[a, b]: v) {
        cin >> a >> b;
        s.insert(a);
        s.insert(b);
    }
    ll t = 1;
    unordered_map<ll, ll> k;
    for (ll i: s) {
        k[i] = t;
        t++;
    }
    for (auto &[a, b]: v) {
        a = k[a];
        b = k[b];
    }
    c.clear();
    for (ll i = 0; i < n; i++)
        c[v[i]].push_back(i + 1);
    for (ll ind = 0;; ind++) {
        if (f(v, ind)) {
            return;
        }
    }
}