#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())

mt19937 rnd(1234);
struct Node {
    ll v, y, cnt = 0, cnt_v = 0;
    Node* L = nullptr;
    Node* R = nullptr;

    Node(ll val) {
        v = val;
        y = rnd();
        cnt = 1;
        cnt_v = 1;
    }

    friend ll get_cnt(Node* r) {
        if (r == nullptr) {
            return 0;
        }
        return r->cnt;
    }

    friend void update(Node* r) {
        if (r == nullptr) {
            return;
        }
        r->cnt = get_cnt(r->L) + r->cnt_v + get_cnt(r->R);
    }

    friend Node* merge(Node* a, Node* b) {
        if (a == nullptr) {
            return b;
        }
        if (b == nullptr) {
            return a;
        }
        if (a->y > b->y) {
            a->R = merge(a->R, b);
            update(a);
            return a;
        } else {
            b->L = merge(a, b->L);
            update(b);
            return b;
        }
    }

    friend pair<Node*, Node*> split(Node* a, ll x) {
        if (a == nullptr) {
            return {nullptr, nullptr};
        }
        if (a->v > x) {
            auto p = split(a->L, x);
            a->L = p.second;
            update(a);
            return {p.first, a};
        } else {
            auto p = split(a->R, x);
            a->R = p.first;
            update(a);
            return {a, p.second};
        }
    }

    friend Node* insert(Node* r, ll x) {
        auto p = split(r, x - 1);
        auto q = split(p.second, x);
        Node* newNode = new Node(x);
        return merge(p.first, merge(newNode, q.second));
    }

    friend bool here(Node* r, ll x) {
        if (r == nullptr) {
            return false;
        }
        if (r->v == x) {
            return true;
        }
        if (r->v < x) {
            return here(r->R, x);
        } else {
            return here(r->L, x);
        }
    }

    friend Node* add(Node* r, ll x) {
        if (r == nullptr) {
            return r;
        }
        if (r->v == x) {
            r->cnt_v++;
            return r;
        }
        if (r->v < x) {
            r->R = add(r->R, x);
            return r;
        } else {
            r->L = add(r->L, x);
            return r;
        }
    }

    friend pair<ll, Node*> count(Node* r, ll x) {
        auto p = split(r, x);
        return {get_cnt(p.first), merge(p.first, p.second)};
    }

    friend void get_all_elements(Node* r, vector<ll> &a) {
        if (r == nullptr) {
            return;
        }
        get_all_elements(r->L, a);
        for (int i = 0; i < r->cnt_v; ++i) {
            a.push_back(r->v);
        }
        get_all_elements(r->R, a);
    }
};

struct multiset_manager {
    Node* r = nullptr;
    ll plus = 0;

    multiset_manager() {}

    void pl(ll x) {
        plus += x;
    }

    void add_x(ll x) {
        if (here(r, x - plus)) {
            r = add(r, x - plus);
        } else {
            r = insert(r, x - plus);
        }
    }

    ll lowerr_bound(ll x) {
        ll ans = 0;
        tie(ans, r) = count(r, x - plus);
        return ans;
    }

    ll size() {
        return get_cnt(r);
    }

    vector<ll> get_elements() {
        vector<ll> el;
        get_all_elements(r, el);
        for (auto &i : el) {
            i += plus;
        }
        return el;
    }
};

const ll MAXN = 2e5 + 1;
ll n, k, q;
ll lSon[MAXN], rSon[MAXN], cnt[MAXN], num_ms[MAXN], ans[MAXN];
multiset_manager ms[MAXN];

void dfs(ll v, ll x, bool this_l) {
    cnt[v] = x;
    if (lSon[v] == 0 && rSon[v] == 0) {
        ms[v].add_x(0);
        num_ms[v] = v;
        return;
    }
    if (v != 1) {
        dfs(lSon[v], x + ll(!this_l), true);
        dfs(rSon[v], x + ll(this_l), false);
    } else {
        dfs(lSon[v], x, true);
        dfs(rSon[v], x, false);
    }
    if (ms[num_ms[lSon[v]]].size() > ms[num_ms[rSon[v]]].size()) {
        num_ms[v] = num_ms[lSon[v]];
        if (!this_l) {
            ms[num_ms[v]].pl(1);
        }
        vector<ll> el = ms[num_ms[rSon[v]]].get_elements();
        for (auto i : el) {
            ms[num_ms[v]].add_x(i + ll(this_l));
        }
    } else {
        num_ms[v] = num_ms[rSon[v]];
        if (this_l) {
            ms[num_ms[v]].pl(1);
        }
        vector<ll> el = ms[num_ms[lSon[v]]].get_elements();
        for (auto i : el) {
            ms[num_ms[v]].add_x(i + ll(!this_l));
        }
    }
    ans[v] = ms[num_ms[v]].lowerr_bound(k - cnt[v]);
}

void solve() {
    cin >> n >> k >> q;
    for (int i = 1; i <= n; ++i) {
        ll t, l, r;
        cin >> t;
        if (t != 0) {
            cin >> l >> r;
            lSon[i] = l;
            rSon[i] = r;
        }
    }
    dfs(1, 0, 0);
    for (int i = 0; i < q; ++i) {
        ll u;
        cin >> u;
        cout << ans[u] << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int times = 1;
//    cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
    return 0;
}
