#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<vector<ll>> dp;
vector<vector<ll>> graph;
vector<pair<ll, ll>> limits;
vector<ll> ans;

void dfs(ll v=1, ll p=-1) {
    for (auto x : graph[v]) {
        if (x != p) {
            dfs(x, v);
        }
    }

    // 1 - берем v
    dp[v][1] = limits[v].second;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][1] += dp[x][0];
        }
    }

    // 2 - не берем v
    dp[v][0] = 0;
    for (auto x : graph[v]) {
        if (x != p) {
            dp[v][0] += max(dp[x][0], dp[x][1]);
        }
    }
}

void build(ll v, ll go_with, ll p=-1) {
    // 1 - берем v
    if (go_with == 1) {
        if (limits[v].second) {
            ans.push_back(v);
        }
        for (auto x : graph[v]) {
            if (x != p) {
                build(x, 0, v);
            }
        }
    } else {
        for (auto x : graph[v]) {
            if (x != p) {
                if (dp[x][0] > dp[x][1]) {
                    build(x, 0, v);
                } else {
                    build(x, 1, v);
                }
            }
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;

    graph.assign(n + 1, vector<ll>());
    limits.assign(n + 1, {0, 0});
    dp.assign(n + 1, vector<ll>(2, 0));

    for (ll i = 0; i < n - 1; ++i) {
        ll a, b;
        cin >> a >> b;
        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    for (ll i = 1; i <= n; ++i) {
        cin >> limits[i].first >> limits[i].second;
    }

    dfs();
    ans.clear();
    if (dp[1][0] > dp[1][1]) {
        build(1, 0);
    } else {
        build(1, 1);
    }

    std::sort(ans.begin(), ans.end());
    vector<ll> cert(ans.size() + 1);
    for (ll i = 0; i < n; ++i) {
        ll cert_now = (x * (i + 1)) % m;
        cert[0] ^= cert_now;
    }

    for (ll i = 0; i < ans.size(); ++i) {
        ll cert_prev = (x * ans[i]) % m;
        ll cert_now = (x * ans[i] + y * 1 * 1) % m;

        cert[i + 1] = cert[i];
        cert[i + 1] ^= cert_prev;
        cert[i + 1] ^= cert_now;
    }

    vector<ll> need(q + 1);
    for (ll i = 1; i <= q; ++i) {
        cin >> need[i];
        if (need[i] > ans.size()) {
            cout << -1 << " ";
        } else {
            cout << cert[need[i]] << " ";
        }
    }
    cout << endl;

    ll i;
    cin >> i;
    while (i != 0) {
        if (need[i] > ans.size()) {
            cout << -1 << " ";
        } else {
            vector<ll> out(n + 1);
            for (ll j = 0; j < need[i]; ++j) {
                out[ans[j]] = 1;
            }
            for (auto x : out) {
                cout << x << " ";
            }
        }
        cin >> i;
    }

    cout << endl;

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;

    while (t--) {
        solve();
    }
    return 0;
}
