//#include <cmath>

#include "bits/stdc++.h"
//#include "iostream"
using namespace std;
typedef long long ll;



class bs {
public:
    ll len;
    ll arrLen;
    ll *data;

    bs(ll len_) {
        arrLen = std::ceil((float)(len_) / 64);
        len = arrLen * 64;
        data = new ll[arrLen];
        for (int i = 0; i < arrLen; ++i) {
            data[i] = 0;
        }
    }
    ~bs() {
        delete[] data;
    }
    bool at(ll i) const {
        ll f =  std::floor(i / 64);
        ll n = data[(int)f];
        return (n >> (i - f * 64)) % 2;
    }
    void set(ll i, bool val) {
        ll f =  std::floor(i / 64);
        ll bit = i - 64 * f;
        if(val) {
            data[(int)f] |= ((ll) (1) << bit);
        } else {
            data[(int) f] &= ~((ll) (1) << bit);
        }
    }
//    void print() {
//        for (int i = 0; i < len; ++i) {
//            cout << at(i);
//        }
//        cout << endl;
//    }
};


bs encryptMsg(bs seq, int k, int n) {
    bs enc(n);
    int counter = 0;
    int r = k;
    for (int i = 0; i < n; ++i) {
        if(seq.at(i)) {
            counter += 1;
        } else {
            if (counter > 0) {
                enc.set(i, true);
                counter -= 1;
                r -= 1;
            }
        }
    }
    for (int i = 0; r > 0; ++i) {
        if(!(seq.at(i) || enc.at(i))) {
            enc.set(i, true);
            r -= 1;
        }
    }
    return enc;
//    return seq;
}
bs decrypt(bs seq, int k, int n) {
    bs dec(seq.len);
    int counter = 0;
    int r = k;
    for (int i = n; i >= 0; --i) {
        if(seq.at(i)) {
            counter += 1;
        } else {
            if (counter > 0) {
                dec.set(i, true);
                counter -= 1;
                r -= 1;
            }
        }
    }
    for (int i = n; r > 0; --i) {
        if(!(seq.at(i) || dec.at(i))) {
            dec.set(i, true);
            r -= 1;
        }
    }
    return dec;
}

int main() {
    int a, m;
    cin >> a >> m;
    if(a == 1) {
        for (int i__ = 0; i__ < m; ++i__) {
            int n, k;
            cin >> n >> k;
            bs b(n);
            for (int i = 0; i < k; ++i) {
                int t;
                cin >> t;
                b.set(t - 1, true);
            }
            b.set(1, true);
            bs enc = encryptMsg(b, k, n);
//            bs enc(n);

            int printed = 0;
            for (int i = 0; i < n; ++i) {
                if(true) { //  enc.at(i)
                    printed += 1;
                    if(printed == k)
                        cout << i + 1 << endl;
                    else
                        cout << i + 1 << ' ';
                }
            }
//cout << 0 << endl;
        }
    } else {
        for (int i__ = 0; i__ < m; ++i__) {
            int n, k;
            cin >> n >> k;
            bs b(n);
            for (int i = 0; i < k; ++i) {
                int t;
                cin >> t;
                b.set(t - 1, true);
            }
            bs dec = decrypt(b, k, n);
//            bs dec(n);

            int printed = 0;
            for (int i = 0; i < n; ++i) {
                if (dec.at(i)) {
                    printed += 1;
                    if(printed == k)
                        cout << i + 1 << endl;
                    else
                        cout << i + 1 << ' ';
                }
            }
        }
    }


    return 0;
}
/*

1
2
2 1
1
5 2
1 4


2
2
5 2
2 5
2 1
2

1
1
10 3
1 5 6

2
1
10 3
2 7 8




 */
