#include "bits/stdc++.h"
using namespace std;
typedef long long ll;

struct bs {
public:
    ll len;
    ll arrLen;
    ll *data;
    bs() {
        bs(64);
    }
    bs(ll len_) {
        arrLen = ::ceil((float)(len_) / 64);
        len = arrLen * 64;
        data = new ll[arrLen];
        for (int i = 0; i < arrLen; ++i) {
            data[i] = 0;
        }
    }
    bool at(ll i) const {
        ll f =  ::floor(i / 64);
        ll n = data[(int)f];
        return (n >> (i - f * 64)) % 2;
    }
    void set(ll i, bool val) {
        ll f =  ::floor(i / 64);
        ll bit = i - 64 * f;
        if(val) {
            data[(int)f] |= ((ll) (1) << bit);
        } else {
            data[(int) f] &= ~((ll) (1) << bit);
        }
    }
};
bs encrypt(bs& seq, int k, int n) {
    bs enc(n);
    int counter = 0;
    int r = k;
    for (int i = 0; i < n; ++i) {
        if(seq.at(i)) {
            counter += 1;
        } else {
            if (counter > 0) {
                enc.set(i, true);
                counter -= 1;
                r -= 1;
            }
        }
    }
    for (int i = 0; r > 0; ++i) {
        if(!(seq.at(i) || enc.at(i))) {
            enc.set(i, true);
            r -= 1;
        }
    }
    return enc;
}
bs decrypt(bs& seq, int k, int n) {
    bs dec(n);
    int counter = 0;
    int r = k;
    for (int i = n - 1; i >= 0; --i) {
        if(seq.at(i)) {
            counter += 1;
        } else {
            if (counter > 0) {
                dec.set(i, true);
                counter -= 1;
                r -= 1;
            }
        }
    }
    for (int i = n - 1; r > 0; --i) {
        if(!(seq.at(i) || dec.at(i))) {
            dec.set(i, true);
            r -= 1;
        }
    }
    return dec;
}

int main() {
    int a, m;
    cin >> a >> m;
    if(a == 1) {
        for (int i__ = 0; i__ < m; ++i__) {
            int n, k;
            cin >> n >> k;
            bs b(n);
            for (int i = 0; i < k; ++i) {
                int t;
                cin >> t;
                b.set(t - 1, true);
            }
            bs enc = encrypt(b, k, n);

            int printed = 0;
            for (int i = 0; i < n; ++i) {
                if(enc.at(i)) {
                    printed += 1;
                    cout << i + 1 << (printed == k ? '\n' : ' ');
                }
            }
        }
    } else {
        for (int i__ = 0; i__ < m; ++i__) {
            int n, k;
            cin >> n >> k;
            bs b(n);
            for (int i = 0; i < k; ++i) {
                int t;
                cin >> t;
                b.set(t - 1, true);
            }
            bs dec = decrypt(b, k, n);

            int printed = 0;
            for (int i = 0; i < n; ++i) {
                if (dec.at(i)) {
                    printed += 1;
                    cout << i + 1 << (printed == k ? '\n' : ' ');
                }
            }
        }
    }


    return 0;
}