#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

void solve();
bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  solve();
//  while (bsolve());
}

//bool bsolve() {
//  ll n;
//  if (!(cin >> n)) return false;
//
//  cout << n + 1 << endl;
//
//  return true;
//}

vi encrypt(ll n, vi& a, ll step) {
  map<ll, ll> msg;

  for (const auto& e : a) {
    msg[e] = 1;
  }

  for (auto e : a) {
    while (msg[e]) e = (e + step + 2 * n - 1) % n + 1;
    msg[e] = 2;
  }

  vi enc;
  for (auto& [k, v] : msg) {
    if (v == 2) enc.emplace_back(k);
  }

  return enc;
}

void solve() {
  ll t;
  cin >> t;
  ll m;
  cin >> m;

  for (int i = 0; i < m; ++i) {
    ll n, k;
    cin >> n >> k;
    vi b(k);
    cin >> b;

    vi res;

    if (t == 1) {
      sort(b.begin(), b.end());
      res = encrypt(n, b, 1);
    } else {
      sort(b.rbegin(), b.rend());
      res = encrypt(n, b, -1);
    }
    cout << res << endl;
  }
}