#ifndef DEBUG
#pragma GCC optimize(Ofast)
#pragma GCC target(avx,avx2)
#endif

#include <bits/extc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vb = vector<bool>;
using vvb = vector<vb>;
using vc = vector<char>;
using vvc = vector<vc>;

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

template<class K, class V>
#ifdef DEBUG
using umap = unordered_map<K, V>;
#else
using umap = __gnu_pbds::gp_hash_table<K, V>;
#endif

void solve();
bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  solve();
//  while (bsolve());
}

//bool bsolve() {
//  ll n;
//  if (!(cin >> n)) return false;
//
//  cout << n + 1 << endl;
//
//  return true;
//}

vi encrypt(ll n, vi& a, ll step) {
  umap<ll, ll> msg, next_free;

  for (auto& e : a) msg[e] = 1;

  deque<ll> b(a.begin(), a.end());
  std::reverse(b.begin(), b.end());

  ll gap = 0;

  for (ll i = 0; i < b.size(); ++i) {
    ll j = (i + 1) % (ll) b.size();
    if (b[i] - step != b[j]) {
      gap = j;
      break;
    }
  }

  for (int i = 0; i < gap; ++i) {
    b.emplace_back(b.front());
    b.pop_front();
  }

  ll last = -1;
  ll start = -1;
  for (auto e : b) {
    if (last == -1 || ((last - step + n - 1) % n + 1 != e)) {
      start = e;
    }
    last = e;
    next_free[e] = (start + 1 - 1) % n + 1;
  }

  for (auto e : a) {
    while (msg[e]) {
      ll tmp = next_free[e];
      next_free[e] = next_free[next_free[e]];
      e = tmp;
    }
    msg[e] = 2;
  }

  vi enc;

  for (auto [k, v] : msg) {
    if (v == 2) {
      enc.emplace_back(k);
    }
  }

  sort(enc.begin(), enc.end());
  return enc;
}

void solve() {
  ll t;
  cin >> t;
  ll m;
  cin >> m;

  for (int i = 0; i < m; ++i) {
    ll n, k;
    cin >> n >> k;
    vi b(k);
    cin >> b;

    vi res;

    if (t == 1) {
//      sort(b.begin(), b.end());
      res = encrypt(n, b, 1);
    } else {
//      sort(b.rbegin(), b.rend());
      reverse(b.begin(), b.end());
      res = encrypt(n, b, -1);
    }
    cout << res << endl;
  }

  cout.flush();
}