#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvb = vector<vb>;

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

  while (bsolve()) cout << endl;
}

ll n, k, q;
vii gr;
vb leaf;
vi order;
vi ans;

void dfs(ll v, ll est, ll dir) {
  if (!leaf[v]) {
    if (dir == -1) {
      dfs(gr[v].first, est, dir);
      if (est > 0) {
        dfs(gr[v].second, est - 1, -dir);
      } else {
        gr[v].second = -1;
      }
    } else {
      dfs(gr[v].second, est, dir);
      if (est > 0) {
        dfs(gr[v].first, est - 1, -dir);
      } else {
        gr[v].first = -1;
      }
    }
  }
  order.emplace_back(v);
}

bool bsolve() {
  if (!(cin >> n >> k >> q)) return false;

  gr.assign(n, {-1, -1});
  leaf.assign(n, false);
  ans.assign(n, 0);

  for (int i = 0; i < n; ++i) {
    ll t;
    cin >> t;
    if (t == 2) {
      ll l, r;
      cin >> l >> r;
      --l, --r;
      gr[i] = {l, r};
    } else {
      leaf[i] = true;
    }
  }

  dfs(gr[0].first, k, -1);
  dfs(gr[0].second, k, 1);
  order.emplace_back(0);

  for (auto v : order) {
    if (leaf[v]) ans[v] = 1;
    else {
      auto [l, r] = gr[v];
      if (l >= 0) ans[v] += ans[l];
      if (r >= 0) ans[v] += ans[r];
    }
  }

  for (int i = 0; i < q; ++i) {
    ll u;
    cin >> u;
    --u;
    cout << ans[u] << endl;
  }

  return true;
}