#include <bits/extc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vb = vector<bool>;
using vc = vector<char>;
using vvc = vector<vc>;
using vvb = vector<vb>;

#ifndef DEBUG
#define endl '\n'
#endif

template<class T, class Y>
istream& operator>>(istream& s, pair<T, Y>& p) {
  return s >> p.first >> p.second;
}

template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (auto& e : v) s >> e;
  return s;
}

template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (const auto& e : v) s << e << ' ';
  return s;
}

bool bsolve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif

  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(25);

//  ll t;
//  cin >> t;

  while (bsolve()) cout << endl;
}

ll n, q;
vii w;
ll z;

bool calc(ll a, ll b, ii k) {
  if (a == 0 && b == 0) return true;
  for (auto it
      = upper_bound(w.begin(), w.end(), k, greater<>());
       it != w.end();
       ++it) {
    ll e = it->first;

    if (a >= e && calc(a - e, b, *it)) return true;
    if (b >= e && calc(a, b - e, *it)) return true;
  }

  return false;
}

bool bsolve() {
  if (!(cin >> n >> q)) return false;

  map<ll, ll> cnt;
  w.assign(n, {});
  for (int i = 0; i < n; ++i) {
    ll v;
    cin >> v;
    w.emplace_back(v, cnt[v]);
    cnt[v] += 1;
  }
  sort(w.rbegin(), w.rend());
  cin >> z;

  for (int qq = 0; qq < q; ++qq) {
    ll k, a, b;
    cin >> k >> a >> b;

    cout << (calc(a, b, {k, 1e18}) ? "Yes" : "No") << endl;
  }

  return true;
}