#include <bits/stdc++.h>

using namespace std;

const int C = 100000;

struct E {
    int l, r, id;
};

struct SegTree {
    vector<pair<int, int>> t;
    int n;

    SegTree(int n) : n(n) {
        t.resize(n * 4 + 5);
    }

    pair<int, int> get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (r < tl || l > tr) return {0, 0};
        int m = (l + r) / 2;
        return max(get(v + v, l, m, tl, tr), get(v + v + 1, m + 1, r, tl, tr));
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, n - 1, l, r);
    }

    void upd(int v, int l, int r, int i, pair<int, int> x) {
        if (l == r) {
            t[v] = max(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            upd(v + v, l, m, i, x);
        } else {
            upd(v + v + 1, m + 1, r, i, x);
        }
        t[v] = max(t[v + v], t[v + v + 1]);
    }

    void upd(int i, pair<int, int> x) {
        upd(1, 0, n - 1, i, x);
    }
};

vector<int> get(vector<E> &a) {
    int n = (int) a.size();
    vector<int> dp(n + 1);
    vector<int> p(n + 1);
    SegTree t(n * 4 + 4);
    for (int i = 1; i <= n; i++) {
        pair<int, int> E = t.get(0, a[i - 1].l - 1);
        dp[i] = 1 + E.first;
        p[i] = E.second;
        t.upd(a[i - 1].r, {dp[i], i});
    }
    int mx = -1;
    int id = -1;
    for (int i = 1; i <= n; i++) {
        if (dp[i] > mx) {
            mx = dp[i];
            id = i;
        }
    }
    vector<int> res;
    int now = id;
    while (now > 0) {
        res.push_back(now - 1);
        now = p[now];
    }
    reverse(res.begin(), res.end());
    return res;
}

bool isec(E a, E b) {
    if (a.r < b.l || a.l > b.r) return false;
    return true;
}

void phonk() {
    int n;
    cin >> n;
    vector<E> a(n);
    vector<int> all;
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r;
        all.push_back(a[i].l);
        all.push_back(a[i].r);
        a[i].id = i;
    }
    sort(all.begin(), all.end());
    map<int, int> val;
    int now = 1;
    val[all[0]] = 0;
    for (int i = 1; i < n * 2; i++) {
        if (all[i] == all[i - 1]) continue;
        val[all[i]] = now++;
    }
    for (auto &x : a) {
        x.l = val[x.l];
        x.r = val[x.r];
    }
    auto cmp = [&](E x, E y) {
        return x.r < y.r;
    };
    sort(a.begin(), a.end(), cmp);
    vector<int> e = get(a);
    vector<bool> ok(n, false);
    for (auto x : e) {
        ok[x] = true;
    }
    int m = (int) e.size();
    int need = n / 2 - m / 2;
    vector<pair<int, int>> w(n);
    w[0] = {0, -1};
    for (int i = 1; i < n; i++) {
        int l = -1, r = i;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (a[mid].r < a[i].l) {
                l = mid;
            } else {
                r = mid;
            }
        }
        // [r; i - 1]
        w[i] = {r, i - 1};
    }
    vector<int> good;
    vector<int> bad;
    for (int i = 0; i < n; i++) {
        if (ok[i]) {
            good.push_back(i);
        } else {
            bad.push_back(i);
        }
    }
    vector<set<int>> is(n);
    for (auto x : good) {
        for (auto y : bad) {
            if (isec(a[x], a[y])) {
                is[x].insert(y);
            }
        }
    }
    set<int> Good, Bad;
    for (int _ = 0; _ < m / 2; _++) {
        int mx = -1;
        int id = -1;
        for (int i = 0; i < n; i++) {
            if ((int) is[i].size() > mx) {
                mx = (int) is[i].size();
                id = i;
            }
        }
        Good.insert(id);
        vector<int> W(is[id].begin(), is[id].end());
        for (auto x : W) {
            Bad.insert(x);
            for (int i = 0; i < n; i++) {
                if (is[i].count(x)) {
                    is[i].erase(x);
                }
            }
        }
    }
    for (auto y : Bad) {
        if (Good.size() == n / 2) break;
        Good.insert(y);
    }
    for (auto x : Good) {
        cout << a[x].id + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    int T = 1;
    cin >> T;
    while (T--) phonk();
}
