#include <bits/stdc++.h>

using namespace std;

const int C = 100000;

struct E {
    int l, r, id;
};

struct SegTree {
    vector<pair<int, int>> t;
    int n;

    SegTree(int n) : n(n) {
        t.resize(n * 4 + 5);
    }

    pair<int, int> get(int v, int l, int r, int tl, int tr) {
        if (l >= tl && r <= tr) {
            return t[v];
        }
        if (r < tl || l > tr) return {0, 0};
        int m = (l + r) / 2;
        return max(get(v + v, l, m, tl, tr), get(v + v + 1, m + 1, r, tl, tr));
    }

    pair<int, int> get(int l, int r) {
        return get(1, 0, n - 1, l, r);
    }

    void upd(int v, int l, int r, int i, pair<int, int> x) {
        if (l == r) {
            t[v] = max(t[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i <= m) {
            upd(v + v, l, m, i, x);
        } else {
            upd(v + v + 1, m + 1, r, i, x);
        }
        t[v] = max(t[v + v], t[v + v + 1]);
    }

    void upd(int i, pair<int, int> x) {
        upd(1, 0, n - 1, i, x);
    }
};

bool isec(E a, E b) {
    if (a.r < b.l || a.l > b.r) return false;
    return true;
}

vector<int> get(vector<E> &a) {
    int n = (int) a.size();
    vector<vector<bool>> dp(n + 1, vector<bool>(n + 1, false));
    vector<vector<pair<int, int>>> p(n + 1, vector<pair<int, int>>(n + 1, {0, 0}));
    for (int i = 1; i <= n; i++) {
        dp[i][1] = true;
        p[i][1] = {0, 0};
        for (int j = 2; j <= n; j++) {
            for (int k = 1; k < i; k++) {
                if (!isec(a[k - 1], a[i - 1])) {
                    if (dp[k][j - 1]) {
                        dp[i][j] = true;
                        p[i][j] = {k, j - 1};
                    }
                }
            }
        }
    }
    int mx = -1;
    pair<int, int> E = {0, 0};
    for (int i = 1; i <= n; i++) {
        for (int j = n; j > 0; j--) {
            if (dp[i][j]) {
                if (j > mx) {
                    mx = j;
                    E = {i, j};
                }
                break;
            }
        }
    }
    int m = E.second;
    pair<int, int> x = {0, 0};
    for (int i = 1; i <= n; i++) {
        if (dp[i][m / 2]) {
            x = {i, m / 2};
            break;
        }
    }
    vector<int> res;
    while (x != make_pair(0, 0)) {
        res.push_back(a[x.first - 1].id + 1);
    }
    return res;
}

void phonk() {
    int n;
    cin >> n;
    vector<E> a(n);
    vector<int> all;
    for (int i = 0; i < n; i++) {
        cin >> a[i].l >> a[i].r;
        all.push_back(a[i].l);
        all.push_back(a[i].r);
        a[i].id = i;
    }
    sort(all.begin(), all.end());
    map<int, int> val;
    int now = 1;
    val[all[0]] = 0;
    for (int i = 1; i < n * 2; i++) {
        if (all[i] == all[i - 1]) continue;
        val[all[i]] = now++;
    }
    for (auto &x : a) {
        x.l = val[x.l];
        x.r = val[x.r];
    }
    auto cmp = [&](E x, E y) {
        return x.r < y.r;
    };
    sort(a.begin(), a.end(), cmp);
    vector<int> e = get(a);
    for (auto x : e) {
        cout << x << " ";
    }
    cout << "\n";
}

mt19937 rnd(228);

int gg(int l, int r) {
    return l + rnd() % (r - l + 1);
}

void stress() {
    while (true) {
        int n = 6;
        vector<pair<int, int>> a(n);
        for (int i = 0; i < n; i++) {
            a[i].first = gg(1, 999);
            a[i].second = gg(a[i].first + 1, 1000);
        }
        //phonk(a);
    }
}

signed main() {
    //stress();
    //return 0;
    int T = 1;
    cin >> T;
    while (T--) phonk();
}
