#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <functional>
#include <cassert>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

mt19937 rnd(1337);

#define int long long

void solve() {
	int n, q; cin >> n >> q;
	vector <int> w(n);
	for (auto& x : w) cin >> x;
	sort(all(w));

	vector <vector <int>> dp(n + 1, vector <int>(5001, -1e18));
	dp[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		dp[i + 1] = dp[i];
		for (int a = 0; a < dp[0].size(); ++a) {
			if (a + w[i] < dp[0].size()) {
				dp[i + 1][a + w[i]] = max(dp[i][a], dp[i + 1][a + w[i]]);
			}
			if (dp[i][a] >= w[i] - 1) {
				dp[i + 1][a] = max(dp[i + 1][a], dp[i][a] + w[i]);
			}
		}
	}

	int z; cin >> z;
	while (q--) {
		int k, a, b; cin >> k >> a >> b;
		int ps = upper_bound(all(w), k) - w.begin();
		if (*min_element(dp[ps].begin(), dp[ps].begin() + a + 1) >= b) cout << "Yes\n";
		else cout << "No\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int32_t t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
}