#include <bits/stdc++.h>
#define ff first
#define ss second
#define endl '\n'
#define all(x) x.begin(), x.end()

typedef long long ll;
using namespace std;

struct ST {
    int sz = 1;
    vector<pair<int, int>> tree;

    ST(int n) {
        while (sz <= n) {
            sz *= 2;
        }

        tree.resize(sz * 2);

        for (int i = 0; i < n; i++) {
            tree[i + sz] = {0, i};
        }
        for (int i = sz - 1; i > 0; i--) {
            tree[i] = tree[i * 2];
        }
    }

    void update(int v, int val) {
        v += sz;
        tree[v] = {val, v - sz};
        v /= 2;
        while (v > 0) {
            tree[v] = max(tree[v * 2], tree[v * 2 + 1]);
            v /= 2;
        }
    }

    pair<int, int> get_max(int v, int tl, int tr, int l, int r) {
        if (l <= tl && tr <= r) return tree[v];

        if (r < tl || tr < l) return {0, -1};

        int m = (tl + tr) / 2;
        auto ls = get_max(v * 2, tl, m, l, r);
        auto rs = get_max(v * 2 + 1, m + 1, tr, l, r);

        return max(ls, rs);
    }
};

struct seg {
    int l, r, id;

    seg() {
    l = 0;
    r = 0;
    id = 0;
    }
};

bool cmp(seg a, seg b) {
    if (a.r != b.r) return a.r < b.r;

    return a.l < b.l;
}

void solve() {
    int n;
    cin >> n;

    vector<seg> e(n);
    vector<pair<int, int>> w(n);
    for (int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;

        seg u;
        u.l = a;
        u.r = b;
        u.id = i;

        e[i] = u;

        w[i] = {b, a};
    }
    sort(all(e), cmp);
    sort(all(w));

    ST st(n);

    vector<int> p(n, -1);
    for (int i = 0; i < n; i++) {
        pair<int, int> q = {e[i].l, 0};
        int id = lower_bound(all(w), q) - w.begin();

        int mx = 0;
        if (id != 0) {
            pair<int, int> e = st.get_max(1, 0, st.sz - 1, 0, id - 1);
            mx = e.ff, p[i] = e.ss;
        }

        st.update(i, mx + 1);
    }

    auto [m, f] = st.get_max(1, 0, st.sz - 1, 0, n - 1);

    vector<int> ans;
    vector<bool> u(n);
    while (f != -1 && ans.size() < n / 2) {
        ans.push_back(f);
        u[f] = 1;
        f = p[f];
    }
    int i = 0;
    while (ans.size() < n / 2) {
        while (u[i]) i++;
        ans.push_back(i);
        i++;
    }

    for (auto x : ans) {
        cout << e[x].id + 1 << " ";
    }
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
