#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

const int MAXC = 307;

bool dp[MAXC][MAXC];
int f[MAXC][MAXC];

struct query {
	long long k, a, b;
	int id;
	query(long long a0, long long a1, long long a2, int ind) {
		k = a0;
		a = a1;
		b = a2;
		id = ind;
	}
};

bool comp(query v, query u) {
	return v.k < u.k;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <long long> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	int z;
	cin >> z;
	vector <query> qu;
	for (int i = 0; i < q; i++) {
		long long k, a, b;
		cin >> k >> a >> b;
		qu.push_back(query(k, a, b, i));
	}
	sort(qu.begin(), qu.end(), comp);
	for (int i = 0; i < MAXC; i++)
		fill(dp[i], dp[i] + MAXC, false);
	dp[0][0] = true;
	int id = 0;
	vector <bool> ans(q);
	for (int i = 0; i < MAXC; i++)
		for (int j = 0; j < MAXC; j++)
			f[i][j] = 0;
	for (int i = 0; i < MAXC; i++) {
		for (int j = 0; j < MAXC; j++) {
			if (dp[i][j])
				f[i][j] = 1;
			if (i)
				f[i][j] += f[i - 1][j];
			if (j)
				f[i][j] += f[i][j - 1];
			if (i && j)
				f[i][j] -= f[i - 1][j - 1];
		}
	}
	for (auto e : qu) {
		while (id < n && w[id] <= e.k) {
			for (int a = MAXC - 1; a >= 0; a--) {
				for (int b = MAXC - 1; b >= 0; b--) {
					if (dp[a][b] && b + w[id] < MAXC)
						dp[a][b + w[id]] = true;
					if (dp[a][b] && a + w[id] < MAXC)
						dp[a + w[id]][b] = true;
				}
			}
			id++;
			for (int i = 0; i < MAXC; i++)
				for (int j = 0; j < MAXC; j++)
					f[i][j] = 0;
			for (int i = 0; i < MAXC; i++) {
				for (int j = 0; j < MAXC; j++) {
					if (dp[i][j])
						f[i][j] = 1;
					if (i)
						f[i][j] += f[i - 1][j];
					if (j)
						f[i][j] += f[i][j - 1];
					if (i && j)
						f[i][j] -= f[i - 1][j - 1];
				}
			}
		}
		if (e.a < MAXC && e.b < MAXC)
			ans[e.id] = (f[e.a][e.b] == (e.a + 1) * (e.b + 1));
	}
	for (auto e : ans) {
		if (e)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}