#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <bitset>
#include <unordered_map>

using namespace std;

const int MAXC = 1507;
const int bSize = 1507;

bitset <bSize> dp[MAXC];

struct query {
	long long k, a, b;
	int id;
	query(long long a0, long long a1, long long a2, int ind) {
		k = a0;
		a = a1;
		b = a2;
		id = ind;
	}
};

bool comp(query v, query u) {
	return v.k < u.k;
}

void solve() {
	int n, q;
	cin >> n >> q;
	vector <long long> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	sort(w.begin(), w.end());
	int z;
	cin >> z;
	vector <query> qu;
	for (int i = 0; i < q; i++) {
		long long k, a, b;
		cin >> k >> a >> b;
		qu.push_back(query(k, a, b, i));
	}

	sort(qu.begin(), qu.end(), comp);
	for (int i = 0; i < MAXC; i++)
		dp[i] = false;
	dp[0][0] = true;
	int id = 0;
	vector <bool> ans(q);
	for (auto e : qu) {
		while (id < n && w[id] <= min(1ll * MAXC, e.k)) {
			for (int a = MAXC - 1; a >= 0; a--) {
				if (a + w[id] < MAXC)
					dp[a + w[id]] |= dp[a];
				if (w[id] < MAXC)
					dp[a] |= (dp[a] << w[id]);
				if (w[id] < MAXC && dp[a][0])
					dp[a][w[id]] = true;
			}
			id++;
		}
		bitset <bSize> temp;
		for (int i = bSize - 1; i >= bSize - e.b - 1; i--)
			temp[i] = true;
		if (e.a < MAXC && e.b < MAXC) {
			ans[e.id] = true;
			for (int i = 0; i <= e.a; i++) {
				if ((dp[i] << (bSize - e.b - 1)) != temp)
					ans[e.id] = false;
			}
		}
	}
	for (auto e : ans) {
		if (e)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	//  cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}