#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

const int MAXN = 2e5 + 7;
vector <int> g[MAXN];
int l[MAXN];
int r[MAXN];

long long dp0[MAXN];
long long dp1[MAXN];

void dfs(int v, int prev = -1) {
	dp1[v] = l[v];
	dp0[v] = 0;
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dfs(to, v);
	}
	for (auto to : g[v]) {
		if (to == prev)
			continue;
		dp0[v] += max(dp0[to], dp1[to]);
		dp1[v] += dp0[to];
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	long long x, y, m;
	cin >> x >> y >> m;
	int v, u;
	for (int i = 0; i < n; i++)
		g[i].clear();
	for (int i = 0; i < n - 1; i++) {
		cin >> v >> u;
		v--; u--;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	vector <int> query(q);
	for (int i = 0; i < q; i++)
		cin >> query[i];
	fill(dp0, dp0 + n, -1e18);
	fill(dp1, dp1 + n, -1e18);
	dfs(0);
	long long ans = max(dp0[0], dp1[0]);
	for (auto e : query) {
		if (e == ans) {
			long long k = 0;
			for (int i = 0; i < n; i++)
				k ^= ((x * (i + 1) + y * l[i] * l[i]) % m);
			cout << k << " ";
		}
		else {
			cout << "-1 ";
		}
	}
	cout << endl;
	int c = 0;
	cin >> c;
	c--;
	while (c != -1) {
		if (query[c] != ans) {
			cout << -1 << endl;
		}
		else {
			for (int i = 0; i < n; i++)
				cout << l[i] << " ";
			cout << endl;
		}
		cin >> c;
		c--;
	}
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}