#include <iostream>
#include <vector>

#define MAX(a, b) ((a) < (b) ? (b) : (a))

using namespace std;

typedef pair <int, int> pi;
typedef pair <long long, long long> pll;
// typedef pair <pi, pi> ppi;

void printv(vector <int> &v) {
    cout << "[";
    for (int x : v) cout << x << ", ";
    cout << "]\n";
    return;
}

int modadd(int a, int b, int m) {
    return (a % m + b % m) % m;
}

int modmul(int a, int b, int m) {
    return ((long long) (a % m) * (b % m)) % m;
}

pll dfs(vector <vector <int>> &w, vector <int> &mx, int r, int u) {
    long long a = 0, b = mx[u];
    for (int v : w[u]) {
        if (v == r) continue;

        pi p = dfs(w, mx, u, v);

        a += MAX(p.first, p.second);
        b += p.first;
    }
    return {a, b};
}

void one() {
    int n, q;
    cin >> n >> q;

    int x, y, m;
    cin >> x >> y >> m;

    vector <vector <int>> w(n);
    for (int i = 0; i < n - 1; ++i) {
        int s, f;
        cin >> s >> f;
        --s;
        --f;
        w[s].push_back(f);
        w[f].push_back(s);
    }

    vector <int> mn(n), mx(n);
    for (int i = 0; i < n; ++i) {
        cin >> mn[i];
        cin >> mx[i];
        if (mn[i] != mx[i]) exit(13);
    }

    ///
    pll p = dfs(w, mx, -1, 0);
    long long e = MAX(p.first, p.second);
    int f = 0;
    for (int i = 0; i < n; ++i) {
        f ^= modadd(modmul(x, (i + 1) % m, m), modmul(y, modmul(mx[i] % m, mx[i] % m, m), m), m);
    }
    // cout << "e=" << e << ", f=" << f << "\n";
    ///

    vector <long long> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
        if (v[i] == e) cout << f << ' ';
        else cout << -1 << ' ';
    }
    cout << endl;

    int j;
    cin >> j;
    while (j != 0) {
        --j;
        if (v[j] == e) {
            for (int i = 0; i < n; ++i) cout << mx[i] << ' ';
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> j;
    }
    return;
}

int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #else
        // ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #endif // LOCAL
    cin >> t;
    while (t--) {
        one();
        cout << endl;
    }
    return 0;
}
