#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

#define int long long
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define fastIo(a) ios_base::sync_with_stdio(a) ; cin.tie(a); cout.tie(a);

const int INF = 1e9;
const ll INFll = 1e18;


struct SegmentTree {
    int R = 1;
    vector<pair<int, int>> tree;
    SegmentTree(int n, vector<int>& v) {
        while (R < n) R <<= 1;
        tree.resize(2 * R, {-INF, -1});
        tree[R].S = 0;
        for (int i = 0; i < v.size(); i++)
            tree[v[i] + R].S = i + 1;
    }
    void upd(int i, int x) {
        i += R;
        tree[i].F = x;
        while (i / 2 > 0) {
            i /= 2;
            tree[i] = max(tree[i * 2], tree[i * 2 + 1]);
        }
    }
    pair<int, int> get(int ql, int qr, int nl, int nr, int node) {
        if (ql >= nr || nl >= qr) return {-INF, -1};
        if (ql <= nl && nr <= qr) return tree[node];
        int nm = (nl + nr) / 2;
        return max(get(ql, qr, nl, nm, node * 2), get(ql, qr, nm, nr, node * 2 + 1));
    }
    pair<int, int> get(int ql, int qr) {
        return get(ql, qr, 0, R, 1);
    }

};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a) cin >> i;

    vector<int> p(n + 1);
    SegmentTree dp(n + 1, a);
    dp.upd(0, 0);
    int mx = -1, mx_ind = -1;
    for (int i = 1; i <= n; i++) {
        auto [x, ind] = dp.get(0, a[i - 1]);
        dp.upd(a[i - 1], x + 1);
        p[i] = ind;
        if (x + 1 > mx) {
            mx = x + 1;
            mx_ind = i;
        }
    }

    int ans = mx;
    vector<bool> used(n + 1);
    int cur = mx_ind;
    while (cur != 0) {
        used[cur - 1] = true;
        cur = p[cur];
    }
    mx = -1;
    bool fl = false;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            fl |= (a[i] < mx);
            mx = max(mx, a[i]);
        }
    }
    ans += (mx > 0) + fl;
    cout << ans << '\n';
}

signed main() {
    fastIo(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}