#include <bits/stdc++.h>

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

using namespace std;

struct Segment {
    int l;
    int r;
    int ind;

    Segment() {}
    Segment(int l, int r, int ind) : l(l), r(r), ind(ind) {}
};

int n, m;

bool run(const vector<Segment>& a, vector<int>& index, bool ost) {
    set<int> index_s(all(index));
    vector<int> need;
    vector<int> trash;

    vector<Segment> segments;
    for (int ind : index) {
        segments.push_back(a[ind]);
    }


    for (auto [l, r, ind] : a) {
        if (index_s.find(ind) == index_s.end()) {
            auto lambda_r = [](const Segment& a, const Segment& b) {
                return a.r < b.r;
            };
            auto it = lower_bound(all(segments), Segment(0, l, 0), lambda_r);

            if ((it != segments.end()) && (it->l <= r)) {
                trash.push_back(ind);
            } else {
                need.push_back(ind);
            }
        }
    }
    if (need.size() > n / 2) {
        return false;
    }

//    cerr << "Index:\n";
//    for (int x : index) {
//        cerr << x << ' ';
//    }
//    cerr << '\n';
//
//    cerr << "Need:\n";
//    for (int x : need) {
//        cerr << x << ' ';
//    }
//    cerr << '\n';

//    cerr << "Trash:\n";
//    for (int x : trash) {
//        cerr << x << ' ';
//    }
//    cerr << '\n';

    int len_add = n / 2 - (int)need.size();
    for (int i = 0; i < len_add; ++i) {
        need.push_back(trash[i]);
    }

    vector<char> is_answer(n, true);
    for (int x : need) {
        is_answer[x] = false;
    }

    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if (is_answer[i]) {
            ans.push_back(i);
        }
    }
    for (int x : ans) {
        cout << x + 1 << ' ';
    }
    cout << '\n';

    return true;
}

void solve() {
    cin >> n;
    vector<Segment> segments(n);
    for (int i = 0; i < n; ++i) {
        segments[i].ind = i;
        cin >> segments[i].l >> segments[i].r;
    }
    auto lambda = [&](const Segment& a, const Segment& b) {
        return a.r < b.r;
    };
    sort(all(segments), lambda);
    int x = 0;

    vector<int> index;
    for (auto [l, r, ind] : segments) {
        if (l > x) {
            index.push_back(ind);
            x = r;
        }
    }
    m = (int)index.size();
    assert(m % 2 == 0);

    vector<int> ind_l;
    for (int i = 0; i < m; i += 2) {
        ind_l.push_back(index[i]);
    }
    vector<int> ind_r;
    for (int i = 1; i < m; i += 2) {
        ind_r.push_back(index[i]);
    }
//    for (int x : ind_l) {
//        cerr << x + 1 << ' ';
//    }
//    cerr << '\n';
//    for (int x : ind_r) {
//        cerr << x + 1 << ' ';
//    }
//    cerr << '\n';
    if (!run(segments, ind_l, 0)) {
        assert(run(segments, ind_r, 1));
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}