#include <iostream>
#include <vector>

using namespace std;

int MOD;

int mex(int mask, int n) {
    int bit = 0;
    while (bit < n && ((mask >> bit) & 1)) {
        bit++;
    }
    return bit;
}

int ultra(int mask, int n) {
    int m = mex(mask, n);
    int new_mask = 0;
    for (int bit = 0; bit < n; bit++) {
        if ((mask >> bit) & 1) {
            new_mask ^= 1 << (bit ^ (m - 1));
        }
    }
    return new_mask;
}

int cache[1 << 20]; // 0 -- not halting, 1 -- halting, 2 -- not in cache

bool is_terminal(int mask, int n, int p) {
    int m = mex(mask, n);
    if (m != p) {
        return false;
    }
    int critical_bit = (m - 1) ^ m;
    if ((mask >> critical_bit) & 1) {
        return false;
    }
    return true;
}

int is_halting(int mask, int n, int p) {
    if (cache[mask] == 2) {
        if (is_terminal(mask, n, p)) {
            cache[mask] = 1;
        } else {
            cache[mask] = 0;
            if (is_halting(ultra(mask, n), n, p)) {
                cache[mask] = 1;
            }
        }
    }
    return cache[mask];
}

void solve() {
    fill(cache, cache + (1 << 20), 2);
    int k, n, p; cin >> k >> n >> p;
    if (__builtin_popcount(p) != 1) {
        cout << 0 << endl;
        return;
    }
    int N = 1 << k;
    int ans = 0;
    for (int mask = 0; mask < (1 << N); mask++) {
        if (__builtin_popcount(mask) != n) {
            continue;
        }
        if (mask % 2 == 0) {
            continue;
        }
        if (is_halting(mask, N, p)) {
            ans++;
        }
    }
    cout << ans % MOD << endl;
}

int main() {
    cin >> MOD;
    int t; cin >> t;
    while (t--) {
        solve();
    }
}
