#include <iostream>
#include <vector>
#include <algorithm>

#define int int64_t

using namespace std;
using DPT = vector<vector<bool>>;

const int MAX_A = 337;

signed main() {
    int n, q; cin >> n >> q;
    vector<int> as(n);
    for (int &i : as) {
        cin >> i;
    }
    sort(as.begin(), as.end());
    vector<DPT> dp(n + 1, DPT(MAX_A, vector<bool>(MAX_A)));
    dp[0][0][0] = 1;
    for (int i = 0; i < n; i++) {
        int x = as[i];
        for (int a = 0; a < MAX_A - x; a++) {
            for (int b = 0; b < MAX_A; b++) {
                dp[i + 1][a][b] = dp[i + 1][a][b] || dp[i][a][b];
                dp[i + 1][a + x][b] = dp[i + 1][a + x][b] || dp[i][a][b];
                dp[i + 1][b][a + x] = dp[i + 1][b][a + x] || dp[i][b][a];
            }
        }
    }
    vector<vector<vector<int>>> dp_prefsums(n, vector<vector<int>>(MAX_A + 1, vector<int>(MAX_A + 1, 0)));
    for (int i = 0; i < n; i++) {
        for (int a = 0; a < MAX_A; a++) {
            for (int b = 0; b < MAX_A; b++) {
                dp_prefsums[i][a + 1][b + 1] = dp_prefsums[i][a + 1][b] + dp_prefsums[i][a][b + 1] - dp_prefsums[i][a][b] + (dp[i][a][b] ? 1 : 0);
            }
        }
    }
    int z; cin >> z; // z == 0
    while (q--) {
        int k, a, b; cin >> k >> a >> b;
        int idx = upper_bound(as.begin(), as.end(), k) - as.begin();
        cout << (dp_prefsums[idx][a + 1][b + 1] == (a + 1) * (b + 1) ? "Yes" : "No") << endl;
    }
}
