#include <iostream>
#include <vector>
#include <algorithm>

#define int int64_t

using namespace std;

const int MAX_A = 5057;

const int64_t INF_LL = 1LL << 57;

int64_t join_values(int64_t a, int64_t l, int64_t r) {
    if (a + 1 >= l) {
        return max(a, r);
    } else {
        return a;
    }
}

signed main() {
    int n, q; cin >> n >> q;
    vector<int64_t> as(n);
    for (int64_t &i : as) {
        cin >> i;
    }
    sort(as.begin(), as.end());
    vector<int64_t> dp(MAX_A, -INF_LL);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        vector<int64_t> new_dp = dp;
        int64_t x = as[i];
        for (int a = 0; a < MAX_A; a++) {
            if (a >= x) {
                new_dp[a] = max(new_dp[a], dp[a - x]);
            }
            new_dp[a] = join_values(new_dp[a], x, dp[a] + x);
        }
        dp.swap(new_dp);
    }
    // vector<vector<int>> dp_prefsums(MAX_A + 1, vector<int>(MAX_A + 1, 0));
    // for (int a = 0; a < MAX_A; a++) {
    //     for (int b = 0; b < MAX_A; b++) {
    //         dp_prefsums[a + 1][b + 1] = dp_prefsums[a + 1][b] + dp_prefsums[a][b + 1] - dp_prefsums[a][b] + (dp[a][b] ? 1 : 0);
    //     }
    // }
    int z; cin >> z; // z == 0
    while (q--) {
        int64_t k, a, b; cin >> k >> a >> b;
        cout << (dp[a] >= b ? "Yes" : "No") << endl;
    }
}
