#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef tuple<int, int, int> ti;
typedef set<ti> sti;

template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}
template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int MAXN = 2e5 + 10, INF = 1e18;

vvi g;
int dp[MAXN][2];
vi l, r;

void solve() {
	int n, q;
	cin >> n >> q;
	l.assign(n + 1, 0);
	r.assign(n + 1, 0);
	g.assign(n + 1, {});
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	int suml = 0;
	for (int i = 1; i <= n; ++i) {
		cin >> l[i] >> r[i];
		if (i > 1)
			suml += l[i];
	}
	int k = 0;
	for (int i = 1; i <= n; ++i)
		k ^= (x * i % m);
	int k1 = k;
	vpi v;
	vi v1;
	for (int i = 0; i < q; ++i) {
		int x;
		cin >> x;
		v.push_back({ x, i });
		v1.push_back(x);
	}
	sort(all(v));
	vi ans(q, -1);
	int j = 2;
	int sm = suml;
	vi c(n + 1, 0);
	for (int i = 1; i <= n; ++i)
		c[i] = l[i];
	k = 0;
	for (int j = 1; j <= n; ++j)
		k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
	for (auto [need, i] : v) {
		if (need < max(l[1], suml))
			ans[i] = -1;
		else {
			while (sm < need && j <= n) {
				int val = min(need - sm, r[j] - c[j]);
				sm += val;
				k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
				c[j] += val;
				k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
				if (r[j] == c[j])
					j++;
			}
			if (sm < need) {
				if (need > r[1])
					ans[i] = -1;
				else
					ans[i] = (k1 ^ (x % m) ^ ((x * 1 % m + ((y * need % m) * need % m)) % m));
			}
			else {
				ans[i] = k;
			}
		}
	}
	for (int i = 0; i < q; ++i)
		cout << ans[i] << ' ';
	cout << endl;
	int i;
	cin >> i;
	while (i) {
		if (ans[i] == -1)
			cout << -1 << endl;
		else {
			int need = v1[i];
			int j = 2;
			int sm = suml + l[1];
			vi c(n + 1, 0);
			for (int i = 1; i <= n; ++i)
				c[i] = l[i];
			k = 0;
			for (int j = 1; j <= n; ++j)
				k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
			while (sm < need && j <= n) {
				int val = min(need - sm, r[j] - c[j]);
				sm += val;
				k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
				c[j] += val;
				k ^= ((x * j % m + ((y * c[j] % m) * c[j] % m)) % m);
				if (r[j] == c[j])
					j++;
			}
			if (sm < need) {
				if (need > r[1])
					ans[i] = -1;
				else
					ans[i] = (k1 ^ (x % m) ^ ((x * 1 % m + ((y * need % m) * need % m)) % m));
			}
			else {
				ans[i] = k;
			}
			for (int i = 1; i <= n; ++i)
				cout << c[i] << ' ';
			cout << endl;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}