#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

vector<int> g[8][128] = {};
int used[8][128] = {};
int res[8][128] = {};
void precalc() {
    for (int i = 2; i <= 7; i++) {
        for (int m1 = 0; m1 < (1 << i); m1++) {
            for (int m2 = 0; m2 < (1 << i); m2++) {
                if (__builtin_popcount(m1) == __builtin_popcount(m2) && (m1 & m2) == 0) {
                    g[i][m1].push_back(m2);
                }
            }
            res[i][m1] = -1;
        }
    }
}

int t = 1;
bool kuhn_dfs(int i, int m) {
    if (used[i][m] == t) {
        return false;
    }
    used[i][m] = t;

    for (auto m2 : g[i][m]) {
        if (res[i][m2] == -1) {
            res[i][m2] = m;
            return true;
        }
    }

    for (auto m2 : g[i][m]) {
        if (kuhn_dfs(i, res[i][m2])) {
            res[i][m2] = m;
            return true;
        }
    }

    return false;
}

void kuhn() {
    for (int i = 2; i <= 7; i++) {
        for (int m = 0; m < (1 << i); m++) {
            if (kuhn_dfs(i, m)) {
                t++;
            }
        }
    }
}

int code[8][128] = {};
void init() {
    precalc();
    kuhn();
    for (int i = 2; i <= 7; i++) {
        for (int m = 0; m < (1 << i); m++) {
            code[i][res[i][m]] = m;
        }
    }
}

void encode(int test) {
    int n, k;
    cin >> n >> k;
    int mask = 0;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        mask |= 1 << (x - 1);
    }

    mask = code[n][mask];
    for (int i = 0; i < n; i++) {
        if ((mask >> i) & 1) {
            cout << i + 1 << ' ';
        }
    }
    cout << '\n';
}

void decode(int test) {
    int n, k;
    cin >> n >> k;
    int mask = 0;
    for (int i = 0; i < k; i++) {
        int x;
        cin >> x;
        mask |= 1 << (x - 1);
    }

    mask = res[n][mask];
    for (int i = 0; i < n; i++) {
        if ((mask >> i) & 1) {
            cout << i + 1 << ' ';
        }
    }
    cout << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    init();
    int a;
    cin >> a;
    int m;
    cin >> m;
    for (int i = 1; i <= m; i++) {
        (a == 1 ? encode(i) : decode(i));
    }

    return 0;
}