#include <bits/stdc++.h>
using namespace std;

pair<long long, long long> get_value(int x, vector<vector<int>>& dfsed_graph, vector<long long>& a) {
    long long c(0), d(0);
    for (auto i : dfsed_graph[x]) {
        pair<long long, long long> rest(get_value(i, dfsed_graph, a));
        c += rest.first;
        d += max((long long)0, rest.second - rest.first);
    }
    return {c + d, c + max(d, a[x])};
}

int certificate(long long x, long long y, long long m, vector<long long>& a) {
    int cert(0);
    for (int i = 0; i < a.size(); i++) {
        cert ^= (x * (i + 1) + y * ((a[i] * a[i]) % m)) % m;
    }
    return cert;
}

void recertify(long long x, long long y, long long m, long long a, long long b, long long i, long long& cert) {
    cert ^= (x * (i + 1) + y * ((a * a) % m)) % m;
    cert ^= (x * (i + 1) + y * ((b * b) % m)) % m;
}

void dfs_graph(int x, int p, vector<vector<int>>& g, vector<vector<int>>& dfsed_graph) {
    for (auto i : g[x]) {
        if (i != p) {
            dfs_graph(i, x, g, dfsed_graph);
            dfsed_graph[x].push_back(i);
        }
    }
}

void f() {
    long long n, k, q, r;
    cin >> n >> k;
    long long m, x, y;
    cin >> x >> y >> m;
    vector<long long> L(n), R(n), A(n);
    vector<vector<int>> graph(n, vector<int>(0));
    for (int i = 0; i < n - 1; i++) {
        cin >> q >> r;
        q--;
        r--;
        graph[q].push_back(r);
        graph[r].push_back(q);
    }
    vector<vector<int>> dfsed_graph(n, vector<int>(0));
    dfs_graph(0, -1, graph, dfsed_graph);
    for (int i = 0; i < n; i++) {
        cin >> q >> r;
        L[i] = q;
        A[i] = q;
        R[i] = r;
    }
    vector<pair<long long, int>> plans{};
    for (int i = 0; i < k; i++) {
        cin >> q;
        plans.push_back({q, i});
    }
    long long prevperformance(get_value(0, dfsed_graph, A).second);
    for (int i = 0; i < n; i++) {
        A[i] = R[i];
    }
    int kch(0);
    long long performance(get_value(0, dfsed_graph, A).second);
    long long cert(certificate(x, y, m, A));
    sort(plans.begin(), plans.end());
    vector<int> certs(k);
    vector<pair<int, int>> answer(k);
    for (int i = 0; i < k; i++) {
        if ((plans[i].first > performance) || (plans[i].first < prevperformance)) {
            certs[plans[i].second] = -1;
        } else {
            certs[plans[i].second] = 0;
        }
    }
    for (int i = 0; i < k; i++) {
        cout << certs[i] << " ";
    }
    cout << endl;
    while (true) {
        cin >> q;
        if (q == 0) {
            return;
        }
        q--;
        if (certs[q] == -1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; i++) {
                if (i < answer[q].first) {
                    cout << R[i];
                } else if (i == answer[q].first) {
                    cout << answer[q].second;
                } else {
                    cout << L[i];
                }
                cout << " ";
            }
            cout << endl;
        }
    }
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        f();
    }
}
