#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
#define vec vector
#define all(v) v.begin(), v.end()
#define sz(v) ((int)v.size())
using namespace std;
const int inf = 1e9, deg = 30;
struct node {
	int v;
	node* l, * r;
	node (int _v): v(_v), l(nullptr), r(nullptr) {}
	node(node* _l, node* _r) : l(_l), r(_r) {
		v = l->v + r->v;
	}
};

node* build(int tl, int tr) {
	if (tl + 1 == tr)
		return new node(0);
	int tm = (tl + tr) / 2;
	return new node(build(tl, tm), build(tm, tr));
}

int get(node* t, int l, int r, int tl, int tr) {
	if (tl == l && tr == r)
		return t->v;
	int tm = (tl + tr) / 2;
	if (r <= tm)
		return get(t->l, l, r, tl, tm);
	else if (tm <= l)
		return get(t->r, l, r, tm, tr);
	else
		return get(t->l, l, tm, tl, tm) + get(t->r, tm, r, tm, tr);
}

void setv(node* t, int i, int x, int tl, int tr) {
	if (tl + 1 == tr) {
		t->v = x;
		return;
	}
	int tm = (tl + tr) / 2;
	if (i < tm)
		setv(t->l, i, x, tl, tm);
	else
		setv(t->r, i, x, tm, tr);
	t->v = t->l->v + t->r->v;
}


void solve(vec<vec<int>> &a, int n, int m) {
	vec<vec<int>> dp(m + 1, vec<int>(n, inf));
	vec<vec<int>> opt(m + 1, vec<int>(n, -1));
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int e = 0; e < i; e++) {
			if (a[e][0] < a[i][1])
				cnt++;
		}
		dp[1][i] = cnt;
	}
	for (int i = 2; i <= m; i++) {
		for (int j = 0; j < n; j++) {
			for (int k = 0; k < j; k++) {
				if (a[k][0] >= a[j][1])
					break;
				int cnt = 0;
				for (int e = k + 1; e < j; e++) {
					if (a[e][1] > a[k][0])
						cnt++;
				}
				dp[i][j] = min(dp[i][j], dp[i - 1][k] + cnt);
				if (dp[i - 1][k] + cnt == dp[i][j])
					opt[i][j] = k;
			}
		}
	}
	vec<int> ans;
	for (int i = 0; i < n; i++) {
		int cnt = 0;
		for (int e = i + 1; e < n; e++) {
			if (a[e][1] > a[i][0])
				cnt++;
		}
		if (dp[m / 2][i] + cnt <= n / 2) {
			int curi = m / 2, curj = i;
			while (curi > 0) {
				ans.push_back(curj);
				curj = opt[curi][curj];
				curi--;
			}
			break;
		}
	}
	reverse(all(ans));
	set<int> del;
	set<int> sans;
	for (int i = 0; i < sz(ans); i++)
		sans.insert(a[ans[i]][2]);
	for (int e = 0; e < ans[0]; e++) {
		if (a[e][0] < a[ans[0]][1])
			del.insert(a[e][2]);
	}
	for (int i = 0; i < sz(ans) - 1; i++) {
		for (int e = ans[i] + 1; e < ans[i + 1]; e++) {
			if (a[e][1] > a[ans[i]][0])
				del.insert(a[e][2]);
		}
	}
	for (int e = ans[sz(ans) - 1] + 1; e < n; e++) {
		if (a[e][1] > a[ans[sz(ans) - 1]][0])
			del.insert(a[e][2]);
	}
	for (int i = 0; i < n && sz(del) < n / 2; i++) {
		if (del.find(i) == del.end() && sans.find(i) == sans.end())
			del.insert(i);
	}
	for (int i = 0; i < n; i++) {
		if (del.find(i) == del.end())
			cout << i + 1 << " ";
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
#endif
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vec<vec<int>> a(n, vec<int>(3));
		for (int i = 0; i < n; i++) {
			cin >> a[i][1] >> a[i][0];
			a[i][2] = i;
		}
		sort(all(a));
		int m = 1;
		int pr = a[0][0];
		for (int i = 0; i < n; i++) {
			if (a[i][1] > pr) {
				m++;
				pr = a[i][0];
			}
		}
		solve(a, n, m);
		cout << "\n";
	}
}