#include<bits/stdc++.h>

#define ll lon long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

using namespace std;

mt19937 rnd(51);

const int INF = 1e9;

struct SegTree {
    vector<int> t;
    int n;
    SegTree(int n_) {
        n = 1;
        while (n < n_) {
            n *= 2;
        }
        t.resize(2 * n, -INF);
    }
    void upd(int i, int val) {
        i += n;
        t[i] = val;
        for (; i > 1; i /= 2) {
            t[i / 2] = max(t[i], t[i ^ 1]);
        }
    }
    int get(int l, int r) {
        int ans = -INF;
        l += n, r += n + 1;
        while (l < r) {
            if (l & 1) {
                ans = max(ans, t[l++]);
            }
            if (r & 1) {
                ans = max(ans, t[--r]);
            }
            l /= 2, r /= 2;
        }
        return ans;
    }
};

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> p(n);
        for (int i = 0; i < n; i++) {
            cin >> p[i];
        }
        vector<SegTree> dpL(n + 2, n + 2), dpR(n + 2, n + 2);
        dpL[0].upd(n + 1, 0);
        dpR[n + 1].upd(0, 0);
        int ans = 0;
        vector<vector<pair<int, int>>> del(n);
        for (int i = 0; i < n; i++) {
            vector<array<int, 3>> upd;
            for (int r = 0; r <= n + 1; r++) {
                int mx = dpR[r].get(0, p[i] - 1);
                upd.pb({p[i], r, mx + 1});
            }
            for (int l = 0; l <= n + 1; l++) {
                int mx = dpL[l].get(p[i] + 1, n + 1);
                upd.pb({l, p[i], mx + 1});
            }
            for (auto [l, r, val] : upd) {
                dpL[l].upd(r, val);
                dpR[r].upd(l, val);
                for (int j = i + 1; j < n; j++) {
                    if (l < p[j] && p[j] < r) {
                        del[j].pb({l, r});
                        break;
                    }
                }
                ans = max(ans, val);
            }
            for (auto [l, r] : del[i]) {
                dpL[l].upd(r, -INF);
                dpR[r].upd(l, -INF);
            }
            for (int l = 0; l <= n + 1; l++) {
                for (int r = 0; r <= n + 1; r++) {
                    if (l < p[i] && p[i] < r) {
                        dpL[l].upd(r, -INF);
                        dpR[r].upd(l, -INF);
                    }
                }
            }
        }
        cout << ans << endl;
    }
    return 0;
}
