﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <tuple>
#include <cassert>
using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int tt;
	cin >> tt;
	while (tt-- > 0) {
		int n;
		cin >> n;
		vector<pair<int, int>> a;
		for (int i = 0; i < n; ++i) {
			int x, y;
			cin >> x >> y;
			a.emplace_back(x, y);
		}
		vector<int> ord(n);
		iota(all(ord), 0);
		sort(all(ord), [&](int i, int j) { return a[i] < a[j]; });
		ll l = -1, r = 1e9;
		vector<pair<int, int>> dp;
		vector<int> prev;
		auto Intersect = [&](int a, int b, int c, int d) {
			return !(b < c || d < a);
		};
		auto Calc = [&](ll c) {
			dp.assign(n + 1, pair<int, int>(0, 0));
			prev.assign(n + 1, -1);
			dp[0] = { 0, 0 };
			auto F = [&](pair<int, int> p) -> ll {
				return p.first * (1 - c) + p.second;
			};
			for (int i = 1; i <= n; ++i) {
		  	int x, y;
		  	tie(x, y) = a[ord[i - 1]];
		  	int cnt = 0;
		  	for (int j = 1; j <= n; ++j) if (i != j) {
		  		int u, v;
		  		tie(u, v) = a[ord[j - 1]];
		  		if (Intersect(x, y, u, v)) ++cnt;
		  	}
		  	dp[i] = {1, cnt};
		  	for (int j = 1; j < i; ++j) {
		  		int u, v;
		  		tie(u, v) = a[ord[j - 1]];
		  		if (Intersect(u, v, x, y)) continue;
		  		int cnt = 0;
		  		for (int t = 1; t <= n; ++t) if (t != i) {
		  			int p, q;
		  			tie(p, q) = a[ord[t - 1]];
		  			if (Intersect(x, y, p, q) && p > v) {
		  				++cnt;
		  			}
		  		}
		  			  	pair<int, int> val = {dp[j].first + 1, dp[j].second + cnt};
		  	if (F(val) > F(dp[i])) {
		  		dp[i] = val;
		  		prev[i] = j;
		  	}
	
		  	}
			}
			int best = 0;
			for (int i = 1; i <= n; ++i) {
				if (F(dp[i]) > F(dp[best]))
					best = i;
			}
			return best;
		};
		int best = Calc(-n);
		int mx = dp[best].first;
		//cout << "mx: " << mx << endl;
 		assert(mx % 2 == 0);
 	  while (r - l > 1) {
 		  ll c = (l + r) >> 1;
 		  int best = Calc(c);
 		  if (dp[best].first > mx / 2) l = c;
 		  else r = c;
	 	}
		best = Calc(r);
		assert(dp[best].first == mx / 2);   
		vector<int> st;
		while (best != -1) {
			st.push_back(ord[best - 1]);
			best = prev[best];
		}
		vector<int> st1;
		for (int j = 0; j < n; ++j) {
			bool can = false;
			auto [x, y] = a[j];
			for (int i : st) {
				auto [u, v] = a[i];
				if (i != j && !(y < u || v < x) && st1.size() + st.size() < n / 2) {
					st1.push_back(j);
				}
			}
		}
		st.insert(st.end(), all(st1));
		sort(all(st));
		for (int i : st) cout << i + 1 << ' ';
		cout << endl;
	}
	return 0;
}