#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;

const int INF = 1e9;

ostream& operator<<(ostream& out, const vi& a) {
    for (int i : a) {
        out << i << ' ';
    }
    return out;
}

istream& operator>>(istream& in, vi& a) {
    for (int& i : a) {
        in >> i;
    }
    return in;
}

void update(int& dp, int val) {
    dp = max(dp, val);
}

void solve() {
    int n;
    cin >> n;
    vi p(n);
    cin >> p;
    for (int& i : p) {
        --i;
    }

    vvvi dp(n, vvi(n, vi(n, -INF))); // pref, max in q, min in r
    dp[0][p[0]][n - 1] = 1;
    dp[0][0][p[0]] = 1;
    for (int i = 0; i < n - 1; ++i) {
        for (int mxq = 0; mxq < n; ++mxq) {
            for (int mnr = 0; mnr < n; ++mnr) {
                if (p[i + 1] > mxq) {
                    update(dp[i + 1][p[i + 1]][mnr], dp[i][mxq][mnr] + 1);
                } else {
                    update(dp[i + 1][mxq][mnr], dp[i][mxq][mnr]);
                }
                if (p[i + 1] < mnr) {
                    update(dp[i + 1][mxq][p[i + 1]], dp[i][mxq][mnr] + 1);
                } else {
                    update(dp[i + 1][mxq][mnr], dp[i][mxq][mnr]);
                }
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            ans = max(ans, dp[n - 1][i][j]);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    for (; t; --t) {
        solve();
    }
    return 0;
}
