#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vi = vector<int>;
using vvi = vector<vi>;

const int INF = 1e9 + 9;
const string yes = "Yes\n", no = "No\n";

ostream& operator<<(ostream& out, const vi& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

struct pii {
    int first, second, ind;

    pii() = default;
    pii(int first, int second, int ind): first(first), second(second), ind(ind) {}
    bool operator<(const pii& other) const {
        if (first == other.first) {
            return second < other.second;
        }
        return first < other.first;
    }
};

bool comp(pii& a, pii& b) {
    if (a.second == b.second) {
        return a.first < b.first;
    }
    return a.second < b.second;
}

int count_m(int n, vector<pii>& seg, vector<pii>& a, vector<pii>& other) {
    sort(seg.begin(), seg.end(), comp);
    vi dp(n + 1, INF);
    dp[0] = -INF;

    a.clear();
    other.clear();
    for (pii p : seg) {
        auto it = lower_bound(dp.begin(), dp.end(), p.first);
        if (*it == INF) {
            a.push_back(p);
        } else {
            other.push_back(p);
        }
        *it = min(*it, p.second);
    }
    return a.size();
}

void solve() {
    int n;
    cin >> n;
    vector<pii> seg(n), a, other, ans;
    for (int i = 0; i < n; ++i) {
        cin >> seg[i].first >> seg[i].second;
        seg[i].ind = i + 1;
    }

    int m = count_m(n, seg, a, other);
    int div = a[m / 2 - 1].second;
    sort(seg.begin(), seg.end());
    int first_half = lower_bound(seg.begin(), seg.end(), pii(div, INF, -1)) - seg.begin();
    if (first_half >= n / 2) {
        ans = vector<pii>(a.begin(), a.begin() + m / 2);
        for (pii& i : other) {
            if (i.first <= div && ans.size() < n / 2) {
                ans.push_back(i);
            }
        }
    } else {
        ans = vector<pii>(a.begin() + m / 2, a.end());
        for (pii& i : other) {
            if (i.first > div && ans.size() < n / 2) {
                ans.push_back(i);
            }
        }
    }

    for (pii& i : ans) {
        cout << i.ind << ' ';
    }
    cout << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }

    return 0;
}
