#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vi = vector<int>;
using vvi = vector<vi>;

ostream& operator<<(ostream& out, const vi& v) {
    for (int i : v) {
        out << i << ' ';
    }
    return out;
}

void dfs(int v, int par, const vi& r, vvll& dp, const vvi& g) {
    if (g[v].size() == 1 && g[v][0] == par) {
        return;
    }

    dp[1][v] = r[v];
    for (int to : g[v]) {
        if (to != par) {
            dfs(to, v, r, dp, g);

            dp[0][v] += max(dp[0][to], dp[1][to]);
            dp[1][v] += dp[0][to];
        }
    }
}

int f(int v, const vi& a, int x, int y, int m) {
    return (x * 1LL * (v + 1) + y * 1LL * (a[v] * 1LL * a[v] % m)) % m;
}

void solve() {
    int n, q;
    cin >> n >> q;
    int m, x, y;
    cin >> x >> y >> m;
    vvi g(n);
    for (int i = 0, s, f; i < n - 1; ++i) {
        cin >> s >> f;
        --s;
        --f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vi l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    vll v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }

    vvll dp(2, vll(n, 0));
    dfs(0, -1, r, dp, g);

    vi a(r);
    int cert = 0;
    for (int i = 0; i < n; ++i) {
        cert ^= f(i, a, x, y, m);
    }
    for (int i = 0; i < q; ++i) {
        cout << (v[i] == max(dp[0][0], dp[1][0]) ? cert : -1) << ' ';
    }
    cout << endl;

    int i;
    for (int _ = 0; _ <= q; ++_) {
        cin >> i;
        --i;
        if (i == -1) {
            break;
        }

        if (v[i] == max(dp[0][0], dp[1][0])) {
            cout << a << endl;
        } else {
            cout << -1 << endl;
        }
    }
}

int main() {
    int t;
    cin >> t;
    for (; t; --t) {
        solve();
    }

    return 0;
}
