#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl;
#else
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define _ <<" "<<

#define int ll

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct event {
    int l, r, id;
};

bool operator<(const event &a, const event &b) {
    return tie(a.l, a.r) < tie(b.l, b.r);
}

int OPEN = 0, CLOSE = 1;

struct ev {
    int x, type, id;

    ev(int x, int t, int id) : x(x), type(t), id(id) {}
};

bool operator<(const ev &a, const ev &b) {
    return tie(a.x, a.type) < tie(b.x, b.type);
}

void solve() {
    int n;
    cin >> n;
    vector<event> events(n);
    vector<ev> evs;
    forn(i, n) {
        cin >> events[i].l >> events[i].r, events[i].id = i;
        evs.emplace_back(events[i].l, OPEN, i);
        evs.emplace_back(events[i].r, CLOSE, i);
    }
    sort(all(evs));
    vector<pair<int, int>> left(n), right(n);
    int mx = 0, cnt_mx = 0;
    for (auto &[x, t, id]: evs) {
        if (t == OPEN) left[id] = {mx, cnt_mx};
        else {
            if (left[id].first + 1 > mx) {
                mx = left[id].first + 1;
                cnt_mx = left[id].second;
            } else if (left[id].first + 1 == mx) {
                cnt_mx += left[id].second;
            }
        }
    }
    sort(rall(evs));
    mx = 0, cnt_mx = 0;
    for (auto &[x, t, id]: evs) {
        if (t == OPEN) right[id] = {mx, cnt_mx};
        else {
            if (right[id].first + 1 > mx) {
                mx = right[id].first + 1;
                cnt_mx = right[id].second;
            } else if (right[id].first + 1 == mx) {
                cnt_mx += right[id].second;
            }
        }
    }
    vector<pair<int, pair<int, int>>> segments(n);
    forn(i, n) segments[i] = {left[i].second * right[i].second, {events[i].r, i}};
    sort(rall(segments));
    forn(i, n / 2) cout << segments[i].second.second + 1 << " ";
    cout << nl;
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
    cin >> t;
    while (t--) solve();
}