#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl;
#else
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast")
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define _ <<" "<<

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

#define int ll

struct query {
    int k, a, b, id;

    query() = default;

    query(int k, int a, int b) : k(k), a(a), b(b) {}
};

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    forn(i, n) cin >> w[i];
    int z;
    cin >> z;

    if (n <= 10 && q <= 10) {
        forn(i, q) {
            int k, a, b;
            cin >> k >> a >> b;
            set<pair<int, int>> can;
            function<void(int, int, int)> f = [&](int c1, int c2, int pos) {
                if (pos == n) {
                    if (c1 <= a && c2 <= b) can.emplace(c1, c2);
                    return;
                }
                if (w[pos] <= k) {
                    f(c1 + w[pos], c2, pos + 1);
                    f(c1, c2 + w[pos], pos + 1);
                }
                f(c1, c2, pos + 1);
            };
            f(0, 0, 0);
            if (can.size() == (a + 1) * (b + 1)) {
                cout << "Yes" << nl;
            } else {
                cout << "No" << nl;
            }
        }
        return;
    }

    vector<query> Q(q);
    bool b_is_zero = true;
    forn(i, q) {
        cin >> Q[i].k >> Q[i].a >> Q[i].b;
        Q[i].id = i;
        if (Q[i].b) b_is_zero = false;
    }

    if (b_is_zero) {
        sort(all(w));
        vector<int> mx(n + 1);
        forn(i, n) {
            if (mx[i] + 1 - w[i] >= 0) {
                mx[i + 1] = mx[i] + w[i];
            } else {
                mx[i + 1] = mx[i];
            }
        }
        forn(i, q) {
            auto [k, a, b, id] = Q[i];
            if (a <= mx[upper_bound(all(w), k) - w.begin()]) {
                cout << "Yes" << nl;
            } else {
                cout << "No" << nl;
            }
        }
        return;
    }

    vector<bool> ans(q);

    int cur = 0;
    set<pair<int, int>> pull1, pull2;
    pull1.emplace(0, 0);
    forn(i, n) {
        for (auto &[c1, c2]: pull1) {
            forn(j, q) if (Q[j].a <= c1 && Q[j].b <= c2) ans[j] = 1;
            if (c1 + 1 - w[i] >= 0 && c1 + w[i] <= 5000) pull2.emplace(c1 + w[i], c2);
            if (c2 + 1 - w[i] >= 0 && c2 + w[i] <= 5000) pull2.emplace(c1, c2 + w[i]);
        }
        swap(pull1, pull2);
        pull2.clear();
    }
    forn(i, q) {
        if (ans[i]) {
            cout << "Yes" << nl;
        } else {
            cout << "No" << nl;
        }
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}