#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <unordered_set>

using namespace std;

typedef long long ll;

struct Hasher
{
	size_t operator()(const pair<ll, ll>& p) const
	{
		return (p.first << 32ll) + p.second;
	}
};

unordered_set<pair<ll, ll>, Hasher> s;

void rec(int i, ll lw, ll rw, vector<ll>& w, ll k)
{
	if (i == w.size() || w[i] > k)
	{
		s.insert({ lw, rw });
		return;
	}
	rec(i + 1, lw, rw, w, k);
	rec(i + 1, lw + w[i], rw, w, k);
	rec(i + 1, lw, rw + w[i], w, k);
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n, q;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> w[i];
	}
	int z;
	cin >> z;
	sort(w.begin(), w.end());
	for (int i = 0; i < q; ++i)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		s.clear();
		rec(0, 0, 0, w, k);
		bool ok = true;
		for (int w1 = 0; w1 <= a; ++w1)
		{
			for (int w2 = 0; w2 <= b; ++w2)
			{
				if (s.count({ w1, w2 }) == 0)
				{
					ok = false;
					break;
				}
			}
			if (!ok)
				break;
		}
		if (ok)
			cout << "Yes\n";
		else
			cout << "No\n";
	}
	return 0;
}
