#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
#include <unordered_set>

using namespace std;

typedef long long ll;

vector<vector<int>> graph;
vector<pair<ll, ll>> dp;
vector<pair<ll, ll>> a;

void dfs(int me, int p)
{
	dp[me].first = a[me].first;
	dp[me].second = 0;
	for (int v : graph[me])
	{
		if (v == p)
			continue;
		dfs(v, me);
	}
	for (int v : graph[me])
	{
		if (v == p)
			continue;
		dp[me].first += dp[v].second;
		dp[me].second += max(dp[v].first, dp[v].second);
	}
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	for (int test = 0; test < t; ++test)
	{
		int n, q;
		cin >> n >> q;
		int x, y, m;
		cin >> x >> y >> m;
		graph.resize(n);
		for (int i = 0; i < n; ++i)
		{
			graph[i].resize(0);
		}
		for (int i = 0; i < n - 1; ++i)
		{
			int s, f;
			cin >> s >> f;
			graph[s - 1].push_back(f - 1);
			graph[f - 1].push_back(s - 1);
		}
		a.resize(n);
		for (int i = 0; i < n; ++i)
			cin >> a[i].first >> a[i].second;
		dp.assign(n, { 0, 0 });
		dfs(0, -1);
		vector<ll> v(q);
		for (int i = 0; i < q; ++i)
		{
			cin >> v[i];
			if (max(dp[0].first, dp[0].second) == v[i])
			{
				ll cert = 0;
				for (int j = 0; j < n; ++j)
				{
					cert ^= (x * (ll(j) + 1) + y * a[j].first * a[j].first) % m;
				}
				cout << cert << ' ';
			}
			else
			{
				cout << -1 << ' ';
			}
		}
		cout << endl;
		while (true)
		{
			int ind;
			cin >> ind;
			if (ind == 0)
				break;
			--ind;
			if (max(dp[0].first, dp[0].second) == v[ind])
			{
				for (int j = 0; j < n; ++j)
				{
					cout << a[j].first << ' ';
				}
				cout << endl;
			}
			else
			{
				cout << -1 << endl;
			}
		}
	}
	return 0;
}
