#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#define int long long

using namespace std;

int mod;
const int maxk = 3e5;
int f[maxk];

int binpow(int a, int p) {
    if (p == 0) return 1;
    if (p & 1) return binpow(a, p - 1) * a % mod;
    return binpow(a * a % mod, p / 2);
}

int inv(int a) {
    return binpow(a, mod - 2);
}

int cnk(int n, int k) {
    return (f[n] * inv(f[k]) % mod) * inv(f[n - k]) % mod;
}

int calc(int n, int p, int k);

int calc_1(int n, int p, int k) {
    if (p > n) {
        return 0;
    }
    int res = cnk(k - p - 3, n - p);
    if (2 * p == k) {
        if (p == 1) {
            res = cnk(k - p - 1, n - p);
        } else res = cnk(k - p - 2, n - p);
    } else if (p == 1) {
        res = cnk(k - p - 2, n - p);
    }
    //cout << res << "\n";
    for (int pw = p * 2; pw < k; pw <<= 1) {
        //cout << pw << " ";
        for (int i = 1; i <= min(n - pw, pw - 1); ++i) {
            if (pw * 2 != k) {
                res += calc(i, p, pw) * cnk(k - 2 * pw - 1, n - i - pw);
                res += calc_1(i, p, pw) * cnk(k - 2 * pw - 1, n - i - pw);
                res %= mod;
            } else {
                res += calc_1(i, p, pw) * cnk(k - 2 * pw, n - i - pw);
                res += calc_1(i, p, pw) * cnk(k - 2 * pw, n - i - pw);
                res %= mod;
            }
        }
    }
    return res;
}

int calc(int n, int p, int k) {
    if (n == k) {
        if (p == k) {
            return 1;
        } else {
            return 0;
        }
    }
    if (p > n) {
        return 0;
    }
    int res = cnk(k - p - 2, n - p);
    if (p == 1) {
        res = cnk(k - p - 1, n - p);
    }
    //cout << res << "\n";
    for (int pw = p * 2; pw < k; pw <<= 1) {
        //cout << pw << " ";
        for (int i = 1; i <= min(n - pw, pw - 1); ++i) {
            res += calc(i, p, pw) * cnk(k - 2 * pw, n - i - pw);
            res += calc_1(i, p, pw) * cnk(k - 2 * pw, n - i - pw);
            res %= mod;
        }
        //cout << res << "\n";
    }
    return res;
}
/*
998244353
1
3 5 1
*/

void solve() {
    int n, p, k; cin >> k >> n >> p;
    int pp = 0;
    while ((1 << pp) < p) pp++;
    if (p != (1 << pp)) {
        cout << "0\n";
        return;
    }
    cout << calc(n, p, (1 << k)) << "\n";
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    cin >> mod;
    f[0] = 1;
    for (int i = 1; i < maxk; ++i) {
        f[i] = f[i - 1] * i % mod;
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
