#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <unordered_map>
#include <cassert>
#define int long long 

using namespace std;

const int maxn = 3e5;
vector <int> g[maxn];
int l[maxn], r[maxn];
int a[maxn];

int dp[maxn][2];

void dfs(int v, int p) {
    dp[v][0] = 0; dp[v][1] = a[v];
    for (auto u : g[v]) {
        if (p != u) {
            dfs(u, v);
            dp[v][0] += max(dp[u][0], dp[u][1]);
            dp[v][1] += dp[u][0];
        }
    }
}

vector <int> inans;

void get_inans(int v, int p, int tp) {
    if (tp == 0) {
        for (auto u : g[v]) {
            if (u != p) {
                get_inans(u, v, 1);
            }
        }
    } else {
        if (dp[v][0] > dp[v][1]) {
            get_inans(v, p, 0);
        } else {
            inans.push_back(v);
            for (auto u : g[v]) {
                if (u != p) {
                    get_inans(u, v, 0);
                }
            }
        }
    }
}

void solve() {
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; ++i) {
        int v, u; cin >> v >> u;
        v--; u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    int ok = 1;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        if (l[i] > 0) ok = 0;
        if (r[i] > 1) {
            ok = 0;
        }
    }
    vector <int> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        a[i] = l[i];
    }
    dfs(0, -1);
    int mi = max(dp[0][0], dp[0][1]);
    for (int i = 0; i < n; ++i) {
        a[i] = r[i];
    }
    dfs(0, -1);
    int ma = max(dp[0][0], dp[0][1]);
    /*if (ok) {
        inans.clear();
        get_inans(0, -1, 1);
        int xr = 0;
        for (int i = 1; i <= n; ++i) {
            xr = xr ^ (x * i % m);
        }
        vector <int> res(ma + 1, xr);
        for (int i = 0; i < ma; ++i) {
            xr = xr ^ (x * inans[i] % m);
            xr = xr ^ ((x * inans[i] + y) % m);
            res[i + 1] = xr;
        }
        for (int i = 0; i < q; ++i) {
            if (mi > v[i] || v[i] > ma) {
                cout << "-1 ";
            } else {
                cout << res[v[i]] << ' ';
            }
        }
        cout << endl;
        int id;
        while (cin >> id) {
            if (id == 0) return;
            id--;
            if (mi > v[id] || v[id] > ma) {
                cout << "-1" << endl;
            } else {
                vector <int> ans(n, 0);
                for (int i = 0; i < v[id]; ++i) {
                    ans[inans[i] - 1] = 1;
                }
                for (auto el : ans) {
                    cout << el << ' ';
                }
                cout << endl;
            }
        }
    }*/
    if (1) {
        vector < vector <int> > ans(q, vector <int> ());
        for (int i = 0; i < q; ++i) {
            if (mi > v[i] || v[i] > ma) {
                cout << "-1 ";
            } else {
                ans[i].resize(n);
                for (int j = 0; j < n; ++j) {
                    a[j] = r[j];
                }
                int sm = ma;
                while (sm > v[i]) {
                    inans.clear();
                    get_inans(0, -1, 1);
                    for (auto v : inans) {
                        a[v] *= -1;
                    }
                    for (int j = 0; j < n; ++j) {
                        if (a[j] >= 0) {
                            a[j] = l[j];
                        } else {
                            a[j] *= -1;
                            if (a[j] - l[j] <= sm - v[i]) {
                                sm -= (a[j] - l[j]);
                                a[j] = l[j];
                            } else {
                                a[j] -= (sm - v[i]);
                                sm = v[i];
                            }
                        }
                    }
                    dfs(0, -1);
                    sm = max(dp[0][0], dp[0][1]);
                }
                int k = 0;
                for (int j = 0; j < n; ++j) {
                    k = k ^ (((x * (j + 1) + (y * a[j] % m) * a[j] % m)) % m);
                    ans[i][j] = a[j];
                }
                cout << k << " ";
            }
        }
        cout << endl;
        int id;
        while (cin >> id) {
            if (id == 0) return;
            id--;
            if (mi > v[id] || v[id] > ma) {
                cout << "-1" << endl;
            } else {
                for (auto el : ans[id]) {
                    cout << el << ' ';
                }
                cout << endl;
            }
        }
    }
    
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
