#include <iostream>
#include <vector>
#include <functional>
#include <set>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

void solve() {
  int n, k, q;
  cin >> n >> k >> q;
  vector<vector<int>> g(n);
  for (int i = 0; i < n; i++) {
    int sz;
    cin >> sz;
    g[i].resize(sz);
    for (auto &u : g[i]) {
      cin >> u;
      --u;
    }
  }

  vector<int> dp(n);
  function<void(int, int, int)> dfs = [&] (int v, int cnt, int dir) {
    if (g[v].empty()) {
      if (cnt <= k) {
        dp[v] = 1;
      }
    } else {
      dfs(g[v][0], cnt + (dir == 1), 0);
      dfs(g[v][1], cnt + (dir == 0), 1);
      dp[v] = dp[g[v][0]] + dp[g[v][1]];
    }
  };
  dfs(0, 0, -1);

  for (int w = 0; w < q; w++) {
    int v;
    cin >> v;
    --v;
    cout << dp[v] << '\n';
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}
