#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

const int inf = 1e18;

void solve() {
  int n;
  cin >> n;
  vector<array<int, 2>> a(n);
  for (auto &[l, r] : a) {
    cin >> l >> r;
  }

  vector<int> p(n);
  for (int i = 0; i < n; i++) {
    p[i] = i;
  }
  sort(all(p), [&] (const int& i, const int& j) {
    return make_pair(a[i][1], a[i][0]) < make_pair(a[j][1], a[j][0]);
  });

  auto new_a = a;
  for (int i = 0; i < n; i++) {
    new_a[i] = a[p[i]];
  }
  a.swap(new_a);


  vector<int> suf(n);
  for (int i = n - 1; i >= 0; i--) {
    suf[i] = 1;
    for (int j = i + 1; j < n; j++) {
      if (a[j][0] > a[i][1]) {
        suf[i] = max(suf[i], suf[j] + 1);
      }
    }
  }

  int rem = n / 2;
  int need = *max_element(all(suf)) / 2;
  vector<int> ban(n);

  vector<int> cur;
  auto calc = [&] (int l, int r) { // ban[l..r] = 1
    int cur_r = (cur.empty() ? -1 : a[cur.back()][1]);
    int cnt = sz(cur);
    for (int i = r + 1; i < n; i++) {
      if (a[i][0] > cur_r) {
        cnt++;
        cur_r = a[i][1];
      }
    }

    return cnt;
  };

  bool was = false;
  for (int i = 0; i + rem <= n; i++) {
    int L = i, R = i + rem - 1;
    if (calc(L, R) <= need) {
      rem = 0;
      while (calc(L, R) < need) {
        int cur_r = (cur.empty() ? -1 : a[cur.back()][1]);
        if (a[L][0] > cur_r) {
          cur.push_back(L);
        }
        L++;
        rem++;
      }
      for (int j = L; j <= R; j++) {
        ban[j] = 1;
      }
      break;
    }
    int cur_r = (cur.empty() ? -1 : a[cur.back()][1]);
    if (a[i][0] > cur_r) {
      cur.push_back(i);
    }
  }

  vector<int> in(n);
  int cur_r = -1;
  for (int i = 0; i < n; i++) {
    if (ban[i]) {
      continue;
    }
    auto [l, r] = a[i];
    if (l > cur_r) {
      cur_r = r;
      in[i] = 1;
    }
  }

  for (int i = 0; i < n; i++) {
    if (!ban[i] && !in[i] && rem > 0) {
      rem -= 1;
      ban[i] = 1;
    }
    if (!ban[i]) {
      cout << p[i] + 1 << ' ';
    }
  }

  cout << '\n';

  assert(rem == 0);
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}