#include <iostream>
#include <vector>
#include <functional>
#include <set>
#include <array>
#include <cassert>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
  int n, q, x, y, m;
  cin >> n >> q >> x >> y >> m;

  vector<vector<int>> g(n);
  for (int w = 1; w < n; w++) {
    int u, v;
    cin >> u >> v;
    --u, --v;
    g[u].push_back(v);
    g[v].push_back(u);
  }

  vector<int> l(n), r(n);
  for (int i = 0; i < n; i++) {
    cin >> l[i] >> r[i];
  }

  vector<int> que(q);
  for (int i = 0; i < q; i++) {
    cin >> que[i];
  }

  vector<int> val(n);
  auto calc = [&] () {
    vector<vector<int>> dp(n, vector<int> (2));
    function<void(int, int)> dfs = [&] (int v, int p) {
      dp[v][1] = r[v];
      for (auto &u : g[v]) {
        if (u != p) {
          dfs(u, v);
          dp[v][1] += dp[u][0];
          dp[v][0] += max(dp[u][0], dp[u][1]);
        }
      }
    };
    dfs(0, -1);

    return max(dp[0][0], dp[0][1]);
  };

  map<int, int> id;
  for (int i = 0; i < q; i++) {
    id[que[i]] = i;
  }


  vector<int> ans(q, -1);
  vector<vector<int>> ar(q);

  function<void(int)> rec = [&] (int v) {
    if (v == n) {
      int cert = 0;
      for (int i = 0; i < n; i++) {
        cert ^= (x * (i + 1) + y * val[i] % m * val[i]) % m;
      }
      int ef = calc();
      if (id.find(ef) != id.end()) {
        int w = id[ef];
        ans[w] = cert;
        ar[w] = val;
      }
      return;
    }
    for (int w = l[v]; w <= r[v]; w++) {
      val[v] = w;
      rec(v + 1);
    }
  };
  rec(0);

  for (auto &x : ans) {
    cout << x << ' ';
  }
  cout << endl;

  int ympa;
  cin >> ympa;
  while (ympa != 0) {
    --ympa;
    if (ans[ympa] != -1) {
      for (auto &x : ar[ympa]) {
        cout << x << ' ';
      }
      cout << endl;
    } else {
      cout << -1 << endl;
    }
    cin >> ympa;
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}