#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace  std;
#define int long long
const int maxn = 2e5 + 1;

vector<int> g[maxn];
int a[maxn];
pair<int, int> dp[maxn];

vector<int> take;

void dfs(int v, int p) {
    dp[v] = {0, a[v]};

    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    for (auto u : g[v]) {
        if (u != p) {
            dp[v].first += max(dp[u].second, dp[u].first);
            dp[v].second += dp[u].first;
        }
    }
}

void rev(int v, int p, int was) {
    if (!was) {
        if (dp[v].first < dp[v].second) {
            take.push_back(v);
            was = 1;
        } else {
            was = 0;
        }
    } else {
        was = 0;
    }
    for (auto u : g[v]) {
        if (u != p) {
            rev(u, v, was);
        }
    }
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i <= n; i++) {
        g[i].clear();
    }
    for (int i = 0; i < n - 1; i++) {
        int s, f;
        cin >> s >> f;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vector<pair<int, int>> edges(n);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        edges[i] = {l, r};
        a[i + 1] = r;
    }
    take.clear();
    dfs(1, 1);
    rev(1, 1, 0);
    int e1 = max(dp[1].first, dp[1].second);
    int e2 = 0;
    vector<int> pref(e1 + 1);
    int k = 0;
    vector<int> used(n + 1);
    for (auto x : take) {
        used[x] = 1;
    }
    for (int i = 1; i <= n; i++) {
        pref[0] ^= (x * i) % m;
    }
    for (int i = 1; i <= take.size(); i++) {
        pref[i] = pref[i - 1] ^ ((x * take[i - 1]) % m) ^ ((x * take[i - 1] + y) % m);
    }
    vector<int> qs;
    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        qs.push_back(u);
        if (u > e1) {
            cout << -1 << ' ';
        } else {
            cout << pref[u] << ' ';
        }
    }
    cout << endl;
    while (true) {
        int i;
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (qs[i] > e1) {
            cout << -1 << endl;
        } else {
            vector<int> res(n + 1);
            for (int j = 0; j < qs[i]; j++) {
                res[take[j]] = 1;
            }
            for (int i = 1; i <= n; i++) {
                cout << res[i] << ' ';
            }
        }
    }
}

signed main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}
