#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
using namespace std;
#define For(i, n) for(int i = 0; i < n; ++i)
#define For3(i, s, n) for(int i = s; i < n; ++i)
#define For4(i, s, n, c) for(int i = s; i < n == c > 0; i += c)
#define all(i) i.begin(), i.end()
#define int long long
#define pii pair<int, int>
const int INF = 1e9 + 17;
const int N = 1e6 + 7;

struct Ver
{
	int f, s, ind;

	set<int> to;
	int par = -1;
	int cntToDel = 0;
	bool isDel = false;

	friend bool operator<(const Ver& p1, const Ver& p2)
	{
		return p1.f < p2.f || (p1.f == p2.f && p1.s > p2.s);
	}
};

Ver vec[N];
int n, m;
int getM()
{
	int lst = 0;
	int cnt = 0;
	For(i, n)
	{
		if (vec[i].f >= lst)
		{
			lst = vec[i].s;
			cnt++;
		}
		else
			if (vec[i].s < lst)
				lst = vec[i].s;
	}
	return cnt;
}
set<pii> cnt_ind;
int used[N];
int cUsed = 1;

int gCnt(int i)
{
	if (vec[i].to.size() == 0) return vec[i].cntToDel;
	return INF;
}

void setCnt(int i, int cnt)
{
	cnt_ind.erase({ gCnt(i), i });
	vec[i].cntToDel = cnt;
	cnt_ind.insert({ gCnt(i), i });
}

void DFS(int v, int cnt = 0)
{
	used[v] = cUsed;
	vec[v].cntToDel = cnt;
	if (vec[v].to.size() == 1) cnt++;
	else cnt = 0;
	for(int u : vec[v].to)
	{
		DFS(u, cnt);
	}
}

void delVer(int i)
{
	if (vec[i].par != -1)
	{
		Ver& p = vec[vec[i].par];
		cnt_ind.erase({ gCnt(vec[i].par), vec[i].par });
		p.to.erase(i);
		setCnt(vec[i].par, p.cntToDel);
	}
}

int delOne()
{
	auto it = cnt_ind.begin();
	int i = it->second;
	cnt_ind.erase(it);

	if (vec[i].isDel) return 0;
	Ver& ver = vec[i];

	vec[i].isDel = true;
	delVer(i);
	if (ver.cntToDel == 0)
	{
		if (vec[i].par != -1)
		{
			Ver& p = vec[vec[i].par];
			if (p.to.size() == 1)
			{
				setCnt(*p.to.begin(), p.cntToDel + 1);
			}
		}
		return 1;
	}
	return 0;
}

void clear()
{
	cUsed++;
	For(i, n)
	{
		vec[i] = Ver();
	}
}
void solve()
{
	cin >> n;
	For(i, n) cin >> vec[i].f >> vec[i].s;
	For(i, n) vec[i].ind = i;
	sort(vec, vec + n);
	m = getM();

	vector<pii> lst;
	For(i, n)
	{
		while (lst.size() != 0 && vec[i].f >= lst.back().first) lst.pop_back();
		if (lst.size())
		{
			vec[lst.back().second].to.insert(i);
			vec[i].par = lst.back().second;
		}
		lst.push_back({ vec[i].s, i });
	}
	For(i, n)
	{
		if (used[i] == cUsed) continue;
		while (vec[i].par != -1) i = vec[i].par;
		DFS(i);
	}

	m /= 2;
	For(i, n)
	{
		setCnt(i, vec[i].cntToDel);
	}

	int wasDel = 0;
	while (m > 0)
	{
		m -= delOne();
		wasDel++;
	}
	For(i, n)
	{
		if (vec[i].isDel) continue;
		if (vec[i].to.size() >= 1)
		{
			vec[i].isDel = 1;
			wasDel++;
		}
		if (wasDel == n / 2) break;
	}

	For(i, n)
	{
		if (vec[i].isDel) cout << vec[i].ind + 1 << " ";
	}
}

signed main()
{
	int t;
	cin >> t;
	while (t--)
	{
		clear();
		solve();
		cout << "\n";
	}
}