#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

struct node {
	ll x, y;
};

void solve() {
	ll h, w; int n;
	cin >> h >> w >> n;
	vector<node> a(n);
	ll mxx = 0, mnx = inf, mxy = 0, mny = inf;
	for (auto& e : a) {
		cin >> e.y >> e.x;
		mxx = max(mxx, e.x);
		mnx = min(mnx, e.x);
		mny = min(mny, e.y);
		mxy = max(mxy, e.y);
	}
	ll sq = mxx - mnx + 1;
	ll ans = 0;
	for (int i = 0; i <= w; ++i) {
		ll minx = inf, maxx = 0;
		for (int j = 0; j < n; ++j) {
			ll curx;
			if (a[j].x <= i) {
				curx = w - (i - a[j].x);
			} else {
				curx = a[j].x - i;
			}
			minx = min(curx, minx);
			maxx = max(curx, maxx);
		}
		if (sq > (maxx - minx + 1) || (sq == maxx - minx + 1 && ans > i)) {
			sq = (maxx - minx + 1);
			ans = i;
		}
	}
	for (int i = 0; i <= w; ++i) {
		ll minx = inf, maxx = 0;
		ll d = w - i + 1;
		for (int j = 0; j < n; ++j) {
			ll curx;
			if (a[j].x + d > w) {
				curx = a[j].x + d - w;
			} else {
				curx = a[j].x + d;
			}
			minx = min(curx, minx);
			maxx = max(curx, maxx);
		}
		if (sq > (maxx - minx + 1) || (sq == (maxx - minx + 1) && ans > d)) {
			sq = (maxx - minx + 1);
			ans = d;
		}
	}
	ll sqy = mxy - mny + 1;
	ll ansy = 0;
	for (int i = 0; i <= h; ++i) {
		ll minx = inf, maxx = 0;
		for (int j = 0; j < n; ++j) {
			ll curx;
			if (a[j].y <= i) {
				curx = h - (i - a[j].y);
			}
			else {
				curx = a[j].y - i;
			}
			minx = min(curx, minx);
			maxx = max(curx, maxx);
		}
		if (sqy > (maxx - minx + 1) || (sqy == maxx - minx + 1 && ansy > i)) {
			sqy = (maxx - minx + 1);
			ansy = i;
		}
	}
	for (int i = 0; i <= h; ++i) {
		ll minx = inf, maxx = 0;
		ll d = h - i + 1;
		for (int j = 0; j < n; ++j) {
			ll curx;
			if (a[j].y + d > h) {
				curx = a[j].y + d - h;
			}
			else {
				curx = a[j].y + d;
			}
			minx = min(curx, minx);
			maxx = max(curx, maxx);
		}
		if (sqy > (maxx - minx + 1) || (sqy == maxx - minx + 1 && ansy > d)) {
			sqy = (maxx - minx + 1);
			ansy = d;
		}
	}
	cout << sq * sqy << ' ' << ans + ansy << '\n';
}
int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}