#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

struct node {
	ll x, y;
};

void solve() {
	ll h, w; int n;
	cin >> h >> w >> n;
	vector<node> a(n);
	for (auto& e : a) cin >> e.y >> e.x;
	set<ll> x, y;
	for (auto& e : a) {
		x.insert(e.x);
		y.insert(e.y);
	}
	ll left = 0, up = 0;
	for (auto& e : x) {
		auto it = x.upper_bound(e);
		if (it != x.end()) {
			ll dist = (*it) - e - 1;
			if (2 * dist + 2 >= w) {
				left = e;
			}
		}
	}
	for (auto& e : y) {
		auto it = y.upper_bound(e);
		if (it != y.end()) {
			ll dist = (*it) - e - 1;
			if (2 * dist + 2 >= h) {
				up = e;
			}
		}
	}
	ll right = w - left, down = h - up;
	ll miny = inf, minx = inf, maxy = 0, maxx = 0;
	for (auto& e : a) {
		if (right > left) {
			if (e.x <= left) {
				e.x = w - (left - e.x);
			} else {
				e.x -= left;
			}
		}
		else {
			if (e.x + right >= w) {
				e.x = e.x + right - w + 1;
			} else {
				e.x += right;
			}
		}
		if (up < down) {
			if (e.y <= up) {
				e.y = h - (up - e.y);
			} else {
				e.y -= up;
			}
		} else {
			if (e.y + down >= h) {
				e.y = e.y + down - h + 1;
			} else {
				e.y += down;
			}
		}
		miny = min(miny, e.y);
		maxy = max(maxy, e.y);
		minx = min(minx, e.x);
		maxx = max(maxx, e.x);
	}
	cout << (maxx - minx + 1) * (maxy - miny + 1) << ' ' << min(left, right) + min(up, down) << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}