#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

int n;
vector<ll> a;
vector<ll> f, s;
ll ans = 0;

void rec(int i) {
	if (i == n) {
		ll cur = 0;
		bool ok = true;
		for (int i = 0; i < f.size(); ++i) {
			ok = true;
			for (int j = 0; j < i; ++j) {
				if (f[i] <= f[j]) {
					ok = false;
					break;
				}
			}
			if (ok) ++cur;
		}
		for (int i = 0; i < s.size(); ++i) {
			ok = true;
			for (int j = 0; j < i; ++j) {
				if (s[i] >= s[j]) {
					ok = false;
					break;
				}
			}
			if (ok) ++cur;
		}
		if (cur > ans) {
			ans = cur;
		}
		return;
	}
	f.push_back(a[i]);
	rec(i + 1);
	f.pop_back();
	s.push_back(a[i]);
	rec(i + 1);
	s.pop_back();
	rec(i + 1);
}

void solve() {
	cin >> n;
	a.resize(n);
	for (auto& e : a) cin >> e;
	vector<vector<ll>> dp(n + 2, vector<ll>(n + 2, -INF));
	vector<vector<bitset<201>>> used(n + 2, vector<bitset<201>>(n + 2));
	dp[0][n + 1] = 0;
	used[0][n + 1][0] = used[0][n + 1][n + 1] = 1;
	for (int i = 0; i < n; ++i) {
		for (int mx = 0; mx < a[i]; ++mx) {
			for (int mn = 0; mn <= n + 1; ++mn) {
				if (mx == mn) continue;
				if (dp[mx][mn] + 1 > dp[a[i]][mn] && used[mx][mn][a[i]] == 0) {
					used[a[i]][mn] = used[mx][mn];
					used[a[i]][mn][a[i]] = 1;
					dp[a[i]][mn] = dp[mx][mn] + 1;
				}
				// dp[a[i]][mn] = max(dp[a[i]][mn], dp[mx][mn] + 1);
			}
		}
		for (int mx = 0; mx <= n; ++mx) {
			for (int mn = a[i] + 1; mn <= n + 1; ++mn) {
				if (mx == mn) break;
				if (dp[mx][mn] + 1 > dp[mx][a[i]] && used[mx][mn][a[i]] == 0) {
					used[mx][a[i]] = used[mx][mn];
					used[mx][a[i]][a[i]] = 1;
					dp[mx][a[i]] = dp[mx][mn] + 1;
				}
				// dp[mx][a[i]] = max(dp[mx][a[i]], dp[mx][mn] + 1);
			}
		}
	}
	ll ans = 0;
	for (int i = 0; i <= n; ++i) {
		for (int j = 1; j <= n + 1; ++j) {
			ans = max(ans, dp[i][j]);
		}
	}
	cout << ans << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}