#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll INF = 1e18 + 21;
const ll M = 1e9 + 7;
const double PI = acos(-1);

struct node {
	int l = -1, r = -1;
};

int k;
vector<node> g;
vector<int> tin, tout;
int cnt = 0;
vector<int> ans;

void dfs(int v, int curk, int p) {
	tin[v] = cnt++;
	if (g[v].l != -1) {
		dfs(g[v].l, curk + (p == 1), 0);
		dfs(g[v].r, curk + (p == 0), 1);
	} else {
		if (curk <= k) {
			ans[v] = 1;
		}
	}
	tout[v] = cnt++;
}

vector<vector<ll>> t;
vector<pair<ll, ll>> a;

void build(int p, int l, int r) {
	if (l + 1 == r) {
		t[p].push_back(a[l].second);
		return;
	}
	int mid = (l + r) / 2;
	build(2 * p + 1, l, mid);
	build(2 * p + 2, mid, r);
	merge(t[2 * p + 1].begin(), t[2 * p + 1].end(), t[2 * p + 2].begin(), t[2 * p + 2].end(), back_inserter(t[p]));
}

ll get(int p, int l, int r, int beg, int end, ll x) {
	if (beg >= r || l >= end) return 0;
	if (beg <= l && r <= end) return upper_bound(t[p].begin(), t[p].end(), x) - t[p].begin();
	int mid = (l + r) / 2;
	return get(2 * p + 1, l, mid, beg, end, x) + get(2 * p + 2, mid, r, beg, end, x);
}

void solve() {
	int n, q;
	cin >> n >> k >> q;
	g.resize(n);
	tin.resize(n);
	tout.resize(n);
	ans.resize(n);
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		if (k == 2) {
			int l, r;
			cin >> l >> r;
			g[i].l = --l;
			g[i].r = --r;
		}
	}
	dfs(0, 0, -1);
	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			a.push_back({ -tin[i], tout[i] });
		}
	}
	sort(a.begin(), a.end());
	t.resize(4 * a.size());
	build(0, 0, a.size());
	while (q--) {
		int v;
		cin >> v;
		--v;
		int l = -1, r = a.size(), mid;
		while (r - l > 1) {
			mid = (l + r) / 2;
			if (a[mid].first > -tin[v]) r = mid;
			else l = mid;
		}
		cout << get(0, 0, a.size(), 0, r, tout[v]) << '\n';
		//ll res = 0;
		//for (int i = 0; i < n; ++i) {
		//	if (!ans[i]) continue;
		//	if (tin[i] >= tin[v] && tout[i] <= tout[v]) {
		//		res++;
		//	}
		// }
		//cout << res << '\n';
	}
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
}