#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <random>
#include <time.h>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll INF = 1e18 + 21;
const ll M = 1e9 + 7;
const double PI = acos(-1);

struct node {
	ll l, r, i;
};

int n, m;
vector<node> a;
vector<int> cur;
bool ok = false;

void rec(int sz, int i) {
	if (ok) return;
	if (sz == n / 2) {
		int curm = 0;
		pair<ll, ll> lst = { 0, 0 };
		for (auto& e : cur) {
			if (a[e].l > lst.second) {
				++curm;
				lst = { a[e].l, a[e].r };
			}
		}
		if (curm * 2 == m) {
			for (auto& e : cur) cout << a[e].i + 1 << ' ';
			cout << '\n';
			ok = 1;
			return;
		}
	}
	if (i == n) return;
	cur.push_back(i);
	rec(sz + 1, i + 1);
	cur.pop_back();
	rec(sz, i + 1);
}

vector<vector<pair<int, int>>> g;
vector<int> path;

void dfs(int v, int l, int c) {
	if (ok) return;
	if (c * 2 > m) return;
	if (l * 2 > n) return;
	if (l * 2 == n && c * 2 == m) {
		for (auto& e : path) cout << a[e].i + 1 << ' ';
		cout << '\n';
		ok = 1;
		return;
	}
	for (auto& e : g[v]) {
		path.push_back(e.first);
		dfs(e.first, l + 1, c + e.second);
		path.pop_back();
	}
}

mt19937 rnd(time(0));

void solve() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].l >> a[i].r;
		a[i].i = i;
	}
	sort(a.begin(), a.end(), [&](node& f, node& s) {
		if (f.r == s.r) return f.l < s.l;
		return f.r < s.r;
		});
	m = 0;
	pair<ll, ll> lst = { 0, 0 };
	for (int i = 0; i < n; ++i) {
		if (a[i].l > lst.second) {
			++m;
			lst = { a[i].l, a[i].r };
		}
	}
	vector<int> b(n / 2);
	vector<int> q(n);
	for (int it = 1; it <= 1e9; ++it) {
		for (int i = 0; i < n / 2; ++i) {
			while (true) {
				b[i] = rnd() % n;
				if (q[b[i]] != it) break;
			}
			q[b[i]] = it;
		}
		sort(b.begin(), b.end(), [&](int f, int s) {
			if (a[f].r == a[s].r) return a[f].l < a[s].l;
			return a[f].r < a[s].r;
			});
		lst = { 0, 0 };
		int curm = 0;
		for (int i = 0; i < b.size(); ++i) {
			if (a[b[i]].l > lst.second) {
				++curm;
				lst = { a[b[i]].l, a[b[i]].r };
			}
		}
		if (curm * 2 == m) {
			for (auto& e : b) {
				cout << a[e].i + 1 << ' ';
			}
			cout << '\n';
			return;
		}
	}
	cout << "-1\n";
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}