#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;

int ANS = 0;

void check(vector<int>& a, vector<int>& b) {
	int res = 0;
	int maxx = -1;
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] > maxx) {
			++res;
			maxx = a[i];
		}
	}
	int minn = INF;
	for (int i = 0; i < b.size(); ++i) {
		if (b[i] < minn) {
			++res;
			minn = b[i];
		}
	}
	ANS = max(ANS, res);
}

void rec(vector<int>& c, vector<int>& a, vector<int>& b, int i, int n) {
	if (i == n) {
		check(a, b);
		return;
	}
	a.push_back(c[i]);
	rec(c, a, b, i + 1, n);
	a.pop_back();
	b.push_back(c[i]);
	rec(c, a, b, i + 1, n);
	b.pop_back();
}

void solve1(int n) {
	ANS = 0;
	vector<int> c(n);
	for (int i = 0; i < n; ++i) {
		cin >> c[i];
	}
	vector<int> a, b;
	rec(c, a, b, 0, n);
	cout << ANS << "\n";
}

class SegmentTree {
private:
	struct Node {
		int mx;
		int idx;
		Node() {}
	};
	vector<Node> tree;
	int n;
	void upd(int i, int l, int r, int q, int x, int idx) {
		if (q < l || q >= r)
			return;
		if (r - l == 1) {
			if (tree[i].mx < x) {
				tree[i].mx = x;
				tree[i].idx = idx;
			}
			return;
		}
		int m = (l + r) / 2;
		upd(i * 2, l, m, q, x, idx);
		upd(i * 2 + 1, m, r, q, x, idx);
		if (tree[i].mx < tree[i * 2].mx) {
			tree[i].mx = tree[i * 2].mx;
			tree[i].idx = tree[i * 2].idx;
		}
		if (tree[i].mx < tree[i * 2 + 1].mx) {
			tree[i].mx = tree[i * 2 + 1].mx;
			tree[i].idx = tree[i * 2 + 1].idx;
		}
	}

	pair<int, int> get(int i, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql)
			return { -1, -1 };
		if (ql <= l && r <= qr)
			return { tree[i].mx, tree[i].idx };
		int m = (l + r) / 2;
		pair<int, int> f1 = get(i * 2, l, m, ql, qr);
		pair<int, int> f2 = get(i * 2 + 1, m, r, ql, qr);
		if (f1.first > f2.first)
			return f1;
		return f2;
	}

public:
	SegmentTree(int n_) : n(1) {
		while (n < n_)
			n *= 2;
		tree.resize(n * 2);
	}
	void upd(int q, int x, int idx) {
		upd(1, 0, n, q, x, idx);
	}
	pair<int, int> get(int ql, int qr) {
		return get(1, 0, n, ql, qr);
	}
};

pair<int, int> nvp(vector<int>& a, SegmentTree& t, vector<int>& dp, vector<int>& p) {
	int n = a.size();
	int mx = 0, idx = -1;
	for (int i = 0; i < n; ++i) {
		pair<int, int> res = t.get(0, a[i]);
		dp[i] = max(0, res.first) + 1;
		p[i] = res.second;
		t.upd(a[i], dp[i], i);
		if (dp[i] > mx) {
			mx = dp[i];
			idx = i;
		}
	}
	return { mx, idx };
}

int bestmin(vector<int>& a) {
	int mn = INF;
	int res = 0;
	for (int i = 0; i < a.size(); ++i) {
		if (a[i] < mn) {
			++res;
			mn = a[i];
		}
	}
	return res;
}

void solve() {
	int n;
	cin >> n;
	if (n <= 16) {
		solve1(n);
		return;
	}
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	SegmentTree t1(n + 1);
	vector<int> dp(n), p(n, -1);
	auto [x, v] = nvp(a, t1, dp, p);
	for (int i = 0; i < n; ++i) {
		vector<bool> used(n, false);
		int idx = i;
		used[idx] = true;
		while (p[idx] != -1) {
			idx = p[idx];
			used[idx] = true;
		}
		vector<int> b;
		for (int i = 0; i < n; ++i) {
			if (!used[i])
				b.push_back(a[i]);
		}
		int y = bestmin(b);
		cout << dp[i] + y << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}