#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> g;
vector<int> pred;
vector<int> cntk;
vector<int> euler;
vector<pair<int, int>> sf;
int k;

void dfs(int v, int last, int c) {
    cntk[v] = c;
    sf[v].first = (int) euler.size();
    if (g[v].empty()) euler.push_back(v);
    else {
        if (last == 0 || last == -1) {
            dfs(g[v][0], 0, c);
        } else {
            dfs(g[v][0], 0, c + 1);
        }

        if (last == -1 or last == 1) {
            dfs(g[v][1], 1, c);
        } else {
            dfs(g[v][1], 1, c + 1);
        }
    }
    sf[v].second = (int) euler.size();
}

struct SegTree {
    vector<int> tree;

    SegTree(int n) {tree.resize(4 * n, 0);}

    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = (cntk[euler[l]] <= k);
        } else {
            int m = (l + r) / 2;
            build(2 * v + 1, l, m);
            build(2 * v + 2, m, r);
            tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
        }
    }

    int get(int v, int l, int r, int ql, int qr) {
        if (ql <= l and r <= qr) {
            return tree[v];
        }
        if (r <= ql or qr <= l) {
            return 0;
        }
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> k >> q;

    g.resize(n);
    pred.resize(n, -1);
    cntk.resize(n, 0);
    sf.resize(n, {-1, -1});

    int t;
    for (int i = 0; i < n; i++) {
        cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            g[i].push_back(l - 1);
            g[i].push_back(r - 1);
        }
    }

    dfs(0, -1, 0);
//    for (int i = 0; i < n; i++) cout << i << " " << cntk[i] << endl;
//    for (int i : euler) cout << i << " ";
//    cout << endl;
//    for (int i = 0; i < n; i++) cout << i << " " << sf[i].first << " " << sf[i].second << endl;
    SegTree sg(euler.size());
    sg.build(0, 0, euler.size());
    int u;
    while (q--) {
        cin >> u;
        cout << sg.get(0, 0, euler.size(), sf[u - 1].first, sf[u - 1].second) << '\n';
    }
}
