#include <bits/stdc++.h>

using namespace std;

int n;
vector<pair<int, int>> lr;

struct seg {
    int l, r, i;
    seg() = default;
    seg(int l, int r, int i): l(l), r(r), i(i) {}
};

bool operator< (seg a1, seg a2) {
    return a1.l < a2.l or a1.l == a2.l and a1.r > a2.r;
}

struct el {
    int x, t, i;
    el() = default;
    el(int x, int t, int i): x(x), t(t), i(i) {}
};

bool operator< (el a1, el b1) {
    if (a1.x != b1.x) return a1.x < b1.x;
    else {
        if (a1.t != b1.t) assert(0);
        else if (a1.t == 1) {
            if (lr[a1.i].second == lr[b1.i].second) return a1.i > b1.i;
            else return lr[a1.i].second > lr[b1.i].second;
        } else {
            if (lr[a1.i].first == lr[b1.i].first) return a1.i < b1.i;
            else return lr[a1.i].first > lr[b1.i].first;
        }
    }
}

vector<vector<int>> g;
vector<int> pred;
vector<int> sz;
vector<bool> used;

pair<int, int> up(int v) {
    if (v == -1 or g[v].size() > 1) return {0, v};
    else {
        auto [x, y] = up(pred[v]);
        return {x + 1, y};
    }
}

void paint(int v) {
    if (v == -1 or g[v].size() > 1) return;
    used[v] = true;
    paint(pred[v]);
}

vector<int> solve() {
    vector<el> scan(2 * n);
    vector<seg> segs(n);
    for (int i = 0; i < n; i++) {
        segs[i] = {lr[i].first, lr[i].second, i};
        scan[2 * i] = {lr[i].first, 1, i};
        scan[2 * i + 1] = {lr[i].second, -1, i};
    }
    //sort(scan.begin(), scan.end());
    g.clear();
    g.resize(n);
    pred.assign(n, -1);
    sz.assign(n, 0);
    sort(segs.begin(), segs.end());
    stack<seg> st;
    for (auto s : segs) {
        if (!st.empty()) {
            while (!st.empty()) {
                if (st.top().r < s.l) st.pop();
                else break;
            }
            g[st.top().i].push_back(s.i);
            pred[s.i] = st.top().i;
            sz[st.top().i]++;
        }
        st.push(s);
    }
//    stack<int> st;
//    for (auto e : scan) {
//        //cout << e.x << " " << e.t << " " << e.i << endl;
//        if (e.t == -1) {
//            st.pop();
//        } else {
//            if (!st.empty()) {
//                g[st.top()].push_back(e.i);
//                pred[e.i] = st.top();
//                sz[st.top()]++;
//            }
//            st.push(e.i);
//        }
//    }
//        for (int i = 0; i < n; i++) {
//            for (int j : g[i]) cout << j << " ";
//            cout << endl;
//        }
//        cout << endl;
    used.resize(n, false);
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) m++;
    }
    vector<int> closestup(n, -1);
    vector<pair<int, int>> l;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) {
            auto [x, y] = up(i);
            closestup[i] = y;
            l.emplace_back(x, i);
        }
    }
    sort(l.begin(), l.end());
    int c = 0, list = 0;
    for (auto [x, y] : l) {
        if (list == m / 2) break;
        if (closestup[y] == -1 || sz[closestup[y]] > 1) {
            paint(y);
            c += x;
            list += 1;
            if (closestup[y] != -1) sz[closestup[y]]--;
        }
    }
    for (int i = 0; i < n; i++) {
        if (c == n / 2) break;
        if (!g[i].empty()) {
            used[i] = true;
            c++;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) ans.push_back(i + 1);
    }
    return ans;
}

void input() {
    cin >> n;
    lr.resize(n);
    for (auto& i : lr) cin >> i.first >> i.second;
}

vector<int> getvector(int x, int extra) {
    vector<int> nums;
    for (int i = 0; i < n; i++) if (x & (1 << i)) nums.push_back(i + extra);
    return nums;
}

bool isIntersect(int i, int j) {
    return lr[i].first <= lr[j].first && lr[j].first <= lr[i].second or
    lr[i].first <= lr[j].second && lr[j].second <= lr[i].second;
}

int isNonIntersect(int x) {
    vector<int> nums = getvector(x, 0);
    for (int i : nums) {
        for (int j : nums) {
            if (i != j && isIntersect(i, j)) {
                return 0;
            }
        }
    }
    return (int) nums.size();
}

int cnt(int x) {
    int res = 0;
    for (int i = 0; i < n; i++) if (x & (1 << i)) res++;
    return res;
}

vector<int> stupidsolve() {
    int m = 0;
    vector<int> buf((1 << n));
    for (int i = 1; i < (1 << n); i++) {
        buf[i] = isNonIntersect(i);
        m = max(m, buf[i]);
    }
    for (int i = 1; i < (1 << n); i++) {
        if (cnt(i) == n / 2) {
            int mx = 0;
            for (int sub = i; sub > 0; sub = i & (sub - 1)) {
                if (buf[sub] > mx) {
                    mx = buf[sub];
                }
            }
            if (mx == m / 2) {
                return getvector(i, 1);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        input();
        auto ans = solve();
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}
