#include <bits/stdc++.h>

using namespace std;

int n;
vector<pair<int, int>> lr;

struct seg {
    int l, r, i;
    seg() = default;
    seg(int l, int r, int i): l(l), r(r), i(i) {}
};

bool operator< (seg a1, seg a2) {
    return a1.l < a2.l or a1.l == a2.l and a1.r > a2.r or a1.l == a2.l and a1.r == a2.r and a1.i < a2.i;
}

struct el {
    int x, t, i;
    el() = default;
    el(int x, int t, int i): x(x), t(t), i(i) {}
};

bool operator< (el a1, el b1) {
    if (a1.x != b1.x) return a1.x < b1.x;
    else {
        if (a1.t != b1.t) assert(0);
        else if (a1.t == 1) {
            if (lr[a1.i].second == lr[b1.i].second) return a1.i > b1.i;
            else return lr[a1.i].second > lr[b1.i].second;
        } else {
            if (lr[a1.i].first == lr[b1.i].first) return a1.i < b1.i;
            else return lr[a1.i].first > lr[b1.i].first;
        }
    }
}

vector<vector<int>> g;
vector<int> pred;
vector<int> sz;
vector<bool> used;

pair<int, int> up(int v) {
    if (v == -1 or sz[v] > 1) return {0, v};
    else {
        auto [x, y] = up(pred[v]);
        return {x + 1, y};
    }
}

void paint(int v) {
    if (v == -1 or sz[v] > 1) return;
    used[v] = true;
    sz[v]--;
    paint(pred[v]);
}

void resizes() {
    g.clear();
    g.resize(n);
    pred.assign(n, -1);
    sz.assign(n, 0);
    used.resize(n, false);
}

vector<int> solve() {
    vector<el> scan(2 * n);
    vector<seg> segs(n);
    for (int i = 0; i < n; i++) {
        segs[i] = {lr[i].first, lr[i].second, i};
        scan[2 * i] = {lr[i].first, 1, i};
        scan[2 * i + 1] = {lr[i].second, -1, i};
    }
    resizes();

//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            if (i != j) {
//                if (check(i, j) && isIntersect(j)) {
//                    g[i].push_back(j);
//                    pred[j] = i;
//                    sz[i]++;
//                }
//            }
//        }
//    }
    sort(segs.begin(), segs.end());
    deque<seg> st;
    for (auto s : segs) {
        while (!st.empty() && st.back().r < s.l) st.pop_back();
        if (!st.empty()) {
            pred[s.i] = st.back().i;
            sz[st.back().i]++;
            g[st.back().i].push_back(s.i);
        }
        st.push_back(s);
    }

    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) m++;
    }
    int c = 0, list = 0;
    for (int i = 0; i < n; i++) {
        if (list == m / 2) break;
        if (g[i].empty()) {
            auto [x, y] = up(i);
            if (c + x <= n / 2) {
                c += x;
                list++;
                paint(i);
                if (y != -1) sz[y]--;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (c == n / 2) break;
        if (!g[i].empty()) {
            used[i] = true;
            c++;
        }
    }
    if (c != n / 2) assert(0);
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) ans.push_back(i + 1);
    }
    return ans;
}

//mt19937 rnd(179);
//
////void gen() {
////    n = rnd() % 10 + 1;
////    vector<
////}

void input() {
    cin >> n;
    lr.resize(n);
    for (auto& i : lr) cin >> i.first >> i.second;
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        input();
        auto ans = solve();
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}
