#include <bits/stdc++.h>

using namespace std;

#define int long long

struct seg {
    int l, r, i;
    seg() = default;
    seg(int l, int r, int i): l(l), r(r), i(i) {}
};

bool operator< (seg a, seg b) {
    return a.l < b.l or a.l == b.l and a.r < b.r or a.l == b.l and a.r == b.r and a.i < b.i;
}

vector<seg> a;

struct el {
    int x, t, i;
    el() = default;
    el(int x, int t, int i): x(x), t(t), i(i) {}
};

bool operator< (el a1, el b1) {
    if (a1.x != b1.x) return a1.x < b1.x;
    else {
        if (a1.t != b1.t) assert(0);
        else if (a1.t == 1) {
            if (a[a1.i].r == a[b1.i].r) return a1.i > b1.i;
            else return a[a1.i].r > a[b1.i].r;
        } else {
            if (a[a1.i].l == a[b1.i].l) return a1.i < b1.i;
            else return a[a1.i].l > a[b1.i].l;
        }
    }
    //return a1.x < b1.x or a1.x == b1.x and a1.t > b1.t or a1.x == b1.x and a1.t == b1.t and a[a1.i].l > a[b1.i].l;
}

vector<vector<int>> g;
vector<int> pred;
vector<int> sz;
vector<bool> used;

pair<int, int> up(int v) {
    if (v == -1 or g[v].size() > 1) return {0, v};
    else {
        auto [x, y] = up(pred[v]);
        return {x + 1, y};
    }
}

void paint(int v) {
    if (v == -1 or g[v].size() > 1) return;
    used[v] = true;
    paint(pred[v]);
}

int n;
vector<pair<int, int>> lr;

vector<int> solve() {
    a.resize(n);
    vector<el> scan(2 * n);
    int L, R;
    for (int i = 0; i < n; i++) {
        L, R = lr[i].first, lr[i].second;
        a[i] = {L, R, i};
        scan[2 * i] = {L, 1, i};
        scan[2 * i + 1] = {R, -1, i};
    }
    sort(scan.begin(), scan.end());
    g.clear();
    g.resize(n);
    pred.assign(n, -1);
    sz.assign(n, 0);
    stack<int> st;
    for (auto e : scan) {
        //cout << e.x << " " << e.t << " " << e.i << endl;
        if (e.t == -1) {
            st.pop();
        } else {
            if (!st.empty()) {
                g[st.top()].push_back(e.i);
                pred[e.i] = st.top();
                sz[st.top()]++;
            }
            st.push(e.i);
        }
    }
//        for (int i = 0; i < n; i++) {
//            for (int j : g[i]) cout << j << " ";
//            cout << endl;
//        }
//        cout << endl;
    used.resize(n, false);
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) m++;
    }
    vector<int> closestup(n, -1);
    vector<pair<int, int>> l;
    for (int i = 0; i < n; i++) {
        if (g[i].empty()) {
            auto [x, y] = up(i);
            closestup[i] = y;
            l.emplace_back(x, i);
        }
    }
    sort(l.begin(), l.end());
    int c = 0, list = 0;
    for (auto [x, y] : l) {
        if (list == m / 2) break;
        if (closestup[y] == -1 || sz[closestup[y]] > 1) {
            paint(y);
            c += x;
            list += 1;
            if (closestup[y] != -1) sz[closestup[y]]--;
        }
    }
    for (int i = 0; i < n; i++) {
        if (c == n / 2) break;
        if (!g[i].empty()) {
            used[i] = true;
            c++;
        }
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (!used[i]) ans.push_back(i + 1);
    }
    return ans;
}

void input() {
    cin >> n;
    lr.resize(n);
    for (auto& i : lr) cin >> i.first >> i.second;
}

vector<int> getvector(int x, int extra) {
    vector<int> nums;
    for (int i = 0; i < n; i++) if (x & (1 << i)) nums.push_back(i + extra);
    return nums;
}

int isNonIntersect(int x) {
    vector<int> nums = getvector(x, 0);
    for (int i = 0; i < nums.size(); i++) {
        for (int j = i + 1; j < nums.size(); j++) {
            if (lr[i].first <= lr[j].first && lr[j].first <= lr[i].second ||
            lr[i].first <= lr[j].second && lr[j].second <= lr[i].second ||
            lr[j].first <= lr[i].first && lr[i].first <= lr[j].second ||
            lr[j].first <= lr[i].second && lr[i].second <= lr[j].second) {
                return 0;
            }
        }
    }
    return (int) nums.size();
}

int cnt(int x) {
    int res = 0;
    for (int i = 0; i < n; i++) if (x & (1 << i)) res++;
    return res;
}

vector<int> stupidsolve() {
    int m = 0;
    for (int i = 1; i < (1 << n); i++) {
        m = max(m, isNonIntersect(i));
    }
    //cout << m << endl;
    for (int i = 1; i < (1 << n); i++) {
        if (cnt(i) == n / 2) {
            for (int sub = i; sub >= 0; sub = i & (sub - 1)) {
                if (isNonIntersect(sub) == m / 2) {
                    return getvector(i, 1);
                }
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        input();
        auto ans = stupidsolve();
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}
