#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-9;

struct DSU {
    vector<ll> p, sz;

    explicit DSU(ll n) {
        p.assign(n, 0);
        for (ll i = 0; i < n; i++) p[i] = i;
        sz.assign(n, 1);
    }

    ll get(ll v) {
        if (p[v] == v) return v;
        return p[v] = get(p[v]);
    }

    void merge(ll a, ll b) {
        a = get(a), b = get(b);
        if (a == b) return;

        if (sz[a] < sz[b]) swap(a, b);

        sz[a] += sz[b];
        p[b] = a;
    }
};

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll a, t;
    cin >> a >> t;

    if (a == 1) {
        while (t--) {
            ll n, k;
            cin >> n >> k;
            vector<bool> w(n);
            vector<ll> p(k);
            for (ll i = 0; i < k; i++) {
                cin >> p[i];
                p[i]--;
            }
            for (ll i = 0; i < k; i++) w[p[i]] = true;

            if (2 * k == n) {
                for (ll i = 0; i < n; i++)
                    if (!w[i])
                        cout << i + 1 << " ";
                cout << "\n";
                continue;
            }

            vector<bool> bAns(n);

            stack<ll> freePos;
            ll b = n - 1;
            vector<bool> cu(n, true);
            while (!w[b]) {
                freePos.push(b);
                cu[b] = false;
                b--;
            }

            for (ll i = 0; i < n; i++) {
                if (w[i]) {
                    bAns[freePos.top()] = true;
                    freePos.pop();
                } else if (cu[i]) {
                    freePos.push(i);
                    cu[i] = false;
                }
            }

            for (ll i = 0; i < n; i++)
                if (bAns[i])
                    cout << i + 1 << " ";
            cout << "\n";
        }
    } else {
        while (t--) {
            ll n, k;
            cin >> n >> k;
            vector<bool> w(n);
            vector<ll> p(k);
            for (ll i = 0; i < k; i++) {
                cin >> p[i];
                p[i]--;
            }
            for (ll i = 0; i < k; i++) w[p[i]] = true;

            if (2 * k == n) {
                for (ll i = 0; i < n; i++)
                    if (!w[i])
                        cout << i + 1 << " ";
                cout << "\n";
                continue;
            }

            for (ll x = 0; x < n; x++) {
                ll b = 0;
                vector<ll> ans;
                for (ll i = 0; i < n; i++) {
                    if (w[(i+x) % n]) {
                        b++;
                    } else if (b > 0) {
                        ans.push_back((i + x) % n + 1);
                        b--;
                    }
                }

                if (b == 0) {
                    sort(ans.begin(), ans.end());
                    for (ll q : ans) cout << q << " ";
                    cout << "\n";
                    break;
                }
            }
        }
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}