#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<ll>> g;

vector<ll> ans, nxt, e;
vector<pair<ll, ll>> seg;

ll INF = 1e18;

void dfs(ll v, ll mx) {
    ans[v] = 1;
    e[v] = seg[v].second;
    if (mx == 1) return;
    for (ll to : g[v]) {
        if (ans[to] == -1) {
            dfs(to, mx - 1);
        }
        if (ans[to] + 1 > ans[v] || ans[to] + 1 == ans[v] && e[to] > e[v]) {
            ans[v] = ans[to] + 1;
            nxt[v] = to;
            e[v] = e[to];
        }
    }
}


int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll t;
    cin >> t;

    while (t--) {
        ll n;
        cin >> n;

        g.assign(n, {});
        e.assign(n, -INF);

        seg.assign(n, {});
        for (ll i = 0; i < n; i++) cin >> seg[i].first >> seg[i].second;

        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {

                if (seg[i].second < seg[j].first) {
                    g[i].push_back(j);
                }
            }
        }

        ans.assign(n, -1);
        nxt.assign(n, -1);
        for (ll i = 0; i < n; i++) {
            if (ans[i] == -1) {
                dfs(i, INF);
            }
        }

        ll ind = max_element(ans.begin(), ans.end()) - ans.begin();
        ll m = ans[ind] / 2;

        bool ok = false;
        for (ll i = 0; i < n; i++) {
            ans.assign(n, -1);
            nxt.assign(n, -1);
            e.assign(n, -INF);
            dfs(i, m);
            if (ans[i] != m) continue;
            vector<bool> used(n, false);

            ll l = seg[i].first, r = e[i];
            ll v = i;
            for (ll j = 0; j < m; j++) {
                used[v] = true;
                v = nxt[v];
            }

            vector<ll> check;
            for (ll j = 0; j < n; j++) {
                if (l <= seg[j].first && seg[j].second <= r && !used[j])
                    check.push_back(j);
            }

            if (m + check.size() < n / 2) continue;
            v = i;
            vector<ll> out;
            for (ll j = 0; j < m; j++) {
                out.push_back(v + 1);
                v = nxt[v];
            }
            for (ll j : check)
                if (out.size() < n / 2) out.push_back(j + 1);

            if (out.size() != n / 2) continue;
            for (ll w : out) cout << w << " ";
            cout << "\n";
            ok = true;
            break;
        }

        assert(ok);
    }

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}