#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef int ll;
vector<vector<ll>> t1, t2;
vector<vector<bool>> st1, st2;
void push1(ll i, ll v, ll l, ll r) {
	if (st1[i][v] == 0) return;
	if (r - l > 1) t1[i][2 * v + 1] = t1[i][2 * v + 2] = t1[i][v], st1[i][2 * v + 1] = st1[i][2 * v + 2] = 1;
	st1[i][v] = 0;
}
ll Max1(ll i, ll v, ll l, ll r, ll a, ll b) {
	push1(i, v, l, r);
	if (l >= b || r <= a) return -1e9;
	if (l >= a && r <= b) return t1[i][v];
	ll m = (l + r) / 2;
	return max(Max1(i, 2 * v + 1, l, m, a, b), Max1(i, 2 * v + 2, m, r, a, b));
}
ll Set1(ll i, ll v, ll l, ll r, ll a, ll b, ll x) {
	push1(i, v, l, r);
	if (l >= b || r <= a) return t1[i][v];
	if (l >= a && r <= b) {
		st1[i][v] = 1;
		t1[i][v] = x;
		push1(i, v, l, r);
		return t1[i][v];
	}
	ll m = (l + r) / 2;
	return t1[i][v] = max(Set1(i, 2 * v + 1, l, m, a, b, x), Set1(i, 2 * v + 2, m, r, a, b, x));
}
void push2(ll i, ll v, ll l, ll r) {
	if (st2[i][v] == 0) return;
	if (r - l > 1) t2[i][2 * v + 1] = t2[i][2 * v + 2] = t2[i][v], st2[i][2 * v + 1] = st2[i][2 * v + 2] = 1;
	st2[i][v] = 0;
}
ll Max2(ll i, ll v, ll l, ll r, ll a, ll b) {
	push2(i, v, l, r);
	if (l >= b || r <= a) return -1e9;
	if (l >= a && r <= b) return t2[i][v];
	ll m = (l + r) / 2;
	return max(Max2(i, 2 * v + 1, l, m, a, b), Max2(i, 2 * v + 2, m, r, a, b));
}
ll Set2(ll i, ll v, ll l, ll r, ll a, ll b, ll x) {
	push2(i, v, l, r);
	if (l >= b || r <= a) return t2[i][v];
	if (l >= a && r <= b) {
		st2[i][v] = 1;
		t2[i][v] = x;
		push2(i, v, l, r);
		return t2[i][v];
	}
	ll m = (l + r) / 2;
	return t2[i][v] = max(Set2(i, 2 * v + 1, l, m, a, b, x), Set2(i, 2 * v + 2, m, r, a, b, x));
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll q;
	cin >> q;
	while (q--) {
		ll n;
		cin >> n;
		vector<ll> a(n);
		for (ll i = 0; i < n; ++i) cin >> a[i];
		if (n > 200) {
			ll ans = 0, mn = 1e9, mx = -1e9;
			for (ll i = 0; i < n; ++i) {
				if (a[i] > mx) mx = a[i], ++ans;
				else if (a[i] < mn) mn = a[i], ++ans;
			}
		}
		else {
			vector<vector<ll>> dp(n + 1, vector<ll>(n + 2, -1e9));
			t1.assign(n + 2, vector<ll>(4 * n + 4, -1e9));
			t2.assign(n + 1, vector<ll>(4 * n + 8, -1e9));
			st1.assign(n + 2, vector<bool>(4 * n + 4, false));
			st2.assign(n + 1, vector<bool>(4 * n + 8, false));
			dp[0][n + 1] = 0;
			Set1(n + 1, 0, 0, n + 1, 0, 1, 0);
			Set2(0, 0, 0, n + 2, n + 1, n + 2, 0);
			for (ll i = 0; i < n; ++i) {
				for (ll k = 1; k < n + 2; ++k) {
					dp[a[i]][k] = Max1(k, 0, 0, n + 1, 0, a[i]) + 1;
				}
				for (ll j = 0; j < n + 1; ++j) {
					dp[j][a[i]] = Max2(j, 0, 0, n + 2, a[i] + 1, n + 2) + 1;
				}
				for (ll k = 1; k < n + 2; ++k) {
					Set1(k, 0, 0, n + 1, a[i], a[i] + 1, dp[a[i]][k]);
					Set2(a[i], 0, 0, n + 2, k, k + 1, dp[a[i]][k]);
				}
				for (ll j = 0; j < n + 1; ++j) {
					Set1(a[i], 0, 0, n + 1, j, j + 1, dp[j][a[i]]);
					Set2(j, 0, 0, n + 2, a[i], a[i] + 1, dp[j][a[i]]);
				}
				for (ll k = a[i] + 1; k < n + 2; ++k) {
					Set1(k, 0, 0, n + 1, 0, a[i], -1e9);
				}
				for (ll j = 0; j < a[i]; ++j) {
					Set2(j, 0, 0, n + 2, a[i] + 1, n + 2, -1e9);
				}
			}
			ll ans = 0;
			for (ll i = 1; i < n + 1; ++i) {
				for (ll j = 1; j < n + 1; ++j) ans = max(ans, dp[i][j]);
			}
			cout << ans << "\n";
		}
	}
	cout << endl;
	return 0;
}