#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

pair<int, vector<int>> solve(vector<pair<pair<int, int>, int>> seg) {
    int n = seg.size();
    vector<int> dp(n + 1);
    dp[0] = 0;

    vector<pair<int, int>> p(n + 1);

    for (int i = 0; i < n; i++) {
        auto it = lower_bound(seg.begin(), seg.end(), seg[i].first.first, [](pair<pair<int, int>, int> a, int b) {
            return a.first.second < b;
        }) - seg.begin();

        if (dp[it] + 1 > dp[i]) {
            p[i + 1] = {1, it};
        } else {
            p[i + 1] = {0, i};
        }

        dp[i + 1] = max(dp[i], dp[it] + 1);
    }

    vector<int> ans;
    int i = n;
    while (i != 0) {
        if (p[i].first == 0) {
            i = i - 1;
        } else {
            ans.push_back(seg[i - 1].second);
            i = p[i].second;
        }
    }
    
    if (dp[n] != ans.size()) exit(1);

    return {dp[n], ans};
}

void solve() {
    int n;
    cin >> n;

    vector<pair<pair<int, int>, int>> seg(n);
    int ind = 0;
    for (auto &i : seg) {
        cin >> i.first.first >> i.first.second;
        i.second = ind++;
    }

    sort(seg.begin(), seg.end(), [](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
        return a.first.second < b.first.second;
    });

    int need = solve(seg).first;
    if (need % 2 == 1) exit(1);

    int L = 0, R = 1e9 + 7;
    while (R - L > 1) {
        int m = (R + L) / 2;

        vector<pair<pair<int, int>, int>> seg1, seg2;
        for (auto i : seg) {
            if (i.first.second < m) {
                seg1.push_back(i);
            }

            if (i.first.first >= m) {
                seg2.push_back(i);
            }
        }

        int k1 = solve(seg1).first;
        if (k1 < need / 2) {
            L = m;
        } else {
            R = m;
        }
    }

    int m = L;
    vector<pair<pair<int, int>, int>> seg1, seg2;
    for (auto i : seg) {
        if (i.first.second < m) {
            seg1.push_back(i);
            continue;
        }

        if (i.first.first >= m) {
            seg2.push_back(i);
            continue;
        }

        seg1.push_back(i);
    }
    
    vector<int> wtf(n);
    pair<int, vector<int>> pr;
    if (seg1.size() >= n / 2 - (pr.first < need / 2)) {
        pr = solve(seg1);

        if (pr.first < need / 2) {
            auto it = max_element(seg2.begin(), seg2.end(), [](pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
                return a.first.first < b.first.first;
            });

            seg1.push_back(*it);
        }

        pr = solve(seg1);
        if (pr.first != need / 2) exit(1);
        
        for (auto i : seg1) {
            wtf[i.second] = 1;
        }

        for (auto i : pr.second) {
            wtf[i] = 2;
        }
    } else {
        seg1 = seg2;

        pr = solve(seg1);
        if (pr.first != need / 2) exit(1);

        vector<bool> wtf(n);
        for (auto i : seg1) {
            wtf[i.second] = 1;
        }

        for (auto i : pr.second) {
            wtf[i] = 2;
        }
    }

    int must = n / 2 - need / 2;
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        if (wtf[i] == 1 && must) {
            must--;
            ans.push_back(i + 1);
        }
    }

    for (auto i : pr.second) {
        ans.push_back(i + 1);
    }

    for (auto i : ans) {
        cout << i << ' ';
    }

    cout << endl;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}