#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <tuple>
#include <vector>

using namespace std;

struct Seg {
    long long first;
    long long second;
    long long i;
    long long tm;
    Seg() {
        first = 0;
        second = 0;
        i = 0;
    }

    bool operator<(const Seg& other) const {
        return tie(first, second, tm) < tie(other.first, other.second, other.tm);
    }
};

vector<vector<long long>> gr;
vector<long long> szs;
vector<long long> h;
vector<long long> nearestupper;

void dfs0(long long v, long long p) {
    if (p != -1) {
        if (gr[p].size() > 1) {
            nearestupper[v] = p;
        } else {
            nearestupper[v] = nearestupper[p];
        }
    }
    for (long long to : gr[v]) {
        if (to != p) {
            h[to] = h[v] + 1;
            dfs0(to, v);
        }
    }
}

void dfs(long long v, long long p) {
    if (gr[v].size() >= 1) {
        szs[v] = 1;
    }
    for (long long to : gr[v]) {
        if (to != p) {
            dfs(to, v);
            szs[v] += szs[to];
        }
    }
    if (gr[v].size() >= 1 && szs[v] == 1) {
        szs[v] = 0;
    }
}

long long getdst(long long v, const vector<long long>& pr) {
    long long res = 0;
    while (v != -1 && gr[v].size() <= 1) {
        res++;
        v = pr[v];
    }
    return res;
}

void solve() {
    long long n;
    cin >> n;

    vector<Seg> a(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].i = i;
    }

    // sort(a.begin(), a.end(), [](const Seg& x, const Seg& y) {
    //     if (x.first != y.first) {
    //         return x.first < y.first;
    //     }
    //     return x.second > y.second;
    // });

    gr.assign(n, vector<long long>(0));

    vector<pair<long long, pair<long long, long long>>> evs(2 * n);
    for (long long i = 0; i < n; i++) {
        evs[2 * i].first = a[i].first;
        evs[2 * i].second = {i, 1};
        evs[2 * i + 1].first = a[i].second;
        evs[2 * i + 1].second = {i, -1};
    }

    sort(evs.begin(), evs.end(), [&a](const pair<long long, pair<long long, long long>>& ev1, const pair<long long, pair<long long, long long>>& ev2) {
        if (ev1.first != ev2.first) {
            return ev1.first < ev2.first;
        }
        if (ev1.second.second == ev2.second.second && ev1.second.second == 1) {
            return make_pair(a[ev1.second.first].second, ev1.second.first) > make_pair(a[ev2.second.first].second, ev2.second.first);
        }
        return ev1.second.second < ev2.second.second;
    });

    set<Seg> sgs;
    vector<long long> pr(n);

    long long ctime = 0;

    for (auto el : evs) {
        long long cind = el.second.first;
        long long ctype = el.second.second;
        if (ctype == 1) {
            long long cp = -1;
            if (!sgs.empty()) {
                cp = (--sgs.end())->i;
            }
            if (cp != -1) {
                gr[cp].emplace_back(cind);
                pr[cind] = cp;
            } else {
                pr[cind] = -1;
            }
            a[cind].tm = ctime++;
            sgs.insert(a[cind]);
        } else {
            sgs.erase(a[cind]);
        }
    }

    long long m = 0;
    vector<long long> leaves;
    for (long long i = 0; i < n; i++) {
        if (gr[i].size() == 0) {
            m++;
            leaves.emplace_back(i);
        }
    }

    vector<bool> alive(n, true);
    long long cm = m;
    long long cn = n;
    for (long long ep = 0; ep < m / 2; ep++) {
        long long bestl = leaves[0];
        long long bestdst = 1000000000;
        for (long long i = 0; i < m; i++) {
            if (alive[leaves[i]]) {
                long long cdst = getdst(leaves[i], pr);
                if (!alive[bestl] || cdst < bestdst) {
                    bestdst = cdst;
                    bestl = leaves[i];
                }
            }
        }
        cm--;
        long long cpr;
        while (bestl != -1 && gr[bestl].size() == 0) {
            alive[bestl] = false;
            cn--;
            cpr = bestl;
            bestl = pr[bestl];
            if (bestl != -1) {
                gr[bestl].erase(find(gr[bestl].begin(), gr[bestl].end(), cpr));
            }
        }
    }
    for (long long i = 0; i < n; i++) {
        if (cn > n / 2 && gr[i].size() > 0 && alive[i]) {
            alive[i] = false;
            cn--;
        }
    }

    for (long long i = 0; i < n; i++) {
        if (alive[i]) {
            cout << a[i].i + 1 << " ";
        }
    }
    cout << "\n";
}

int main() {
    long long t;
    cin >> t;
    for (long long i = 0; i < t; i++) {
        solve();
    }
    return 0;
}