#include <algorithm>
#include <cassert>
#include <iostream>
#include <set>
#include <vector>

using namespace std;

struct Seg {
    int first;
    int second;
    int i;
    Seg() {
        first = 0;
        second = 0;
        i = 0;
    }

    bool operator<(const Seg& other) const {
        return make_pair(first, second) < make_pair(other.first, other.second);
    }
};

vector<vector<int>> gr;
vector<int> szs;

void dfs(int v, int p) {
    if (gr[v].size() >= 1) {
        szs[v] = 1;
    }
    for (int to : gr[v]) {
        if (to != p) {
            dfs(to, v);
            szs[v] += szs[to];
        }
    }
    if (gr[v].size() >= 1 && szs[v] == 1) {
        szs[v] = 0;
    }
}

void solve() {
    int n;
    cin >> n;

    vector<Seg> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].i = i;
    }

    sort(a.begin(), a.end(), [](const Seg& x, const Seg& y) {
        if (x.first != y.first) {
            return x.first < y.first;
        }
        return x.second > y.second;
    });

    gr.assign(n, vector<int>(0));

    vector<pair<int, pair<int, int>>> evs(2 * n);
    for (int i = 0; i < n; i++) {
        evs[2 * i].first = a[i].first;
        evs[2 * i].second = {i, 1};
        evs[2 * i + 1].first = a[i].second;
        evs[2 * i + 1].second = {i, -1};
    }

    sort(evs.begin(), evs.end(), [](const pair<int, pair<int, int>>& ev1, const pair<int, pair<int, int>>& ev2) {
        if (ev1.first != ev2.first) {
            return ev1.first < ev2.first;
        }
        return ev1.second.second < ev2.second.second;
    });

    set<Seg> sgs;
    vector<int> pr(n);

    for (auto el : evs) {
        int cind = el.second.first;
        int ctype = el.second.second;
        if (ctype == 1) {
            int cp = -1;
            if (!sgs.empty()) {
                cp = (--sgs.end())->i;
            }
            if (cp != -1) {
                gr[cp].emplace_back(cind);
                pr[cind] = cp;
            } else {
                pr[cind] = -1;
            }
            sgs.emplace(a[cind]);
        } else {
            sgs.erase(a[cind]);
        }
    }

    int m = 0;
    vector<int> leaves;
    for (int i = 0; i < n; i++) {
        if (gr[i].size() == 0) {
            m++;
            leaves.emplace_back(i);
        }
    }

    szs.assign(n, 0);
    for (int i = 0; i < m / 2; i++) {
        szs[leaves[i]] = 1;
    }

    dfs(0, -1);

    int cntalive = 0;
    for (int i = 0; i < n; i++) {
        if (szs[i] > 0) {
            cntalive++;
        }
    }

    assert(cntalive >= n / 2);
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}