#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <queue>
#include <cassert>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;

vector<pair<ll, ll>> mrg(vector<pair<ll, ll>> a, vector<pair<ll, ll>> b) {
	vector<pair<ll, ll>> res(a.size() + b.size());
	merge(all(a), all(b), res.begin());
	int h = 0;
	int n = res.size();
	vector<pair<ll, ll>> ans;
	for (int i = n - 1; i >= 0; i--)
	{
		if (-res[i].second < h || (i != 0 && res[i] == res[i-1]))continue;
		h = -res[i].second;
		ans.push_back(res[i]);
	}
	reverse(all(ans));
	return ans;
}

vector<pair<ll, ll>> upd(vector<pair<ll, ll>> ap, int wei) {
	vector<pair<ll, ll>> a = ap;
	vector<pair<ll, ll>> b = ap;
	vector<bool> were(a.size());
	for (int i = 0; i < b.size(); i++)
		if (b[i].first + 1 >= wei)b[i].first += wei, were[i] = true;
	bool br = false;
	for (int i = 0; i < a.size(); i++)
		if (-a[i].second + 1 >= wei) {
			if (were[i])br = true;
			a[i].second -= wei;
		};
	if (br) {
		a = ap;
		b = ap;
		for (auto& i : a)i.second -= wei;
		for (auto& i : b)i.first += wei;
	}
	return mrg(a, b);
}

void outp(vector<pair<ll, ll>> arr) {
	return;
	int last = -1;
	for (auto& i : arr) {
		while (last < i.first) {
			for (int j = 0; j <= -i.second; j++)
				cerr << '#';
			cerr << '\n';
			last++;
		}
	}
	cerr << '\n';
	cerr << '\n';

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, q = 100;
	cin >> n >> q;
	vector<ll> wei(n);
	for (auto& i : wei)cin >> i;
	sort(all(wei));
	vector<pair<ll, ll>> arr(1, { 0,0 });
	for (auto& i : wei) {
		outp(arr);
		arr = upd(arr, i);
	}
	outp(arr);
	
	int z; cin >> z;
	while (q--)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		auto ps = lower_bound(all(arr), make_pair(a,(ll)-2e18));
		cout << ((ps != arr.end() && -(*ps).second >= b) ? "Yes" : "No") << '\n';
	}
}