#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <numeric>
#include <cassert>
#include <bitset>

using namespace std;
using ll = long long;

constexpr int C = 5003;
bitset<C> dp[C];
constexpr int INF = 0x3f3f3f3f;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    dp[0][0] = true;
    cin.tie(0)->sync_with_stdio(0);
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (ll &now : w) cin >> now;
//    std::sort(w.begin(), w.end());
    int z;
    cin >> z;
    for (int i = 0; i < n; ++i) {
        for (int f = C - 1; f >= 0; --f) {
            if (f + w[i] < C) dp[f + w[i]] = dp[f + w[i]] | dp[f];
            dp[f] = dp[f] | (dp[f] << w[i]);
        }
    }
    while (q --> 0) {
        int k, a, b;
        cin >> k >> a >> b;
        bool ok = true;
        for (int i = 0; i <= a && ok; ++i) {
            for (int j = 0; j <= b; ++j) {
                if (!dp[i][j]) {
                    ok = false;
                    break;
                }
            }
        }
        if (ok) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    return 0;
}