//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcmt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef int ll;

const ll INF = 1'000'000'000;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

struct segment_tree {
	vector<ll> tree;
	ll size, dp, ds;
	segment_tree(ll n = 0) {
		size = 1;
		while (size < n) {
			size *= 2;
		}
		dp = 0;
		ds = n;
		tree.resize(size * 2, -INF);
	}
	void set(ll x, ll y) {
		if (x < dp) {
			return;
		}
		x += size;
		while (x > 0) {
			assign_max(tree[x], y);
			x >>= 1;
		}
	}
	ll get(ll l, ll r) {
		assign_max(l, dp);
		assign_min(r, ds);
		if (l > r) {
			return -INF;
		}
		l += size;
		r += size;
		ll ans = max(tree[l], tree[r]);
		while ((r >> 1) != (l >> 1)) {
			if (!(l & 1)) {
				assign_max(ans, tree[l ^ 1]);
			}
			if (r & 1) {
				assign_max(ans, tree[r ^ 1]);
			}
			l >>= 1;
			r >>= 1;
		}
		return ans;
	}
	void die_pref(ll x) {
		assign_max(dp, x);
	}
	void die_suff(ll x) {
		assign_min(ds, x);
	}
};

ll solve(ll n, vector<ll> arr) {
	segment_tree st(n + 1);
	st.set(0, 0);
	for (auto i : arr) {
		st.set(i, st.get(0, i));
	}
	return min(n, st.get(0, n) + 1);
	vector<segment_tree> row(n + 2, segment_tree(n + 2)), col(n + 2, segment_tree(n + 2));
	row[0].set(n + 1, 0);
	col[n + 1].set(0, 0);
	set<ll> have;
	have.insert(0);
	have.insert(n + 1);
	for (auto i : arr) {
		for (auto j : have) {
			ll x = row[j].get(i + 1, n + 1) + 1, y = col[j].get(0, i) + 1;
			row[i].set(j, y);
			row[j].set(i, x);
			col[i].set(j, x);
			col[j].set(i, y);
			if (j < i) {
				row[j].die_suff(i + 1);
			}
			if (j > i) {
				col[j].die_pref(i);
			}
		}
		have.insert(i);
	}
	ll ans = 0;
	for (ll i = 0; i <= n + 1; i++) {
		assign_max(ans, row[i].get(0, n + 1));
		assign_max(ans, col[i].get(0, n + 1));
	}
	return ans;
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vector<ll> arr(n);
		for (ll i = 0; i < n; i++) {
			cin >> arr[i];
		}
		cout << solve(n, arr) << '\n';
	}
}
