#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;


struct DebugPrint : ostream {} cnul;
template <class T>
DebugPrint& operator<<(DebugPrint& dst, const T& src) {return dst;}
#ifdef LOCAL_JUDGE
#define cdbg cout
#define dprint(x) cdbg << #x << ": " << x << endl;
#else
#define cdbg cnul
#define dprint(x)
#endif


struct Event {
  size_t x, t, seg;
  Event(size_t _x, size_t _t, size_t _seg) : x(_x), t(_t), seg(_seg) {}
};
bool operator<(const Event& a, const Event& b) {
  return tie(a.x, a.t, a.seg) < tie(b.x, b.t, b.seg);
}

size_t _prev = -1;
vector<ps> segments;
vector<Event> events;
vector<size_t> segments_before, prev_segment, useful_segs;
size_t ind_segs(size_t mask) {
  size_t max_visited_segs = 0;
  for (auto& e : events) {
    if (e.seg < 32 && ((mask >> e.seg) & 1)) continue;
    if (e.t == 0) {
      prev_segment[e.seg] = _prev;
      segments_before[e.seg] = max_visited_segs + 1;
    } else {
      if (segments_before[e.seg] > max_visited_segs) _prev = e.seg;
      max_visited_segs = max(max_visited_segs, segments_before[e.seg]);
    }
  }
  return max_visited_segs;
}
bool intersect(ps& a, ps& b) {
  return max(a.first, b.first) <= min(a.second, b.second);
}

mt19937 rnd(0x20230405);
void shuffle(vector<bool>& dst, size_t n) {
  for (size_t i = 1; i < n; i++) {
    size_t j = rnd() % (i + 1);
    if (i != j) swap(dst[i], dst[j]);
  }
}


size_t t, n, mask, i, l, r;
int main() {
  #ifdef LOCAL_JUDGE
  freopen("/home/roi/work/0405B/big.in", "r", stdin);
  #endif

  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> t; while (t--) {
    cin >> n;
    events.clear(); segments_before.resize(n);
    for (i = 0; i < n; i++) {
      cin >> l >> r;
      events.emplace_back(l, 0, i);
      events.emplace_back(r, 1, i);
      segments.emplace_back(l, r);
    }
    sort(events.begin(), events.end());
    prev_segment.resize(n);

    if (n >= 10) {
      size_t m = ind_segs(0);

      while (_prev + 1) {
        useful_segs.push_back(_prev);
        _prev = prev_segment[_prev];
      }

      dprint(m);
      dprint(useful_segs.size());

      vector<bool> active(m / 2, true);
      active.resize(m, false);
      vector<bool> ok(n, false);

      while (true) {
        size_t cn = 0;
        for (size_t i = 0; i < n; i++) {
          ok[i] = false;
          for (size_t j = 0; j < m; j++) {
            if (!active[j]) continue;
            if (intersect(segments[i], segments[useful_segs[j]])) {
              ok[i] = true;
              cn++; break;
            }
          }
        }
        if (cn * 2 == n) {
          for (i = 0; i < n; i++) {
            if (ok[i]) cout << i + 1 << " ";
          }
          cout << "\n";
          break;
        }
        shuffle(active, m);
      }

      continue;
    }

    size_t m = ind_segs(0);

    for (mask = (1ull << (n / 2)) - 1; mask < (1ull << n); mask++) {
      if (__builtin_popcountll(mask) > n / 2) continue;
      if (__builtin_popcountll(mask) < n / 2) {
        mask |= (1ull << (n / 2 - __builtin_popcountll(mask))) - 1;
        if (__builtin_popcountll(mask) < n / 2) continue;
      }
      cdbg << "mask " << mask << " -> " << ind_segs(mask) << endl;
      if (ind_segs(mask) == m / 2) {
        for (i = 0; i < n; i++) {
          if ((mask >> i) & 1) continue;
          cout << i + 1 << " ";
        }
        cout << "\n";
        break;
      }
    }

    dprint(m);
  }

  return 0;
}
