#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;


void mxz(size_t& a, const size_t& b) {
  a = max(a, b);
}
void mxz(ps& a, const ps& b) {
  mxz(a.first,  b.first);
  mxz(a.second, b.second);
}
void add(ps& a, const ps& b) {
  a.first += b.first; a.second += b.second;
}


vector<size_t> plan;
vector<vector<size_t>> edges;
vector<ps> answer_no, answer_maybe, own_range;
void calc_answer(size_t u, size_t parent) {
  answer_no[u] = make_pair(0, 0);
  answer_maybe[u] = own_range[u];

  for (auto& v : edges[u]) {
    if (v == parent) continue;

    calc_answer(v, u);
    add(answer_no[u], answer_maybe[v]);
    add(answer_maybe[u], answer_no[v]);
  }

  mxz(answer_maybe[u], answer_no[u]);
}
void achieve_plan(size_t u, size_t eff, size_t parent) {
  if (answer_no[u].first <= eff && eff <= answer_no[u].second) {
    // this node is not taken
    plan[u] = own_range[u].first;
    eff -= answer_no[u].first;
    for (auto& v : edges[u]) {
      if (v == parent) continue;

      size_t v_eff = min(eff + answer_maybe[v].first, answer_maybe[v].second);
      achieve_plan(v, v_eff, u);
      eff -= v_eff - answer_maybe[v].first;
    }
  } else {
    eff -= answer_maybe[u].first;
    for (auto& v : edges[u]) {
      if (v == parent) continue;

      size_t v_eff = min(eff + answer_maybe[v].first, answer_maybe[v].second);
      achieve_plan(v, v_eff, u);
      eff -= v_eff - answer_maybe[v].first;
    }

  }
}


size_t t, n, q, u, v, cert_x, cert_y, cert_m, i;
int main() {
  #ifdef LOCAL_JUDGE
  freopen("/home/roi/work/0405D/test.in", "r", stdin);
  #endif

  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> t; while (t--) {
    cin >> n >> q >> cert_x >> cert_y >> cert_m;
    edges.resize(n);
    for (i = 1; i < n; i++) {
      cin >> u >> v; --u; --v;
      edges[u].push_back(v);
      edges[v].push_back(u);
    }
    answer_no.resize(n); answer_maybe.resize(n);
    own_range.resize(n); for (auto& [a, b] : own_range) cin >> a >> b;

    calc_answer(0, -1ull);

    while (q--) {
      cin >> u;
      if (answer_maybe[0].first <= u && u <= answer_maybe[0].second)
        cout << "1 ";
      else
        cout << "-1 ";
    }
    cout << endl;
    cin >> u;
    if (u) return 1;
  }

  return 0;
}
