#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

pair<long long, long long> calc(long long m, vector<long long> y)
{
	sort(y.begin(), y.end());
	y.erase(unique(y.begin(), y.end()), y.end());
	long long mny = y[0], mxy = y.back();
	long long ay = mxy - mny + 1;
	long long mvy = 0;
	for (long long i = 1; i < y.size(); i++)
	{
		mny = 0;
		mxy = m - (y[i] - y[i - 1]);
		long long mv = y[i];
		if (m - y[i] < y[i])
		{
			mv = m - y[i];
		}

		if (mxy - mny + 1 < ay || (mxy - mny + 1 == ay && mv < mvy))
		{
			ay = mxy - mny + 1;
			mvy = mv;
		}
	}
	return { ay, mvy };
}

void solve()
{
	long long n, m, k;
	vector<pair<long long, long long>> v;
	cin >> n >> m >> k;
	v.resize(k);
	for (long long i = 0; i < k; i++)
	{
		cin >> v[i].first >> v[i].second;
		v[i].first--;
		v[i].second--;
	}

	vector<long long> x, y;
	for (long long i = 0; i < k; i++)
	{
		x.push_back(v[i].first);
		y.push_back(v[i].second);
	}

	auto [ay, mvy] = calc(m, y);
	auto [ax, mvx] = calc(n, x);
	cout << ay * ax << " " << mvy + mvx << "\n";
}

pair<long long, long long> solve2(long long n, long long m, long long k, vector<pair<long long, long long>> v)
{
	for (long long i = 0; i < k; i++)
	{
		v[i].first--;
		v[i].second--;
	}

	long long ans = INF, nd = INF;
	for (long long dx = -n; dx <= n; dx++)
	{
		for (long long dy = -m; dy <= m; dy++)
		{
			if (dy == 1 && dx == -1)
			{
				dy += 0;
			}
			vector<pair<long long, long long>> nv = v;
			long long mxy = -INF, mny = INF, mxx = -INF, mnx = INF;
			for (long long i = 0; i < k; i++)
			{
				nv[i].first += dx;
				nv[i].second += dy;
				nv[i].first %= n;
				nv[i].second %= m;
				if (nv[i].first < 0)
				{
					nv[i].first += n;
				}
				if (nv[i].second < 0)
				{
					nv[i].second += m;
				}
				mxx = max(mxx, nv[i].first);
				mnx = min(mnx, nv[i].first);
				mxy = max(mxy, nv[i].second);
				mny = min(mny, nv[i].second);
			}

			long long xx = abs(dx) + abs(dy);
			long long ss = (mxx - mnx + 1) * (mxy - mny + 1);
			if (ss < ans || (ss == ans && xx < nd))
			{
				ans = ss;
				nd = xx;
			}
		}
	}
	return { ans, nd };
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long n, m, k;
	vector<pair<long long, long long>> v;
	cin >> n >> m >> k;
	v.resize(k);
	for (long long i = 0; i < k; i++)
	{
		cin >> v[i].first >> v[i].second;
	}

	auto [a1, a2] = solve2(n, m, k, v);
	cout << a1 << " " << a2 << "\n";
	return 0;

	solve();

	return 0;
}

/*





















*/
