#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

struct query
{
	long long k, a, b, idx;
};

const long long INF = 1e18, MOD = 1e9 + 7;

bool k18 = true, b0 = true, a5 = true;

long long n, q;
vector<long long> v;
vector<query> qr;

bool subn10()
{
	if (n > 10 || q > 10)
	{
		return false;
	}

	for (auto& [k, a, b, idx] : qr)
	{
		long long bd = 0;
		while (bd < n && v[bd] <= k)
		{
			bd++;
		}

		vector<pair<long long, long long>> can;
		for (long long mask = 0; mask < (long long)(pow(3, bd)); mask++)
		{
			pair<long long, long long> sum = { 0, 0 };
			long long nm = mask;
			for (long long i = 0; i < bd; i++)
			{
				if (nm % 3 == 0)
				{
					sum.first += v[i];
				}
				else if (nm % 3 == 1)
				{
					sum.second += v[i];
				}
				nm /= 3;
			}
			if (sum.first > a || sum.second > b)
			{
				continue;
			}
			can.push_back(sum);
		}
		sort(can.begin(), can.end());
		can.erase(unique(can.begin(), can.end()), can.end());
		if (can.size() == (a + 1) * (b + 1))
		{
			cout << "Yes\n";
		}
		else
		{
			cout << "No\n";
		}
	}
	return true;
}

bool subb0()
{
	if (!b0)
	{
		return false;
	}

	vector<long long> mxb(n);
	long long can = 0;
	for (long long i = 0; i < n; i++)
	{
		if (v[i] <= can + 1)
		{
			can += v[i];
		}
		mxb[i] = can;
	}

	for (auto& i : qr)
	{
		if (i.k < v[0])
		{
			if (i.a == 0)
			{
				cout << "Yes\n";
			}
			else
			{
				cout << "No\n";
			}
			continue;
		}

		long long left = 0, right = n;
		while (right - left > 1)
		{
			long long mid = (left + right) / 2;
			if (v[mid] <= i.k)
			{
				left = mid;
			}
			else
			{
				right = mid;
			}
		}
		if (mxb[left] >= i.a)
		{
			cout << "Yes\n";
		}
		else
		{
			cout << "No\n";
		}
	}
	return true;
}

bool get_ans(vector<long long>& bb, long long a, long long b)
{
	return bb[a] >= b;
}

bool sub_abn()
{
	sort(qr.begin(), qr.end(),
		[](query& x, query& y)
		{
			return x.k < y.k;
		}
	);

	long long ptr = 0;
	vector<bool> ans(qr.size());
	long long mxa = 0, mxb = 0;
	for (auto& i : qr)
	{
		mxa = max(mxa, i.a);
		mxb = max(mxb, i.b);
	}
	long long mxc = max(mxa, mxb);

	vector<vector<bool>> dp(mxc + 1, vector<bool>(mxc + 1));
	dp[0][0] = true;
	vector<long long> bb(mxc + 1, -1);
	bb[0] = 0;
	for (long long i = 0; i < n; i++)
	{
		while (ptr < qr.size() && v[i] > qr[ptr].k)
		{
			ans[qr[ptr].idx] = get_ans(bb, qr[ptr].a, qr[ptr].b);
			ptr++;
		}

		if (v[i] > mxc)
		{
			break;
		}

		for (long long a = mxc; a > -1; a--)
		{
			for (long long b = mxc; b > -1; b--)
			{
				if (dp[a][b])
				{
					if (a + v[i] <= mxc)
					{
						dp[a + v[i]][b] = true;
					}
					if (b + v[i] <= mxc)
					{
						dp[a][b + v[i]] = true;
					}
				}
			}
		}

		for (long long a = 0; a < mxc + 1; a++)
		{
			bb[a] = mxc;
			for (long long b = 0; b < mxc + 1; b++)
			{
				if (!dp[a][b])
				{
					bb[a] = b - 1;
					break;
				}
			}
		}
		for (long long i = 1; i < mxc + 1; i++)
		{
			bb[i] = min(bb[i - 1], bb[i]);
		}
	}
	while (ptr < qr.size())
	{
		ans[qr[ptr].idx] = get_ans(bb, qr[ptr].a, qr[ptr].b);
		ptr++;
	}
	for (long long i = 0; i < ans.size(); i++)
	{
		if (ans[i])
		{
			cout << "Yes\n";
		}
		else
		{
			cout << "No\n";
		}
	}
	return true;
}

void solve()
{
	cin >> n >> q;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	sort(v.begin(), v.end());

	long long z;
	cin >> z;
	qr.resize(q);
	for (long long i = 0; i < q; i++)
	{
		cin >> qr[i].k >> qr[i].a >> qr[i].b;
		qr[i].idx = i;
		if (qr[i].k != 1e18)
		{
			k18 = false;
		}
		if (qr[i].b)
		{
			b0 = false;
		}
		if (qr[i].a > 1e5)
		{
			a5 = false;
		}
	}

	if (subn10())
	{
		return;
	}
	if (subb0())
	{
		return;
	}
	if (sub_abn())
	{
		return;
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*





















*/
