#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n, q, x, y, m;
vector<long long> g[200000], l, r;
vector<long long> qr;

void dfslr(long long v, long long p, vector<vector<long long>>& dp)
{
	dp[v][1] = l[v];
	for (auto& i : g[v])
	{
		if (i == p)
		{
			continue;
		}

		dfslr(i, v, dp);
		dp[v][0] += max(dp[i][0], dp[i][1]);
		dp[v][1] += dp[i][0];
	}
}

void solve()
{
	cin >> n >> q;
	cin >> x >> y >> m;
	for (long long i = 0; i < n - 1; i++)
	{
		long long a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	l.resize(n);
	r.resize(n);
	for (long long i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}
	qr.resize(q);
	for (long long i = 0; i < q; i++)
	{
		cin >> qr[i];
	}
	
	vector<vector<long long>> dp(n, vector<long long>(2));
	dfslr(0, -1, dp);

	long long mx = max(dp[0][0], dp[0][1]);
	long long k = 0;
	for (long long i = 0; i < n; i++)
	{
		k ^= ((x * (i + 1)) % m + ((y * l[i]) % m * l[i]) % m) % m;
	}

	for (long long i = 0; i < q; i++)
	{
		if (qr[i] == mx)
		{
			cout << k << " ";
		}
		else
		{
			cout << -1 << " ";
		}
	}
	cout << "\n";
	cout.flush();

	long long nd;
	cin >> nd;
	while (nd)
	{
		nd--;
		if (qr[nd] == mx)
		{
			for (long long i = 0; i < n; i++)
			{
				cout << l[i] << " ";
			}
			cout << "\n";
		}
		else
		{
			cout << -1 << "\n";
		}
		cout.flush();
		cin >> nd;
	}
}

void reset()
{
	for (long long i = 0; i < n; i++)
	{
		g[i] = {};
	}
	l = r = qr = {};
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
		reset();
	}

	return 0;
}

/*





















*/
