#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct segtree {
    int size = 1;
    vector<int> tree;

    int init(int n) {
        while (size < n) size *= 2;
        tree.assign(2 * size - 1, 0);
        return size;
    }

    void set(int x, int lx, int rx, int i, int v) {
        if (rx - lx == 1) {
            tree[x]+=v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) set(2 * x + 1, lx, m, i, v);
        else set(2 * x + 2, m, rx, i, v);
        tree[x] = tree[2 * x + 1] + tree[2 * x + 2];
    }

    int get(int x, int lx, int rx, int l, int r) {
        if (lx >= r or rx <= l) return 0;
        if (l <= lx and r >= rx) return tree[x];
        int m = (lx + rx) / 2;
        return get(2 * x + 1, lx, m, l, r) + get(2 * x + 2, m, rx, l, r);
    }
};


int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<pair<pair<int, int>, int>> a(n);
        set<int> s;
        for (int i = 0; i < n; i++) {
            cin >> a[i].first.first >> a[i].first.second;
            s.insert(a[i].first.first);
            s.insert(a[i].first.second);
            a[i].second = i;
        }
        map<int, int> d;
        int j = 0;
        while (!s.empty()) {
            int x = *s.begin();
            s.erase(s.begin());
            d[x] = j;
            j++;
        }
        for (int i = 0; i < n; i++) {
            a[i].first.first = d[a[i].first.first];
            a[i].first.second = d[a[i].first.second];
        }
        int m = 0;
        sort(a.begin(), a.end());
        segtree sg;
        int size = sg.init(4 * n);
        map<pair<int, int>, int> was;
        for (int i = 0; i < n; i++) {
            was[a[i].first] ++;
            sg.set(0, 0, size, a[i].first.first, 1);
            sg.set(0, 0, size, a[i].first.second, 1);
        }
        vector<pair<int, int>> c(n);
        for (int i = 0; i < n; i++) {
            int x = sg.get(0, 0, size, a[i].first.first, a[i].first.second + 1);
            x-=2;
            x=x/2;
            c[i] = {x, i};
            if (x == 0) m++;
        }
        int gg = 0;
        j = m;
        int cnt = 0;
        sort(c.begin(), c.end());
        vector <bool> vis(n, true);
        while (gg<m/2) {
            for (int i = 0; i<n; i++) {
                if (!vis[i]) continue;
                int x = sg.get(0, 0, size, a[i].first.first, a[i].first.second + 1);
                x-=2;
                x=x/2;
                c[i] = {x, i};
            }
            int ind = 0;
            int mn = 1e9;
            for (int i = 0; i<n; i++) {
                if (!vis[i]) continue;
                if (mn > c[i].first) {
                    mn = c[i].first;
                    ind = c[i].second;
                }
            }
            vis[ind] = false;
            if (mn == 0) gg++;
            cnt++;
            sg.set(0, 0, size, a[ind].first.first, -1);
            sg.set(0, 0, size, a[ind].first.second, -1);
        }
        while (cnt<n/2) {
            for (int i = 0; i<n; i++) {
                if (!vis[i]) continue;
                int x = sg.get(0, 0, size, a[i].first.first, a[i].first.second + 1);
                x-=2;
                x=x/2;
                c[i] = {x, i};
            }
            int ind = 0;
            int mx = 0;
            for (int i = 0; i<n; i++) {
                if (!vis[i]) continue;
                if (mx < c[i].first) {
                    mx = c[i].first;
                    ind = c[i].second;
                }
            }
            cnt++;
            sg.set(0, 0, size, a[ind].first.first, -1);
            sg.set(0, 0, size, a[ind].first.second, -1);
        }
        for (int i = 0; i<n; i++) {
            if (vis[i]) cout << a[i].second + 1 << "\n";
        }
        cout << "\n";
    }

}