#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(a) cerr << a << endl;
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
// #define int ll


bool ok (vector <int> a, vector <int> b, int n) {
    int i1 = 0, i2 = 0;
    while (true) {
        if (a[i1] == b[i2]) {
            return false;
        }
        else if (a[i1] < b[i2]) {
            ++i1;
        }
        else {
            ++i2;
        }
        if (i1 == n || i2 == n) {
            return true;
        }
    }
}


void stress (int n, int k) {
    vector<vector<int>> a;
    for (int i = 0; i < (1 << n); ++i) {
        vector <int> b;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) & 1) {
                b.pb(j);
            }
        }
        if (b.size() == k) {
            a.pb(b);
        }
    }
    vector <bool> can(a.size(), true);
    for (int i = 0; i < a.size(); ++i) {
        bool found = false;
        for (int j = a.size() - 1; j >= 0; --j) {
            if (can[j] && ok(a[i], a[j], k)) {
                found = true;
                can[j] = false;
                vout(a[i]); vout(a[j]);
                cout << endl;
                break;
            }
        }
        if (!found) {
            cout << "No" << endl;
            return;
        }
    }
    cout << "Yes" << endl;
}


void solve1() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    if (2 * k == n) {
        vector <bool> can(n + 1, true);
        for (auto i : a) {
            can[i] = false;
        }
        vector <int> b;
        for (int i = 1; i <= n; ++i) {
            if (can[i]) b.pb(i);
        }
        vout(b);
        return;
    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    if (2 * k == n) {
        vector <bool> can(n + 1, true);
        for (auto i : a) {
            can[i] = false;
        }
        vector <int> b;
        for (int i = 1; i <= n; ++i) {
            if (can[i]) b.pb(i);
        }
        vout(b);
        return;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tp, tests; cin >> tp >> tests;
    while (tests--) {
        if (tp == 1) {
            solve1();
        }
        else {
            solve2();
        }
    }
}