#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(a) cerr << a << endl;
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
// #define int ll


bool ok (vector <int> a, vector <int> b, int n) {
    int i1 = 0, i2 = 0;
    while (true) {
        if (a[i1] == b[i2]) {
            return false;
        }
        else if (a[i1] < b[i2]) {
            ++i1;
        }
        else {
            ++i2;
        }
        if (i1 == n || i2 == n) {
            return true;
        }
    }
}

map <vector<int>, vector<int>> mp;
void stress (int n, int k) {
    vector<vector<int>> a;
    for (int i = 0; i < (1 << n); ++i) {
        vector <int> b;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) & 1) {
                b.pb(j);
            }
        }
        if (b.size() == k) {
            a.pb(b);
        }
    }
    vector <bool> can(a.size(), true);
    for (int i = 0; i < a.size(); ++i) {
        bool found = false;
        for (int j = a.size() - 1; j >= 0; --j) {
            if (can[j] && ok(a[i], a[j], k)) {
                found = true;
                can[j] = false;
                mp[a[i]] = a[j];
                break;
            }
        }
        if (!found) {
            debug("cock");
            // cout << "No" << endl;
            return;
        }
    }
    // cout << "Yes" << endl;
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    auto f = [&] (int i, int delta) {
        if (i + delta <= n) {
            return i + delta;
        }
        else {
            return i + delta - n;
        }
    };
    vector <int> b;
    for (auto i : a) {

    }
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector <int> a(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
    auto f = [&] (int i, int delta) {
        if (i + delta <= n) {
            return i + delta;
        }
        else {
            return i + delta - n;
        }
    };

}


struct segtree {
    struct node {
        int ma = -mxn, l = -1;
    };

    vector <node> tree;
    int sz;


    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.resize(2 * sz - 1);
    }

    void push (int x, int lx, int rx) {
        if (tree[x].l == -1 || rx - lx == 1) return;
        tree[2 * x + 1].l = tree[x].l;
        tree[2 * x + 2].l = tree[x].l;
        tree[2 * x + 1].ma = tree[x].l;
        tree[2 * x + 2].ma = tree[x].l;
        tree[x].l = -1;
    }


    void update (int l, int r, int v, int x, int lx, int rx) {
        push(x, lx, rx);
        if (lx >= r || l >= rx) {
            return;
        }
        if (lx >= l && rx <= r) {
            tree[x].l = v;
            tree[x].ma = v;
            return;
        }
        int m = (lx + rx) >> 1;
        update(l, r, v, 2 * x + 1, lx, m);
        update(l, r, v, 2 * x + 2, m, rx);
        tree[x].ma = max(tree[2 * x + 1].ma, tree[2 * x + 2].ma);
    }

    int get (int l, int r, int x, int lx, int rx) {
        push(x, lx, rx);
        if (lx >= r || l >= rx) {
            return -mxn;
        }
        if (lx >= l && rx <= r) {
            return tree[x].ma;
        }
        int m = (lx + rx) >> 1;
        return max(get(l, r, 2 * x + 1, lx, m), get(l, r, 2 * x + 2, m, rx));
    }
};


void solve() {
    int n; cin >> n;
    vector <int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    vector <segtree> A(n + 1), B(n + 1);
    for (int i = 0; i <= n; ++i) {
        A[i].init(n + 1);
        B[i].init(n + 1);
    }
    A[0].update(0, 1, 0, 0, 0, n + 1);
    B[0].update(0, 1, 0, 0, 0, n + 1);
    for (int i = 0; i < n; ++i) {
        for (int y = 0; y <= n; ++y) {
            if (y == p[i]) {
                A[p[i]].update(y, y + 1, -mxn, 0, 0, n + 1);
                B[y].update(p[i], p[i] + 1, -mxn, 0, 0, n + 1);
            }
            else {
                int val = B[y].get(0, p[i], 0, 0, n + 1) + 1;
                A[p[i]].update(y, y + 1, val, 0, 0, n + 1);
                B[y].update(p[i], p[i] + 1, val, 0, 0, n + 1);
            }
        }
        for (int x = 0; x <= n; ++x) {
            if (x == p[i]) {
                B[p[i]].update(x, x + 1, -mxn, 0, 0, n + 1);
                A[x].update(p[i], p[i] + 1, -mxn, 0, 0, n + 1);
            }
            else {
                int val = max(A[x].get(0, 1, 0,0, n + 1), A[x].get(p[i] + 1, n + 1, 0, 0, n + 1)) + 1;
                // debug(x << ' ' << val);
                B[p[i]].update(x, x + 1, val, 0, 0, n + 1);
                A[x].update(p[i], p[i] + 1, val, 0, 0, n + 1);
            }
        }
        for (int x = 0; x < p[i]; ++x) {
            A[x].update(p[i] + 1, n + 1, -mxn, 0, 0, n + 1);
            A[x].update(0, 1, -mxn, 0, 0, n + 1);
        }
        for (int y = p[i] + 1; y <= n; ++y) {
            B[y].update(0, p[i], -mxn, 0, 0, n + 1);
            B[y].update(0, 1, -mxn, 0, 0, n + 1);
        }
        // debug(A[0].get(4, 5, 0, 0, n + 1));
        // return;
        // debug(A[10].get(1, 2, 0, 0, n + 1));
        // debug(B[4].get(1, 2, 0, 0, n + 1));
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        ans = max(ans, A[i].get(0, n + 1, 0, 0, n + 1));
    }
    // cout << A[10].get(1, 2, 0, 0, n + 1) << endl;
    // cout << A[9].get(1, 2, 0, 0, n + 1) << endl;
    cout << ans << endl; return;
    segtree st; st.init(n + 1);
    for (int i = 0; i < n; ++i) {
        st.update(p[i], p[i] + 1, st.get(0, p[i], 0, 0, n + 1) + 1, 0, 0, n + 1);
    }
    cout << min(n, 1 + st.get(0, n + 1, 0, 0, n + 1)) << endl;
}

const int N = 2e3 + 1;
int dp[N][N];

void solve3() {
    int n; cin >> n;
    vector <int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = -1;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        int t = p[i];
        for (int y = 0; y <= n; ++y) {
            if (y != t) {
                int ma = -1;
                for (int x1 = 0; x1 < t; ++x1) {
                    if (dp[x1][y] != -1) {
                        ma = max(ma, dp[x1][y] + 1);
                    }
                }
                dp[t][y] = ma;
            }
        }
        for (int x = 0; x <= n; ++x) {
            if (x != t) {
                int ma = -1;
                for (int y1 = t + 1; y1 <= n; ++y1) {
                    if (dp[x][y1] != -1) {
                        ma = max(ma, dp[x][y1] + 1);
                    }
                }
                if (dp[x][0] != -1) {
                    ma = max(ma, dp[x][0] + 1);
                }
                dp[x][t] = ma;
            }
        }
        dp[t][t] = -1;
        for (int x = 0; x <= t; ++x) {
            for (int y = t + 1; y <= n; ++y) {
                dp[x][y] = -1;
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve3();
    }
}